package com.hisense.hipos;

import android.content.Context;

import com.hisense.hiaposcmp.config.Config;
import com.hisense.pos.print.icbc.ICBCDeviceHelper;
import com.hisense.hiaposcmp.pos.icbc.ICBCHelper;
import com.hisense.pos.payment.icbc.IcbcService;


/**
 * {银行服务绑定/解绑操作}
 *
 * @author wangyaogang 2019-03-13
 */
public class BankServiceHelper {

    /**
     * 绑定服务
     *
     * @param context 上下文
     */
    public static void bindService(Context context) {
        //绑定工行收单服务
        IcbcService.bind(context, Config.APP_NAME);
        ICBCHelper.getInstance().init(context).bindICBCService();
        //绑定工行读卡服务
        ICBCDeviceHelper.getInstance().init(context).bindICBCDeviceService();
    }

    /**
     * 解绑服务
     *
     * @param context 上下文
     */
    public static void unBindService(Context context) {
        //解绑工行服务
        IcbcService.unbind();
        ICBCHelper.getInstance().unBindICBCService();
        ICBCDeviceHelper.getInstance().init(context).unbindICBCDeviceService();
    }
}
