/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp;

import com.hisense.hipos.payment.PayMethod;

import java.util.List;

/**
 * APP 运行的上下文环境
 *
 * @author zhangsai 2018-01-08
 */
public final class AppContext {

    // 支付方式列表
    private static List<PayMethod> payMethods;

    private AppContext() {
        // NO CODE HERE. 防止类被初始化
    }

    /**
     * 返回支付方式列表。
     *
     * @return 支付方式列表
     */
    public static List<PayMethod> payMethods() {
        return AppContext.payMethods;
    }

    /**
     * 设置支付方式列表。
     *
     * @param payMethods 支付方式列表
     */
    public static void payMethods(List<PayMethod> payMethods) {
        AppContext.payMethods = payMethods;
    }

    public static void reset() {
        payMethods = null;
    }
}
