/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import com.hisense.crm.card.Card;
import com.hisense.crm.card.VipCard;
import com.hisense.crm.vip.VerifyType;
import com.hisense.hiaposcmp.activity.std.pay.CardPayShowStdActivity;
import com.hisense.hiaposcmp.activity.std.pay.CardPayStdActivity;
import com.hisense.hiaposcmp.activity.std.pay.CardReturnQueryStdActivity;
import com.hisense.hiaposcmp.activity.std.pay.PayStdDialogActivity;
import com.hisense.hiaposcmp.activity.std.pay.PointsPayShowStdActivity;
import com.hisense.hiaposcmp.activity.std.pay.PointsPayStdActivity;
import com.hisense.hiaposcmp.activity.std.pay.CardSecurityInputStdActivity;
import com.hisense.hiaposcmp.activity.std.sale.SaleStdDialogActivity;
import com.hisense.hiaposcmp.activity.ysy.card.CardReturnQueryActivity;
import com.hisense.hiaposcmp.activity.ysy.card.CardSecurityInputActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.CardPayActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.CardPayShowActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PointsPayActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PointsPayShowActivity;
import com.hisense.hiaposcmp.activity.ysy.refund.viewModel.RefundViewModel;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hipos.payment.PayMethod;

import java.util.ArrayList;

import static com.hisense.hiaposcmp.constant.ActivityConstants.REQUEST_CARD_BALANCE_QUERY;

/**
 * @author zhenghao    2017-02-21
 * @author wangyaogang 2019-06-19 HIPOSAPP-1171 打开校验框时增加isECard是否电子卡字段
 * @author wangyaogang 2019-06-26 HIPOSAPP-1180 储值卡/积分卡验证页面传值去掉支付方式,新增VerifyType,打开校验页面方法调至PopCardVerifyActivity中
 * @author wangyaogang 2019-12-27 HIAPOSCMP-455 标准版支付功能开发
 * @author wangyaogang 2020-01-15 HIAPOSCMP-496 标准版-储值卡/积分支付页面改造
 */
public class StartActivityService {

    /**
     * 打开储值卡刷卡页面
     */
    public static void gotoCardPayActivity(Activity activity, PayMethod payMethod, ArrayList<RefundViewModel> listPayments, String totalReceive) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", payMethod);
        if (listPayments != null) {
            bundle.putSerializable("payments", listPayments);
            bundle.putString("fSsTotal", totalReceive);
        }

        Intent intent = new Intent();
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, CardPayStdActivity.class);
        } else {
            intent.setClass(activity, CardPayActivity.class);
        }
        intent.putExtras(bundle);
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_PAY_TO_CARD);
    }

    /**
     * 支付中,打开储值卡余额页面
     */
    public static void gotoCardPayShowActivity(Activity activity, Card card, String fSsTotal) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("card", card);
        bundle.putString("fSsTotal", fSsTotal);

        Intent intent = new Intent();
        intent.putExtras(bundle);
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, CardPayShowStdActivity.class);
        } else {
            intent.setClass(activity, CardPayShowActivity.class);
        }
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_TO_CARD_PAY_SHOW);
    }

    /**
     * 打开积分卡刷卡页面
     */
    public static void gotoPointsPayActivity(Activity activity, PayMethod payMethod, ArrayList<RefundViewModel> listPayments, String totalReceive) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", payMethod);
        if (listPayments != null) {
            bundle.putSerializable("payments", listPayments);
            bundle.putString("fSsTotal", totalReceive);
        }
        Intent intent = new Intent();
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, PointsPayStdActivity.class);
        } else {
            intent.setClass(activity, PointsPayActivity.class);
        }
        intent.putExtras(bundle);
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_PAY_TO_POINTS);
    }

    /**
     * 支付中,打开积分余额页面
     */
    public static void gotoPointsPayShowActivity(Activity activity, VipCard card, String totalReceive, String remark) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("card", card);
        bundle.putString("fSsTotal", totalReceive);
        bundle.putString("remark", remark);

        Intent intent = new Intent();
        intent.putExtras(bundle);
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, PointsPayShowStdActivity.class);
        } else {
            intent.setClass(activity, PointsPayShowActivity.class);
        }

        activity.startActivityForResult(intent, ActivityConstants.REQUEST_TO_POINTS_PAY_SHOW);
    }

    /**
     * 退货,打开储值卡/积分余额页面
     */
    public static void gotoCardReturnQueryActivity(Activity activity, String typeTag, Card card, VipCard card2, String fSsTotal, String maxRefund, String remark) {
        Bundle bundle = new Bundle();
        if ("vipCard".equalsIgnoreCase(typeTag)) {
            bundle.putSerializable("card", card2);
        } else {
            bundle.putSerializable("card", card);
        }
        bundle.putString("fSsTotal", fSsTotal);
        bundle.putString("maxRefund", maxRefund);
        bundle.putString("typeTag", typeTag);
        bundle.putString("remark", remark);
        Intent intent = new Intent();
        intent.putExtras(bundle);
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, CardReturnQueryStdActivity.class);
        } else {
            intent.setClass(activity, CardReturnQueryActivity.class);
        }

        activity.startActivityForResult(intent, REQUEST_CARD_BALANCE_QUERY);
    }

    /**
     * 标准版聚合支付 扫码页面
     */
    public static void gotoIntePayActivity(Activity activity, PayMethod payMethod, String totalReceive) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", payMethod);
        bundle.putString("fSsTotal", totalReceive);
        bundle.putString("activity", activity.getLocalClassName().substring(activity.getLocalClassName().lastIndexOf(".") + 1));

        Intent intent = new Intent();
        intent.setClass(activity, PayStdDialogActivity.class);
        intent.putExtras(bundle);
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_INTE_PAY_INPUT);
    }

    /**
     * 标准版调整数量界面
     *
     * @param activity
     */
    public static void gotoStdSaleDialogActivity(Activity activity, int position, int pluCount) {
        Bundle bundle = new Bundle();
        bundle.putInt("position", position);
        bundle.putInt("pluCount", pluCount);

        Intent intent = new Intent();
        intent.setClass(activity, SaleStdDialogActivity.class);
        intent.putExtras(bundle);
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_SALE_TO_CHANGE_QUALITY);
    }

    /**
     * 启动CardSecurityInputActivity
     *
     * @param activity   发起调用的Activity
     * @param iseCard    是否电子卡
     * @param verifyType 验证信息
     */
    public static void startCardSecurityInputActivity(Activity activity, boolean iseCard, VerifyType verifyType) {
        Intent intent = new Intent();
        intent.putExtra("iseCard", iseCard);
        intent.putExtra("verifyType", verifyType);
        if (CommonUtils.isStdStyle()) {
            intent.setClass(activity, CardSecurityInputStdActivity.class);
        } else {
            intent.setClass(activity, CardSecurityInputActivity.class);
        }
        activity.startActivityForResult(intent, ActivityConstants.REQUEST_TO_CARD_SECURITY_INPUT);
    }
}
