package com.hisense.hiaposcmp.activity.ali;

import android.content.Intent;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.KeyEvent;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.CommonConstants;
import com.hisense.hiaposcmp.presenter.pay.PaySuccessPresenter;
import com.hisense.hiaposcmp.view.IView.pay.IPaySuccessView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 支付失败展示界面
 *
 * @author dukunbiao(null) 2018-06-19
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_pay_failure_ant)
public class PayFailureAliActivity extends BaseMvpActivity<IPaySuccessView, PaySuccessPresenter> implements IPaySuccessView {

    @BindView(R.id.payFailureTvReceipt)
    public TextView payFailureTvReceipt;

    @BindView(R.id.payFailureTvNumber)
    public TextView payFailureTvNumber;

    @BindView(R.id.payFailureTvMsg)
    public TextView payFailureTvMsg;

    @BindView(R.id.payFailureBtnClose)
    public Button payFailureBtnClose;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
        initCountDown();
    }

    @Override
    protected PaySuccessPresenter createPresenter() {
        return new PaySuccessPresenter();
    }

    @OnClick(R.id.payFailureBtnClose)
    public void onClickClose() {
        finish();
    }

    private void init() {
        Intent intent = this.getIntent();
        Bundle bundle = intent.getExtras();

        if (bundle == null) {
            return;
        }
        payFailureTvReceipt.setText("￥" + mPresenter.getSale().getTotalUnPaid());
        payFailureTvNumber.setText("共" + mPresenter.getSale().calcCount() + "件商品");

        if (bundle.containsKey("msg")) {
            payFailureTvMsg.setText(bundle.getString("msg"));
        }
    }

    private void initCountDown() {
        new CountDownTimer(CommonConstants.PAY_FAIL_MILLIS_IN_FUTURE, CommonConstants.PAY_FAIL_COUNT_DOWN_INTERVAL) {

            @Override
            public void onTick(long millisUntilFinished) {
                //重置倒计时文本
                payFailureBtnClose.setText("再试一次   (" + String.format("%ds", millisUntilFinished / 1000) + ")");
            }

            @Override
            public void onFinish() {
                finish();
            }
        }.start();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        return true;
    }
}
