package com.hisense.hiaposcmp.activity.ali;

import android.os.Bundle;
import android.text.Editable;
import android.text.InputType;
import android.text.TextWatcher;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.bean.BaseEventBean;
import com.hisense.hiaposcmp.constant.EventActions;
import com.hisense.hiaposcmp.presenter.sale.PluCodeInputPresenter;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.view.IView.sale.IPluCodeInputView;
import com.hisense.hiaposcmp.view.KeyBoardAliView;

import org.greenrobot.eventbus.EventBus;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author liaoyuping on 2018\5\29 0029.
 * @author dukunbiao(null)  2019-07-24  重构
 */
@ActivityLayoutInject(R.layout.activity_inputbarcode_ant)
public class PluCodeInputAliActivity extends BaseMvpActivity<IPluCodeInputView, PluCodeInputPresenter> implements IPluCodeInputView, KeyBoardAliView.IOnKeyboardListener {

    @BindView(R.id.img_quit)
    public ImageView imgQuit;

    @BindView(R.id.edt_inputcode)
    public EditText edtInputCode;

    @BindView(R.id.txt_tip)
    public TextView txtTip;

    @BindView(R.id.keyboar_ant_inputbarcode)
    public KeyBoardAliView myKeyboard;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    private void init() {
        myKeyboard.setIOnKeyboardListener(this);

        txtTip.setText("请输入 \n商品条码下方的数字");
        edtInputCode.setInputType(InputType.TYPE_NULL);
        edtInputCode.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                if (StringUtils.isEmpty(s.toString())) {
                    edtInputCode.setFocusable(true);
                    edtInputCode.requestFocus();
                }
            }
        });
    }

    @Override
    protected PluCodeInputPresenter createPresenter() {
        return new PluCodeInputPresenter();
    }

    @OnClick(R.id.img_quit)
    public void onClickQuit() {
        finish();
    }

    @Override
    public void onInsertKeyEvent(String text) {
        edtInputCode.append(text);
    }

    @Override
    public void onDeleteKeyEvent() {
        String inputStr = edtInputCode.getText().toString().trim();
        if (inputStr.length() >= 1) {
            edtInputCode.setText(inputStr.substring(0, inputStr.length() - 1));
        }
    }

    @Override
    public void onDoneKeyEvent() {
        if (isFastClick()) {
            return;
        }
        EventBus.getDefault().post(new BaseEventBean(EventActions.ON_MANUAL_BARCODE_INPUT_COMPLETE, getText()));
        finish();
    }

    private String getText() {
        return edtInputCode.getText().toString().trim();
    }
}
