package com.hisense.hiaposcmp.activity.aliland;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.tool.ScanKeyEventHelper;
import com.hisense.hiaposcmp.presenter.pay.PayScanPresenter;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.pay.IPayScanView;
import com.hisense.hipos.payment.PayMethod;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author liaoyuping on 2018/6/5.
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_aliscanpay_ant_landscape)
public class PayScanAliLandActivity extends BaseMvpActivity<IPayScanView, PayScanPresenter> implements IPayScanView, ScanKeyEventHelper.OnScanSuccessListener {

    @BindView(R.id.imvAliScanPayQuit)
    public ImageView imgQuit;

    @BindView(R.id.textView)
    public TextView textView;

    @BindView(R.id.txtNeedPayCost)
    public TextView txtNeedPayCost;

    @BindView(R.id.txtPayedCost)
    public TextView txtPayedCost;

    private ScanKeyEventHelper mScanKeyEventHelper;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        processIntent();
    }

    @Override
    protected PayScanPresenter createPresenter() {
        return new PayScanPresenter();
    }

    protected void processIntent() {
        txtNeedPayCost.setText("");
        txtPayedCost.setText("");

        Intent intent = this.getIntent();
        Bundle bundle = intent.getExtras();
        if (bundle == null) {
            return;
        }

        if (bundle.containsKey("payType")) {
            if (PayMethod.isWxPay(bundle.getString("payType"))) {
                textView.setText("请打开微信");
            }
        }

        if (bundle.containsKey("needPayCost")) {
            txtNeedPayCost.setText(bundle.getString("needPayCost"));
        }

        if (bundle.containsKey("payedCost")) {
            txtPayedCost.setText(bundle.getString("payedCost"));
        }
    }

    @OnClick(R.id.imvAliScanPayQuit)
    public void onClickQuit() {
        finish();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getKeyCode() == KeyEvent.KEYCODE_ENTER && isFastClick()) {
            //屏蔽连扫的第二个条码
            LoggerUtils.getLogger().info("屏蔽条码:" + event.getKeyCode());
        } else {
            mScanKeyEventHelper.analysisKeyEvent(event);
        }

        return super.dispatchKeyEvent(event);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mScanKeyEventHelper.onDestroy();
    }

    @Override
    protected void onPause() {
        super.onPause();
        mScanKeyEventHelper.onDestroy();
    }

    @Override
    protected void onResume() {
        super.onResume();
        mScanKeyEventHelper = new ScanKeyEventHelper(this);
    }

    protected void onConfirm(String barcode) {
        Intent intent = new Intent();
        intent.putExtra("barcode", barcode);
        PayScanAliLandActivity.this.setResult(ActivityConstants.RESULT_PAY_TO_SCAN, intent);
        PayScanAliLandActivity.this.finish();
        finish();
    }

    @Override
    public void onScanSuccess(String barcode) {
        CommonUtils.startBeepBgm(this, barcode);

        Intent intent = new Intent();
        intent.putExtra("barcode", barcode);
        PayScanAliLandActivity.this.setResult(ActivityConstants.RESULT_PAY_TO_SCAN, intent);
        PayScanAliLandActivity.this.finish();
        finish();
    }
}
