package com.hisense.hiaposcmp.activity.aliland;

import android.os.Bundle;
import android.text.InputType;
import android.widget.EditText;
import android.widget.ImageButton;

import androidx.annotation.Nullable;

import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.bean.BaseEventBean;
import com.hisense.hiaposcmp.constant.EventActions;
import com.hisense.hiaposcmp.presenter.VipLoginPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IVipLoginView;
import com.hisense.hiaposcmp.view.KeyBoardAliView;

import org.greenrobot.eventbus.EventBus;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author wangwenyue on 2018/5/25.
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_viplogin_ant_landscape)
public class VipLoginAliLandActivity extends BaseMvpActivity<IVipLoginView, VipLoginPresenter> implements IVipLoginView, KeyBoardAliView.IOnKeyboardListener {

    @BindView(R.id.imb_cancel)
    public ImageButton imbCancel;

    @BindView(R.id.edt_vipnum_input)
    public EditText edtNumInput;

    @BindView(R.id.keyboar_ant_viplogin)
    public KeyBoardAliView myKeyboard;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @Override
    protected VipLoginPresenter createPresenter() {
        return new VipLoginPresenter();
    }

    private void init() {
        myKeyboard.setIOnKeyboardListener(this);
        edtNumInput.setInputType(InputType.TYPE_NULL);
    }

    @OnClick(R.id.imb_cancel)
    public void onClickCancel() {
        CommonTools.goTo(VipLoginAliLandActivity.this, WelcomeAliLandActivity.class);
        finish();
    }

    @Override
    public void onInsertKeyEvent(String text) {
        edtNumInput.append(text);
    }

    @Override
    public void onDeleteKeyEvent() {
        String inputStr = edtNumInput.getText().toString().trim();
        if (inputStr.length() >= 1) {
            edtNumInput.setText(inputStr.substring(0, inputStr.length() - 1));
        }
    }

    @Override
    public void onDoneKeyEvent() {
        String vipNo = edtNumInput.getText().toString().trim();
        if (isFastClick()) {
            return;
        }

        try {
            mPresenter.vipQuery(vipNo);
        } catch (NullPointerException e) {
            hideLoadingDialog();
            showHintDialog("网络状态异常", "请检查网络");
        }
    }

    @Override
    public void vipLoginSuccess(Vip vip) {
        mPresenter.getSale().setVip(vip);
        EventBus.getDefault().post(new BaseEventBean(EventActions.ON_VIP_LOGIN, ""));
        CommonTools.goTo(VipLoginAliLandActivity.this, SaleAliLandActivity.class);
        finish();
    }

    @Override
    public void vipLoginFail(String msg) {
        showHintDialog("会员验证失败", msg);
    }

    @Override
    public void verifyTypeSuccess(Vip vip) {

    }

    @Override
    public void verifyTypeFail(String msg) {

    }
}
