/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.common;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.util.DateUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.boot.Custom;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.DeviceInfoUtils;

import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 关于。
 *
 * @author guanguangjin 2017-03-04
 * @author zhangsai     2017-12-15 HIPOSAPP-241
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_about)
public class AboutActivity extends BaseActivity {

    @BindView(R.id.txtVersion)
    public TextView txtVersion;

    @BindView(R.id.btnGoBack)
    public LinearLayout btnGoBack;

    @BindView(R.id.lytAboutUs)
    public RelativeLayout lytAboutUs;

    @BindView(R.id.lytWechat)
    public RelativeLayout lytWeChat;

    @BindView(R.id.lytWebsite)
    public RelativeLayout lytWebsite;

    @BindView(R.id.lytServiceTel)
    public LinearLayout lytServiceTel;

    @BindView(R.id.txtCopyright)
    public TextView txtCopyright;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    private void init() {
        txtVersion.setText(this.getVersion() + " 渠道:" + Custom.current().getName() + "\n硬件序列号" + DeviceInfoUtils.getSystemBuildSerial());
        txtCopyright.setText(String.format(Locale.CHINESE, "©2017-%s 版权所有", DateUtils.dateFormat("yyyy")));
    }

    @OnClick(R.id.btnGoBack)
    public void onClickBack() {
        finish();
    }

    @OnClick(R.id.lytAboutUs)
    public void onClickAbout() {
        CommonTools.goTo(AboutActivity.this, AboutUsActivity.class);
    }

    @OnClick(R.id.lytWechat)
    public void onClickWechat() {
        CommonTools.goTo(AboutActivity.this, WechatActivity.class);
    }

    @OnClick(R.id.lytWebsite)
    public void onClickWebsite() {
        try {
            Intent intent = new Intent(Intent.ACTION_VIEW);
            intent.setData(Uri.parse("http://hics.hisense.com"));
            startActivity(intent);
        } catch (Exception e) {
            CommonTools.showUiDialog("无法获取该设备打开浏览器权限，" + e.getMessage());
        }
    }

    @OnClick(R.id.lytServiceTel)
    public void onClickServiceTel() {
        try {
            Intent intent1 = new Intent(Intent.ACTION_DIAL);
            intent1.setData(Uri.parse("tel:4006-585-111"));
            startActivity(intent1);
        } catch (Exception e) {
            CommonTools.showUiDialog("无法获取该设备电话拨号权限，" + e.getMessage());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
