package com.hisense.hiaposcmp.activity.common;

import android.os.Bundle;
import android.text.InputType;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.presenter.PermissionPrintPresenter;
import com.hisense.hiaposcmp.print.printer.Printer;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.view.IView.IPermissionPrintView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author liaoyuping on 2018/7/11.
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_permissioncodeprint_wx)
public class PermissionPrintActivity extends BaseMvpActivity<IPermissionPrintView, PermissionPrintPresenter> implements IPermissionPrintView {

    @BindView(R.id.lytPCPrintBack)
    public LinearLayout lytPcPrintBack;

    @BindView(R.id.edit_permissionCode)
    public EditText editPermissionCode;

    @BindView(R.id.imgPrintPermission)
    public ImageView imgPrintPermission;

    @BindView(R.id.cboxShowPermission)
    public CheckBox cBoxShowPermission;

    private String permissionCode;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    private void init() {
        cBoxShowPermission.setOnCheckedChangeListener((compoundButton, b) -> {
            if (b) {
                editPermissionCode.setInputType(InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD);
            } else {
                editPermissionCode.setInputType(InputType.TYPE_TEXT_VARIATION_PASSWORD | InputType.TYPE_CLASS_TEXT);
            }
        });

        cBoxShowPermission.setChecked(true);
        permissionCode = "";
    }

    @Override
    protected PermissionPrintPresenter createPresenter() {
        return new PermissionPrintPresenter();
    }

    @OnClick(R.id.lytPCPrintBack)
    public void onClickBack() {
        finish();
    }

    @OnClick(R.id.imgPrintPermission)
    public void onClickPermission() {
        permissionCode = editPermissionCode.getText().toString();
        if (!StringUtils.isEmpty(permissionCode)) {
            printPermissionCode();
        }
    }

    private void printPermissionCode() {
        runOnUiThread(() -> {
            Printer.printBarHs650(permissionCode, 0);
        });
    }
}
