package com.hisense.hiaposcmp.activity.common;


import android.os.Bundle;
import android.os.Handler;
import android.view.KeyEvent;
import android.widget.TextView;
import android.widget.Toast;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.aliland.LoginAliLandActivity;
import com.hisense.hiaposcmp.activity.std.LoginStdActivity;
import com.hisense.hiaposcmp.activity.wx.PosSettingActivity;
import com.hisense.hiaposcmp.activity.wx.refund.SaleReturnWxActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.presenter.PosManagePresenter;
import com.hisense.hiaposcmp.print.printer.Printer;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.IPosManageView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author liaoyuping on 2018\5\17 0017.
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_manage_sspos)
public class PosManageActivity extends BaseMvpActivity<IPosManageView, PosManagePresenter> implements IPosManageView {

    @BindView(R.id.txtTitleManage)
    public TextView txtTitleManage;

    private long mExitTime;
    private boolean mIsExit;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    private void init() {
        txtTitleManage.setText(R.string.app_name);

        mIsExit = false;
    }

    @Override
    protected PosManagePresenter createPresenter() {
        return new PosManagePresenter();
    }

    @OnClick(R.id.btnLeaveManage)
    public void onClickLeave() {
        finish();
    }

    @OnClick(R.id.linearEndDayManage)
    public void onClickEndDay() {
        mPresenter.reSubmit();
    }

    @OnClick(R.id.linearUploadLogs)
    public void onClickUploadLogs() {
        CommonTools.goTo(this, UpLogActivity.class);
    }

    @OnClick(R.id.linearSettingManage)
    public void onClickSetting() {
        CommonTools.goTo(this, PosSettingActivity.class);
    }

    @OnClick(R.id.lytAboutManage)
    public void onClickAbout() {
        CommonTools.goTo(this, AboutActivity.class);
    }

    @OnClick(R.id.lytAppQuit)
    public void onClickQuit() {
        quit();
    }

    @OnClick(R.id.linearPrintPermission)
    public void onClickPrintPermission() {
        printPermissionCode();
    }

    @OnClick(R.id.linearSaleReturn)
    public void onClickSaleReturn() {
        // 退货
        CommonTools.goTo(this, SaleReturnWxActivity.class);
    }

    private void printPermissionCode() {
        runOnUiThread(() -> {
            if(GeneralSettings.INSTANCE.getDeviceType().isHSX()){
                Printer.printBarHs650(GeneralSettings.INSTANCE.GetPermissionCode(), 0);
            }
            if(GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()){
                Printer.printBarSunmiT2(GeneralSettings.INSTANCE.GetPermissionCode(), 0);
            }
        });
    }

    protected void quit() {
        if (mIsExit) {
            exitApp();
        } else {
            Toast.makeText(this, "再按一次退出", Toast.LENGTH_SHORT).show();
            mIsExit = true;
            new Handler().postDelayed(() -> mIsExit = false, 2000);
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            this.exit();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    public void exit() {
        if ((System.currentTimeMillis() - mExitTime) > 2000) {
            Toast.makeText(PosManageActivity.this, "再次点击返回登录", Toast.LENGTH_SHORT).show();
            mExitTime = System.currentTimeMillis();
        } else {
            if (CommonUtils.isStdStyle() || CommonUtils.isUniformStyle()) {
                if(CommonUtils.isAliLandStyle()){
                    CommonTools.goTo(this, LoginAliLandActivity.class);
                } else {
                    CommonTools.goTo(this, LoginStdActivity.class);
                }
            } else {
                CommonTools.goTo(this, LoginActivity.class);
            }

            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
