/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.common;

import android.os.Bundle;
import android.widget.EditText;
import android.widget.TextView;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.print.PrinterHelper;
import com.hisense.hiaposcmp.print.services.PrintTemplateService;
import com.hisense.hipos.template.models.PrintTemplateType;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 打印模板设置。
 *
 * @author guanguangjin 2017-03-09
 * @author dengyunpeng  2017-07-17 HIPOSAPP-118 将打印模板保存在本地SQLite数据库
 * @author zhangsai     2017-10-24 HIPOSAPP-189 升级打印模板更新的WebAPI调用
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.template_editor_layout)
public class TemplateEditActivity extends BaseActivity {

    private PrintTemplateType templateType;

    @BindView(R.id.editor)
    public EditText mEditor;

    @BindView(R.id.title)
    public TextView mTitle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @OnClick(R.id.cancel)
    public void onClickCancel() {
        finish();
    }

    @OnClick(R.id.confirm)
    public void onClickConfirm() {
        PrintTemplateService.checkUpdate(TemplateEditActivity.this, templateType);
    }

    /**
     * 初始化
     */
    private void init() {
        templateType = (PrintTemplateType) getIntent().getSerializableExtra("type");

        switch (templateType) {
            case GiftCoupon:
                mTitle.setText("礼品券格式");
                break;
            case Coupon:
                mTitle.setText("赠券格式");
                break;
            case Receipt:
            default:
                mTitle.setText("小票格式");
                break;
        }

        String template = PrinterHelper.getInstance().getTemplate(templateType);
        if (!StringUtils.isEmpty(template)) {
            mEditor.setText(template);
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
