package com.hisense.hiaposcmp.activity.std; /***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/


import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.util.DateUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.activity.common.AboutUsActivity;
import com.hisense.hiaposcmp.activity.common.WechatActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.boot.Custom;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.DeviceInfoUtils;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 关于海信。
 *
 * @author guolina      2020-01-03 HIPOSAPP-241
 */
@ActivityLayoutInject(R.layout.activity_about_std)
public class AboutStdActivity extends BaseActivity {


    @BindView(R.id.btnBack)
    Button btnBack;

    @BindView(R.id.txtVersion)
    TextView txtVersion;

    @BindView(R.id.lytAboutUs)
    RelativeLayout lytAboutUs;

    @BindView(R.id.lytWebsite)
    RelativeLayout lytWebsite;

    @BindView(R.id.lytWechat)
    RelativeLayout lytWechat;

    @BindView(R.id.lytServiceTel)
    LinearLayout lytServiceTel;

    /**
     * 会员的图标
     */
    @BindView(R.id.tvStdTitleVipIcon)
    TextView tvStdTitleVipIcon;

    /**
     * 正中的标题
     */
    @BindView(R.id.tvStdTitleItem)
    TextView mTvStdTitleItem;

    /**
     * 标题栏  时间
     */
    @BindView(R.id.tvStdTitleDate)
    TextView tvStdTitleDate;
    /**
     * 标题栏 门店名称
     */
    @BindView(R.id.tvStdTitleOrgName)
    TextView tvStdTitleOrgName;
    /**
     * 标题栏 营业员名称
     */
    @BindView(R.id.tvStdTitleCashierName)
    TextView tvStdTitleCashierName;
    /**
     * 会员登录(隐藏)
     */
    @BindView(R.id.tvStdTitleVipLogin)
    public TextView tvStdTitleVipLogin;

    /**
     * 切换会员(隐藏)
     */
    @BindView(R.id.tvStdTitleVipChange)
    TextView tvStdTitleVipChange;

    @BindView(R.id.tvTipSaleNo)
    TextView mTvTipSaleNo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    private void init() {
        mTvStdTitleItem.setText("关于");
        tvStdTitleVipLogin.setVisibility(View.GONE);
        tvStdTitleVipChange.setVisibility(View.GONE);
        tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
        tvStdTitleOrgName.setText(com.hisense.hipos.webapi.Context.orgName());
        tvStdTitleCashierName.setText(Config.user_name);
        tvStdTitleVipIcon.setVisibility(View.GONE);
        mTvTipSaleNo.setVisibility(View.GONE);

        txtVersion.setText(this.getVersion() + " 渠道:" + Custom.current().getName() + "\n硬件序列号:" + DeviceInfoUtils.getSystemBuildSerial());
    }
    @OnClick({R.id.btnBack, R.id.linearStdTitleHome, R.id.lytAboutUs, R.id.lytWebsite, R.id.lytWechat, R.id.lytServiceTel})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.btnBack:
            case R.id.linearStdTitleHome:
                finish();
                break;
            case R.id.lytAboutUs:
                CommonTools.goTo(AboutStdActivity.this, AboutUsActivity.class);
                break;
            case R.id.lytWebsite:
                try {
                    Intent intent = new Intent(Intent.ACTION_VIEW);
                    intent.setData(Uri.parse("http://hics.hisense.com"));
                    startActivity(intent);
                } catch (Exception e) {
                    CommonTools.showUiDialog("无法获取该设备打开浏览器权限，" + e.getMessage());
                }
                break;
            case R.id.lytWechat:
                CommonTools.goTo(AboutStdActivity.this, WechatActivity.class);
                break;
            case R.id.lytServiceTel:
                try {
                    Intent intent1 = new Intent(Intent.ACTION_DIAL);
                    intent1.setData(Uri.parse("tel:4006-585-111"));
                    startActivity(intent1);
                } catch (Exception e) {
                    CommonTools.showUiDialog("无法获取该设备电话拨号权限，" + e.getMessage());
                }
                break;
        }
    }
}
