/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.std;

import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.layout.SoftInput;
import com.hisense.hiaposcmp.presenter.auth.ChangePasswordPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IChangePasswordView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;
import com.hisense.hiaposcmp.view.KeyBoardView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 修改密码。
 *
 * @author guolina  2020-01-07
 */
@ActivityLayoutInject(R.layout.activity_change_password_std)
public class ChangePasswordStdActivity extends BaseMvpActivity<IChangePasswordView, ChangePasswordPresenter> implements IChangePasswordView, KeyBoardStdView.OnKeyboardListener {


    @BindView(R.id.imgClose)
    ImageView imgClose;

    @BindView(R.id.edtOld)
    EditText edtOld;

    @BindView(R.id.imgOldClear)
    ImageView imgOldClear;

    @BindView(R.id.edtNew)
    EditText edtNew;

    @BindView(R.id.imgNewClear)
    ImageView imgNewClear;

    @BindView(R.id.edtConfirm)
    EditText edtConfirm;

    @BindView(R.id.imgConfirmClear)
    ImageView imgConfirmClear;

    @BindView(R.id.btnChange)
    Button btnChange;

    @BindView(R.id.keyBoard)
    KeyBoardStdView keyBoardView;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @Override
    protected ChangePasswordPresenter createPresenter() {
        return new ChangePasswordPresenter();
    }


    private void init() {
        SoftInput.disable(edtOld);
        SoftInput.disable(edtNew);
        SoftInput.disable(edtConfirm);

        keyBoardView.setOnKeyboardListener(this);

    }


    @Override
    public void changePasswordSuccess() {
        CommonTools.goTo(ChangePasswordStdActivity.this, MainStdActivity.class);
        finish();
    }

    @OnClick(R.id.imgClose)
    public void onClickGoBack(View view) {
        finish();
    }

    @OnClick(R.id.btnChange)
    public void onClickChange(View view) {
        String oldPwd = edtOld.getText().toString();
        String newPwd = edtNew.getText().toString();
        String confirmPwd = edtConfirm.getText().toString();
        mPresenter.changePassword(oldPwd, newPwd, confirmPwd);
    }

    @Override
    public void onInsertKeyEvent(String text) {
        if (edtOld.isFocused()) {
            KeyBoardStdView.addChar(edtOld, text);
        } else if (edtNew.isFocused()) {
            KeyBoardStdView.addChar(edtNew, text);
        }else if (edtConfirm.isFocused()) {
            KeyBoardStdView.addChar(edtConfirm, text);
        }
    }

    @Override
    public void onDeleteKeyEvent() {
        if (edtOld.isFocused()) {
            KeyBoardStdView.deleteChar(edtOld);
        } else if (edtNew.isFocused()) {
            KeyBoardStdView.deleteChar(edtNew);
        }else if (edtConfirm.isFocused()) {
            KeyBoardStdView.deleteChar(edtConfirm);
        }
    }

    @Override
    public void onClearKeyEvent() {
        if (edtOld.isFocused()) {
            KeyBoardStdView.clearChar(edtOld);
        } else if (edtNew.isFocused()) {
            KeyBoardStdView.clearChar(edtNew);
        }else if (edtConfirm.isFocused()) {
            KeyBoardStdView.clearChar(edtConfirm);
        }
    }

    @Override
    public void onDoneKeyEvent() {

    }
}
