/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.std;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.preference.EditTextPreference;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceGroup;
import android.preference.PreferenceScreen;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatDelegate;

import com.hisense.common.util.DateUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.common.TemplateEditActivity;
import com.hisense.hiaposcmp.activity.common.UpLogActivity;
import com.hisense.hiaposcmp.boot.ActivityCollector;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.constant.device.DeviceType;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.AutoFlowLayout;
import com.hisense.hiaposcmp.view.FlowAdapter;
import com.hisense.hipos.template.models.PrintTemplateType;
import com.hisense.webapi.WebApi;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * 设置界面
 *
 * @author guolina  2019-12-30  新建标准版系统设置
 */

public class SettingStdActivity extends PreferenceActivity {

    /**
     * 会员的图标
     */
    @BindView(R.id.tvStdTitleVipIcon)
    TextView tvStdTitleVipIcon;

    /**
     * 正中的标题
     */
    @BindView(R.id.tvStdTitleItem)
    TextView mTvStdTitleItem;

    /**
     * 标题栏  时间
     */
    @BindView(R.id.tvStdTitleDate)
    TextView tvStdTitleDate;
    /**
     * 标题栏 门店名称
     */
    @BindView(R.id.tvStdTitleOrgName)
    TextView tvStdTitleOrgName;
    /**
     * 标题栏 营业员名称
     */
    @BindView(R.id.tvStdTitleCashierName)
    TextView tvStdTitleCashierName;
    /**
     * 会员登录(隐藏)
     */
    @BindView(R.id.tvStdTitleVipLogin)
    public TextView tvStdTitleVipLogin;

    /**
     * 切换会员(隐藏)
     */
    @BindView(R.id.tvStdTitleVipChange)
    TextView tvStdTitleVipChange;

    @BindView(R.id.tvTipSaleNo)
    TextView mTvTipSaleNo;

    List<String> settingTexts;
    @BindView(R.id.btnBack)
    Button btnBack;
    @BindView(R.id.aflSetting)
    AutoFlowLayout aflSetting;

    private LayoutInflater mLayoutInflater;

    private AppCompatDelegate delegate;
    int deviceInfoPosition;
    private Handler mScrollHandler = new Handler();


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        getDelegate().installViewFactory();
        getDelegate().onCreate(savedInstanceState);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_setting_std);
        ButterKnife.bind(this);

        addPreferencesFromResource(R.xml.setting_std);

        deviceInfoPosition = 0;
        findPreferencePosition("settingAll", getPreferenceScreen());
        mScrollHandler.postDelayed(mScrollRunner, 100);

        ActivityCollector.AddActivity(this);
        init();
        EditTextPreference interval = (EditTextPreference) findPreference(Config.PAPER_CURT_INTERVAL);
        interval.setSummary(interval.getText() + " 秒");
        interval.setOnPreferenceChangeListener((preference, newValue) -> {
            preference.setSummary(newValue + " 秒");
            return true;
        });

        EditTextPreference terminalId = (EditTextPreference) findPreference(GeneralSettings.Keys.TERMINAL_ID);
        terminalId.setSummary(terminalId.getText());
        terminalId.setOnPreferenceChangeListener((preference, newValue) -> {
            preference.setSummary(newValue.toString());
            return true;
        });

        EditTextPreference timeOfUpload = (EditTextPreference) findPreference(GeneralSettings.Keys.TIME_OF_UPLOAD);
        timeOfUpload.setSummary(timeOfUpload.getText());
        timeOfUpload.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object newValue) {
                preference.setSummary(newValue.toString());
                return true;
            }
        });
        //bindPreferenceSummary(GeneralSettings.Keys.TOTAL_REDUCTION_WAY, "%s", null);
        bindPreferenceSummary(GeneralSettings.Keys.RETURN_SALE_DAYS, "%s 天", null);
        bindPreferenceSummary(GeneralSettings.Keys.LOG_FILE_EXPIRED_DAYS, "%s 天", null);
        bindPreferenceSummary(GeneralSettings.Keys.RECEIPT_PRINT_BY_SHOP, "%s", R.array.receiptPrintType, R.array.receiptPrintTypeValues);
        bindPreferenceSummary(GeneralSettings.Keys.TIMEOUT, "%s 秒", null, null, (preference, newValue) -> {
            String value = (String) newValue;
            CommonTools.loginConfig(App.getInstance()).edit()
                    .putString(GeneralSettings.Keys.TIMEOUT, value)
                    .commit();
            WebApi.init(Config.getUrl(Config.base_url) + "/", Integer.parseInt(value), TimeUnit.SECONDS);
            return true;
        });

        // 设备类型
        bindPreferenceSummary(GeneralSettings.Keys.DEVICE_TYPE, "%s", R.array.deviceType, R.array.deviceTypeValues, null,
                (pre, newValue) -> {
                    // 如果选择的设备类型不支持当前的扫描器类型，则提示用户
                    if (!DeviceType.valueOf((String) newValue).isHI98() &&
                            GeneralSettings.INSTANCE.getScannerType().isLaser()) {
                        CommonTools.toastShort(String.format(Locale.CHINESE, "%s不支持%s",
                                getDeviceTypeName(DeviceType.valueOf((String) newValue)),
                                getResources().getStringArray(R.array.scannerTypeNames)[1]));
                        return false;
                    } else {
                        return true;
                    }
                });

        // 扫描器类型
//        bindPreferenceSummary(GeneralSettings.Keys.SCANNER_TYPE, "%s", R.array.scannerTypeNames, R.array.scannerTypeValues,
//                getResources().getStringArray(R.array.scannerTypeNames)[0], (preference, newValue) -> {
//                    // 如果选择的设备类型不支持当前的扫描器类型，则不允许修改配置项，同时提示用户
//                    if (getResources().getStringArray(R.array.scannerTypeValues)[1].equals(newValue) &&
//                            !GeneralSettings.INSTANCE.getDeviceType().isHI98()) {
//                        // 激光扫码+非HI98时，返回false
//                        CommonTools.toastShort(String.format(Locale.CHINESE, "%s不支持%s",
//                                getDeviceTypeName(),
//                                getResources().getStringArray(R.array.scannerTypeNames)[1]));
//                        return false;
//                    } else {
//                        return true;
//                    }
//                });

        // 打印字体大小
        bindPreferenceSummary(GeneralSettings.Keys.PRINTER_TEXT_SIZE, "%s",
                R.array.printer_text_size_entries, R.array.printer_text_size_values);

        // IC卡版本
        bindPreferenceSummary(GeneralSettings.Keys.IC_CARD_VERSION, "%s",
                R.array.cardVersion, R.array.cardVersionValues);

        // 计算精度
        bindPreferenceSummary(GeneralSettings.Keys.CURRENCY_PRECISION, "%s",
                R.array.currencyPrecision, R.array.currencyPrecisionValues);

        // 会员认证方式
        bindPreferenceSummary(GeneralSettings.Keys.AUTH_METHOD, "%s",
                R.array.authMethod, R.array.authMethodValues);

        // 支付通道
//        bindPreferenceSummary(GeneralSettings.Keys.PAYMENT_CHANNEL, "%s",
//                R.array.paymentChannel, R.array.paymentChannelValue);

        // 聚合支付通道
//        bindPreferenceSummary(GeneralSettings.Keys.AGGREGATE_PAYMENT_CHANNEL, "%s",
//                R.array.aggregatePayChannel, R.array.aggregatePayChannelValue);
    }

    private Runnable mScrollRunner = new Runnable() {
        public void run() {
            ListView lastView = getListView();
            // move to the visiable position.
            lastView.setItemChecked(deviceInfoPosition - 1, true);
            lastView.setSelection(deviceInfoPosition - 1);
        }
    };
    private Preference findPreferencePosition(CharSequence key,
                                              PreferenceGroup root) {
        if (key.equals(root.getKey())) {
            return root;
        } else {
            deviceInfoPosition++;
        }
        final int preferenceCount = root.getPreferenceCount();
        for (int i = 0; i < preferenceCount; i++) {
            final Preference preference = root.getPreference(i);
            final String curKey = preference.getKey();
            if (curKey != null && curKey.equals(key)) {
                return preference;
            }

            if (preference instanceof PreferenceGroup) {
                PreferenceGroup group = (PreferenceGroup) preference;
                final Preference returnedPreference = findPreferencePosition(
                        key, group);
                if (returnedPreference != null) {
                    return returnedPreference;
                }
            } else {
                deviceInfoPosition++;
            }
        }

        return null;
    }

    private void init() {
        mTvStdTitleItem.setText("设置");
        tvStdTitleVipLogin.setVisibility(View.GONE);
        tvStdTitleVipChange.setVisibility(View.GONE);
        tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
        tvStdTitleOrgName.setText(com.hisense.hipos.webapi.Context.orgName());
        tvStdTitleCashierName.setText(Config.user_name);
        tvStdTitleVipIcon.setVisibility(View.GONE);
        mTvTipSaleNo.setVisibility(View.GONE);

        mLayoutInflater = LayoutInflater.from(this);
        aflSetting.setDefSelected(0);
        settingTexts = Arrays.asList(new String[]{"通用设置", "交易设置", "促销设置", "支付设置", "退货设置", "打印设置", "储值卡/积分卡设置"});
        aflSetting.setAdapter(new FlowAdapter(settingTexts) {
            @Override
            public View getView(int position) {
                String settingText = settingTexts.get(position);

                View item = mLayoutInflater.inflate(R.layout.item_std_setting, null);
                TextView tvSetting = item.findViewById(R.id.tvSetting);
                tvSetting.setText(settingText);

                return item;
            }
        });
        aflSetting.setOnItemClickListener(new AutoFlowLayout.OnItemClickListener() {
            @Override
            public void onItemClick(int position, View view) {
                aflSetting.select();
                String settingText = settingTexts.get(position);

                LoggerUtils.getLogger().debug("settingText:" + settingText);
                showSetting(position);
            }
        });
        showSetting(0);

    }


    private void showSetting(int index) {
        deviceInfoPosition = 0;
        switch (index) {
            case 0:


                findPreferencePosition("settingAll", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);
                break;

            case 1:
                findPreferencePosition("settingSale", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

            case 2:
                findPreferencePosition("settingPromotion", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

            case 3:

                findPreferencePosition("settingPay", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);
                break;

            case 4:
                findPreferencePosition("settingReturn", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

            case 5:
                findPreferencePosition("settingPrint", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

            case 6:
                findPreferencePosition("settingCard", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

            case 7:
                findPreferencePosition("settingVip", getPreferenceScreen());
                mScrollHandler.postDelayed(mScrollRunner, 100);

                break;

        }
    }


    @OnClick({R.id.btnBack, R.id.linearStdTitleHome, R.id.aflSetting})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.btnBack:
            case R.id.linearStdTitleHome:
                finish();
                break;
            case R.id.aflSetting:
                break;
        }
    }

    @Override
    public boolean onPreferenceTreeClick(PreferenceScreen preferenceScreen, Preference preference) {
        if ("upLog".equals(preference.getKey())) {
            CommonTools.gotoActivity(UpLogActivity.class);
        } else if ("orgCode".equals(preference.getKey())) {
            Intent intent = new Intent(this, ConfigStdActivity.class);
            intent.putExtra("pos", 1);
            startActivity(intent);
        } else if ("shopCode".equals(preference.getKey())) {
            Intent intent = new Intent(this, ConfigStdActivity.class);
            intent.putExtra("pos", 2);
            startActivity(intent);
        } else if ("posNo".equals(preference.getKey())) {
            Intent intent = new Intent(this, ConfigStdActivity.class);
            intent.putExtra("pos", 3);
            startActivity(intent);
        }

        return super.onPreferenceTreeClick(preferenceScreen, preference);
    }

    /**
     * 返回设备名称。
     */
    private String getDeviceTypeName() {
        return getDeviceTypeName(GeneralSettings.INSTANCE.getDeviceType());
    }

    /**
     * 返回设备名称。
     *
     * @param deviceType 设备类型
     */
    private String getDeviceTypeName(DeviceType deviceType) {
        return getEntryNameByValue(deviceType.toString(),
                R.array.deviceType, R.array.deviceTypeValues);
    }

    /**
     * 返回配置项值 {@param value} 对应的名称。
     *
     * @param value       配置项的当前值
     * @param entries     配置项名称集合
     * @param entryValues 配置项的值集合
     * @return 配置项对应的名称
     */
    private String getEntryNameByValue(String value, int entries, int entryValues) {
        if (value != null) {
            for (int i = 0; i < App.getContext().getResources().getStringArray(entries).length; i++) {
                if (value.equals(App.getContext().getResources().getStringArray(entryValues)[i])) {
                    return App.getContext().getResources().getStringArray(entries)[i];
                }
            }
        }

        return "";
    }

    @Override
    protected void onResume() {
        super.onResume();
        setNumber(Config.ORG_CODE);
        setNumber(Config.SHOP_CODE);
        setNumber(Config.POS_NO);
    }

    /**
     * 设置门店号等
     *
     * @param key
     */
    private void setNumber(String key) {
        Preference preference = findPreference(key);
        final String value = CommonTools.loginConfig(this).getString(key, "");
        preference.setSummary(value);
    }

    /**
     * 绑定配置项说明。
     *
     * @param key    配置项的键
     * @param format 配置项说明的格式
     * @param values 配置项的值集合
     */
    private void bindPreferenceSummary(final String key, final String format, final Map<String, String> values) {
        this.bindPreferenceSummary(key, format, values, null, null);
    }

    /**
     * 绑定配置项说明。
     *
     * @param key         配置项的键
     * @param format      配置项说明的格式
     * @param entries     配置项名称集合
     * @param entryValues 配置项的值集合
     */
    private void bindPreferenceSummary(final String key, final String format, int entries, int entryValues) {
        this.bindPreferenceSummary(key, format, entries, entryValues, null, null);
    }

    /**
     * 绑定配置项说明。
     *
     * @param key          配置项的键
     * @param format       配置项说明的格式
     * @param entries      配置项名称集合
     * @param entryValues  配置项的值集合
     * @param defaultValue 配置项的默认值
     * @param listener     监听配置项变化的监听器
     */
    private void bindPreferenceSummary(final String key, final String format, int entries, int entryValues,
                                       final String defaultValue,
                                       final Preference.OnPreferenceChangeListener listener) {
        Map<String, String> map = new HashMap<>();
        for (int i = 0; i < App.getContext().getResources().getStringArray(entries).length; i++) {
            map.put(
                    App.getContext().getResources().getStringArray(entryValues)[i],
                    App.getContext().getResources().getStringArray(entries)[i]);
        }
        this.bindPreferenceSummary(key, format, map, defaultValue, listener);
    }

    /**
     * 绑定配置项说明。
     *
     * @param key          配置项的键
     * @param format       配置项说明的格式
     * @param values       配置项的键值图
     * @param defaultValue 配置项的默认值
     * @param listener     监听配置项变化的监听器
     */
    private void bindPreferenceSummary(final String key, final String format, final Map<String, String> values,
                                       final String defaultValue,
                                       final Preference.OnPreferenceChangeListener listener) {
        ListPreference preference = (ListPreference) findPreference(key);
        CharSequence entry = preference.getEntry();
        if (entry != null) {
            preference.setSummary(String.format(Locale.CHINESE, format, preference.getEntry()));
        } else {
            preference.setSummary(String.format(Locale.CHINESE, format, defaultValue));
        }

        preference.setOnPreferenceChangeListener((pre, newValue) -> {
            if (listener != null) {
                if (!listener.onPreferenceChange(pre, newValue)) {
                    return false;
                }
            }

            String value = (String) newValue;
            if (values != null) {
                value = values.get(newValue);
            }
            pre.setSummary(String.format(Locale.CHINESE, format, value));

            return true;
        });
    }

    /**
     * 编辑小票模板
     *
     * @param view 视图对象
     */
    public void editVoucherTemplate(View view) {
        enterEditTemplate(PrintTemplateType.Receipt);
    }

    /**
     * 编辑赠券模板
     *
     * @param view 视图对象
     */
    public void editCouponTemplate(View view) {
        enterEditTemplate(PrintTemplateType.Coupon);
    }

    /**
     * 编辑礼品券模板
     *
     * @param view 视图对象
     */
    public void editGiftCouponTemplate(View view) {
        enterEditTemplate(PrintTemplateType.GiftCoupon);
    }

    /**
     * 打开编辑票据模板页面
     *
     * @param type 模板类型
     */
    private void enterEditTemplate(PrintTemplateType type) {
        Intent intent = new Intent(this, TemplateEditActivity.class);
        intent.putExtra("type", type);
        startActivity(intent);
    }

    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        getDelegate().onPostCreate(savedInstanceState);
    }

    @Override
    public void setContentView(int layoutResID) {
        super.setContentView(layoutResID);
        getDelegate().setContentView(layoutResID);
    }

    @Override
    protected void onPostResume() {
        super.onPostResume();
        getDelegate().onPostResume();
    }

    @Override
    protected void onStop() {
        super.onStop();
        getDelegate().onStop();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        ActivityCollector.removeActivity(this);
        getDelegate().onDestroy();
    }

    /**
     * 获取 delegate 对象。
     *
     * @return delegate 对象
     */
    private AppCompatDelegate getDelegate() {
        if (delegate == null) {
            delegate = AppCompatDelegate.create(this, null);
        }
        return delegate;
    }
}
