package com.hisense.hiaposcmp.activity.std.pay;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.common.boot.SingleCallback;
import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.DateUtils;
import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.StartActivityService;
import com.hisense.hiaposcmp.activity.ysy.pay.CouponUseActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.OtherPayActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.ScrmCouponUseActivity;
import com.hisense.hiaposcmp.adapter.PayedMethodStdAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.layout.SoftInput;
import com.hisense.hiaposcmp.pos.payment.BocPaymentFactory;
import com.hisense.hiaposcmp.pos.payment.CcbPaymentFactory;
import com.hisense.hiaposcmp.pos.payment.IcbcPaymentFactory;
import com.hisense.hiaposcmp.pos.payment.UmsPaymentFactory;
import com.hisense.hiaposcmp.pos.payment.UnionCcbPaymentFactory;
import com.hisense.hiaposcmp.presenter.pay.PayPresenter;
import com.hisense.hiaposcmp.service.payment.AggregatePaymentChannel;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.tool.HomeWatcher;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.AutoFlowLayout;
import com.hisense.hiaposcmp.view.FlowAdapter;
import com.hisense.hiaposcmp.view.IView.pay.IPayView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;
import com.hisense.hiaposcmp.view.MoneyView;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.webapi.Callback;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 标准版支付页  HIAPOSCMP-455
 *
 * @author wangyaogang 2019-12-27 HIAPOSCMP-455 标准版支付功能开发
 * @author wangyaogang 2020-22-20 HIAPOSCMP-544 临时剔除无用支付方式
 */
@ActivityLayoutInject(R.layout.activity_pay_std)
public class PayStdActivity extends BaseMvpActivity<IPayView, PayPresenter> implements IPayView {

    /**
     * 会员的图标
     */
    @BindView(R.id.tvStdTitleVipIcon)
    TextView tvStdTitleVipIcon;

    /**
     * 所有支付方式
     */
    @BindView(R.id.afl_pay_method)
    AutoFlowLayout mAflPayMethod;
    /**
     * 已支付列表
     */
    @BindView(R.id.rcv_payed)
    RecyclerView mRcvPayed;
    /**
     * 正中的标题
     */
    @BindView(R.id.tvStdTitleItem)
    TextView mTvStdTitleItem;

    @BindView(R.id.linearStdTitleHome)
    LinearLayout linearStdTitleHome;

    /**
     * 输入金额
     */
    @BindView(R.id.et_input_amount)
    MoneyView mEtInputAmount;

    /**
     * 快结金额列表
     */
    @BindView(R.id.afl_cash_list)
    AutoFlowLayout mAflCashList;
    /**
     * 自定义键盘
     */
    @BindView(R.id.edt_pay_keyboard)
    KeyBoardStdView mEdtPayKeyboard;
    /**
     * 标题栏  时间
     */
    @BindView(R.id.tvStdTitleDate)
    TextView tvStdTitleDate;
    /**
     * 标题栏 流水号
     */
    @BindView(R.id.tvStdTitleSaleNo)
    TextView tvStdTitleSaleNo;
    /**
     * 标题栏 门店名称
     */
    @BindView(R.id.tvStdTitleOrgName)
    TextView tvStdTitleOrgName;
    /**
     * 标题栏 营业员名称
     */
    @BindView(R.id.tvStdTitleCashierName)
    TextView tvStdTitleCashierName;
    /**
     * 会员登录(隐藏)
     */
    @BindView(R.id.tvStdTitleVipLogin)
    public TextView tvStdTitleVipLogin;

    /**
     * 会员信息父布局
     */
    @BindView(R.id.linearStdTitleVipInfo)
    public LinearLayout linearStdTitleVipInfo;
    /**
     * 会员名
     */
    @BindView(R.id.tvStdTitleVipName)
    TextView tvStdTitleVipName;
    /**
     * 会员类别
     */
    @BindView(R.id.tvStdTitleVipLevel)
    TextView tvStdTitleVipLevel;
    /**
     * 会员生日
     */
    @BindView(R.id.tvStdTitleVipBirth)
    TextView tvStdTitleVipBirth;
    /**
     * 积分
     */
    @BindView(R.id.tvStdTitlePoints)
    TextView tvStdTitlePoints;
    /**
     * 余额
     */
    @BindView(R.id.tvStdTitleBalance)
    TextView tvStdTitleBalance;
    /**
     * 切换会员(隐藏)
     */
    @BindView(R.id.tvStdTitleVipChange)
    TextView tvStdTitleVipChange;
    /**
     * 右侧 返回交易
     */
    @BindView(R.id.ll_pay_back)
    LinearLayout mLlPayBack;
    /**
     * 应收金额
     */
    @BindView(R.id.tv_ys_amount)
    TextView mTvYsAmount;
    /**
     * 合计金额
     */
    @BindView(R.id.tv_total_amount)
    TextView mTvTotalAmount;
    /**
     * 优惠金额
     */
    @BindView(R.id.tv_discount_amount)
    TextView mTvDiscountAmount;
    /**
     * 找零
     */
    @BindView(R.id.tv_change_amount)
    TextView mTvChangeAmount;
    /**
     * 底部撤销支付
     */
    @BindView(R.id.ll_pay_cancel)
    LinearLayout mLlPayCancel;
    /**
     * 未付金额
     */
    @BindView(R.id.tv_unpayed_amount)
    TextView mTvUnpayedAmount;
    /**
     * 已付金额
     */
    @BindView(R.id.tv_payed_amount)
    TextView mTvPayedAmount;

    /**
     * 快速选择金额
     */
    private String[] fastSelectNum = {"50", "100", "200", "500"};

    private ArrayList<SalePayModel> mSalePayItems;//支付信息
    private PayedMethodStdAdapter mPayedMethodStdAdapter;//已支付信息适配器

    private boolean mVipServiceCalled = false;
    private volatile boolean hasCanceled;//是否点击过取消

    private Context mContext;
    private HomeWatcher mHomeWatcher;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        LoggerUtils.getLogger().debug("----------onCreate-----------PayStdActivity----------");
        //记录当前处于支付过程中
        mContext = this;
        App.getInstance().isPaying = true;

        init();
        initPayMethod();
        initPresenter();
        initPayedList();
        initFastPaySelect();
        updateTotal();
        initValue();
    }

    private final BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action != null && action.equals(Intent.ACTION_TIME_TICK)) {
                tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
            }
        }
    };

    private void initValue() {
        IntentFilter filter = new IntentFilter();
        filter.addAction(Intent.ACTION_TIME_TICK);
        registerReceiver(receiver, filter);

        tvStdTitleVipLogin.setVisibility(View.GONE);
        tvStdTitleVipChange.setVisibility(View.GONE);
        tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
        tvStdTitleOrgName.setText(com.hisense.hipos.webapi.Context.orgName());
        tvStdTitleCashierName.setText(Config.user_name);
        tvStdTitleSaleNo.setText(mPresenter.getSale().getSaleNo());
        updateVipInfo(mPresenter.getSale().getVip());

        //如果全场收银或登录为会员，则进行满减
       /* if ((GeneralSettings.INSTANCE.isNoShopLimits() || mPresenter.getSale().allowTotalDsc()) &&
                GeneralSettings.INSTANCE.allowTotalDiscount() &&
                "商品优惠".equals(GeneralSettings.INSTANCE.getTotalDiscountWay())) {
            mPresenter.saleTotalReduction();
        } else {
            mPresenter.abandonFenDsc();
        }*/
    }

    private void updateVipInfo(Vip vip) {
        if (vip == null) {
            tvStdTitleVipIcon.setVisibility(View.GONE);
            return;
        }
        linearStdTitleVipInfo.setVisibility(View.VISIBLE);

        tvStdTitleVipName.setText(vip.name());
        tvStdTitleVipLevel.setText(vip.card().cardType().name());
        tvStdTitleVipBirth.setText(vip.birthday());

        String points = "0";
        String balance = "0";
        if (vip.projects().size() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.projects().get(0).usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.projects().get(0).usableBalance());

        } else if (vip.card() != null && vip.card().usablePoints() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.card().usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.card().usableBalance());

        }

        tvStdTitlePoints.setText(points);
        tvStdTitleBalance.setText(balance);
    }

    private void initPresenter() {
        mPresenter.initMiYaConfig();
        mPresenter.initYstConfig();
    }

    private void init() {
        isNotShowExitDialog(true);

        mTvStdTitleItem.setText("支付");
        linearStdTitleHome.setVisibility(View.INVISIBLE);

        //右侧金额输入框,屏蔽系统键盘,使用自定义
        SoftInput.disable(mEtInputAmount);
        mEdtPayKeyboard.setOnKeyboardListener(new KeyBoardStdView.OnKeyboardListener() {
            @Override
            public void onInsertKeyEvent(String text) {
                KeyBoardStdView.addChar(mEtInputAmount, text);
            }

            @Override
            public void onDeleteKeyEvent() {
                KeyBoardStdView.deleteChar(mEtInputAmount);
            }

            @Override
            public void onClearKeyEvent() {
                KeyBoardStdView.clearChar(mEtInputAmount);
            }

            @Override
            public void onDoneKeyEvent() {

            }
        });

        mEtInputAmount.setText(mTvUnpayedAmount.getText());
        mEtInputAmount.requestFocus();
        mEtInputAmount.setSelection(mEtInputAmount.length());

        //点击home按键
        mHomeWatcher = new HomeWatcher(this);
        mHomeWatcher.setOnHomePressedListener(new HomeWatcher.OnHomePressedListener() {
            @Override
            public void onHomePressed() {
                if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                    return;
                }

                mPresenter.cancelPayFinish();
            }

            @Override
            public void onHomeLongPressed() {
                if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                    return;
                }

                mPresenter.cancelPayFinish();
            }
        });

        mHomeWatcher.startWatch();
    }

    /**
     * 初始化 快结的选择内容
     */
    private void initFastPaySelect() {
        mAflCashList.setAdapter(new FlowAdapter(Arrays.asList(fastSelectNum)) {
            @Override
            public View getView(int position) {
                View item = LayoutInflater.from(mContext).inflate(R.layout.item_std_cash_select, null);
                TextView tvCashSelect = item.findViewById(R.id.tv_cash_select);
                tvCashSelect.setText("¥" + fastSelectNum[position]);
                return item;
            }
        });
        mAflCashList.setOnItemClickListener(new AutoFlowLayout.OnItemClickListener() {
            @Override
            public void onItemClick(int position, View view) {
                TextView tvCashSelect = view.findViewById(R.id.tv_cash_select);
                String inputMoney = tvCashSelect.getText().toString().replace("¥", "");
                LoggerUtils.getLogger().debug("快结点击了:" + inputMoney);
                mAflCashList.select();
                mEtInputAmount.setText(inputMoney);
            }
        });
    }

    /**
     * 初始化 所有支付方式
     */
    private void initPayMethod() {
        showLoadingDialog();
        PayMethodService.getAll(mContext, new Callback<List<PayMethod>>() {
            @Override
            public void onSuccess(List<PayMethod> payMethods) {
                List<PayMethod> supportedMethods = new ArrayList<>();
                for (PayMethod payMethod : payMethods) {
                    if (payMethod.isCash() || payMethod.isWxPay() || payMethod.isAliPay()
                            || payMethod.isCardType() || payMethod.isCardByPayType()
                            || payMethod.isPointsType() || payMethod.isRemainType()) {
                        supportedMethods.add(payMethod);
                    }
                }

                mAflPayMethod.setAdapter(new FlowAdapter(supportedMethods) {
                    @Override
                    public View getView(int position) {
                        PayMethod method = supportedMethods.get(position);

                        View item = LayoutInflater.from(mContext).inflate(R.layout.item_std_pay_method, null);
                        TextView tvPaymethod = item.findViewById(R.id.tv_paymethod);
                        tvPaymethod.setText(method.name());

                        ImageView ivPaymethod = item.findViewById(R.id.iv_paymethod);
                        ivPaymethod.setImageDrawable(ContextCompat.getDrawable(mContext, PayMethodService.getIconByCode(method)));
                        return item;
                    }
                });
                mAflPayMethod.setOnItemClickListener(new AutoFlowLayout.OnItemClickListener() {
                    @Override
                    public void onItemClick(int position, View view) {
                        String inputMoney = mEtInputAmount.getText().toString();
                        if (StringUtils.isEmpty(inputMoney)) {
                            mAflPayMethod.reset();
                            showHintDialog("请输入支付金额");
                            return;
                        }
                        if (BigDecimalUtils.isEquals0(inputMoney)) {
                            mAflPayMethod.reset();
                            showHintDialog("支付金额不允许为0");
                            return;
                        }

                        mAflPayMethod.select();
                        PayMethod method = supportedMethods.get(position);
                        LoggerUtils.getLogger().debug("Pay支付方式:" + method);
                        PayMethodService.updateFrequency(mContext, method);
                        mPresenter.payStd(method);
                    }
                });
                hideLoadingDialog();
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
            }
        });

    }

    /**
     * 左侧已支付列表,
     * 需要数据源,刷新页面
     */
    private void initPayedList() {
        LinearLayoutManager layoutManager = new LinearLayoutManager(this);
        layoutManager.setOrientation(LinearLayoutManager.VERTICAL);
        mSalePayItems = new ArrayList<>();
        mSalePayItems.addAll(getSale().getPays());
        mPayedMethodStdAdapter = new PayedMethodStdAdapter(this, mSalePayItems);
        mPayedMethodStdAdapter.setOnItemClickListener(new PayedMethodStdAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(View view, int position) {
                if (isFastClick()) {
                    LoggerUtils.getLogger().debug("支付列表_快速点击:" + position);
                    return;
                }
                LoggerUtils.getLogger().debug(position + "单笔撤销点击:" + getSale().getPays().get(position));
                mPresenter.cancelStdSinglePay(position);
            }
        });
        mRcvPayed.setLayoutManager(layoutManager);
        mRcvPayed.setAdapter(mPayedMethodStdAdapter);
    }

    public void updateAdapter() {
        if (mPayedMethodStdAdapter != null) {
            mPayedMethodStdAdapter.setData(mPresenter.getSale().getPays());
            mPayedMethodStdAdapter.notifyDataSetChanged();
        }
    }

    @Override
    protected PayPresenter createPresenter() {
        return new PayPresenter();
    }

    @Override
    public void whenPayDone() {

    }

    @Override
    public void gotoScanActivity() {

    }

    @Override
    public void afterPaySuccess(Bundle bundle) {
        LoggerUtils.getLogger().debug("找零:" + getSale().getTotalChange());
        if (mPresenter.selectedPayMethod().isCash() && BigDecimalUtils.isGreater0(getSale().getTotalChange())) {
            showHintDialog(String.format("找零%s元", getSale().getTotalChange()), new SingleCallback() {
                @Override
                public void onSuccess(String msg) {
                    backToSale();
                }
            });
        } else {
            backToSale();
        }
    }

    private void backToSale() {
        mLlPayCancel.setEnabled(false);

        Intent intent = new Intent();
        this.setResult(ActivityConstants.RESULT_SALE_TO_PAY, intent);
        this.finish();
    }

    @Override
    public void afterPayFailure(String msg) {

    }

    @Override
    public void gotoCouponUseActivity() {
        //todo 暂使用原来的,不适配
        if (!ListUtils.isEmpty(mPresenter.getSale().getPays())) {
            for (SalePayModel payModel : mPresenter.getSale().getPays()) {
                if (PayMethod.isVipCoupon(payModel.getRemark())) {
                    showHintDialog("请勿重复使用会员券支付");
                    return;
                }
            }
        }
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", mPresenter.selectedPayMethod());

        Intent intent = new Intent();
        intent.setClass(mContext, CouponUseActivity.class);
        intent.putExtras(bundle);
        startActivityForResult(intent, ActivityConstants.REQUEST_PAY_TO_COUPON);
    }

    @Override
    public void gotoScrmCouponActivity() {
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", mPresenter.selectedPayMethod());

        Intent intent = new Intent();
        intent.setClass(mContext, CouponQueryStdActivity.class);
        intent.putExtras(bundle);
        startActivityForResult(intent, ActivityConstants.REQUEST_SCRM_COUPON_USE);
    }

    @Override
    public void gotoCardPayActivity() {
        //储值卡刷卡
        StartActivityService.gotoCardPayActivity(PayStdActivity.this, mPresenter.selectedPayMethod(), null, "");
    }

    @Override
    public void gotoPointsPayActivity() {
        //积分卡分支
        StartActivityService.gotoPointsPayActivity(PayStdActivity.this, mPresenter.selectedPayMethod(), null, "0");
    }

    @Override
    public void gotoOtherPayActivity() {
        //todo 暂使用原来的,不适配
        String totalUnpaid = mEtInputAmount.getText().toString();
        if (BigDecimalUtils.isGreater(totalUnpaid, getSale().getTotalUnPaid())) {
            totalUnpaid = getSale().getTotalUnPaid();
        }
        Intent intent = new Intent();
        intent.putExtra("total_unpaid", totalUnpaid);
        intent.setClass(mContext, OtherPayActivity.class);
        startActivityForResult(intent, ActivityConstants.REQUEST_OTHER_PAYMETHOD);
    }

    @Override
    public void gotoPayChannel(String totalPaid) {
        if (StringUtils.isEmpty(mEtInputAmount.getText().toString())) {
            showHintDialog("请输入支付金额");
            return;
        }
        if (BigDecimalUtils.isEquals0(mEtInputAmount.getText().toString())) {
            showHintDialog("支付金额不允许为0");
            return;
        }
        if (mPresenter.selectedPayMethod().isCash()) {
            String inputMoney = mEtInputAmount.getText().toString();
            if (BigDecimalUtils.isLessAndEquals(inputMoney, getSale().getTotalUnPaid())) {
                showHintConfirm(String.format("使用现金支付%s元?", inputMoney), new UniCallback() {
                    @Override
                    public void onSuccess(String msg) {
                        LoggerUtils.getLogger().debug(totalPaid + ":确认使用现金支付:" + inputMoney);
                        mPresenter.cashPay(inputMoney);
                    }

                    @Override
                    public void onError(String err) {
                        LoggerUtils.getLogger().debug(totalPaid + ":取消使用现金支付:" + inputMoney);
                    }
                });
            } else {
                LoggerUtils.getLogger().debug(totalPaid + ":使用现金支付:" + inputMoney);
                mPresenter.cashPay(inputMoney);
            }
            return;
        }
        IPaymentProvider paymentProvider;
        try {
            paymentProvider = getStdPaymentProvider(this, mPresenter.selectedPayMethod().remark());
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("获取支付提供程序失败：" + e.toString());
            showHintDialog("暂未支持该支付方式");
            return;
        }

        if (paymentProvider != null) {
            LoggerUtils.getLogger().debug("获取支付提供程序paymentProvider != null");
            showHintDialog("暂未支持该支付方式");
            return;
        }
        if (mPresenter.selectedPayMethod().isAllInPayType()
                || mPresenter.selectedPayMethod().isAllOrChannelType()
                || mPresenter.selectedPayMethod().isAllInPayByPayType()) {
            LoggerUtils.getLogger().debug("使用该支付方式:" + mPresenter.selectedPayMethod());
            StartActivityService.gotoIntePayActivity(PayStdActivity.this, mPresenter.selectedPayMethod(), mEtInputAmount.getText().toString());
        } else {
            showHintDialog("暂未支持该支付方式");
        }
    }

    /**
     * 暂时使用这种方式 屏蔽掉 收单行的支付
     */
    private IPaymentProvider getStdPaymentProvider(Activity activity, String payMethodRemark) {
        IPaymentProvider paymentProvider;

        /*if (!AggregatePaymentChannel.isCHANNEL()) {
            if (PayMethod.isAliPay(payMethodRemark) || PayMethod.isWxPay(payMethodRemark)) {
                return null;
            }
        }*/
        if (PayMethod.isAliPay(payMethodRemark) || PayMethod.isWxPay(payMethodRemark)) {
            return null;
        }
        // 银联商务
        paymentProvider = UmsPaymentFactory.createProvider(activity, payMethodRemark);
        if (paymentProvider != null) {
            return paymentProvider;
        }

        // 建行收单
        paymentProvider = UnionCcbPaymentFactory.createProvider(activity, payMethodRemark);
        if (paymentProvider != null) {
            return paymentProvider;
        }

        paymentProvider = CcbPaymentFactory.createProvider(activity, payMethodRemark);
        if (paymentProvider != null) {
            return paymentProvider;
        }

        //工行
        paymentProvider = IcbcPaymentFactory.createProvider(activity, payMethodRemark);
        if (paymentProvider != null) {
            return paymentProvider;
        }

        //中行
        paymentProvider = BocPaymentFactory.createProvider(activity, payMethodRemark);
        return paymentProvider;
    }

    private void payChannelAfterDialog(String totalPaid, String scanCode) {
        if (mPresenter.selectedPayMethod().isAllInPayType()) {
            LoggerUtils.getLogger().debug("海信全支付打开扫描");
            hxPay(totalPaid, scanCode);
            return;
        }
        if (mPresenter.selectedPayMethod().isAllOrChannelType()) {
            if (CommonUtils.isStdStyle()) {
                LoggerUtils.getLogger().debug("标准版默认海信支付打开扫描");
                hxPay(totalPaid, scanCode);
                return;
            }
            if (AggregatePaymentChannel.isYST()) {
                LoggerUtils.getLogger().debug("赢商通支付打开扫描");
                mPresenter.payYst(scanCode, totalPaid);
            } else if (AggregatePaymentChannel.isMIYA()) {
                LoggerUtils.getLogger().debug("米雅支付打开扫描");
                mPresenter.payMiYa(scanCode, totalPaid);
            } else if (AggregatePaymentChannel.isHXPAY()) {
                LoggerUtils.getLogger().debug("海信支付打开扫描");
                hxPay(totalPaid, scanCode);
            }
        } else if (mPresenter.selectedPayMethod().isAllInPayByPayType()) {
            LoggerUtils.getLogger().debug("海信在线支付打开扫描");
            hxPay(totalPaid, scanCode);
        } else {
            showHintDialog("暂未支持该支付方式");
        }
    }

    private void hxPay(String totalPaid, String scanCode) {
        mPresenter.updatePayAmount(totalPaid);
        mPresenter.payPay(scanCode);
    }

    @Override
    public void updateTotal() {
        mAflCashList.reset();
        mTvTotalAmount.setText(mPresenter.getSale().getTotalRecv());                  //合计
        mTvYsAmount.setText(mPresenter.getSale().getTotalRecv());                     //应收
        mTvUnpayedAmount.setText(mPresenter.getSale().getTotalUnPaid());              //未付
        mTvPayedAmount.setText(mPresenter.getSale().getTotalPaid());                  //已付
        mEtInputAmount.setText(mPresenter.getSale().getTotalUnPaid());                //需付
        mTvDiscountAmount.setText(mPresenter.getSale().getTotalDsc());                //优惠
        mTvChangeAmount.setText(mPresenter.getSale().getTotalChange());               //找零

        mEtInputAmount.setSelection(mEtInputAmount.length());

        if (mPresenter.getSale().hasAlreadyPaid()) {
            mLlPayCancel.setEnabled(true);
        }
    }

    @Override
    public void paySuccess(SalePayModel payModel) {
        if (payModel == null) {
            updateTotal();
            return;
        }
//        PayFinishedActivity.afterPay(PayStdActivity.this, ActivityConstants.REQUEST_PAY_FINISHED);
        mSalePayItems.add(payModel);
        mPayedMethodStdAdapter.notifyDataSetChanged();
    }

    @Override
    public void gotoCancelPayChannel(SalePayModel payModel) {
        hideLoadingDialog();
    }

    @Override
    public void cancelPaySuccess(SalePayModel payModel) {

        mSalePayItems.remove(payModel.getSerialNo() - 1);
        mPayedMethodStdAdapter.notifyDataSetChanged();
    }

    @Override
    public void cancelPayError() {

    }

    @Override
    public void cancelPayFinish() {
        Intent intent = new Intent();
        intent.putExtra("isVipServiceCalled", mVipServiceCalled);
        this.setResult(RESULT_CANCELED, intent);
        this.finish();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME || keyCode == KeyEvent.KEYCODE_MENU) {
            if (mSalePayItems.size() > 0) {
                showHintDialog("已经进行了支付，不能返回");
                return false;
            }
            mPresenter.cancelPayFinish();
        }

        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if ((requestCode == ActivityConstants.REQUEST_PAY_TO_CARD && resultCode == ActivityConstants.RESULT_PAY_TO_CARD_SUCCESS) ||
                (requestCode == ActivityConstants.REQUEST_PAY_TO_POINTS && resultCode == ActivityConstants.RESULT_PAY_TO_POINTS_SUCCESS)) {
            mVipServiceCalled = true;

            mPresenter.paySuccess();
            LoggerUtils.getLogger().debug("标准版-储值卡支付成功");
        } else if (requestCode == ActivityConstants.REQUEST_PAY_TO_COUPON && resultCode == ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS) {
            mPresenter.paySuccess();
        } else if (requestCode == ActivityConstants.REQUEST_OTHER_PAYMETHOD && resultCode == ActivityConstants.RESULT_OTHER_PAYMETHOD) {
            mPresenter.paySuccess();
        } else if (requestCode == ActivityConstants.REQUEST_SCRM_COUPON_USE && resultCode == ActivityConstants.RESULT_VIP_COUPON_CALCULATE) {
            if (data != null) {
                Intent intent = new Intent();
                intent.putExtra("vipCardNo", data.getStringExtra("vipCardNo"));
                intent.setClass(this, ScrmCouponUseActivity.class);
                startActivityForResult(intent, ActivityConstants.REQUEST_SCRM_COUPON_ADDITION);
            }
        } else if (requestCode == ActivityConstants.REQUEST_SCRM_COUPON_ADDITION && resultCode == ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS) {
            mPresenter.paySuccess();
        } else if (requestCode == ActivityConstants.REQUEST_INTE_PAY_INPUT && resultCode == ActivityConstants.RESULT_NTE_PAY_SUCCESS) {
            if (data != null) {
                String inputMoney = data.getStringExtra("inputMoney");
                String payNo = data.getStringExtra("payNo");
                LoggerUtils.getLogger().debug("标准版-聚合支付成功返回:" + inputMoney + "||" + payNo);
                payChannelAfterDialog(inputMoney, payNo);
            }
        }

        updateAdapter();
        updateTotal();
        super.onActivityResult(requestCode, resultCode, data);
    }

    @OnClick({R.id.ll_pay_back, R.id.ll_pay_cancel, R.id.linearStdTitleHome})
    public void onViewClicked(View view) {
        if (isFastClick()) {
            LoggerUtils.getLogger().debug("返回或者取消 ,快速点击");
            return;
        }
        switch (view.getId()) {
            case R.id.ll_pay_back: {
                if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                } else {
                    mPresenter.cancelPayFinish();
                }
            }
            break;
            case R.id.ll_pay_cancel: {
                try {
                    if (hasCanceled) {
                        return;
                    }
                    LoggerUtils.getLogger().debug("点击取消交易");
                    executeAnimation(mLlPayCancel);
                    hasCanceled = true;
                    mPresenter.cancelPay();
                } finally {
                    hasCanceled = false;
                }
            }
            break;
            case R.id.linearStdTitleHome: {
                //todo  暂不响应 跳转首页按钮
               /* if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                    return;
                }
                CommonTools.goToWithFinishMe(PayStdActivity.this, MainStdActivity.class);*/
            }
            break;
            default:
                break;
        }
    }

    @Override
    protected void onStart() {
        LoggerUtils.getLogger().debug("----------onStart-----------PayStdActivity----------");
        super.onStart();
    }

    @Override
    protected void onResume() {
        LoggerUtils.getLogger().debug("----------onResume-----------PayStdActivity----------");
        super.onResume();
    }

    @Override
    protected void onPause() {
        LoggerUtils.getLogger().debug("----------onPause-----------PayStdActivity----------");
        super.onPause();
    }

    @Override
    protected void onStop() {
        LoggerUtils.getLogger().debug("----------onStop-----------PayStdActivity----------");
        super.onStop();
    }

    @Override
    protected void onDestroy() {
        LoggerUtils.getLogger().debug("----------onDestroy-----------PayStdActivity----------");
        //记录当前不处于支付过程中
        App.getInstance().isPaying = false;
        unregisterReceiver(receiver);
        mHomeWatcher.stopWatch();
        super.onDestroy();
    }

    @Override
    public void setIsClickPayFalse() {
        //标准版不需要实现
    }

}
