package com.hisense.hiaposcmp.activity.std.refund;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.InputType;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.DateUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.std.MainStdActivity;
import com.hisense.hiaposcmp.activity.ysy.refund.viewModel.ReturnItemViewModel;
import com.hisense.hiaposcmp.adapter.OnRecyclerItemClickListener;
import com.hisense.hiaposcmp.adapter.ReturnItemStdAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.boot.WrapContentLinearLayoutManager;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.presenter.refund.SaleReturnPresenter;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.refund.ISaleReturnView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;
import com.hisense.hipos.model.ReturnSaleModel;
import com.hisense.hipos.model.ReturnSalePluModel;
import com.hisense.pos.scanner.IScanner;

import java.io.File;

import OnePlusOneAndroidSDK.ScalesOS.ScalesSDK;
import OnePlusOneAndroidSDK.ScalesOS.WeightInfo;
import butterknife.BindView;
import butterknife.OnClick;
import butterknife.OnTextChanged;

/**
 * 标准版退款页  	HIAPOSCMP-487
 *
 * @author xieliyan 2019-01-07 	HIAPOSCMP-487 标准版退款功能开发
 * @author xieliyan 2019-01-07 	HIAPOSCMP-521 修复调整商品数量，右侧合计金额更新的问题
 */
@ActivityLayoutInject(R.layout.activity_return_std)
public class ReturnStdActivity extends BaseMvpActivity<ISaleReturnView, SaleReturnPresenter> implements ISaleReturnView, KeyBoardStdView.OnKeyboardListener {
    /**
     * 右侧 返回交易
     */
    @BindView(R.id.llReturnBack)
    LinearLayout mLlReturBack;

    /**
     * 会员的图标
     */
    @BindView(R.id.tvStdTitleVipIcon)
    TextView tvStdTitleVipIcon;

    /**
     * 正中的标题
     */
    @BindView(R.id.tvStdTitleItem)
    TextView mTvStdTitleItem;

    /**
     * 标题栏  时间
     */
    @BindView(R.id.tvStdTitleDate)
    TextView tvStdTitleDate;
    /**
     * 标题栏 流水号
     */
    @BindView(R.id.tvStdTitleSaleNo)
    TextView tvStdTitleSaleNo;
    /**
     * 标题栏 门店名称
     */
    @BindView(R.id.tvStdTitleOrgName)
    TextView tvStdTitleOrgName;
    /**
     * 标题栏 营业员名称
     */
    @BindView(R.id.tvStdTitleCashierName)
    TextView tvStdTitleCashierName;
    /**
     * 会员登录(隐藏)
     */
    @BindView(R.id.tvStdTitleVipLogin)
    public TextView tvStdTitleVipLogin;

    /**
     * 会员信息父布局
     */
    @BindView(R.id.linearStdTitleVipInfo)
    public LinearLayout linearStdTitleVipInfo;
    /**
     * 会员名
     */
    @BindView(R.id.tvStdTitleVipName)
    TextView tvStdTitleVipName;
    /**
     * 会员类别
     */
    @BindView(R.id.tvStdTitleVipLevel)
    TextView tvStdTitleVipLevel;
    /**
     * 会员生日
     */
    @BindView(R.id.tvStdTitleVipBirth)
    TextView tvStdTitleVipBirth;
    /**
     * 积分
     */
    @BindView(R.id.tvStdTitlePoints)
    TextView tvStdTitlePoints;
    /**
     * 余额
     */
    @BindView(R.id.tvStdTitleBalance)
    TextView tvStdTitleBalance;
    /**
     * 切换会员(隐藏)
     */
    @BindView(R.id.tvStdTitleVipChange)
    TextView tvStdTitleVipChange;


    @BindView(R.id.imgViewAllSelect)
    public ImageView mImgViewAllSelect;

    @BindView(R.id.rvReturnStdPluList)
    public RecyclerView mRvReturnStdPluList;


    @BindView(R.id.edtReturnBoardShow)
    public EditText mEdtReturnBoardShow;

    @BindView(R.id.keyBrdReturnKeyBoard)
    public KeyBoardStdView mKeyBrdReturnKeyBoard;

    @BindView(R.id.btnReturnBoardShowClear)
    public Button mBtnReturnBoardShowClear;


    @BindView(R.id.tvReturnCount)
    public TextView mTvReturnCount;

    @BindView(R.id.tvTotalCount)
    public TextView mTvTotalCount;

    @BindView(R.id.tvReturnTotalRefund)
    public TextView mTvReturnTotalRefund;
    @BindView(R.id.linearStdTitleHome)
    LinearLayout mLinearStdTitleHome;

    @BindView(R.id.tvReturnTotalRecv)
    public TextView mTvReturnTotalRecv;

    /**
     * 称重模块
     */
    @BindView(R.id.stdScalesRadioBtnIsBalance)
    public RadioButton stdScalesRadioBtnIsBalance;
    @BindView(R.id.stdScalesRadioBtnIsZero)
    public RadioButton stdScalesRadioBtnIsZero;
    @BindView(R.id.stdScalesRadioBtnIsTare)
    public RadioButton stdScalesRadioBtnIsTare;
    @BindView(R.id.stdScalesTvNet)
    public TextView stdScalesTvNet;
    @BindView(R.id.stdScalesTvTare)
    public TextView stdScalesTvTare;
    @BindView(R.id.stdScalesTvPrice)
    public TextView stdScalesTvPrice;
    @BindView(R.id.stdScalesTvTotal)
    public TextView stdScalesTvTotal;
    @BindView(R.id.stdScalesTvPluName)
    public TextView stdScalesTvPluName;

    private ReturnItemStdAdapter mReturnItemStdAdapter;
    /**
     * 是否点击退货按钮
     */
    private volatile boolean hasReturned;

    private ScalesSDK mscalessdk;
    private boolean open = false;
    private ReturnItemViewModel pluModelTemp = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mPresenter.saveAuthNo();
        mainSaleModel.returnSaleModel(null);
        initTitle();
        init();

        initPluAdapter();
        updateVip(null);
    }

    @Override
    protected SaleReturnPresenter createPresenter() {
        return new SaleReturnPresenter();
    }

    private void init() {
        mTvStdTitleItem.setText("退货");
        mLinearStdTitleHome.setVisibility(View.INVISIBLE);
        isNotShowExitDialog(true);
        mEdtReturnBoardShow.setText(SaleNoService.getMax(this, Config.org_code, Config.pos_no));
        mEdtReturnBoardShow.setSelection(mEdtReturnBoardShow.length());
        mEdtReturnBoardShow.requestFocus();
        mEdtReturnBoardShow.setInputType(InputType.TYPE_NULL);
        tvStdTitleSaleNo.setText(mEdtReturnBoardShow.getText().toString());
        mKeyBrdReturnKeyBoard.setOnKeyboardListener(this);
    }


    private final BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action != null && action.equals(Intent.ACTION_TIME_TICK)) {
                tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
            }
        }
    };

    private void initTitle() {
        IntentFilter filter = new IntentFilter();
        filter.addAction(Intent.ACTION_TIME_TICK);
        registerReceiver(receiver, filter);
        tvStdTitleVipLogin.setVisibility(View.GONE);
        tvStdTitleVipChange.setVisibility(View.GONE);
        tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
        // tvStdTitleOrgName.setText(mainSaleModel.getShopInfo().getOrgName());
        tvStdTitleCashierName.setText(Config.user_name);
    }

    private void initPluAdapter() {
        mRvReturnStdPluList.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        mReturnItemStdAdapter = new ReturnItemStdAdapter(mRvReturnStdPluList, mPresenter.saleItem());
        mRvReturnStdPluList.setAdapter(mReturnItemStdAdapter);
        mReturnItemStdAdapter.setOnItemClickListener((view, viewName, position) -> processViewClick(viewName, position));

        //防崩溃java.lang.IndexOutOfBoundsException: Inconsistency detected（自带bug）
        mRvReturnStdPluList.setLayoutManager(new WrapContentLinearLayoutManager(this, LinearLayoutManager.VERTICAL, false));
    }

    /**
     * 返回
     */
    @OnClick(R.id.llReturnBack)
    public void onClickBack() {
        LoggerUtils.getLogger().debug("点击返回键");
        onBackPressed();
    }

    /**
     * 全选
     */
    @OnClick(R.id.llyAllSelect)
    public void onClickSelectAll() {
        changeSelectAllState();
    }

    /**
     * 点击退货按钮
     */
    @OnClick(R.id.btnStdRefund)
    public void onClickReturn() {
        try {
            LoggerUtils.getLogger().debug("return点击了退货");
            if (hasReturned) {
                return;
            }
            LoggerUtils.getLogger().debug("return有效点击了退货");
            hasReturned = true;

            mPresenter.refund();
        } finally {
            hasReturned = false;
        }
    }

    /**
     * 更改全选状态。
     */
    private void changeSelectAllState() {
        if (mReturnItemStdAdapter == null || mPresenter.getReturnSaleModel() == null) {
            return;
        }

        boolean checkAll = true;
        if (mPresenter.getReturnSaleModel().isReturnAll()) {
            checkAll = false;
        }

        for (ReturnItemViewModel item : mPresenter.getListSalesItemData()) {
            item.changeCheckState(checkAll);
        }

        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    private void processViewClick(OnRecyclerItemClickListener.RecyclerItemViewName viewName, int position) {
        if (isFastClick(300)) {
            return;
        }
        ReturnItemViewModel itemViewModel = mPresenter.saleItem().get(position);
        switch (viewName) {
            case ITEM:
                if (mPresenter.saleItem().size() == 0) {
                    return;
                }

                resetScalesData();
                if (itemViewModel.isChecked()) {
                    itemViewModel.unCheck();

                    mReturnItemStdAdapter.returnPluUnSelected();
                } else {
                    itemViewModel.check();
                    mReturnItemStdAdapter.returnPluSelected();

                    if (itemViewModel.saleItem().isWeight()) {
                        if (!open) {
                            showHintDialog("电子秤未打开");
                            return;
                        }

                        try {
                            pluModelTemp = itemViewModel;
                            pluModelTemp.setPosition(position);
                            stdScalesTvPluName.setText(pluModelTemp.saleItem().getPluName());
                            stdScalesTvPrice.setText(pluModelTemp.saleItem().getPrice());
                        } catch (Exception e) {
                            LoggerUtils.getLogger().error("商品称重失败，请重试：" + e.getMessage());
                            showHintDialog("商品称重失败，请重试：" + e.getMessage());
                            pluModelTemp = null;
                        }
                    }
                }

                changeItemCheckState();
                break;
            case INCREASE:
                if (getSale().getPlu(position).isWeightOrEquivalent()) {
                    showHintDialog("称重商品禁止修改数量");
                    return;
                }

                mReturnItemStdAdapter.btnDecressState(itemViewModel.testReturnLess());
                if (!itemViewModel.testReturnMore()) {
                    return;
                }
                itemViewModel.returnMore();
                mReturnItemStdAdapter.btnIncressState(itemViewModel.testReturnMore());

                returnMore(position);
                break;
            case DECREASE:
                if (getSale().getPlu(position).isWeightOrEquivalent()) {
                    showHintDialog("称重商品禁止修改数量");
                    return;
                }

                mReturnItemStdAdapter.btnIncressState(itemViewModel.testReturnMore());
                if (!itemViewModel.testReturnLess()) {
                    return;
                }

                itemViewModel.returnLess();
                mReturnItemStdAdapter.btnDecressState(itemViewModel.testReturnLess());

                returnLess(position);
                if (BigDecimalUtils.isEquals0(itemViewModel.count())) {
                    if (itemViewModel.isChecked()) {
                        itemViewModel.unCheck();
                        mReturnItemStdAdapter.btnIncressState(itemViewModel.test());
                        mReturnItemStdAdapter.returnPluUnSelected();
                        changeItemCheckState();
                    }
                    return;
                }

                break;
            default:
                break;
        }
    }

    /**
     * 多退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnMore(int position) {
        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();
        returnSalePluModel.returnMore(mPresenter.getReturnSaleModel());
        // mPresenter.getReturnSaleModel().returnMore(position, returnSalePluModel);
        updateTotal(mPresenter.getReturnSaleModel());
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    private void returnQuality(ReturnItemViewModel itemViewModel) {
        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(itemViewModel.getPosition()).returnSaleItem();
        returnSalePluModel.changeQuantityReturn(itemViewModel.getCount(), mPresenter.getReturnSaleModel());
        updateTotal(mPresenter.getReturnSaleModel());
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    /**
     * 少退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnLess(int position) {
        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();
        returnSalePluModel.returnLess(mPresenter.getReturnSaleModel());
        // mPresenter.getReturnSaleModel().returnLess(position, returnSalePluModel);

        updateTotal(mPresenter.getReturnSaleModel());
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    /**
     * 更改商品选择状态。
     */
    private void changeItemCheckState() {
        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    @OnClick(R.id.btnReturnBoardShowClear)
    public void onClickBoardShowClear() {
        KeyBoardStdView.clearChar(mEdtReturnBoardShow);
    }

    @Override
    public void onInsertKeyEvent(String text) {
        KeyBoardStdView.addChar(mEdtReturnBoardShow, text);
    }

    @Override
    public void onDeleteKeyEvent() {
        mEdtReturnBoardShow.setSelection(mEdtReturnBoardShow.getText().toString().length());
        KeyBoardStdView.deleteChar(mEdtReturnBoardShow);
    }

    @Override
    public void onClearKeyEvent() {
        KeyBoardStdView.clearChar(mEdtReturnBoardShow);
    }

    @Override
    public void onDoneKeyEvent() {
        mPresenter.querySale(mEdtReturnBoardShow.getText().toString());
    }

    @Override
    public void updateSaleNo(String saleNo) {
        tvStdTitleSaleNo.setText(saleNo);
    }

    @Override
    public void updateTotal(ReturnSaleModel returnSaleModel) {
        updateTotal(returnSaleModel.calcQuantity(), returnSaleModel.getTotalRecv());
    }

    @Override
    public void updateTotal(String returnCount, String totalReturn) {
        if (mPresenter.getReturnSaleModel() != null && mPresenter.getReturnSaleModel().isReturnAll()) {
            mImgViewAllSelect.setImageResource(R.drawable.btn_std_plu_item_selected);
        } else {
            mImgViewAllSelect.setImageResource(R.drawable.btn_std_plu_item_unselected);
        }
        mTvReturnCount.setText(String.valueOf(returnCount));
        mTvReturnTotalRefund.setText(totalReturn);
    }

    @Override
    public void updateTotal(String returnCount, String totalCount, String totalReceived, String totalReturn) {
        mTvReturnTotalRecv.setText(totalReceived);
        mTvTotalCount.setText(String.valueOf(totalCount));
        updateTotal(returnCount, totalReturn);
        //todo xly
        //   lytReturnCount.setVisibility(totalCount > 0 ? View.VISIBLE : View.GONE);
        mReturnItemStdAdapter.notifyDataSetChanged();
    }

    @Override
    public void updateVip(Vip vip) {
        if (vip == null) {
            tvStdTitleVipIcon.setVisibility(View.GONE);
            return;
        }
        linearStdTitleVipInfo.setVisibility(View.VISIBLE);

        tvStdTitleVipName.setText(vip.name());
        tvStdTitleVipLevel.setText(vip.card().cardType().name());
        tvStdTitleVipBirth.setText(vip.birthday());

        String points = "0";
        String balance = "0";
        if (vip.projects().size() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.projects().get(0).usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.projects().get(0).usableBalance());

        } else if (vip.card() != null && vip.card().usablePoints() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.card().usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.card().usableBalance());

        }

        tvStdTitlePoints.setText(points);
        tvStdTitleBalance.setText(balance);
    }

    @Override
    public void gotoRefundActivity() {
        CommonTools.goTo(this, RefundStdActivity.class);
    }

    @Override
    public void adapter() {
        initPluAdapter();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            LoggerUtils.getLogger().debug("点击设备返回键");
            CommonTools.exit(this, MainStdActivity.class);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public IScanner iScanner() {
        return mScanner;
    }

    @Override
    protected void onPause() {
        super.onPause();

        closeScales();
    }

    @Override
    protected void onResume() {
        super.onResume();

        initScales();
    }

    private void initScales() {
        mscalessdk = ScalesSDK.getInstance(this, new ScalesSDK.WeightChangedListener() {
            @Override
            public void onWeightChanged(final WeightInfo weightInfo) {
                runOnUiThread(() -> {
                    stdScalesTvNet.setText(weightInfo.getNetWeight());
                    stdScalesTvTare.setText(weightInfo.getTareWeight());

                    //稳定，则稳定灯亮
                    if ("Stable".equals(weightInfo.getStatus())) {
                        stdScalesRadioBtnIsBalance.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsBalance.setChecked(false);
                    }
                    //皮重不为0，则皮重灯亮
                    if (BigDecimalUtils.isNotEquals0(weightInfo.getTareWeight())) {
                        stdScalesRadioBtnIsTare.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsTare.setChecked(false);
                    }
                    //净重为0，则零位灯亮
                    if (weightInfo.getZero()) {
                        stdScalesRadioBtnIsZero.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsZero.setChecked(false);
                    }
                });
            }
        });

        openScales();
    }

    private void openScales() {
        if (mscalessdk != null) {
            if (!open) {
                if (mscalessdk.Open(new File("/dev/ttyS0"))) {
                    open = true;
                    LoggerUtils.getLogger().debug("电子秤串口打开成功");
                }
            }
        }
    }

    private void closeScales() {
        if (mscalessdk != null) {
            if (open) {
                int close = mscalessdk.Close();
                LoggerUtils.getLogger().debug("电子秤串口关闭成功");
                if (close == 1) {
                    LoggerUtils.getLogger().debug("电子秤串口关闭成功");
                    open = false;
                } else {
                    String msg = "电子秤串口关闭失败 " + CommonUtils.getScalesErrorInfo(close);
                    LoggerUtils.getLogger().debug(msg);
                    showHintDialog(msg);
                }
            }
        }
    }

    @OnClick(R.id.stdScalesTvZero)
    public void zeroScales(View view) {
        executeAnimation(view);

        if (mscalessdk != null) {
            int zero = mscalessdk.Zero();
            if (zero == 1) {
                LoggerUtils.getLogger().debug("清零成功");
            } else {
                String msg = "清零失败 " + CommonUtils.getScalesErrorInfo(zero);
                LoggerUtils.getLogger().debug(msg);
                showHintDialog(msg);
            }
        } else {
            showHintDialog("串口未打开");
        }
    }

    @OnClick(R.id.stdScalesTvClearTare)
    public void clearTareScales(View view) {
        executeAnimation(view);

        if (mscalessdk != null) {
            int tare = mscalessdk.Tare();
            if (tare == 1) {
                LoggerUtils.getLogger().debug("去皮成功");
            } else {
                String msg = "去皮失败 " + CommonUtils.getScalesErrorInfo(tare);
                LoggerUtils.getLogger().debug(msg);
                showHintDialog(msg);
            }
        } else {
            showHintDialog("串口未打开");
        }
    }

    @OnClick(R.id.stdScalesTvConfirm)
    public void confirmScales(View view) {
        executeAnimation(view);

        if (pluModelTemp == null) {
            showHintDialog("请先录入商品");
            return;
        }
        if (!stdScalesRadioBtnIsBalance.isChecked()) {
            showHintDialog("称不稳定");
            return;
        }
        if (BigDecimalUtils.isLessAndEquals0(stdScalesTvNet.getText().toString())) {
            showHintDialog("重量必须大于零");
            return;
        }

        if (!pluModelTemp.returnWeightPlu(stdScalesTvNet.getText().toString())) {
            showHintDialog("称重重量大于最大可退货重量");
            return;
        }

        returnQuality(pluModelTemp);

        resetScalesData();
    }

    @OnTextChanged({R.id.stdScalesTvNet, R.id.stdScalesTvPrice})
    public void onTextChangedNet() {
        if (pluModelTemp == null) {
            return;
        }

        try {
            stdScalesTvTotal.setText(BigDecimalUtils.multiply(stdScalesTvPrice.getText().toString(),
                    stdScalesTvNet.getText().toString(), 2));
        } catch (Exception e) {
            stdScalesTvTotal.setText("0.00");
        }
    }

    private void resetScalesData() {
        pluModelTemp = null;
        stdScalesTvPluName.setText("");
        stdScalesTvPrice.setText("0.00");
        stdScalesTvTotal.setText("0.00");
    }
}
