package com.hisense.hiaposcmp.activity.std.sale;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpFragment;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.presenter.SalePreKeyPresenter;
import com.hisense.hiaposcmp.view.AutoFlowLayout;
import com.hisense.hiaposcmp.view.FlowAdapter;
import com.hisense.hiaposcmp.view.IView.ISalePreKeyView;
import com.hisense.hipos.prekey.PluPreKey;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;

/**
 * 销售界面预置键
 *
 * @author dukunbiao(null)  2020-03-17
 */
@ActivityLayoutInject(R.layout.fragment_sale_pre_key_std)
public class SalePreKeyStdFragment extends BaseMvpFragment<ISalePreKeyView, SalePreKeyPresenter> implements ISalePreKeyView {

    @BindView(R.id.aflPluPreKey)
    public AutoFlowLayout aflPluPreKey;
    @BindView(R.id.aflPluPreKeyTag)
    public TextView aflPluPreKeyTag;

    private SaleStdActivity saleStdActivity;
    private String tab;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = super.onCreateView(inflater, container, savedInstanceState);
        return view;
    }

    public SalePreKeyStdFragment(String tab) {
        this.tab = tab;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
    }

    @Override
    protected void initData() {
        aflPluPreKeyTag.setText(tab);

        List<PluPreKey> pluPreKeys = new ArrayList<>();
        PluPreKey pluPreKey1 = new PluPreKey("66660001", "小熊猫香烟AAA小熊猫香烟AAA");
        PluPreKey pluPreKey2 = new PluPreKey("66660002", "哈罗那雪茄哈罗那雪茄");
        PluPreKey pluPreKey3 = new PluPreKey("66660003", "茅台国宴佳酿72度600ML茅台国宴佳酿72度600ML");
        PluPreKey pluPreKey4 = new PluPreKey("66660004", "15年绍兴女儿红15年绍兴女儿红");
        PluPreKey pluPreKey5 = new PluPreKey("66660005", "韩国七星香烟韩国七星香烟");
        PluPreKey pluPreKey6 = new PluPreKey("66660006", "绍兴女儿红绍兴女儿红");
        PluPreKey pluPreKey7 = new PluPreKey("66660007", "大前门香烟大前门香烟");
        PluPreKey pluPreKey8 = new PluPreKey("66660008", "黄山香烟（软）黄山香烟（软）");
        pluPreKeys.add(pluPreKey1);
        pluPreKeys.add(pluPreKey2);
        pluPreKeys.add(pluPreKey3);
        pluPreKeys.add(pluPreKey4);
        pluPreKeys.add(pluPreKey5);
        pluPreKeys.add(pluPreKey6);
        pluPreKeys.add(pluPreKey7);
        pluPreKeys.add(pluPreKey8);

        aflPluPreKey.setAdapter(new FlowAdapter(pluPreKeys) {
            @Override
            public View getView(int position) {
                PluPreKey pluPreKey = pluPreKeys.get(position);

                View item = LayoutInflater.from(getContext()).inflate(R.layout.item_std_plu_pre_key, null);
                TextView tvPluCode = item.findViewById(R.id.tvPluCode);
                tvPluCode.setText(pluPreKey.getPluCode());

                TextView tvPluName = item.findViewById(R.id.tvPluName);
                tvPluName.setText(pluPreKey.getPluName());
                return item;
            }
        });
        aflPluPreKey.setOnItemClickListener((position, view) -> {
            executeAnimation(view);

            if (saleStdActivity == null) {
                showHintDialog("预置键数据错误，请重试");
                return;
            }

            saleStdActivity.pluQueryWithCheck(pluPreKeys.get(position).getPluCode());
        });
    }

    @Override
    protected SalePreKeyPresenter createPresenter() {
        return new SalePreKeyPresenter();
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);

        if (context instanceof SaleStdActivity) {
            saleStdActivity = (SaleStdActivity) context;
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        saleStdActivity = null;
    }
}
