/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.std.sale;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.InputType;
import android.view.KeyEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.google.android.material.tabs.TabLayout;
import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.DateUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.MapUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.AppContext;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.StartActivityService;
import com.hisense.hiaposcmp.activity.std.pay.PayStdActivity;
import com.hisense.hiaposcmp.activity.std.vip.VipLoginStdActivity;
import com.hisense.hiaposcmp.adapter.OnRecyclerItemClickListener;
import com.hisense.hiaposcmp.adapter.PluDscItemStdAdapter;
import com.hisense.hiaposcmp.adapter.SaleItemStdAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.boot.WrapContentLinearLayoutManager;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.presenter.sale.SalePresenter;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.tool.ScanKeyEventHelper;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.util.NetUtils;
import com.hisense.hiaposcmp.view.IView.sale.ISaleView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.SalePluDscModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.hipos.sale.CalcType;
import com.hisense.hipos.sale.TranType;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import OnePlusOneAndroidSDK.ScalesOS.ScalesSDK;
import OnePlusOneAndroidSDK.ScalesOS.WeightInfo;
import butterknife.BindView;
import butterknife.OnClick;
import butterknife.OnTextChanged;
import jp.wasabeef.recyclerview.animators.SlideInRightAnimator;

/**
 * 销售界面
 *
 * @author dukunbiao(null)  2019-12-16  新建
 * @author guolina          2020-01-10  HIAPOSCMP-480  增加预销售
 */
@ActivityLayoutInject(R.layout.activity_sale_std)
public class SaleStdActivity extends BaseMvpActivity<ISaleView, SalePresenter> implements ISaleView, KeyBoardStdView.OnKeyboardListener, ScanKeyEventHelper.OnScanSuccessListener {

    @BindView(R.id.tvStdTitleDate)
    public TextView tvStdTitleDate;

    @BindView(R.id.tvStdTitleSaleNo)
    public TextView tvStdTitleSaleNo;

    @BindView(R.id.tvStdTitleOrgName)
    public TextView tvStdTitleOrgName;

    @BindView(R.id.tvStdTitleCashierName)
    public TextView tvStdTitleCashierName;

    @BindView(R.id.tvStdTitleVipLogin)
    public TextView tvStdTitleVipLogin;

    @BindView(R.id.linearStdTitleVipInfo)
    public LinearLayout linearStdTitleVipInfo;

    @BindView(R.id.tvStdTitleVipName)
    public TextView tvStdTitleVipName;

    @BindView(R.id.tvStdTitleVipLevel)
    public TextView tvStdTitleVipLevel;

    @BindView(R.id.tvStdTitleVipBirth)
    public TextView tvStdTitleVipBirth;

    @BindView(R.id.tvStdTitlePoints)
    public TextView tvStdTitlePoints;

    @BindView(R.id.tvStdTitleBalance)
    public TextView tvStdTitleBalance;

    @BindView(R.id.tvStdTitleVipChange)
    public TextView tvStdTitleVipChange;

    @BindView(R.id.rvSaleStdPluList)
    public RecyclerView rvSaleStdPluList;

    @BindView(R.id.rvSaleStdPluDscList)
    public RecyclerView rvSaleStdPluDscList;

    @BindView(R.id.tvSaleStdTotal)
    public TextView tvSaleStdTotal;

    @BindView(R.id.tvSaleStdTotalDsc)
    public TextView tvSaleStdTotalDsc;

    @BindView(R.id.tvSaleStdTotalRecv)
    public TextView tvSaleStdTotalRecv;

    @BindView(R.id.tvSaleStdPluCount)
    public TextView tvSaleStdPluCount;

    @BindView(R.id.edtSaleStdBoardShow)
    public EditText edtSaleStdBoardShow;

    @BindView(R.id.keyBrdSaleStdKeyBoard)
    public KeyBoardStdView keyBrdSaleStdKeyBoard;

    @BindView(R.id.linearSaleStdCutting)
    public LinearLayout linearSaleStdCutting;

    @BindView(R.id.linearSaleStdPluPresetKey)
    public LinearLayout linearSaleStdPluPresetKey;

    @BindView(R.id.linearSaleStdWxPay)
    public LinearLayout linearSaleStdWxPay;

    @BindView(R.id.tvSaleStdWxPay)
    public TextView tvSaleStdWxPay;

    @BindView(R.id.linearSaleStdAliPay)
    public LinearLayout linearSaleStdAliPay;

    @BindView(R.id.tvSaleStdAliPay)
    public TextView tvSaleStdAliPay;

    @BindView(R.id.linearSaleStdPay)
    public LinearLayout linearSaleStdPay;

    @BindView(R.id.tvStdTitleItem)
    public TextView tvStdTitleItem;

    /**
     * 称重模块
     */
    @BindView(R.id.stdScalesRadioBtnIsBalance)
    public RadioButton stdScalesRadioBtnIsBalance;
    @BindView(R.id.stdScalesRadioBtnIsZero)
    public RadioButton stdScalesRadioBtnIsZero;
    @BindView(R.id.stdScalesRadioBtnIsTare)
    public RadioButton stdScalesRadioBtnIsTare;
    @BindView(R.id.stdScalesTvNet)
    public TextView stdScalesTvNet;
    @BindView(R.id.stdScalesTvTare)
    public TextView stdScalesTvTare;
    @BindView(R.id.stdScalesTvPrice)
    public TextView stdScalesTvPrice;
    @BindView(R.id.stdScalesTvTotal)
    public TextView stdScalesTvTotal;
    @BindView(R.id.stdScalesTvPluName)
    public TextView stdScalesTvPluName;

    /**
     * 商品列表title
     */
    @BindView(R.id.linearSaleStdPluTitleCount)
    public LinearLayout linearSaleStdPluTitleCount;
    @BindView(R.id.linearSaleStdPluTitlePrice)
    public LinearLayout linearSaleStdPluTitlePrice;
    @BindView(R.id.linearSaleStdPluTitleTotal)
    public LinearLayout linearSaleStdPluTitleTotal;

    /**
     * 预置键界面
     */
    @BindView(R.id.tabSaleStdPreKey)
    public TabLayout tabSaleStdPreKey;
    @BindView(R.id.frameSaleStdPreKey)
    public FrameLayout frameSaleStdPreKey;

    private FragmentManager fmPreKey;
    private Map<String, SalePreKeyStdFragment> salePreKeyStdFragments;

    private SaleItemStdAdapter mSaleItemAdapter;
    private PluDscItemStdAdapter mPluDscItemStdAdapter;
    private List<SalePluDscModel> pluDscModels = new ArrayList<>();

    private ScalesSDK mscalessdk;
    private boolean open = false;
    private BaseSalePluModel pluModelTemp = null;

    public TranType tranType = TranType.Sale;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
        initValue();
        initPayMethod();
        initAdapter();
        initPluPresetKey();
    }

    @Override
    protected SalePresenter createPresenter() {
        return new SalePresenter();
    }

    private void init() {
        isNotShowExitDialog(true);

        edtSaleStdBoardShow.setInputType(InputType.TYPE_NULL);
        keyBrdSaleStdKeyBoard.setOnKeyboardListener(this);
    }

    private final BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action != null && action.equals(Intent.ACTION_TIME_TICK)) {
                tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
            }
        }
    };

    private void initValue() {
        Bundle bundle = this.getIntent().getExtras();
        if (bundle != null) {
            String sTranType = bundle.getString("tranType");
            if (!StringUtils.isEmpty(sTranType)) {
                tranType = TranType.valueOfType(sTranType);
                GeneralSettings.INSTANCE.setTranType(sTranType);
            }
        }
        if (tranType == TranType.PreSale) {
            tvStdTitleItem.setText("预销售");
            rvSaleStdPluList.setBackgroundResource(R.drawable.presale_bg_bmp);
        }
        IntentFilter filter = new IntentFilter();
        filter.addAction(Intent.ACTION_TIME_TICK);
        registerReceiver(receiver, filter);

        tvStdTitleDate.setText(DateUtils.dateFormatWithWeek("MM月dd日    ww   aa hh:mm"));
        tvStdTitleOrgName.setText(Config.org_name);
        tvStdTitleCashierName.setText(Config.user_name);

        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                updateTotal();
                updateVipInfo(mPresenter.getSale().getVip());
                tvStdTitleSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String message) {
                showHintDialog(message);
            }
        });
    }

    private void initPayMethod() {
        PayMethodService.getAll(this, null);
        List<PayMethod> payMethods = AppContext.payMethods();
        for (PayMethod payMethod : payMethods) {
            if (payMethod.isAliPay()) {
                linearSaleStdAliPay.setVisibility(View.VISIBLE);
                linearSaleStdAliPay.setTag(payMethod);
                tvSaleStdAliPay.setText(payMethod.name());
                continue;
            }

            if (payMethod.isWxPay()) {
                linearSaleStdWxPay.setVisibility(View.VISIBLE);
                linearSaleStdWxPay.setTag(payMethod);
                tvSaleStdWxPay.setText(payMethod.name());
            }
        }
    }

    private void initAdapter() {
        initPluAdapter();
        initPluDscAdapter();
    }

    private void initPluAdapter() {
        rvSaleStdPluList.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        mSaleItemAdapter = new SaleItemStdAdapter(rvSaleStdPluList);
        rvSaleStdPluList.setAdapter(mSaleItemAdapter);
        mSaleItemAdapter.setOnItemClickListener((view, viewName, position) -> processViewClick(viewName, position));

        //防崩溃java.lang.IndexOutOfBoundsException: Inconsistency detected（自带bug）
        rvSaleStdPluList.setLayoutManager(new WrapContentLinearLayoutManager(this, LinearLayoutManager.VERTICAL, false));

        //动画
        rvSaleStdPluList.setItemAnimator(new SlideInRightAnimator());
        rvSaleStdPluList.getItemAnimator().setAddDuration(300);
        rvSaleStdPluList.getItemAnimator().setRemoveDuration(50);
        rvSaleStdPluList.getItemAnimator().setMoveDuration(50);
        rvSaleStdPluList.getItemAnimator().setChangeDuration(50);
    }

    private void initPluDscAdapter() {
        rvSaleStdPluDscList.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        mPluDscItemStdAdapter = new PluDscItemStdAdapter(rvSaleStdPluDscList);
        rvSaleStdPluDscList.setAdapter(mPluDscItemStdAdapter);
    }

    private void initPluPresetKey() {
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("全部"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("炒货"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("素食"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("蜜饯"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("肉类"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("零食"));
        tabSaleStdPreKey.addTab(tabSaleStdPreKey.newTab().setText("新春大礼包"));

        fmPreKey = getSupportFragmentManager();
        salePreKeyStdFragments = new HashMap<>();
        showPreKeyFragment("全部");
        tabSaleStdPreKey.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                if (tab == null || tab.getText() == null) {
                    showHintDialog("预置键列表类目错误，请重试");
                    return;
                }

                showPreKeyFragment(tab.getText().toString());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                //添加未选中Tab的逻辑
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
                //再次选中tab的逻辑
            }
        });
    }

    private void showPreKeyFragment(String tab) {
        FragmentTransaction ft = fmPreKey.beginTransaction();
        hidePreKeyFragment(ft);

        if (!salePreKeyStdFragments.containsKey(tab)) {
            SalePreKeyStdFragment preKeyStdFragment = new SalePreKeyStdFragment(tab);
            salePreKeyStdFragments.put(tab, preKeyStdFragment);
            ft.add(R.id.frameSaleStdPreKey, preKeyStdFragment);
        } else {
            SalePreKeyStdFragment preKeyStdFragment = salePreKeyStdFragments.get(tab);
            if (preKeyStdFragment == null) {
                salePreKeyStdFragments.remove(tab);
                showHintDialog("获取该品类预置数据失败，请重试");
                return;
            }

            ft.show(preKeyStdFragment);
        }

        ft.commit();
    }

    private void hidePreKeyFragment(FragmentTransaction ft) {
        if (MapUtils.isEmpty(salePreKeyStdFragments)) {
            return;
        }

        for (String key : salePreKeyStdFragments.keySet()) {
            SalePreKeyStdFragment preKeyStdFragment = salePreKeyStdFragments.get(key);
            if (preKeyStdFragment != null) {
                ft.hide(preKeyStdFragment);
            }
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME || keyCode == KeyEvent.KEYCODE_MENU) {
            if (mPresenter.getSale() != null && mPresenter.getSale().pluSize() > 0) {
                showHintDialog("已添加商品，请整笔取消后返回");
                return false;
            } else {
                this.finish();
                return true;
            }
        } else {
            return super.onKeyDown(keyCode, event);
        }
    }

    @OnClick({R.id.linearStdTitleHome, R.id.linearSaleStdMenuSaleHome})
    public void onClickHome(View view) {
        executeAnimation(view);

        if (mPresenter.getSale() != null && mPresenter.getSale().pluSize() > 0) {
            showHintDialog("已添加商品，请整笔取消后返回");
        } else {
            this.finish();
        }
    }

    @OnClick({R.id.tvStdTitleVipLogin, R.id.tvStdTitleVipChange})
    public void onClickBoardVipLogin(View view) {
        executeAnimation(view);

        Intent intent = new Intent(this, VipLoginStdActivity.class);
        startActivityForResult(intent, ActivityConstants.REQUEST_SALE_TO_VIP_LOGIN);
    }

    @OnClick(R.id.btnSaleStdBoardShowClear)
    public void onClickBoardShowClear() {
        KeyBoardStdView.clearChar(edtSaleStdBoardShow);
    }

    @OnClick(R.id.linearSaleStdMenuPresetKey)
    public void onClickBoardSalePresetKey() {
        if (linearSaleStdPluPresetKey.getVisibility() == View.VISIBLE) {
            linearSaleStdPluPresetKey.setVisibility(View.GONE);
            linearSaleStdCutting.setVisibility(View.VISIBLE);
            mSaleItemAdapter.updateUi(false);
            updateUiByPreKey(false);
        } else {
            linearSaleStdPluPresetKey.setVisibility(View.VISIBLE);
            linearSaleStdCutting.setVisibility(View.GONE);
            mSaleItemAdapter.updateUi(true);
            updateUiByPreKey(true);
        }
    }

    private void updateUiByPreKey(boolean isShowPreKey) {
        if (isShowPreKey) {
            linearSaleStdPluTitleCount.getLayoutParams().width = 215;
            linearSaleStdPluTitlePrice.getLayoutParams().width = 63;
            linearSaleStdPluTitleTotal.getLayoutParams().width = 63;
        } else {
            linearSaleStdPluTitleCount.getLayoutParams().width = 355;
            linearSaleStdPluTitlePrice.getLayoutParams().width = 63;
            linearSaleStdPluTitleTotal.getLayoutParams().width = 290;
        }
    }

    @OnClick(R.id.linearSaleStdMenuSaleCancel)
    public void onClickBoardSaleCancel() {
        LoggerUtils.getLogger().debug("总清");

        clearAllUseData();
        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                tvStdTitleSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String err) {
                showHintDialog(err);
            }
        });
    }

    @OnClick({R.id.linearSaleStdWxPay, R.id.linearSaleStdAliPay, R.id.linearSaleStdPay})
    public void onClickPay(View view) {
        if (isFastClick()) {
            return;
        }

        executeAnimation(view);
        mPresenter.checkSaleNo(view);
    }

    private void processViewClick(OnRecyclerItemClickListener.RecyclerItemViewName viewName, int position) {
        if (isFastClick(300)) {
            return;
        }

        switch (viewName) {
            case ITEM:
                setSelected(position);
                break;
            case DELETE:
                pluDelete(position);
                break;
            case INCREASE:
                pluAdjust(position, true);
                break;
            case DECREASE:
                pluAdjust(position, false);
                break;
            case CHANGE_QUALITY:
                pluChangeQuality(position);
                setSelected(position);
                break;
            default:
                break;
        }
    }

    private synchronized void setSelected(int position) {
        mSaleItemAdapter.setItemSelected(position);
    }

    private void pluDelete(int position) {
        mPresenter.pluDelete(position);
    }

    private void pluAdjust(int position, boolean add) {
        mPresenter.pluAdjust(position, add);
    }

    private void pluChangeQuality(int position) {
        // 称重或等价于称重（录入的小数）的商品不允许修改数量
        if (getSale().getPlu(position).isWeightOrEquivalent()) {
            return;
        }

        StartActivityService.gotoStdSaleDialogActivity(this, position, getSale().getPlu(position).count());
    }

    @Override
    public void hideShoppingCartPrompt() {

    }

    @Override
    public void showShoppingCartPrompt() {

    }

    @Override
    public void showBagsPopupWindow() {

    }

    @Override
    public void hideBagsPopupWindow() {

    }

    public void updateTotal() {
        if (mPresenter.getSale() != null) {
            updateTotal(mPresenter.getSale().calcCount(), mPresenter.getSale().getTotalDsc(), mPresenter.getSale().getTotalRecv());
        } else {
            updateTotal(0, "0.00", "0.00");
        }
    }

    @Override
    public void updateTotal(int count, String totalDsc, String totalRecv) {
        tvSaleStdPluCount.setText(String.format(Locale.CHINESE, "共%d件商品", count));
        tvSaleStdTotal.setText(String.format(Locale.CHINESE, "￥%s", getSale().getTotal()));
        tvSaleStdTotalDsc.setText(String.format(Locale.CHINESE, "￥%s", totalDsc));
        tvSaleStdTotalRecv.setText(String.format(Locale.CHINESE, "￥%s", totalRecv));

        if (count > 0) {
            LoggerUtils.getLogger().debug(String.format(Locale.CHINESE, "商品: %d，小计: %s", count, totalRecv));
        }

        edtSaleStdBoardShow.getText().clear();
    }

    @Override
    public void updateAdapter() {
        if (mSaleItemAdapter != null) {
            mSaleItemAdapter.setData(mPresenter.getSale().getPlus());
        }

        if (pluDscModels == null) {
            pluDscModels = new ArrayList<>();
        }
        pluDscModels.clear();
        for (BaseSalePluModel pluModel : mPresenter.getSale().getPlus()) {
            if (pluModel.pluDscSize() > 0) {
                pluDscModels.addAll(pluModel.getPluDscs());
            }
        }
        mPluDscItemStdAdapter.setData(pluDscModels);
    }

    @Override
    public void addPlu(int position, BaseSalePluModel salePluModel) {
        mSaleItemAdapter.addPlu(position, salePluModel);
        if (salePluModel.pluDscSize() > 0) {
            mPluDscItemStdAdapter.addPluDscs(salePluModel.getPluDscs());
        }
    }

    @Override
    public void removePlu(int position) {
        mSaleItemAdapter.removePlu(position);
    }

    @Override
    public void changeQuantity(int position) {
        mSaleItemAdapter.changeQuantity(position);
        updateAdapter();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == ActivityConstants.REQUEST_SALE_TO_VIP_LOGIN && resultCode == ActivityConstants.RESULT_SALE_TO_VIP_LOGIN) {
            updateVipInfo(data);
        } else if (requestCode == ActivityConstants.REQUEST_INTE_PAY_INPUT && resultCode == ActivityConstants.RESULT_NTE_PAY_SUCCESS) {
            afterScanSuccess(data);
        } else if (requestCode == ActivityConstants.REQUEST_SALE_TO_PAY && resultCode == ActivityConstants.RESULT_SALE_TO_PAY) {
            salePaySuccess(data);
        } else if (requestCode == ActivityConstants.REQUEST_SALE_TO_SET_PLU_PRICE && resultCode == ActivityConstants.RESULT_SALE_TO_SET_PLU_PRICE) {
            addPluNoCode(data);
        } else if (ActivityConstants.REQUEST_SALE_TO_PAY == requestCode && resultCode == RESULT_CANCELED) {
            salePayCancel(data);
        } else if (requestCode == ActivityConstants.REQUEST_INTE_PAY_INPUT && resultCode == Activity.RESULT_CANCELED) {
            saleQuickPayCancel(data);
        }

        updateAdapter();
        updateTotal();
        super.onActivityResult(requestCode, resultCode, data);
    }

    private void addPluNoCode(Intent data) {
        Bundle bundle = data.getExtras();
        if (bundle == null) {
            return;
        }

        BaseSalePluModel pluModel = (BaseSalePluModel) bundle.getSerializable("plu");
        if (pluModel == null) {
            showHintDialog("获取商品信息错误，请重试");
            return;
        }
        pluModel.setQuantity(BigDecimalUtils.format(pluModel.getQuantity()));

        mPresenter.checkPluVipDiscount(pluModel);
    }

    private void salePayCancel(Intent data) {
        LoggerUtils.getLogger().info("pay返回sale：RESULT_CANCELED,也可能是异常,默认cancel");
        if (mPresenter.getSale() != null) {
            boolean isVipServiceCalled = false;

            if (data != null) {
                isVipServiceCalled = data.getBooleanExtra("isVipServiceCalled", true);
            }
            if (isVipServiceCalled) {
                // 只有使用储值卡/积分成功支付后，撤销时才保存流水号，避免使用同一流水号再次支付时，会员服务报错（存在相同流水号的交易）。
                SaleNoService.save(this, mPresenter.getMainSaleModel().getShopInfo().getOrgCode(),
                        mPresenter.getSale().getPosNo(), mPresenter.getSale().getSaleNo());
            }
        }

        if (!NetUtils.isNetworkAvailable()) {
            showHintDialog("网络异常，检查流水号失败");
            return;
        }

        mPresenter.createNewSale(mPresenter.getSale().getVip(), tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                LoggerUtils.getLogger().info("pay返回sale RESULT_CANCELED：获取流水号成功");
                updateVipInfo(mPresenter.getSale().getVip());
                mPresenter.getSale().clearPlu();

                for (BaseSalePluModel pluModel : mSaleItemAdapter.getPluModels()) {
                    mPresenter.getSale().addPlu(pluModel);
                }

                mPresenter.reCalcVipDiscount();

                mSaleItemAdapter.notifyDataSetChanged();

                updateAdapter();
                updateTotal();
            }

            @Override
            public void onError(String message) {
                LoggerUtils.getLogger().info("pay返回sale RESULT_CANCELED：获取流水号失败");
                clearAllUseData();
            }
        });
    }

    private void saleQuickPayCancel(Intent data) {
        mPresenter.promotionCalc(null, CalcType.Enter);
    }

    private void updateVipInfo(Intent data) {
        Vip vip = (Vip) data.getSerializableExtra("vip");
        if (mPresenter.getSale() != null) {
            updateVipInfo(vip);
            mPresenter.reCalcVipDiscount();
        } else {
            mPresenter.createNewSale(vip, tranType, new UniCallback() {
                @Override
                public void onSuccess(String s) {
                    updateVipInfo(vip);
                    mPresenter.reCalcVipDiscount();
                }

                @Override
                public void onError(String message) {
                    showHintDialog(message);
                }
            });
        }
    }

    @Override
    public void updateVipInfo(Vip vip) {
        if (vip == null) {
            return;
        }

        mPresenter.getSale().setVip(vip);

        LoggerUtils.getLogger().info(String.format(Locale.CHINESE, "会员[%s]登录", vip.card().cardFaceNo()));

        tvStdTitleVipLogin.setVisibility(View.GONE);
        linearStdTitleVipInfo.setVisibility(View.VISIBLE);
        tvStdTitleVipChange.setVisibility(View.VISIBLE);

        tvStdTitleVipName.setText(vip.name());
        tvStdTitleVipLevel.setText(vip.card().cardType().name());
        tvStdTitleVipBirth.setText(vip.birthday());

        String points = "0";
        String balance = "0";
        if (vip.projects().size() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.projects().get(0).usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.projects().get(0).usableBalance());

        } else if (vip.card() != null && vip.card().usablePoints() > 0) {
            points = BigDecimalUtils.decimalFormat(vip.card().usablePoints());
            balance = BigDecimalUtils.decimalFormat(vip.card().usableBalance());

        }

        tvStdTitlePoints.setText(points);
        tvStdTitleBalance.setText(balance);
        mPresenter.getSale().setLastUsablePoint(balance);
        mPresenter.getSale().setVipPoints(balance);
    }

    private void afterScanSuccess(Intent data) {
        if (data == null) {
            showHintDialog("支付扫码返回信息为空");
            return;
        }

        String inputMoney = data.getStringExtra("inputMoney");
        String payNo = data.getStringExtra("payNo");
        LoggerUtils.getLogger().debug("标准版-支付页面支付成功返回:" + inputMoney + "||" + payNo);

        mPresenter.payPay(inputMoney, payNo);
    }

    private void salePaySuccess(Intent data) {
        try {
            mPresenter.saleSubmit();
        } catch (Exception ex) {
            LoggerUtils.getLogger().error("流水上传异常：" + ex.toString());

            //获取新的流水号
            SaleNoService.abandon();
            mPresenter.resetSaleModel();
            submitFail("流水上传异常：" + ex.getMessage());

            showHintDialog("流水上传失败,请点击右上角上传流水重试");
        }
    }

    private void clearAllUseData() {
        mPresenter.getSale().clearPlu();
        updateAdapter();

        updateTotal();
        tvStdTitleSaleNo.setText("");

        tvStdTitleVipLogin.setVisibility(View.VISIBLE);
        linearStdTitleVipInfo.setVisibility(View.GONE);
        tvStdTitleVipChange.setVisibility(View.GONE);
    }

    @Override
    public void callPayActivity() {
        Intent billPay = new Intent(this, PayStdActivity.class);
        startActivityForResult(billPay, ActivityConstants.REQUEST_SALE_TO_PAY);
    }

    @Override
    public void promotionCalcSuccess(View view) {
        updateAdapter();
        updateTotal();

        if (view.getId() == R.id.linearSaleStdWxPay || view.getId() == R.id.linearSaleStdAliPay) {
            PayMethod payMethod = (PayMethod) view.getTag();

            mPresenter.selectedPayMethod(payMethod);
            StartActivityService.gotoIntePayActivity(this, payMethod, getSale().getTotalRecv());
        } else {
            callPayActivity();
        }
    }

    @Override
    public void callGiftActivity() {

    }

    @Override
    public void scrollListToBottom() {
        try {
            int position = mSaleItemAdapter.getItemCount() - 1;
            if (position >= 0) {
                rvSaleStdPluList.smoothScrollToPosition(position);
            }

            int positionPluDsc = mPluDscItemStdAdapter.getItemCount() - 1;
            if (positionPluDsc >= 0) {
                rvSaleStdPluDscList.smoothScrollToPosition(position);
            }
        } catch (Exception e) {
            CommonTools.toastLong("滚动失败:" + e.getMessage());
        }
    }

    @Override
    public void scrollListToPosition(int position) {

    }

    @Override
    public void setPluDeleteEnabled(boolean decreaseEnabled) {

    }

    @Override
    public void backToWelcomeActivity() {

    }

    @Override
    public void pluQueryNoCode(BaseSalePluModel pluModel) {
        if (pluModel.isWeightNoCode() && !pluModel.isCountQuantity()) {
            if (!open) {
                showHintDialog("电子秤未打开");
                return;
            }

            try {
                pluModelTemp = pluModel;
                stdScalesTvPluName.setText(pluModel.getPluName());
                stdScalesTvPrice.setText(pluModel.getPrice());
            } catch (Exception e) {
                LoggerUtils.getLogger().error("商品称重失败，请重试：" + e.getMessage());
                showHintDialog("商品称重失败，请重试：" + e.getMessage());
                pluModelTemp = null;
            }
        } else {
            Bundle bundle = new Bundle();
            bundle.putSerializable("plu", pluModel);

            Intent intent = new Intent(this, SaleItemPriceStdActivity.class);
            intent.putExtras(bundle);

            startActivityForResult(intent, ActivityConstants.REQUEST_SALE_TO_SET_PLU_PRICE);
        }
    }

    @Override
    public void checkoutSuccess() {
        List<BaseSalePluModel> pluModels = new ArrayList<>(mSaleItemAdapter.getPluModels());
        for (final BaseSalePluModel pluModel : pluModels) {
            mPresenter.pluQuery(pluModel.getPluCode());
        }

        tvStdTitleSaleNo.setText(mPresenter.getSale().getSaleNo());
        updateAdapter();
        updateTotal();
    }

    @Override
    public void checkoutError() {

    }

    @Override
    public void submitSuccess() {
        afterSubmit();
    }

    @Override
    public void submitFail(String msg) {
        afterSubmit();
    }

    private void afterSubmit() {
        clearAllUseData();
        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                tvStdTitleSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String message) {
                showHintDialog(message);
            }
        });
    }

    @Override
    public void reSubmitSuccess(String msg) {

    }

    @Override
    public void reSubmitFail(String msg) {

    }

    @Override
    public void onlineFail(String msg) {

    }

    @Override
    public void onInsertKeyEvent(String text) {
        KeyBoardStdView.addChar(edtSaleStdBoardShow, text);
    }

    @Override
    public void onDeleteKeyEvent() {
        KeyBoardStdView.deleteChar(edtSaleStdBoardShow);
    }

    @Override
    public void onClearKeyEvent() {
        KeyBoardStdView.clearChar(edtSaleStdBoardShow);
    }

    @Override
    public void onDoneKeyEvent() {
        pluQueryWithCheck(edtSaleStdBoardShow.getText().toString());
    }

    public void pluQueryWithCheck(String pluCode) {
        if (pluModelTemp == null) {
            mPresenter.pluQueryWithCheck(pluCode);
            return;
        }

        showHintConfirm("正在称重，是否进行新商品查询？该操作将会取消当前商品称重", new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                resetScalesData();
                mPresenter.pluQueryWithCheck(pluCode);
            }

            @Override
            public void onError(String err) {

            }
        });
    }

    @Override
    public void onScanSuccess(String barcode) {
        //屏蔽扫描结果为空的barcode
        if (StringUtils.isEmpty(barcode)) {
            return;
        }

        LoggerUtils.getLogger().info("saleStd_onScanSuccess:" + barcode);
        pluQueryWithCheck(barcode);
        KeyBoardStdView.clearChar(edtSaleStdBoardShow);
    }

    private ScanKeyEventHelper mScanKeyEventHelper;

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mScanKeyEventHelper.onDestroy();
    }

    @Override
    protected void onPause() {
        super.onPause();
        mScanKeyEventHelper.onDestroy();

        closeScales();
    }

    @Override
    protected void onResume() {
        super.onResume();
        mScanKeyEventHelper = new ScanKeyEventHelper(this);

        initScales();
    }

    private void initScales() {
        mscalessdk = ScalesSDK.getInstance(this, new ScalesSDK.WeightChangedListener() {
            @Override
            public void onWeightChanged(final WeightInfo weightInfo) {
                runOnUiThread(() -> {
                    stdScalesTvNet.setText(weightInfo.getNetWeight());
                    stdScalesTvTare.setText(weightInfo.getTareWeight());

                    //稳定，则稳定灯亮
                    if ("Stable".equals(weightInfo.getStatus())) {
                        stdScalesRadioBtnIsBalance.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsBalance.setChecked(false);
                    }
                    //皮重不为0，则皮重灯亮
                    if (BigDecimalUtils.isNotEquals0(weightInfo.getTareWeight())) {
                        stdScalesRadioBtnIsTare.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsTare.setChecked(false);
                    }
                    //净重为0，则零位灯亮
                    if (weightInfo.getZero()) {
                        stdScalesRadioBtnIsZero.setChecked(true);
                    } else {
                        stdScalesRadioBtnIsZero.setChecked(false);
                    }
                });
            }
        });

        openScales();
    }

    private void openScales() {
        if (mscalessdk != null) {
            if (!open) {
                if (mscalessdk.Open(new File("/dev/ttyS0"))) {
                    open = true;
                    LoggerUtils.getLogger().debug("电子秤串口打开成功");
                }
            }
        }
    }

    private void closeScales() {
        if (mscalessdk != null) {
            if (open) {
                int close = mscalessdk.Close();
                LoggerUtils.getLogger().debug("电子秤串口关闭成功");
                if (close == 1) {
                    LoggerUtils.getLogger().debug("电子秤串口关闭成功");
                    open = false;
                } else {
                    String msg = "电子秤串口关闭失败 " + CommonUtils.getScalesErrorInfo(close);
                    LoggerUtils.getLogger().debug(msg);
                    showHintDialog(msg);
                }
            }
        }
    }

    @OnClick(R.id.stdScalesTvZero)
    public void zeroScales(View view) {
        executeAnimation(view);

        if (mscalessdk != null) {
            int zero = mscalessdk.Zero();
            if (zero == 1) {
                LoggerUtils.getLogger().debug("清零成功");
            } else {
                String msg = "清零失败 " + CommonUtils.getScalesErrorInfo(zero);
                LoggerUtils.getLogger().debug(msg);
                showHintDialog(msg);
            }
        } else {
            showHintDialog("串口未打开");
        }
    }

    @OnClick(R.id.stdScalesTvClearTare)
    public void clearTareScales(View view) {
        executeAnimation(view);

        if (mscalessdk != null) {
            int tare = mscalessdk.Tare();
            if (tare == 1) {
                LoggerUtils.getLogger().debug("去皮成功");
            } else {
                String msg = "去皮失败 " + CommonUtils.getScalesErrorInfo(tare);
                LoggerUtils.getLogger().debug(msg);
                showHintDialog(msg);
            }
        } else {
            showHintDialog("串口未打开");
        }
    }

    @OnClick(R.id.stdScalesTvConfirm)
    public void confirmScales(View view) {
        executeAnimation(view);

        if (pluModelTemp == null) {
            showHintDialog("请先录入商品");
            return;
        }
        if (!stdScalesRadioBtnIsBalance.isChecked()) {
            showHintDialog("称不稳定");
            return;
        }
        if (BigDecimalUtils.isLessAndEquals0(stdScalesTvNet.getText().toString())) {
            showHintDialog("重量必须大于零");
            return;
        }
        if (BigDecimalUtils.isEquals0(stdScalesTvTotal.getText().toString())) {
            showHintDialog("总价不能为零");
            return;
        }

        pluModelTemp.weightPlu(stdScalesTvNet.getText().toString());
        mPresenter.checkPluVipDiscount(pluModelTemp);
        resetScalesData();
    }

    @OnTextChanged({R.id.stdScalesTvNet, R.id.stdScalesTvPrice})
    public void onTextChangedNet() {
        if (pluModelTemp == null) {
            return;
        }

        try {
            stdScalesTvTotal.setText(BigDecimalUtils.multiply(stdScalesTvPrice.getText().toString(),
                    stdScalesTvNet.getText().toString(), 2));
        } catch (Exception e) {
            stdScalesTvTotal.setText("0.00");
        }
    }

    private void resetScalesData() {
        pluModelTemp = null;
        stdScalesTvPluName.setText("");
        stdScalesTvPrice.setText("0.00");
        stdScalesTvTotal.setText("0.00");
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        edtSaleStdBoardShow.setFocusable(true);
        edtSaleStdBoardShow.setFocusableInTouchMode(true);
        edtSaleStdBoardShow.requestFocus();
        edtSaleStdBoardShow.setSelection(edtSaleStdBoardShow.getText().length());
        if (event.getKeyCode() == KeyEvent.KEYCODE_ENTER && isFastClick()) {
            //屏蔽连扫的第二个条码
            LoggerUtils.getLogger().info("saleStd 屏蔽条码:" + event.getKeyCode());
        } else {
            mScanKeyEventHelper.analysisKeyEvent(event);
        }

        return super.dispatchKeyEvent(event);
    }
}
