package com.hisense.hiaposcmp.activity.std.sale;

import android.content.Intent;
import android.os.Bundle;
import android.widget.EditText;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.layout.SoftInput;
import com.hisense.hiaposcmp.presenter.EmptyPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IEmptyView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author wangyaogang 2019-12-27 HIAPOSCMP-455 标准版支付功能开发,聚合扫码页
 */
@ActivityLayoutInject(R.layout.activity_sale_std_dialog)
public class SaleStdDialogActivity extends BaseMvpActivity<IEmptyView, EmptyPresenter> implements IEmptyView, KeyBoardStdView.OnKeyboardListener {

    @BindView(R.id.edtSaleStdModifyPluCount)
    public EditText edtSaleStdModifyPluCount;

    @BindView(R.id.saleStdModifyKeyboard)
    public KeyBoardStdView saleStdModifyKeyboard;

    private int position;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
        initValue(this.getIntent());
    }

    @Override
    protected EmptyPresenter createPresenter() {
        return new EmptyPresenter();
    }

    private void init() {
        SoftInput.disable(edtSaleStdModifyPluCount);
        saleStdModifyKeyboard.setOnKeyboardListener(this);
        findViewById(R.id.tvStdBoardNumPoints).setEnabled(false);
    }

    public void initValue(Intent intent) {
        Bundle bundle = intent.getExtras();
        if (bundle == null) {
            CommonTools.toastLong("商品数量为空");
            return;
        }

        position = bundle.getInt("position");
        edtSaleStdModifyPluCount.setText(String.valueOf(bundle.getInt("pluCount")));
        edtSaleStdModifyPluCount.setSelection(edtSaleStdModifyPluCount.getText().toString().length());
    }

    @OnClick(R.id.relativeSaleStdModifyCancel)
    public void onClickCancel() {
        finish();
    }

    @Override
    public void onInsertKeyEvent(String text) {
        if (".".equals(text)) {
            return;
        }

        KeyBoardStdView.addChar(edtSaleStdModifyPluCount, text);
    }

    @Override
    public void onDeleteKeyEvent() {
        KeyBoardStdView.deleteChar(edtSaleStdModifyPluCount);
    }

    @Override
    public void onClearKeyEvent() {
        KeyBoardStdView.clearChar(edtSaleStdModifyPluCount);
    }

    @Override
    public void onDoneKeyEvent() {
        if (StringUtils.isEmpty(edtSaleStdModifyPluCount.getText().toString().trim())) {
            CommonTools.toastShort("数量不能为空");
            return;
        }
        int quantity;
        try {
            quantity = Integer.parseInt(edtSaleStdModifyPluCount.getText().toString().trim());
        } catch (NumberFormatException e) {
            CommonTools.toastShort("数量过大或不合法");
            return;
        }
        if (quantity == 0) {
            CommonTools.toastShort("数量不能为0");
            return;
        }

        getSale().changeQuantity(position, quantity);
        finish();
    }
}
