package com.hisense.hiaposcmp.activity.std.vip;

import android.content.Intent;
import android.os.Bundle;
import android.text.InputType;
import android.widget.EditText;

import androidx.annotation.Nullable;

import com.hisense.crm.card.CardNo;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.card.CardBaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.presenter.VipLoginPresenter;
import com.hisense.hiaposcmp.view.IView.IVipLoginView;
import com.hisense.hiaposcmp.view.KeyBoardStdView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author wangwenyue on 2018/7/4.
 * @author dukunbiao(null)  2019-07-24  重构
 * @author wangyaogang      2020-02-18  HIAPOSCMP-518 标准版会员登录页优化
 */
@ActivityLayoutInject(R.layout.activity_vip_login_std)
public class VipLoginStdActivity extends CardBaseMvpActivity<IVipLoginView, VipLoginPresenter> implements IVipLoginView, KeyBoardStdView.OnKeyboardListener {

    @BindView(R.id.edtVipLoginStdCardNo)
    public EditText edtVipLoginStdCardNo;

    @BindView(R.id.edtVipLoginStdPwd)
    public EditText edtVipLoginStdPwd;

    @BindView(R.id.keyBrdSaleStdKeyBoard)
    public KeyBoardStdView keyBrdSaleStdKeyBoard;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @Override
    protected VipLoginPresenter createPresenter() {
        return new VipLoginPresenter();
    }

    private void init() {
        isNotShowExitDialog(true);

        edtVipLoginStdCardNo.setInputType(InputType.TYPE_NULL);
        edtVipLoginStdPwd.setInputType(InputType.TYPE_NULL);

        keyBrdSaleStdKeyBoard.setOnKeyboardListener(this);
    }

    @OnClick(R.id.imvVipLoginStdCancel)
    public void onClickCancel() {
        finish();
    }

    @OnClick(R.id.btnVipLoginStdLogin)
    public void onClickEnter() {
        if (isFastClick()) {
            return;
        }

        try {
            mPresenter.vipQuery(edtVipLoginStdCardNo.getText().toString().trim());
        } catch (NullPointerException e) {
            hideLoadingDialog();
        }
    }

    @Override
    public void vipLoginSuccess(Vip vip) {
        Intent intent = new Intent();
        if (vip != null) {
            intent.putExtra("vip", vip);
        }
        setResult(ActivityConstants.RESULT_SALE_TO_VIP_LOGIN, intent);
        finish();
    }

    @Override
    public void vipLoginFail(String msg) {
        showHintDialog("会员验证失败", msg);
    }

    @Override
    public void verifyTypeSuccess(Vip vip) {

    }

    @Override
    public void verifyTypeFail(String msg) {

    }

    @Override
    public void onInsertKeyEvent(String text) {
        KeyBoardStdView.addChar(edtVipLoginStdCardNo, text);
    }

    @Override
    public void onDeleteKeyEvent() {
        KeyBoardStdView.deleteChar(edtVipLoginStdCardNo);
    }

    @Override
    public void onClearKeyEvent() {
        KeyBoardStdView.clearChar(edtVipLoginStdCardNo);
    }

    @Override
    public void onDoneKeyEvent() {
        if (isFastClick()) {
            return;
        }

        try {
            mPresenter.vipQuery(edtVipLoginStdCardNo.getText().toString().trim());
        } catch (NullPointerException e) {
            hideLoadingDialog();
        }
    }
    @Override
    protected void onCardRead(CardNo cardNo) {
        mPresenter.vipQuery(cardNo);
    }
}
