package com.hisense.hiaposcmp.activity.wx;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.tool.ScanKeyEventHelper;
import com.hisense.hiaposcmp.presenter.pay.PayScanPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.pay.IPayScanView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author liaoyuping on 2018/7/4.
 * @author dukunbiao(null)  2019-07-25  重构
 */
@ActivityLayoutInject(R.layout.activity_qrpay_wx)
public class PayScanWxActivity extends BaseMvpActivity<IPayScanView, PayScanPresenter> implements IPayScanView, ScanKeyEventHelper.OnScanSuccessListener {

    private ScanKeyEventHelper mScanKeyEventHelper;

    @BindView(R.id.lytQRPayBack)
    public RelativeLayout lytBack;

    @BindView(R.id.txtYFCost)
    public TextView txtYfCost;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        LoggerUtils.getLogger().debug("PayScanWxActivity onCreate");

        processIntent();
    }

    @Override
    protected PayScanPresenter createPresenter() {
        return new PayScanPresenter();
    }

    protected void processIntent() {
        txtYfCost.setText("");

        Intent intent = this.getIntent();
        Bundle bundle = intent.getExtras();
        if (bundle == null) {
            CommonTools.toastLong(this, "获取请求支付参数失败");
            return;
        }

        if (bundle.containsKey("totalPaid")) {
            txtYfCost.setText("￥" + bundle.getString("totalPaid"));
        }
    }

    @OnClick(R.id.lytQRPayBack)
    public void onClickQuit() {
        finish();
    }

    @Override
    public void onScanSuccess(String barcode) {
        CommonUtils.startBeepBgm(this, barcode);

        Intent intent = new Intent();
        intent.putExtra("barcode", barcode);
        PayScanWxActivity.this.setResult(ActivityConstants.RESULT_PAY_TO_SCAN, intent);
        PayScanWxActivity.this.finish();
        finish();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getKeyCode() == KeyEvent.KEYCODE_ENTER && isFastClick()) {
            //屏蔽连扫的第二个条码
            LoggerUtils.getLogger().info("屏蔽条码:" + event.getKeyCode());
        } else {
            mScanKeyEventHelper.analysisKeyEvent(event);
        }

        return super.dispatchKeyEvent(event);
    }

    @Override
    protected void onResume() {
        super.onResume();
        LoggerUtils.getLogger().debug("PayScanWxActivity onResume");
        mScanKeyEventHelper = new ScanKeyEventHelper(this);

    }

    @Override
    protected void onPause() {
        super.onPause();
        LoggerUtils.getLogger().debug("PayScanWxActivity onPause");
        mScanKeyEventHelper.onDestroy();
    }

    @Override
    protected void onDestroy() {
        LoggerUtils.getLogger().debug("PayScanWxActivity onDestroy");
        mScanKeyEventHelper.onDestroy();
        super.onDestroy();
    }
}
