package com.hisense.hiaposcmp.activity.wx.refund;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.MainActivity;
import com.hisense.hiaposcmp.activity.ysy.refund.SaleRefundActivity;
import com.hisense.hiaposcmp.activity.ysy.refund.viewModel.ReturnItemViewModel;
import com.hisense.hiaposcmp.adapter.SaleReturnItemsAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.layout.SwitchViewWatcher;
import com.hisense.hiaposcmp.presenter.refund.SaleReturnPresenter;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.refund.ISaleReturnView;
import com.hisense.hipos.model.ReturnSaleModel;
import com.hisense.hipos.model.ReturnSalePluModel;
import com.hisense.pos.scanner.IScanner;

import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

@ActivityLayoutInject(R.layout.activity_sale_return_wx)
public class SaleReturnWxActivity extends BaseMvpActivity<ISaleReturnView, SaleReturnPresenter> implements ISaleReturnView {
    /**
     * 原交易流水号
     */
    @BindView(R.id.btnGoBack)
    public LinearLayout btnGoBack;
    /**
     * 原交易流水号
     */
    @BindView(R.id.edtSaleNo)
    public EditText edtSaleNo;
    /**
     * 退货流水号
     */
    @BindView(R.id.txtSaleNo)
    public TextView txtSaleNo;
    /**
     * 会员布局
     */
    @BindView(R.id.lytVip)
    public LinearLayout lytVip;
    /**
     * 会员卡布局
     */
    @BindView(R.id.lytVipCard)
    public LinearLayout lytVipCard;
    /**
     * 非会员布局
     */
    @BindView(R.id.lytNonVip)
    public LinearLayout lytNonVip;
    /**
     * 会员卡号
     */
    @BindView(R.id.txtVipCardNo)
    public TextView txtVipCardNo;
    /**
     * 会员卡类型名称
     */
    @BindView(R.id.txtVipTypeName)
    public TextView txtVipTypeName;
    /**
     * 会员名称
     */
    @BindView(R.id.txtVipName)
    public TextView txtVipName;
    /**
     * 券号
     */
    @BindView(R.id.txtTotalReturn)
    public TextView txtTotalReturn;
    /**
     * 合计实收
     */
    @BindView(R.id.txtTotal)
    public TextView txtTotal;
    /**
     * 全选
     */
    @BindView(R.id.imgSelectAll)
    public ImageView imgSelectAll;
    /**
     * 退货商品数量布局
     */
    @BindView(R.id.lytReturnCount)
    public LinearLayout lytReturnCount;
    /**
     * 退货商品数量
     */
    @BindView(R.id.txtReturnCount)
    public TextView txtReturnCount;
    /**
     * 原交易商品数量
     */
    @BindView(R.id.txtTotalCount)
    public TextView txtTotalCount;
    /**
     * 清空流水号
     */
    @BindView(R.id.lytClearSaleNo)
    public RelativeLayout lytClearSaleNo;
    /**
     * 扫描条码
     */
    @BindView(R.id.lytScanForSaleNo)
    public RelativeLayout lytScanForSaleNo;
    /**
     * 查询
     */
    @BindView(R.id.lytQuery)
    public RelativeLayout lytQuery;
    /**
     * 全选
     */
    @BindView(R.id.lytSelectAll)
    public LinearLayout lytSelectAll;
    /**
     * 退货
     */
    @BindView(R.id.lytReturn)
    public LinearLayout lytReturn;
    /**
     * 退货商品listview
     */
    @BindView(R.id.lvwSaleItems)
    public ListView lvwReturnItems;
    /**
     * 是否点击退货按钮
     */
    private volatile boolean hasReturned;

    /**
     * 退货商品适配器
     */
    private SaleReturnItemsAdapter saleReturnItemsAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mScanner = getScanner(this);
        mPresenter.saveAuthNo();
        mainSaleModel.returnSaleModel(null);
        edtSaleNoListener();
        adapter();
        updateVip(null);
    }

    @Override
    protected SaleReturnPresenter createPresenter() {
        return new SaleReturnPresenter();
    }

    /**
     * 返回
     */
    @OnClick(R.id.btnGoBack)
    public void onClickBack() {
        LoggerUtils.getLogger().debug("点击返回键");
        onBackPressed();
    }

    /**
     * 退货商品适配器
     */
    @OnClick(R.id.lytQuery)
    public void onClickQuery() {
        mPresenter.querySale(edtSaleNo.getText().toString());
    }

    /**
     * 退货商品适配器
     */
    @OnClick(R.id.lytClearSaleNo)
    public void onClickClearSaleNo() {
        edtSaleNo.setText("");
    }

    /**
     * 扫描流水号条码
     */
    @OnClick(R.id.lytScanForSaleNo)
    public void onClickScanForSaleNo() {
        mPresenter.scanForSaleNo();
    }

    /**
     * 全选
     */
    @OnClick(R.id.lytSelectAll)
    public void onClickSelectAll() {
        changeSelectAllState();
    }

    /**
     * 点击退货按钮
     */
    @OnClick(R.id.lytReturn)
    public void onClickReturn() {
        try {
            LoggerUtils.getLogger().debug("return点击了退货");
            if (hasReturned) {
                return;
            }
            LoggerUtils.getLogger().debug("return有效点击了退货");
            hasReturned = true;

            mPresenter.refund();
        } finally {
            hasReturned = false;
        }
    }

    /**
     * 更新流水号
     */
    @Override
    public void updateSaleNo(String saleNo) {
        txtSaleNo.setText(saleNo);
    }

    /**
     * 更新合计信息。
     *
     * @param returnCount   退货数量
     * @param totalCount    原交易流水合计商品数量
     * @param totalReceived 原交易流水合计实收金额
     * @param totalReturn   合计退款金额
     */
    @Override
    public void updateTotal(String returnCount, String totalCount, String totalReceived, String totalReturn) {
        txtTotal.setText(totalReceived);
        txtTotalCount.setText(String.valueOf(totalCount));
        this.updateTotal(returnCount, totalReturn);
        lytReturnCount.setVisibility(BigDecimalUtils.isGreater0(totalCount) ? View.VISIBLE : View.GONE);
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 使用退货流水更新合计信息。
     *
     * @param returnSaleModel 退货流水
     */
    @Override
    public void updateTotal(ReturnSaleModel returnSaleModel) {
        this.updateTotal(returnSaleModel.calcQuantity(), returnSaleModel.getTotalRecv());
    }

    /**
     * 使用指定数据更新合计。
     *
     * @param returnCount 退货数量
     * @param totalReturn 合计退款金额
     */
    @Override
    public void updateTotal(String returnCount, String totalReturn) {
        if (mPresenter.getReturnSaleModel() != null && mPresenter.getReturnSaleModel().isReturnAll()) {
            imgSelectAll.setImageResource(R.drawable.ic_check_checked);
        } else {
            imgSelectAll.setImageResource(R.drawable.ic_check_normal);
        }
        txtReturnCount.setText(String.valueOf(returnCount));
        txtTotalReturn.setText(totalReturn);
    }


    @Override
    public IScanner iScanner() {
        return mScanner;
    }

    /**
     * 更改全选状态。
     */
    private void changeSelectAllState() {
        if (saleReturnItemsAdapter == null || mPresenter.getReturnSaleModel() == null) {
            return;
        }

        boolean checkAll = true;
        if (mPresenter.getReturnSaleModel().isReturnAll()) {
            checkAll = false;
        }

        for (ReturnItemViewModel item : mPresenter.getListSalesItemData()) {
            item.changeCheckState(checkAll);
        }

        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 更改商品选择状态。
     */
    private void changeItemCheckState() {
        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 多退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnMore(int position) {
        //  mPresenter.getListSalesItemData().get(position).returnSaleItem().returnMore();

        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();

        mPresenter.getReturnSaleModel().returnMore(position, returnSalePluModel);
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 少退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnLess(int position) {
        // mPresenter.getListSalesItemData().get(position).returnSaleItem().returnLess();
        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();

        mPresenter.getReturnSaleModel().returnLess(position, returnSalePluModel);
//        if (returnSalePluModel.isWeightOrEquivalent()) {
//            mPresenter.getReturnSaleModel().changeQuantity(position+1,0);
//        } else {
//            mPresenter.getReturnSaleModel().changeQuantity(position+1,Integer.parseInt(returnSalePluModel.getQuantity()));
//        }

        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 输入流水号后触发查询流水事件
     */
    private void edtSaleNoListener() {
        edtSaleNo.addTextChangedListener(new SwitchViewWatcher(lytClearSaleNo, lytScanForSaleNo));
        edtSaleNo.setImeOptions(EditorInfo.IME_ACTION_DONE);
        edtSaleNo.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int actionId, KeyEvent keyEvent) {
                if (actionId == EditorInfo.IME_ACTION_DONE) {
                    mPresenter.querySale(edtSaleNo.getText().toString());
                }
                return false;
            }
        });
        edtSaleNo.setText(SaleNoService.getMax(this, Config.org_code, Config.pos_no));
        edtSaleNo.setSelection(edtSaleNo.length());
        edtSaleNo.requestFocus();
    }

    /**
     * 退货商品适配器
     */
    @Override
    public void adapter() {
        saleReturnItemsAdapter = new SaleReturnItemsAdapter(this, true, mPresenter.saleItem(), new ReturnItemAdapterHandler(this));
        lvwReturnItems.setAdapter(saleReturnItemsAdapter);

    }

    /**
     * 选择的退货商品列表
     */
    private List<ReturnItemViewModel> getPresenterReturnModels() {
        return mPresenter.getListSalesItemData();
    }

    /**
     * 退货商品适配器处理程序。
     */
    public class ReturnItemAdapterHandler extends Handler {
        private SaleReturnWxActivity activity;

        ReturnItemAdapterHandler(SaleReturnWxActivity activity) {
            this.activity = activity;
        }

        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);

            // 少退一件
            if (msg.what == SaleReturnItemsAdapter.SALE_ITEM_QUANTITY_DECREASED) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                this.activity.returnLess(position);
            }

            // 多退一件
            if (msg.what == SaleReturnItemsAdapter.SALE_ITEM_QUANTITY_INCREASED) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                this.activity.returnMore(position);
            }

            // 修改退款金额
            if (msg.what == SaleReturnItemsAdapter.EDIT_SINGLE_ITEM_TOTAL) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                double returnTotal = bundle.getDouble("returnTotal");
                this.activity.getPresenterReturnModels().get(position).returnSaleItem().returnTotal(returnTotal);
                this.activity.updateTotal(mPresenter.getReturnSaleModel());
            }

            // 更改选择状态
            if (msg.what == SaleReturnItemsAdapter.CHECKBOX_SINGLE_ITEM_COUNT) {
                this.activity.changeItemCheckState();
            }
        }
    }

    /**
     * 更新会员布局
     */
    @Override
    public void updateVip(Vip vip) {
        if (vip == null) {
            lytVip.setVisibility(View.GONE);
            lytVipCard.setVisibility(View.GONE);
            lytNonVip.setVisibility(View.VISIBLE);
        } else {
            lytVip.setVisibility(View.VISIBLE);
            lytVipCard.setVisibility(View.VISIBLE);
            lytNonVip.setVisibility(View.GONE);

            txtVipCardNo.setText(vip.card().cardFaceNo());
            txtVipTypeName.setText(vip.card().cardType().name());
            txtVipName.setText(vip.name());

            if (vip.projects().size() > 0) {
                mPresenter.getReturnSaleModel().setLastUsablePoint(String.format("%s", vip.projects().get(0).usablePoints()));
            } else {
                mPresenter.getReturnSaleModel().setLastUsablePoint("0");
            }
        }
    }

    @Override
    public void gotoRefundActivity() {

        CommonTools.goTo(this, SaleRefundWxActivity.class);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            updateSaleNo(mScanner.getScanResult(data));
            mPresenter.querySale(mScanner.getScanResult(data));

        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            LoggerUtils.getLogger().debug("点击设备返回键");
            CommonTools.exit(this, MainActivity.class);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }


    @Override
    protected void onResume() {
        super.onResume();
    }
}
