/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.common.AboutActivity;
import com.hisense.hiaposcmp.activity.common.AuthActivity;
import com.hisense.hiaposcmp.activity.common.LoginActivity;
import com.hisense.hiaposcmp.activity.ysy.auth.ChangePasswordActivity;
import com.hisense.hiaposcmp.activity.ysy.auth.LeaveActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PaymentChannelActivity;
import com.hisense.hiaposcmp.activity.ysy.report.CashierReportActivity;
import com.hisense.hiaposcmp.activity.ysy.report.ReportEntryActivity;
import com.hisense.hiaposcmp.activity.ysy.report.SaleReportActivity;
import com.hisense.hiaposcmp.activity.ysy.sale.QueryActivity;
import com.hisense.hiaposcmp.activity.ysy.sale.SaleGiftActivity;
import com.hisense.hiaposcmp.activity.ysy.vip.VipLoginActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.cache.Cache;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.presenter.MainPresenter;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.service.sale.SaleApplicationService;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.IMainView;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.user.Privileges;
import com.hisense.hipos.user.User;
import com.hisense.hipos.webapi.Context;
import com.hisense.pos.payment.IPaymentServiceProvider;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 主界面
 *
 * @author fujiaxin    2017-03-14
 * @author caoakai     2017-03-20
 * @author xieliyan    2017-09-01 选择总交易报表时，传入报表类型
 * @author xieliyan    2017-09-18 HIPOSAPP-158 修复本地上传流水签名错误问题
 * @author zhangsai    2017-10-26 HIPOSAPP-193 退出时提示用户
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author xieliyan    2017-11-24 HIPOSAPP-224 射频卡密码获取方式更改
 * @author zhangsai    2017-12-21 HIPOSAPP-250 改由通过 SaleService 获取当前结账日期
 * @author xieliyan    2018-01-23 HIPOSAPP-299 支持建行收单
 * @author zhangsai    2018-01-24 HIPOSAPP-302 改由通过 SaleService 进行日结
 * @author zhangsai    2018-03-28 HIPOSAPP-369 更改对话框调用
 * @author zhangsai    2018-06-20 HIPOSAPP-545 上传流水返回时从消息中获取流水号和会员卡号（兼容正常流水和本地流水上传）
 * @author zhangsai    2018-01-08 HIPOSAPP-649 优化获取射频卡密码逻辑
 * @author zhangsai    2018-07-16 HIPOSAPP-668 创建时加载支付方式
 * @author wangyaogang 2018-11-08 HIPOSAPP-813 增加中行支付渠道
 * @author wangyaogang 2018-11-26 HIPOSAPP-836 系统设置流程调整
 * @author guolina     2018-11-26 HIPOSAPP-902 读取本地未上传流水表时去掉条数限制
 * @author wangyaogang 2018-12-18 HIPOSAPP-870 日结时调用银石APP同时结算
 * @author wangyaogang 2018-12-24 HIPOSAPP-926 日结后进行结算流程优化,增加可配置选项
 * @author zhangsai    2018-12-26 HIPOSAPP-931 优化本地流水上传逻辑，使用 SaleApplicationService 上传流水
 * @author guolina     2019-01-15 HIPOSAPP-934 日结时增加结账日期提示
 * @author wangyaogang 2019-01-16 HIPOSAPP-936 功能权限由CMP5控制下发,尤其是【查询】和【报表】中的功能权限
 * @author wangyaogang 2019-01-16 HIPOSAPP-987 登录用户没有权限时设置权限列表为空
 * @author guolina     2019-04-10 HIPOSAPP-1065 支持清理本地三个月前已上传流水信息
 * @author dukunbiao(null)  2019-09-06  重构
 * @author guolina     2019-10-24  重构日结
 * @author guolina     2019-10-21 HIPOSAPP-1317 利客来未上传流水自动上传
 */
@ActivityLayoutInject(R.layout.activity_main)
public class MainActivity extends BaseMvpActivity<IMainView, MainPresenter> implements IMainView {

    @BindView(R.id.txtTitle)
    public TextView txtTitle;

    @BindView(R.id.txtUserName)
    public TextView txtUserName;

    @BindView(R.id.linearSale)
    public RelativeLayout mLinearSale;

    @BindView(R.id.linearReturn)
    public RelativeLayout mLinearReturn;

    @BindView(R.id.linearPreSales)
    public RelativeLayout mLinearPreSales;

    @BindView(R.id.imgSale)
    public ImageView mImgSale;

    @BindView(R.id.txtSale)
    public TextView mTxtSale;

    @BindView(R.id.txtUnion)
    public TextView txtUnion;

    @BindView(R.id.imgUnion)
    public ImageView imgUnion;

    private int mCurrentCardVersion = -1;

    private IPaymentServiceProvider paymentServiceProvider;
    private SaleApplicationService saleApplicationService;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @Override
    protected MainPresenter createPresenter() {
        return new MainPresenter();
    }

    private void init() {
        isNotShowExitDialog = true;

        txtTitle.setText(R.string.app_name);
        txtUserName.setText(Config.user_name);

        initView();

        PayMethodService.getAll(this, null);

        saleApplicationService = new SaleApplicationService(this);

        if (!saleApplicationService.deleteUploadedLocalData()) {
            LoggerUtils.getLogger().info("本地无三个月前已上传流水");
        }
    }

    private void initView() {
        updateMenuPayment();

        if (GeneralSettings.INSTANCE.isUseGiftCard() != true) {
            View view = this.findViewById(R.id.giftcashSquare);
            view.setVisibility(View.INVISIBLE);
        }

        if (GeneralSettings.INSTANCE.isSaleReturnEnabled()) {
            mLinearReturn.setVisibility(View.VISIBLE);
        } else {
            mLinearReturn.setVisibility(View.GONE);
        }
        if (GeneralSettings.INSTANCE.isPreSaleEnabled()) {
            mLinearPreSales.setVisibility(View.VISIBLE);
        } else {
            mLinearPreSales.setVisibility(View.GONE);
        }

        if (GeneralSettings.INSTANCE.isSaleEnabled()) {
            mImgSale.setImageResource(R.drawable.ic_menu_sale);
            mTxtSale.setVisibility(View.VISIBLE);
            mLinearSale.setEnabled(true);
        } else {
            mImgSale.setImageResource(R.drawable.logo72);
            mTxtSale.setVisibility(View.GONE);
            mLinearSale.setEnabled(false);
        }
    }

    private void updateMenuPayment() {
        if (GeneralSettings.INSTANCE.getPaymentChannel().isCCB()) {
            txtUnion.setText(R.string.payment_channel_ccb);
            imgUnion.setImageResource(R.drawable.ic_menu_ccb);
        } else if (GeneralSettings.INSTANCE.getPaymentChannel().isICBC()) {
            txtUnion.setText(R.string.payment_channel_icbc);
            imgUnion.setImageResource(R.drawable.ic_menu_icbc);
        } else if (GeneralSettings.INSTANCE.getPaymentChannel().isBOC()) {
            txtUnion.setText(R.string.payment_channel_boc);
            imgUnion.setImageResource(R.drawable.ic_menu_boc);
        } else {
            txtUnion.setText(R.string.payment_channel_ums);
            imgUnion.setImageResource(R.drawable.ic_menu_union_pay);
        }
    }

    @OnClick(R.id.btnLeave)
    public void onClickLeave() {
        if (!mPresenter.uploadLocalData()) {
            CommonTools.goTo(this, LeaveActivity.class);
        }

    }

    @OnClick(R.id.linearSale)
    public void onClickSale() {
        mPresenter.serviceOnline();
    }

    @OnClick(R.id.linearReturn)
    public void onClickReturn() {
        AuthActivity.authToReturn(this);
    }

    @OnClick(R.id.linearPreSales)
    public void onClickPreSales() {
        CommonTools.goTo(this, VipLoginActivity.class, "tranType", String.valueOf(TranType.PreSale.value()));
    }

    @OnClick(R.id.linearSearch)
    public void onClickSearch() {
        CommonTools.goTo(this, QueryActivity.class);
    }

    @OnClick(R.id.linearAllReport)
    public void onClickAllReport() {
        if (hasPrivilege(Privileges.REPORT_SALE)) {
            CommonTools.gotoActivity(SaleReportActivity.class, "tranType", TranType.Sale.value());
        } else {
            showHintDialog("没有总交易报表查询权限");
        }
    }

    @OnClick(R.id.linearCashierReport)
    public void onClickCashierReport() {
        if (hasPrivilege(Privileges.REPORT_CASHIER)) {
            CommonTools.goTo(this, CashierReportActivity.class);
        } else {
            showHintDialog("没有收银员报表查询权限");
        }
    }

    @OnClick(R.id.linearSpecialReport)
    public void onClickSpecialReport() {
        CommonTools.goTo(this, ReportEntryActivity.class);
    }

    @OnClick(R.id.linearSettingPwd)
    public void onClickSettingPwd() {
        CommonTools.goTo(this, ChangePasswordActivity.class);
    }

    @OnClick(R.id.linearSetting)
    public void onClickSetting() {
        AuthActivity.authToSystemSettings(this);
    }

    @OnClick(R.id.linearEndDay)
    public void onClickEndDay() {
        if (!saleApplicationService.uploadLocalData()) {
            mPresenter.account();
        }

    }

    @OnClick(R.id.giftcash)
    public void onClickGiftCash() {
        CommonTools.goTo(this, SaleGiftActivity.class);
    }

    @OnClick(R.id.linearUnionPay)
    public void onClickUnionPay() {
        CommonTools.goTo(this, PaymentChannelActivity.class);
    }

    @OnClick(R.id.lytAbout)
    public void onClickAbout() {
        CommonTools.goTo(this, AboutActivity.class);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            CommonTools.exit(this, LoginActivity.class);


            return true;
        }
        return super.onKeyDown(keyCode, event);
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (paymentServiceProvider != null && paymentServiceProvider.requestCode() == requestCode) {
            try {
                paymentServiceProvider.handleResult(data);
            } catch (Exception ex) {
                showHintDialog(ex.getMessage());
                LoggerUtils.getLogger().error(ex.getMessage(), ex);
            }
        }

        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    protected void onResume() {
        super.onResume();
        mPresenter.startSaleUploadAuto();

        showLoadingDialog();
        CommonUtils.reInitSaleModel(new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                hideLoadingDialog();
            }

            @Override
            public void onError(String err) {
                hideLoadingDialog();
                showHintDialog(err);
            }
        });

        initView();

        //获取射频卡信息
        if (mCurrentCardVersion != GeneralSettings.INSTANCE.getIcCardVersion().value()) {
            mPresenter.getIcCardPassword();
        }

        paymentServiceProvider = getPaymentServiceProvider(this);
        if (Context.cashier() != null) {
            mPresenter.queryPrivileges(Context.cashier().id());
        }
    }

    @Override
    public void serviceOnlineSuccess() {
        CommonTools.goTo(this, VipLoginActivity.class, "tranType", String.valueOf(TranType.Sale.value()));
    }

    @Override
    public void getIcCardPasswordSuccess(String password) {
        mCurrentCardVersion = GeneralSettings.INSTANCE.getIcCardVersion().value();
        Cache.icCardPassword(password);
    }

    @Override
    public void queryPrivilegesSuccess(User user) {
        super.setUser(user);
    }

    @Override
    public void queryPrivilegesFail() {
        super.setUser(null);
    }

    @Override
    public void getAccountingDateSuccess(String accDate) {
        mPresenter.confirmAccounting(accDate);
    }

    @Override
    public void accountingSuccess(String s) {
        LoggerUtils.getLogger().debug("允许结算:" + GeneralSettings.INSTANCE.isSettleAfterAccount());
        if (GeneralSettings.INSTANCE.isSettleAfterAccount()) {
            try {
                paymentServiceProvider.settle(null);
            } catch (Exception ex) {
                showHintDialog(ex.getMessage());
                LoggerUtils.getLogger().error(ex.getMessage(), ex);
            }
        }
    }
}
