/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.auth;

import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.MainActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.presenter.auth.ChangePasswordPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IChangePasswordView;
import com.hisense.hiaposcmp.view.KeyBoardView;

import butterknife.BindView;
import butterknife.OnClick;
import butterknife.OnTouch;

/**
 * 修改密码。
 *
 * @author fujiaxin 2017-03-14
 * @author xieliyan 2017-07-11 密码输入使用安全键盘
 * @author zhangsai 2017-10-27 HIPOSAPP-194 升级修改登录密码的WebAPI调用；增加新密码确认
 * @author guolina  2019-10-23  重构
 */
@ActivityLayoutInject(R.layout.activity_change_password)
public class ChangePasswordActivity extends BaseMvpActivity<IChangePasswordView, ChangePasswordPresenter> implements IChangePasswordView {

    @BindView(R.id.txtCashierName)
    TextView txtCashierName;

    @BindView(R.id.txtCashierCode)
    TextView txtCashierCode;

    @BindView(R.id.editOld)
    EditText editOld;

    @BindView(R.id.editNew)
    EditText editNew;

    @BindView(R.id.editConfirm)
    EditText editConfirm;

    KeyBoardView keyBoard;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    @Override
    protected ChangePasswordPresenter createPresenter() {
        return new ChangePasswordPresenter();
    }

    private void init() {
        txtCashierName.setText(Config.user_name);
        txtCashierCode.setText(Config.user_code);
    }

    @Override
    public void changePasswordSuccess() {
        CommonTools.goTo(ChangePasswordActivity.this, MainActivity.class);
        finish();
    }

    @OnClick(R.id.btnGoBack)
    public void onClickGoBack(View view) {
        finish();
    }

    @OnClick(R.id.btnChange)
    public void onClickChange(View view) {
        String oldPwd = editOld.getText().toString();
        String newPwd = editNew.getText().toString();
        String confirmPwd = editConfirm.getText().toString();
        mPresenter.changePassword(oldPwd, newPwd, confirmPwd);
    }

    @OnTouch({R.id.editOld, R.id.editNew, R.id.editConfirm})
    public boolean onTouch(View view, MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_UP) {
            keyBoard = new KeyBoardView((EditText) view);
            keyBoard.showKeyboard();
            mPresenter.disableShowSoftInput(editOld);
            mPresenter.disableShowSoftInput(editNew);
            mPresenter.disableShowSoftInput(editConfirm);
        }
        return false;
    }
}
