/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.auth;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.TextView;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.MainActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.layout.CombinedEditText;
import com.hisense.hiaposcmp.presenter.auth.LeavePresenter;
import com.hisense.hiaposcmp.tool.SystemConfig;
import com.hisense.hiaposcmp.view.IView.ILeaveView;
import com.hisense.hipos.webapi.auth.LoginResultData;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 暂离。
 *
 * @author fujiaxin 2017-03-14
 * @author zhangsai 2017-10-20 HIPOSAPP-186 升级用户身份验证的WebAPI调用
 * @author zhangsai 2017-10-26 HIPOSAPP-193 退出时提示用户
 * @author guolina  2019-10-23  重构
 */
@ActivityLayoutInject(R.layout.activity_leave)
public class LeaveActivity extends BaseMvpActivity<ILeaveView, LeavePresenter> implements ILeaveView {

    @BindView(R.id.edtPassword)
    CombinedEditText edtPassword;

    @BindView(R.id.txtCashierCode)
    TextView txtCashierCode;

    @BindView(R.id.txtVersion)
    TextView txtVersion;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    @Override
    protected LeavePresenter createPresenter() {
        return new LeavePresenter();
    }

    private void init() {
        txtCashierCode.setText(Config.user_name);
        txtVersion.setText(this.getVersion());

        edtPassword.getKeyboard();
    }

    /**
     * 暂离。
     *
     * @author zhangsai 2017-10-26 HIPOSAPP-193
     * @author xieliyan 2017-11-13 HIPOSAPP-210 暂离时用户名选择错误
     */
    private void login() {
        String password = this.edtPassword.getText().toString();
        if (StringUtils.isEmpty(password)) {
            showHintDialog(this.getString(R.string.msg_no_password));
            return;
        }

        String uuid = SystemConfig.getBluetoothAddress();
        if (StringUtils.isEmpty(uuid)) {
            showHintDialog(this.getString(R.string.msg_no_uuid));
            return;
        }
        mPresenter.login(password, uuid);
    }

    @Override
    public void loginSuccess(LoginResultData loginResult) {
        Intent intent = new Intent(LeaveActivity.this, MainActivity.class);
        startActivity(intent);
    }

    /**
     * 设备键盘监听事件
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            this.mPresenter.exit();
            return true;
        }

        return true;
    }

    @OnClick(R.id.btnLeaveLogin)
    public void onViewClicked() {
        login();
    }
}
