/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.card;

import android.os.Bundle;
import android.widget.TextView;

import com.hisense.crm.card.Card;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;

import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 储值卡余额。
 *
 * @author xieliyan 2017-03-28
 * @author zhangsai 2018-01-31 HIPOSAPP-311 优化储值卡余额查询
 */
@ActivityLayoutInject(R.layout.activity_card_balance_query)
public class CardBalanceActivity extends BaseActivity {

    @BindView(R.id.txtCardBalance)
    public TextView txtBalance;

    @BindView(R.id.txtCardFaceNo)
    public TextView txtCardFaceNo;

    @BindView(R.id.txtCardType)
    public TextView txtCardType;

    @BindView(R.id.txtCardExpiredDate)
    public TextView txtCardExpiredDate;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    private void init() {
        Bundle bundle = this.getIntent().getExtras();
        Card card = (Card) bundle.getSerializable("card");

        txtCardFaceNo.setText(card.cardFaceNo());
        txtCardType.setText(String.format(Locale.CHINESE, "%s-%s", card.cardType().code(), card.cardType().name()));
        txtBalance.setText(String.format(Locale.CHINESE, "%.2f", card.usableTotal()));
        txtCardExpiredDate.setText(card.expireDate());
    }

    @OnClick(R.id.btnGoBack)
    public void onViewClicked() {
        onBackPressed();
    }
}
