/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.pay;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.vip.VerifyType;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.StartActivityService;
import com.hisense.hiaposcmp.activity.std.pay.CouponQueryStdActivity;
import com.hisense.hiaposcmp.activity.ysy.sale.SaleActivity;
import com.hisense.hiaposcmp.adapter.VipCoupon;
import com.hisense.hiaposcmp.adapter.VipCouponListAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.presenter.pay.CouponPresenter;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.ICouponView;
import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.CouponType;
import com.hisense.hipos.coupon.UsableCoupon;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 会员券显示界面
 *
 * @author xieliyan    2017-11-14 HIPOSAPP-235
 * @author xieliyan    2017-12-20 HIPOSAPP-248  修复取消用券再次点击时不可用的缺陷
 * @author xieliyan    2017-12-21 HIPOSAPP-235  修复券可核销金额为0时仍记录的缺陷
 * @author xieliyan    2018-03-07 HIPOSAPP-348  一段式赠券单笔添加
 * @author xieliyan    2018-04-09 HIPOSAPP-382  修复由于App.getContext空指针异常导致的闪退问题
 * @author guolina     2019-02-25 HIPOSAPP-1029 去掉TicketPluBean.java文件，优化代码
 * @author guolina     2019-03-25 HIPOSAPP-1048 修复手动添加会员券再次选中时未传校验码导致的用券失败
 * @author wangyaogang 2019-06-13 HIPOSAPP-1134 一段式核销接口返回剩余可用券信息
 * @author wangyaogang 2019-06-28 HIPOSAPP-1184 一段式用券验证支付密码
 * @author wangyaogang 2019-07-02 HIPOSAPP-1180 校验参数封装为CardSecurity
 * @author wangyaogang 2019-07-03 HIPOSAPP-1130 单张点击添加和全选之前判断券类型是否和已选的一致,全选时还会判断所有要添加的券类型是否一致
 * @author wangyaogang 2019-07-19 HIPOSAPP-1216 积分卡传值优化,卡类型为7时,isVerifyPwd值取决于开关状态,非7默认1
 * @author xieliyan    2019-08-05 HIPOSAPP-1277 对接SCRM-获取会员卡验证方式:请求参数增加payMethod
 * @author dukunbiao(null)  2019-10-17  重构
 * @author guolina     2019-12-13 HIAPOSCMP-430 单个添加会员券全选时去掉不可全选提示
 * @author guolina     2020-02-20 HIPOSAPP-1377 批量用券时一次性计算
 */
@ActivityLayoutInject(R.layout.activity_vip_coupon_show)
public class CouponUseActivity extends BaseMvpActivity<ICouponView, CouponPresenter> implements ICouponView, AdapterView.OnItemClickListener {

    @BindView(R.id.relativeSelect)
    public RelativeLayout lytSelect;

    @BindView(R.id.relativeChange)
    public RelativeLayout lytChange;

    @BindView(R.id.relativeAdd)
    public RelativeLayout lytAdd;

    @BindView(R.id.imgSelect)
    public ImageView imgSelect;

    @BindView(R.id.btnSelect)
    public Button btnSelect;

    @BindView(R.id.btnConfirm)
    public Button btnConfirm;

    @BindView(R.id.txtTotalValue)
    public TextView txtTotalValue;

    @BindView(R.id.lytGoBack)
    public LinearLayout lytBack;

    @BindView(R.id.list_vip_coupon)
    public ListView list;

    private VipCouponListAdapter mVipCouponListAdapter;
    private List<VipCoupon> mCouponList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    @Override
    protected CouponPresenter createPresenter() {
        return new CouponPresenter();
    }

    private void init() {
        txtTotalValue.setText("0.0");
        list.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE);
        list.setOnItemClickListener(this);

        mPresenter.initSelectedPayMethod(this.getIntent());
    }

    @OnClick(R.id.lytGoBack)
    public void onClickBack() {
        clearAll();
        imgSelect.setImageResource(R.drawable.ic_check_normal);
        finish();
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            LoggerUtils.getLogger().debug("点击设备返回键");
            clearAll();
            imgSelect.setImageResource(R.drawable.ic_check_normal);
            finish();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    @OnClick(R.id.btnConfirm)
    public void onClickConfirm() {
        if (mVipCouponListAdapter == null) {
            return;
        }
        if (mVipCouponListAdapter.available() == 0) {
            showHintDialog("未生成抵扣金额");
        } else {
            //mPresenter.couponUse1(mVipCouponListAdapter.useValue());
            mPresenter.calCoupon(mVipCouponListAdapter,mCouponList);
        }
    }

    @OnClick(R.id.relativeSelect)
    public void onClickSelect() {
        if (mVipCouponListAdapter == null) {
            return;
        }

        if (mVipCouponListAdapter.isAllSelected()) {
            imgSelect.setImageResource(R.drawable.ic_check_normal);
            clearAll();
            return;
        }

        //全选之前判断券类型和已使用的是否一致
        for (UsableCoupon usableCoupon : mPresenter.getSale().getUsableCoupons().items()) {
            for (VipCoupon vipCoupon : mCouponList) {
                if (usableCoupon.coupon().type() != vipCoupon.coupon().type()) {
                    showHintDialog("请勿同时使用金额券和折扣券");
                    return;
                }
            }
        }

        //全选之前判断要选的券是否类型一致
        if (mCouponList.size() > 1) {
            CouponType type = mCouponList.get(0).coupon().type();
            for (VipCoupon vipCoupon : mCouponList) {
                if (type != vipCoupon.coupon().type()) {
                    showHintDialog("请勿同时使用金额券和折扣券");
                    return;
                }
            }
        }

        if (mCouponList.size() > 10) {
            showHintConfirm("券数量大于10，是否确定全选 ?", new UniCallback() {
                @Override
                public void onSuccess(String msg) {
                    lytSelect.setEnabled(false);
                    selectAll();
                }

                @Override
                public void onError(String err) {

                }
            });
        } else {
            selectAll();
        }
    }

    @OnClick(R.id.relativeChange)
    public void onClickChange() {
        Intent intent = new Intent();
        //todo 临时在这替换, 原则上整个页面都需要修改
        if (CommonUtils.isStdStyle()) {
            intent.setClass(this, CouponQueryStdActivity.class);
        } else {
            intent.setClass(this, CouponQueryActivity.class);
        }
        startActivityForResult(intent, ActivityConstants.REQUEST_VIP_COUPON_CALCULATE);
    }

    @OnClick(R.id.relativeAdd)
    public void onClickAdd() {
        Intent intent = new Intent();
        intent.setClass(this, CouponAdditionActivity.class);
        startActivityForResult(intent, ActivityConstants.REQUEST_COUPON_ADDITION);
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        view.setFocusable(true);
        view.setFocusableInTouchMode(true);
        if (mCouponList.get(position).isSelected()) {
            imgSelect.setImageResource(R.drawable.ic_check_normal);
            int index = mVipCouponListAdapter.selectedItems().indexOf(position);
            mVipCouponListAdapter.unSelect(position);
            try {
                mPresenter.getSale().getUsableCoupons().cancel(index);
            } catch (Exception e) {
                showHintDialog(e.getMessage());
            }
            updateUi();
        } else {
            //mPresenter.couponCalc(coupon, position);
            calculate(position);
        }
    }
    /**
     * 单选券计算
     *
     * @param position 选中券位置
     */
    private void calculate(final int position) {
        selectCoupon(position);
        updateSelected();}

    /**
     * 选中券
     *
     * @param position 券位置
     */
    private void selectCoupon(final int position) {
        final Coupon coupon = mCouponList.get(position).coupon();
        final UsableCoupon usableCoupon = new UsableCoupon(null, coupon, null);
        mPresenter.getSale().getUsableCoupons().use(usableCoupon);
        mVipCouponListAdapter.select(position, usableCoupon);
        updateUi();
    }

    private void selectAll() {
        clearAll();
        for (int i = 0; i < mCouponList.size(); i++) {
            selectCoupon(i);
        }
        if (mVipCouponListAdapter.isAllSelected()) {
            imgSelect.setImageResource(R.drawable.ic_check_checked);
        }

        lytSelect.setEnabled(true);
    }

    private void clearAll() {
        try {
            mVipCouponListAdapter.unSelectAll();
            mPresenter.getSale().getUsableCoupons().cancelAll();
            updateUi();
        } catch (Exception e) {
            showHintDialog(e.getMessage());
        }
    }

    private void updateUi() {
        txtTotalValue.setText(String.valueOf(mVipCouponListAdapter.available()));
        if (mVipCouponListAdapter.selectedItems().size() > 0) {
            btnConfirm.setText(String.format(Locale.CHINESE, "核销(%d)", mVipCouponListAdapter.selectedItems().size()));
        } else {
            btnConfirm.setText("核销");
        }
    }

    private void updateSelected() {
        if (mVipCouponListAdapter.isAllSelected()) {
            imgSelect.setImageResource(R.drawable.ic_check_checked);
        }
    }

    private void updateSelectButton() {
        if (mCouponList.size() > 0) {
            btnSelect.setText(String.format(Locale.CHINESE, "全选(%d)", mCouponList.size()));
        } else {
            btnSelect.setText("全选");
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode == ActivityConstants.REQUEST_VIP_COUPON_CALCULATE && resultCode == ActivityConstants.RESULT_VIP_COUPON_CALCULATE) {
            if (data != null) {
                String cardFaceNo = data.getStringExtra("cardFaceNo");
                mPresenter.queryVipCoupons(cardFaceNo);
            }
        } else if (requestCode == ActivityConstants.REQUEST_COUPON_ADDITION && resultCode == ActivityConstants.RESULT_COUPON_ADDITION) {
            couponAddSuccess(data);
        }
    }

    private void couponAddSuccess(Intent data) {
        Bundle bundle = data.getExtras();
        if (bundle == null) {
            return;
        }

        final UsableCoupon usableCoupon = (UsableCoupon) bundle.getSerializable("usableCoupon");
        if (usableCoupon == null) {
            return;
        }

        final VipCoupon vipCoupon = new VipCoupon(true, usableCoupon.coupon());
        mCouponList.add(vipCoupon);

        if (mVipCouponListAdapter == null) {
            mVipCouponListAdapter = new VipCouponListAdapter(CouponUseActivity.this, mCouponList);
            list.setAdapter(mVipCouponListAdapter);
        } else {
            mVipCouponListAdapter.coupons(mCouponList);
        }

        mVipCouponListAdapter.select(mCouponList.indexOf(vipCoupon), usableCoupon);

        updateUi();
        updateSelected();

        updateSelectButton();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onStop() {

        super.onStop();
    }

    @Override
    public void couponCalcSuccess(int position, UsableCoupon usableCoupon) {
        mVipCouponListAdapter.select(position, usableCoupon);
        updateUi();
        updateSelected();
    }

    @Override
    public void needVerifyType(VerifyType verifyType) {
        StartActivityService.startCardSecurityInputActivity(CouponUseActivity.this, false, verifyType);
    }

    @Override
    public void queryVipCouponsSuccess(List<Coupon> coupons) {
        //清除已添加的券
        if (mVipCouponListAdapter != null) {
            clearAll();
            imgSelect.setImageResource(R.drawable.ic_check_normal);
            if (mCouponList.size() > 0) {
                mCouponList.clear();
            }
        }

        //将可用券添加到列表中
        for (int i = 0; i < coupons.size(); i++) {
            if (coupons.get(i).available() > 0) {
                VipCoupon vipCoupon = new VipCoupon(false, coupons.get(i));
                mCouponList.add(vipCoupon);
                LoggerUtils.getLogger().info("查询出的会员券,第" + mCouponList.size() + "个" + vipCoupon.coupon().no());
            }
        }

        //适配
        mVipCouponListAdapter = new VipCouponListAdapter(CouponUseActivity.this, mCouponList);
        list.setAdapter(mVipCouponListAdapter);
        updateSelectButton();
    }

    @Override
    public void couponUse1Success(Collection<UsableCoupon> usableCoupons, Collection<Coupon> coupons) {
        SaleActivity.remainedCouponMap.put(mPresenter.getSale().getSaleNo(), coupons);

        Intent intent = new Intent();
        intent.putExtra("use", String.valueOf(mVipCouponListAdapter.useValue()));
        intent.putExtra("usableCoupons", (Serializable) usableCoupons);
        setResult(ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS, intent);
        finish();
    }

    @Override
    public void calcCouponsSuccess() {
        updateUi();
        updateSelected();
    }
}
