/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.pay;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.StartActivityService;
import com.hisense.hiaposcmp.adapter.PayItemsAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.pos.payment.UmsPaymentFactory;
import com.hisense.hiaposcmp.presenter.pay.PayPresenter;
import com.hisense.hiaposcmp.service.payment.AggregatePaymentChannel;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.tool.HomeWatcher;
import com.hisense.hiaposcmp.tool.UpdateTextButton;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.util.NetUtils;
import com.hisense.hiaposcmp.view.IView.pay.IPayView;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.PayRequest;
import com.hisense.pos.payment.PayResult;
import com.hisense.pos.payment.PaymentHandler;
import com.hisense.pos.payment.PaymentProviderException;
import com.hisense.pos.payment.icbc.IcbcPaymentProvider;
import com.hisense.pos.payment.icbc.PurchaseTransResult;
import com.hisense.pos.scanner.IScanner;
import com.hisense.pos.scanner.ScannerCallback;
import com.ums.AppHelper;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 支付。
 *
 * @author zhenghao    2017-03-30
 * @author fujiaxin    2017-04-18 修复采用多次不同支付方式支付，第二次采用支付宝或微信支付后如果仍任没有完全支付但直接跳转到销售页面的问题。
 * @author xieliyan    2017-09-06 增加厦门会员卡1和厦门会员卡2的支付方式
 * @author xieliyan    2017-09-09 HIPOSAPP-150 由于网络原因造成的卡撤销失败使用重试功能
 * @author xieliyan    2017-09-09 HIPOSAPP-203 使用其他支付方式支付，重新回到支付界面，需付金额大于0时，确定按钮可用
 * @author zhangsai    2017-10-23 HIPOSAPP-187 升级获取赢商通配置的WebAPI调用
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author xieliyan    2017-11-17 HIPOSAPP-219 厦门本地会员卡撤销
 * @author xieliyan    2017-12-06 HIPOSAPP-236 商品列表加密处理
 * @author zhangsai    2017-12-21 HIPOSAPP-253 通过 PaymentService 获取支付方式
 * @author xieliyan    2017-12-21 HIPOSAPP-254 控制需付金额大小
 * @author xieliyan    2017-12-25 HIPOSAPP-256 满减根据支付方式顺序调整参与计算金额
 * @author xieliyan    2018-01-02 HIPOSAPP-262 支持建行收单支付（银联卡，微信，支付宝）
 * @author xieliyan    2018-01-04 HIPOSAPP-265 储值卡查询时增加密码
 * @author zhangsai    2018-01-16 HIPOSAPP-277 根据支付方式个数动态创建支付方式布局
 * @author zhangsai    2018-02-01 HIPOSAPP-313 通过 CardService 进行储值卡支付
 * @author zhangsai    2018-02-01 HIPOSAPP-314 通过 CardService 进行储值卡支付撤销
 * @author zhangsai    2018-02-02 HIPOSAPP-315 通过 PointsService 查询积分
 * @author zhangsai    2018-02-02 HIPOSAPP-316 通过 PointsService 进行积分支付
 * @author zhangsai    2018-02-02 HIPOSAPP-317 通过 PointsService 进行积分支付撤销
 * @author xieliyan    2018-02-05 HIPOSAPP-318 储值卡支付 - 余额存在小数无法继续进行支付
 * @author xieliyan    2018-02-07 HIPOSAPP-320 修复会员券号记录错误的问题
 * @author xieliyan    2018-02-08 HIPOSAPP-301 交易完成支付后自动上传流水，无需用户手工点击"完成"按钮
 * @author zhangsai    2018-02-13 HIPOSAPP-331 通过 CouponService 进行赠券解锁
 * @author zhangsai    2018-02-13 HIPOSAPP-332 通过 CouponService 进行赠券核销
 * @author xieliyan    2018-03-02 HIPOSAPP-333 一笔交易中同一张赠券不允许多次录入
 * @author xieliyan    2018-03-05 HIPOSAPP-343 一段式赠券核销单笔单次使用
 * @author xieliyan    2018-03-15 HIPOSAPP-356 满减金额分摊造成的异常问题
 * @author xieliyan    2018-04-10 HIPOSAPP-346 会员一段式用券支持撤销
 * @author xieliyan    2018-04-18 HIPOSAPP-408 支持米雅支付
 * @author guolina     2018-05-03 HIPOSAPP-429 修复积分和储值卡支付撤销时如果有会员券支付出错的问题
 * @author guolina     2018-05-15 HIPOSAPP-449 包含微信支付宝支付的不允许撤销
 * @author xieliyan    2018-05-23 HIPOSAPP-459 修复储值卡撤销卡号和流水序号不对应导致的撤销异常问题
 * @author xieliyan    2018-05-28 HIPOSAPP-464 修复支付完成后，流水上传成功，支付方式仍能撤销的问题
 * @author lizhixin    2018-06-04 HIPOSAPP-485 记录当前是否处于支付过程中，用于强制退出的判断条件
 * @author zhangsai    2018-06-15 HIPOSAPP-538 从SaleActivity传入Sale流水，记录支付信息
 * @author zhangsai    2018-06-20 HIPOSAPP-565 使用SaleActivity进行满减促销（记录为支付方式）
 * @author zhangsai    2018-06-21 HIPOSAPP-576 修改满减促销逻辑，同时支持支付方式和商品优惠两种记录方式
 * @author zhangsai    2018-07-01 HIPOSAPP-611 满减以支付方式记录时点击支付方式直接满减，无需点击确定按钮
 * @author guolina     2018-07-02 HIPOSAPP-616 支付撤销增加提示对话框
 * @author zhangsai    2018-07-12 HIPOSAPP-664 使用储值卡/积分成功支付后记录状态并在撤销时返回该状态
 * @author zhangsai    2018-07-16 HIPOSAPP-670 点击确定按钮先判断满减再判断现金，避免满减作为现金处理
 * @author guolina     2018-08-07 HIPOSAPP-572 修复会员券核销出现需付金额为负数。
 * @author guolina     2018-08-15 HIPOSAPP-724 修复满赠券支付完成时无法上传流水。
 * @author guolina     2018-08-16 HIPOSAPP-735 修复撤销时需付金额刷新错误
 * @author guolina     2018-08-17 HIPOSAPP-738 修复支付列表显示会员券面值而不是实际抵扣金额的问题
 * @author guolina     2018-08-17 HIPOSAPP-741 修复储值卡撤销未付金额没刷新的问题
 * @author guolina     2018-09-04 HIPOSAPP-763 修复银联卡撤销未付金额没刷新的问题
 * @author guolina     2018-09-26 HIPOSAPP-770 支持销售/退款后增加储值卡和积分余额打印
 * @author zhangsai    2018-12-07 HIPOSAPP-888 使用IPaymentProvider完成支付/撤销
 * @author wangyaogang 2018-12-04 HIPOSAPP-837 支持微信,支付宝直连支
 * @author wangyaogang 2018-12-08 HIPOSAPP-889 优化撤销交易逻辑
 * @author zhangsai    2018-12-08 HIPOSAPP-892 优化支付撤销逻辑，撤销时按支付顺序倒序依次撤销
 * @author wangyaogang 2018-12-08 HIPOSAPP-855 付款界面中控制微信和支付宝支付不允许串刷，避免对账混乱。
 * @author wangyaogang 2019-01-04 HIPOSAPP-906 修复满减金额为0时仍进行支付的错误
 * @author guolina     2018-09-26 HIPOSAPP-839 打印支持聚合支付优惠
 * @author zhangsai    2019-01-07 HIPOSAPP-956 支持POS中间件4.7.4整单促销接口
 * @author zhangsai    2019-01-08 HIPOSAPP-966 支持多种促销的商品分摊
 * @author wangyaogang 2019-01-11 HIPOSAPP-972 对接中间件石基支付,请求参数优化
 * @author zhangsai    2019-01-15 HIPOSAPP-971 “满减”改为“优惠”，整单促销接口返回非满减促销时显示对应的优惠金额
 * @author wangyaogang 2019-01-15 HIPOSAPP-981 对接中间件石基支付，返回结果ZFNO字段由 tradeNo 改为记outTradeNo
 * @author guolina     2019-02-25 HIPOSAPP-1029 去掉TicketPluBean.java文件，优化代码
 * @author wangyaogang 2019-02-28 HIPOSAPP-1031 优化扫描结果传值逻辑
 * @author guolina     2019-03-14 HIPOSAPP-1052 支持其他支付方式
 * @author guolina     2019-04-09 HIPOSAPP-1074 支持储值卡/积分动态码支付
 * @author guolina     2019-04-09 HIPOSAPP-1082 修复积分录入会员密码后的闪退
 * @author wangyaogang 2019-05-09 HIPOSAPP-1086 支持银联扫码支付
 * @author wangyaogang 2019-05-14 HIPOSAPP-1095 易收银各类Toast提示信息改为弹窗提示,方便记录
 * @author wangyaogang 2019-05-23 HIPOSAPP-1124 请求储值卡支付时增加交易查询避免网络问题导致单边账
 * @author wangyaogang 2019-05-23 HIPOSAPP-1125 请求积分支付时增加交易查询避免网络问题导致单边账
 * @author wangyaogang 2019-05-23 HIPOSAPP-1123 请求海信支付时增加交易查询避免网络问题导致单边账
 * @author wangyaogang 2019-05-24 HIPOSAPP-1123 优化储值卡/积分/海信支付调用支付结果查询接口的逻辑
 * @author wangyaogang 2019-05-27 HIPOSAPP-1139 去掉"商户优惠金额”和“平台优惠金额”的弹框提示
 * @author wangyaogang 2019-05-29 HIPOSAPP-1135 可配置付款码查询时是否需要密码
 * @author wangyaogang 2019-06-03 HIPOSAPP-1151 储值卡/积分/海信pay支付和撤销时超时时间设置为2分钟
 * @author wangyaogang 2019-06-10 HIPOSAPP-1135 储值卡/积分支付 查询/支付/撤销接口增加isVerifyPwd字段
 * @author zhangsai    2019-06-13 HIPOSAPP-1169 Sale.pay(Payment) 返回类型改为 ISalePayment
 * @author wangyaogang 2019-06-19 HIPOSAPP-1171 储值卡/积分卡查询,支付,撤销增加校验码cardVerifyCode字段,且各开关不再互斥
 * @author wangyaogang 2019-06-26 HIPOSAPP-1180 储值卡/积分卡更改为根据接口确定验证类型(动态付款码仍根据本地开关确定)
 * @author wangyaogang 2019-07-01 HIPOSAPP-1189 使用 IScanner 扫描器实例扫描
 * @author wangyaogang 2019-07-02 HIPOSAPP-1180 储值卡/积分卡校验参数封装为CardSecurity
 * @author wangyaogang 2019-07-17 HIPOSAPP-1214 储值卡/积分卡传值优化,卡类型为7时,isVerifyPwd值取决于开关状态,非7默认1
 * @author wangyaogang 2019-08-02 HIPOSAPP-1237 防止短时间内多次响应操作请求,确定和取消按钮
 * @author wangyaogang 2019-08-08 HIPOSAPP-1259 封装网络异常判断方法
 * @author wangyaogang 2019-08-09 HIPOSAPP-1264 调整online接口超时时间,在判断网络状态有问题时,立刻弹框提示
 * @author xieliyan    2019-08-02 HIPOSAPP-1238 增加scrm会员券核销
 * @author xieliyan    2019-08-02 HIPOSAPP-1239 增加scrm会员券撤销
 * @author xieliyan    2019-08-07 HIPOSAPP-1226  增加SCRM积分支付
 * @author xieliyan    2019-08-07 HIPOSAPP-1258  增加SCRM余额支付
 * @author xieliyan    2019-08-07 HIPOSAPP-1260  增加SCRM积分撤销
 * @author xieliyan    2019-08-07 HIPOSAPP-1258  增加SCRM余额撤销
 * @author wangyaogang 2019-08-19 HIPOSAPP-1225  银联商务增加支付查询
 * @author xieliyan    2019-08-05 HIPOSAPP-1277 对接SCRM-获取会员卡验证方式:请求参数增加payMethod
 * @author wangyaogang 2019-08-05 HIPOSAPP-1285 储值卡/积分撤销时,根据remark查询对应的code和name,而不是取最后选择的支付方式的值
 * @author dukunbiao(null)  2019-10-14  重构
 * @author wangyaogang 2019-12-10 HIAPOSCMP-413 工行撤销时关闭loading
 * @author wangyaogang 2019-12-13 HIAPOSCMP-417 工行支付返回数据异常时进行提示,让用户选择接下来的操作
 * @author guolina     2020-01-13 HIAPOSCMP-495 易收银调整整单促销接口
 * @author wangyaogang 2020-04-14 HIAPOSCMP-654 增加利客来银联商务支付异常（超时等）查询功能
 */
@ActivityLayoutInject(R.layout.activity_pay)
public class PayActivity extends BaseMvpActivity<IPayView, PayPresenter> implements IPayView, View.OnClickListener {

    private IPaymentProvider paymentProvider;

    @BindView(R.id.btnPay)
    public Button btnPay;

    @BindView(R.id.lytTotalDscShare)
    public LinearLayout lytTotalDscShare;

    @BindView(R.id.btnFinish)
    public Button btnFinish;

    @BindView(R.id.txtPayAmount)
    public EditText txtPayAmount;      // 本笔支付金额

    @BindView(R.id.txtTotal)
    public TextView txtTotal;          // 合计

    @BindView(R.id.txtTotalDue)
    public TextView txtTotalDue;       // 应收金额

    @BindView(R.id.txtTotalUnpaid)
    public TextView txtTotalUnpaid;    // 未付金额

    @BindView(R.id.txtTotalPaid)
    public TextView txtTotalPaid;      // 已付金额

    @BindView(R.id.txtTotalDscShare)
    public TextView txtTotalDscShare;  // 整单促销优惠金额

    @BindView(R.id.lvwSalePayItems)
    public ListView lvwSalePayItems;

    @BindView(R.id.lytExpand)
    public LinearLayout lytExpand;

    private ArrayList<SalePayModel> mSalePayItems;//支付信息
    private PayItemsAdapter mPayItemsAdapter;

    private PayMethod mSelectedPayMethod; //当前支付方式
    public LinearLayout lytSelectedPayMethod;

    private boolean mVipServiceCalled = false;
    private volatile boolean hasPayed;//是否点击过确定
    private volatile boolean hasCanceled;//是否点击过取消
    private volatile String uniqueNo = ""; //用于区分每笔收单行交易

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //记录当前处于支付过程中
        App.getInstance().isPaying = true;
        // 查询支付方式
        PayMethodService.createCompactLayout(this, this);

        init();
        initPresenter();
        initAdapter();
        updateTotal();
        initValue();
    }

    @Override
    protected PayPresenter createPresenter() {
        return new PayPresenter();
    }

    private void init() {
        mScanner = getScanner(this);
        txtPayAmount.setEnabled(true);
        txtPayAmount.setText(txtTotalUnpaid.getText());
        txtPayAmount.setInputType(EditorInfo.TYPE_CLASS_PHONE);
        btnPay.setEnabled(true);
        btnPay.setTag(0);

        //点击home按键
        HomeWatcher mHomeWatcher = new HomeWatcher(this);
        mHomeWatcher.setOnHomePressedListener(new HomeWatcher.OnHomePressedListener() {
            @Override
            public void onHomePressed() {
                if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                    return;
                }

                mPresenter.cancelPayFinish();
            }

            @Override
            public void onHomeLongPressed() {
                if (mSalePayItems.size() > 0) {
                    showHintDialog("已经进行了支付，不能返回");
                    return;
                }

                mPresenter.cancelPayFinish();
            }
        });

        mHomeWatcher.startWatch();
    }

    private void initPresenter() {
        mPresenter.initMiYaConfig();
        mPresenter.initYstConfig();
    }

    private void initAdapter() {
        mSalePayItems = new ArrayList<>();
        mPayItemsAdapter = new PayItemsAdapter(this, mSalePayItems);
        lvwSalePayItems.setAdapter(mPayItemsAdapter);
    }

    private void initValue() {
        mPresenter.abandonFenDsc();
    }

    @OnClick(R.id.lytExpand)
    public void onClickExpand() {
        Intent intent = new Intent(PayActivity.this, PayMethodSelectActivity.class);
        startActivityForResult(intent, ActivityConstants.RESULT_SELECT_PAY_METHOD);
    }

    @OnClick(R.id.btnGoBack)
    public void onClickGoBack() {
        if (mSalePayItems.size() > 0) {
            showHintDialog("已经进行了支付，不能返回");
        } else {
            mPresenter.cancelPayFinish();
        }
    }

    @Override
    public void whenPayDone() {

    }

    @Override
    public void gotoScanActivity() {

    }

    @Override
    public void afterPaySuccess(Bundle bundle) {
        btnFinish.setEnabled(false);
        btnFinish.setText("完成");

        Intent intent = new Intent();
        this.setResult(ActivityConstants.RESULT_SALE_TO_PAY, intent);
        this.finish();
    }

    @Override
    public void afterPayFailure(String msg) {

    }

    @Override
    public void gotoCouponUseActivity() {
        if (!ListUtils.isEmpty(mPresenter.getSale().getPays())) {
            for (SalePayModel payModel : mPresenter.getSale().getPays()) {
                if (PayMethod.isVipCoupon(payModel.getRemark())) {
                    showHintDialog("请勿重复使用会员券支付");
                    return;
                }
            }
        }
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", mPresenter.selectedPayMethod());

        Intent intent = new Intent();
        intent.setClass(PayActivity.this, CouponUseActivity.class);
        intent.putExtras(bundle);
        startActivityForResult(intent, ActivityConstants.REQUEST_PAY_TO_COUPON);
    }

    @Override
    public void gotoScrmCouponActivity() {
        Bundle bundle = new Bundle();
        bundle.putSerializable("payMethod", mPresenter.selectedPayMethod());

        Intent intent = new Intent();
        intent.setClass(PayActivity.this, CouponQueryActivity.class);
        intent.putExtras(bundle);
        startActivityForResult(intent, ActivityConstants.REQUEST_SCRM_COUPON_USE);
    }

    @Override
    public void updateTotal() {
        txtTotal.setText(mPresenter.getSale().getTotalRecv());                      //合计
        txtTotalDue.setText(mPresenter.getSale().getTotalRecv());                   //应收
        txtTotalUnpaid.setText(mPresenter.getSale().getTotalUnPaid());              //未付
        txtTotalPaid.setText(mPresenter.getSale().getTotalPaid());                  //已付
        txtPayAmount.setText(mPresenter.getSale().getTotalUnPaid());                //需付

        if (BigDecimalUtils.isNotEquals(mPresenter.getSale().getTotalDsc(), "0")) {
            lytTotalDscShare.setVisibility(View.VISIBLE);
            txtTotalDscShare.setText(mPresenter.getSale().getTotalDsc());
        }

        txtPayAmount.setSelection(txtPayAmount.getText().toString().length());
        UpdateTextButton.setOnTextChange(txtPayAmount, mPresenter.getSale().getTotalUnPaid());

        if (mPresenter.getSale().hasAlreadyPaid()) {
            btnFinish.setEnabled(true);
            btnFinish.setText("撤销");
            txtPayAmount.setEnabled(true);
        }
    }

    public void updateAdapter() {
        if (mPayItemsAdapter != null) {
            mPayItemsAdapter.setData(mPresenter.getSale().getPays());
            mPayItemsAdapter.notifyDataSetChanged();
        }
    }

    @Override
    public void gotoCardPayActivity() {
        StartActivityService.gotoCardPayActivity(PayActivity.this, mPresenter.selectedPayMethod(), null, "");    //储值卡刷卡
    }

    @Override
    public void gotoPointsPayActivity() {
        StartActivityService.gotoPointsPayActivity(PayActivity.this, mPresenter.selectedPayMethod(), null, "0");//积分卡分支
    }

    @Override
    public void gotoOtherPayActivity() {
        Intent intent = new Intent();
        intent.putExtra("total_unpaid", txtPayAmount.getText().toString());
        intent.setClass(PayActivity.this, OtherPayActivity.class);
        startActivityForResult(intent, ActivityConstants.REQUEST_OTHER_PAYMETHOD);
    }

    @Override
    public void gotoPayChannel(String totalPaid) {
        if (mSelectedPayMethod.isAllInPayType()) {
            LoggerUtils.getLogger().debug("海信全支付打开扫描");
            hxPay(totalPaid);

            return;
        }

        try {
            paymentProvider = getPaymentProvider(this, mSelectedPayMethod.remark());
        } catch (Exception e) {
            showHintDialog("获取支付提供程序失败：" + e.toString());
            return;
        }

        if (paymentProvider != null) {
            bankPay(totalPaid);
        } else if (mSelectedPayMethod.isAllOrChannelType()) {
            if (AggregatePaymentChannel.isYST()) {
                mScanner.scan(new ScannerCallback() {
                    @Override
                    public void onSuccess(final String s) {
                        mScanner.close();
                        mPresenter.payYst(s, totalPaid);
                    }

                    @Override
                    public void onError(final Throwable t) {
                        showHintDialog(t.getMessage());
                    }
                });
            } else if (AggregatePaymentChannel.isMIYA()) {
                mScanner.scan(new ScannerCallback() {
                    @Override
                    public void onSuccess(final String s) {
                        mScanner.close();
                        mPresenter.payMiYa(s, totalPaid);
                    }

                    @Override
                    public void onError(final Throwable t) {
                        showHintDialog(t.getMessage());
                    }
                });
            } else if (AggregatePaymentChannel.isHXPAY()) {
//                //海信支付时,温州时代希望微信走海信支付,支付宝仍使用收单行渠道,所以加此分支
//                if (mSelectedPayMethod.isAliPay() && CommonUtils.isTimesSquare(this)) {
//                    LoggerUtils.getLogger().debug("温州时代-海信Pay-支付宝走收单行渠道-pay");
//                    try {
//                        paymentProvider = UmsPaymentFactory.createProvider(this, mSelectedPayMethod.remark());
//                    } catch (Exception e) {
//                        showHintDialog("获取支付提供程序失败：" + e.toString());
//                        return;
//                    }
//                    if (paymentProvider != null) {
//                        bankPay(totalPaid);
//                    }
//
//                    return;
//                }

                LoggerUtils.getLogger().debug("海信支付打开扫描");
                hxPay(totalPaid);
            }
        } else if (mSelectedPayMethod.isAllInPayByPayType()) {
            LoggerUtils.getLogger().debug("海信在线支付打开扫描");
            hxPay(totalPaid);
        } else {
            showHintDialog("暂未支持该支付方式");
        }
    }

    private void hxPay(String totalPaid) {
        mScanner.scan(new ScannerCallback() {
            @Override
            public void onSuccess(final String s) {
                mScanner.close();
                mPresenter.payPay(s);
            }

            @Override
            public void onError(final Throwable t) {
                showHintDialog(t.getMessage());
            }
        });
    }

    private void bankPay(String totalPaid) {
        try {
            showLoadingDialog();
            queryCount = 0;
            uniqueNo = PayRequest.generateUniqueNo(com.hisense.hipos.webapi.Context.posNo());
            PayRequest payRequest = new PayRequest(Double.parseDouble(totalPaid), uniqueNo);
            paymentProvider.pay(payRequest, new PaymentHandler() {
                @Override
                public void onFinish(Object... args) {
                    hideLoadingDialog();
                    handleIcbcPurchaseResult(args);
                }
            });
        } catch (Exception ex) {
            hideLoadingDialog();
            showHintDialog(ex.getMessage());
            LoggerUtils.getLogger().error(ex.toString(), ex);
        }
    }

    @Override
    public void paySuccess(SalePayModel payModel) {
        if (payModel == null) {
            updateTotal();
            btnFinish.setText("撤销");
            txtPayAmount.setEnabled(true);
            return;
        }

        PayFinishedActivity.afterPay(PayActivity.this, ActivityConstants.REQUEST_PAY_FINISHED);
        mSalePayItems.add(payModel);
        mPayItemsAdapter.notifyDataSetChanged();
    }

    @Override
    public void cancelPaySuccess(SalePayModel payModel) {
        btnPay.setEnabled(true);
        if (PayMethod.isVipCoupon(payModel.getRemark())) {
            for (int i = 0; i < getSale().getUsableCoupons().size(); i++) {
                if (0 == mSalePayItems.size()) {
                    showHintDialog("支付列表为空");
                    return;
                }
                int j = mSalePayItems.size() - 1;
                //针对ArrayList的操作均需要在同步锁保护下进行，如add、remove、get等操作，防止闪退
                Object mLock = new Object();
                synchronized (mLock) {
                    mSalePayItems.remove(j);
                }


                if (i > 0) {
                    getSale().removePay(j);
                }
            }
        } else if (PayMethod.isScrmCoupon(payModel.getRemark())) {
            int j = 0;
            for (int i = mSalePayItems.size() - 1; i >= 0; i--) {
                if (PayMethod.isScrmCoupon(mSalePayItems.get(i).getRemark())) {
                    mSalePayItems.remove(i);

                    if (j > 0) {
                        getSale().removePay(i);
                    }
                    j++;
                }
            }
        } else {
            mSalePayItems.remove(mSalePayItems.size() - 1);
        }

        mPayItemsAdapter.notifyDataSetChanged();
    }

    @Override
    public void cancelPayError() {
        btnPay.setEnabled(true);
    }

    @Override
    public void cancelPayFinish() {
        Intent intent = new Intent();
        intent.putExtra("isVipServiceCalled", mVipServiceCalled);
        this.setResult(RESULT_CANCELED, intent);
        this.finish();
    }

    @Override
    public void onClick(View v) {
        if (isFastClick()) {
            return;
        }

        LinearLayout lytPayMethod = (LinearLayout) v;
        selectPayMethod(lytPayMethod);
        paySuccess(null);
        mSelectedPayMethod = (PayMethod) lytSelectedPayMethod.getTag();

        LoggerUtils.getLogger().debug("payactivity支付方式:" + mSelectedPayMethod.code() + "," + mSelectedPayMethod.name() + "," + mSelectedPayMethod.remark());
        PayMethodService.updateFrequency(this, mSelectedPayMethod);

        mPresenter.pay((PayMethod) lytPayMethod.getTag());
    }

    @OnClick(R.id.btnFinish)
    public void onClickFinish() {
        try {
            if (hasCanceled) {
                return;
            }

            hasCanceled = true;
            mPresenter.cancelPay();
        } finally {
            hasCanceled = false;
        }
    }

    @OnClick(R.id.btnPay)
    public void onClickPay() {
        try {
            if(isFastClick()){
                return;
            }
            LoggerUtils.getLogger().info("点击了支付");
            if ((mSelectedPayMethod == null) || (lytSelectedPayMethod == null)) {
                showHintDialog("支付", "请选择支付方式");
                return;
            }

            if (!btnPay.isEnabled() || hasPayed) {
                return;
            }

            LoggerUtils.getLogger().info("有效点击了支付");
            hasPayed = true;
            btnPay.setEnabled(false);

            mPresenter.pay(txtPayAmount.getText().toString().trim());
        } finally {
            hasPayed = false;
            btnPay.setEnabled(true);
        }
    }

    private void selectPayMethod(LinearLayout l) {
        if (lytSelectedPayMethod != null) {
            lytSelectedPayMethod.setBackgroundResource(R.drawable.border);
        }

        lytSelectedPayMethod = l;
        lytSelectedPayMethod.setBackgroundResource(R.drawable.border_red);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME || keyCode == KeyEvent.KEYCODE_MENU) {
            if (mSalePayItems.size() > 0) {
                showHintDialog("已经进行了支付，不能返回");
                return false;
            }

            mPresenter.cancelPayFinish();
        }

        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if ((requestCode == ActivityConstants.REQUEST_PAY_TO_CARD && resultCode == ActivityConstants.RESULT_PAY_TO_CARD_SUCCESS) ||
                (requestCode == ActivityConstants.REQUEST_PAY_TO_POINTS && resultCode == ActivityConstants.RESULT_PAY_TO_POINTS_SUCCESS)) {
            btnPay.setEnabled(true);
            mVipServiceCalled = true;

            mPresenter.paySuccess();
            LoggerUtils.getLogger().debug("储值卡支付成功");
        } else if (requestCode == ActivityConstants.REQUEST_PAY_TO_COUPON && resultCode == ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS) {
            mPresenter.paySuccess();
        } else if (paymentProvider != null && paymentProvider.requestCode() == requestCode) {
            bankPay(data);
        } else if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            scanSuccessPay(data);
        } else if ((requestCode == ActivityConstants.SCANNIN_UPWALLET_CODE) && (resultCode == RESULT_OK)) {
            //fixme null
            HashMap<String, Object> map = new HashMap<>();
            map.put("amt", mPresenter.getSale().getTotalUnPaid());
            map.put("tradeType", "useScan");
            AppHelper.callTrans(PayActivity.this, "POS 通", "POS通", new JSONObject(map));
        } else if (ActivityConstants.RESULT_SELECT_PAY_METHOD == requestCode && resultCode == 1) {
            PayMethod method = (PayMethod) data.getExtras().getSerializable("PayMethod");
            PayMethodService.selectPayMethod(this, method, this);
        } else if (requestCode == ActivityConstants.REQUEST_OTHER_PAYMETHOD && resultCode == ActivityConstants.RESULT_OTHER_PAYMETHOD) {
            mPresenter.paySuccess();
        } else if (requestCode == ActivityConstants.REQUEST_SCRM_COUPON_USE && resultCode == ActivityConstants.RESULT_VIP_COUPON_CALCULATE) {
            if (data != null) {
                Intent intent = new Intent();
                intent.putExtra("vipCardNo", data.getStringExtra("vipCardNo"));
                intent.setClass(this, ScrmCouponUseActivity.class);
                startActivityForResult(intent, ActivityConstants.REQUEST_SCRM_COUPON_ADDITION);
            }
        } else if (requestCode == ActivityConstants.REQUEST_SCRM_COUPON_ADDITION && resultCode == ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS) {
            mPresenter.paySuccess();
        }

        updateAdapter();
        updateTotal();
        super.onActivityResult(requestCode, resultCode, data);
    }

    private void scanSuccessPay(Intent data) {
        String scanCode = mScanner.getScanResult(data);
        LoggerUtils.getLogger().debug("获取支付条码:" + scanCode);
        if (mPresenter.selectedPayMethod().isAllInPayType()) {
            mPresenter.payPay(scanCode);
            return;
        }

        if (AggregatePaymentChannel.isYST()) {
            mPresenter.payYst(scanCode);
        } else if (AggregatePaymentChannel.isMIYA()) {
            mPresenter.payMiYa(scanCode);
        } else if (AggregatePaymentChannel.isHXPAY()) {
            mPresenter.payPay(scanCode);
        } else if (mPresenter.selectedPayMethod().isAllInPayByPayType()) {
            mPresenter.payPay(scanCode);
        } else {
            showHintDialog("暂未支持该支付方式：" + mPresenter.selectedPayMethod().name());
        }
    }

    private volatile static int queryCount = 0;//查询次数

    private void bankPay(Intent data) {
        try {
            //增加打印收单行返回信息，目前农行应该不可用，工行有自己的回调
            try {
                NetUtils.printExtras(data == null ? null : data.getExtras());
            } catch (Exception e) {
                NetUtils.printDetail("打印收单行返回信息", e);
            }
            /**
             * 仅1， 支付返回超时,查询正常返回
             * 1，2  支付返回超时，查询返回空
             * 仅3     小于2 支付返回空，第2次查询正常返回， 小于3支付返回空，两次查询都返回空
             */
            //1.
            /* if (queryCount < 2) {
                LoggerUtils.getLogger().debug("测试代码,手动修改返回结果");
                data = new Intent();
                JSONObject obj = new JSONObject();
                obj.put("resCode", "68");
                obj.put("resDesc", "交易超时");
                JSONObject obj2 = new JSONObject();
                obj2.put("transData", obj.toString());
                obj2.put("resultCode", "0");
                obj2.put("resultMsg", "接口调用成功");
                Bundle bundle = new Bundle();
                bundle.putString("result", obj2.toString());
                data.putExtras(bundle);
            }*/
            //2.
          /*  if (queryCount == 2) {
                LoggerUtils.getLogger().debug("测试代码,手动置空返回结果");
                data = null;
            }*/
            //3.
           /* if (queryCount < 3) {
                LoggerUtils.getLogger().debug("测试代码,手动置空返回结果");
                data = null;
            }*/
            PayResult result = paymentProvider.handleResult(data);
            if (result.isPayment()) {
                LoggerUtils.getLogger().debug("收单行支付成功");
                mPresenter.handleResult(result);
            } else if (result.isCancellation()) {
                LoggerUtils.getLogger().debug("收单行撤销成功");
                mPresenter.cancelPaySuccess(mPresenter.getSale().getLastPay());
            } else if (result.isQuery()) {
                LoggerUtils.getLogger().debug("收单行查询支付结果成功");
                mPresenter.handleResult(result);
            }
            hideLoadingDialog();
        } catch (PaymentProviderException ex) {
            if (PayResult.CODE_NO_DATA.equalsIgnoreCase(ex.code()) && paymentProvider.supportPayQuery()) {
                //没有数据返回时,进行两次查询,仍为空,询问用户是否成功,成功,选择银联压卡记账
                queryCount++;
                if (queryCount > 2) {
                    queryCount = 0;
                    LoggerUtils.getLogger().debug("查询两次仍无结果,提示压卡记账");
                    hideLoadingDialog();
                    String tip = CommonUtils.isLklUms(PayActivity.this) ? getString(R.string.bank_lkl_nodata_tip) : getString(R.string.bank_nodata_tip);
                    showHintDialog(tip);
                    return;
                }

                LoggerUtils.getLogger().debug("收单行准备查询" + queryCount);
                payQuery();
            } else if (paymentProvider.supportPayQuery() && PayResult.needPayQuery(ex.code())) {
                //支持查询，即 有appid且是银商的jar包，然后code为几个超时之一
                showHintConfirm(getString(R.string.bank_timeout_tip), new UniCallback() {
                    @Override
                    public void onSuccess(String msg) {
                        LoggerUtils.getLogger().debug("收单行返回异常，确认查询：" + ex.code());
                        queryCount = 2; //为了不重复触发上一个判断？
                        payQuery();
                    }

                    @Override
                    public void onError(String err) {
                        queryCount = 0;
                        hideLoadingDialog();
                        LoggerUtils.getLogger().debug("收单行返回异常，取消查询：" + ex.code());
                    }
                });
            } else {
                queryCount = 0;
                hideLoadingDialog();
                LoggerUtils.getLogger().error("交易失败: " + String.format(Locale.CHINESE, "(%s) %s", ex.code(), ex.getMessage()));
                showHintDialog("交易失败: " + String.format(Locale.CHINESE, "(%s) %s", ex.code(), ex.getMessage()));
            }
        } catch (Exception e) {
            hideLoadingDialog();
            LoggerUtils.getLogger().error("收单行支付异常:" + e.getMessage(), e);
            showHintDialog(getString(R.string.bank_nodata_tip));
        } finally {
//                paymentProvider = null; // DON'T DELETE THIS CODE.
        }
    }

    /**
     * 调用收单行查询方法
     * （目前仅支持银商和中行）
     */
    private void payQuery() {
        try {
            paymentProvider.payQuery(uniqueNo, null);
        } catch (PaymentProviderException e) {
            hideLoadingDialog();
            LoggerUtils.getLogger().error("收单行查询出错:" + e.getMessage(), e);
            showHintDialog(getString(R.string.bank_nodata_tip));
        }
    }

    @Override
    public void gotoCancelPayChannel(SalePayModel payModel) {
        try {
//            if (PayMethod.isAliPay(payModel.getRemark()) && CommonUtils.isTimesSquare(this)) {
//                paymentProvider = UmsPaymentFactory.createProvider(this, payModel.getRemark());
//            } else {

                paymentProvider = PayActivity.getPaymentProvider(PayActivity.this, payModel.getRemark());
         //   }
        } catch (Exception e) {
            hideLoadingDialog();
            showHintDialog("获取支付提供程序失败：" + e.toString());
            return;
        }

        if (paymentProvider != null) {
            LoggerUtils.getLogger().debug(paymentProvider.getClass().getName());
            LoggerUtils.getLogger().debug("撤销(TRACE_NO)：" + payModel.getOutTradeNo());
            try {
                HashMap<String, String> params = new HashMap<>();
                params.put("PAY_NO", payModel.getBuyerLogonId());
                uniqueNo = PayRequest.generateUniqueNo(com.hisense.hipos.webapi.Context.posNo());
                PayRequest payRequest = new PayRequest(Double.parseDouble(payModel.getTotalRecv()), uniqueNo);
                paymentProvider.cancel(payRequest, payModel.getOutTradeNo(), params, new PaymentHandler() {
                    @Override
                    public void onFinish(Object... args) {
                        hideLoadingDialog();
                        handleIcbcCancellationResult(args);
                    }
                });
            } catch (Exception ex) {
                hideLoadingDialog();
                showHintDialog(ex.getMessage());
                LoggerUtils.getLogger().error(ex.getMessage(), ex);
            }
        }
    }

    @Override
    protected void onStart() {
        LoggerUtils.getLogger().debug("----------onStart-----------PayActivity----------");
        super.onStart();
    }

    @Override
    protected void onResume() {
        LoggerUtils.getLogger().debug("----------onResume-----------PayActivity----------");
        super.onResume();
    }

    @Override
    protected void onPause() {
        LoggerUtils.getLogger().debug("----------onPause-----------PayActivity----------");
        super.onPause();
    }

    @Override
    protected void onStop() {
        LoggerUtils.getLogger().debug("----------onStop-----------PayActivity----------");
        super.onStop();
    }

    private void handleIcbcPurchaseResult(Object... args) {
        if (args == null || args.length != 3) {
            LoggerUtils.getLogger().debug("handleIcbcPurchaseResult_工行返回数据不合法");
            showHintDialog(getString(R.string.bank_nodata_tip));
            return;
        }

        try {
            Bundle baseResult = (Bundle) args[0];
            Bundle transResult = (Bundle) args[1];

            IcbcPaymentProvider provider = (IcbcPaymentProvider) paymentProvider;
            PayResult payResult = provider.handleResult(args);

            showHintDialog(provider.handleBaseResult(baseResult).description());

            LoggerUtils.getLogger().debug("payResult.amount()：" + payResult.amount());
            LoggerUtils.getLogger().debug("payResult.cardNo()：" + payResult.cardNo());
            LoggerUtils.getLogger().debug("payResult.refNo()：" + payResult.refNo());
            LoggerUtils.getLogger().debug("payResult.traceNo()：" + payResult.traceNo());
            LoggerUtils.getLogger().debug("payResult.termNo()：" + payResult.termNo());
            LoggerUtils.getLogger().debug("transResult.QRCodeOrder()：" + provider.handleResult(PurchaseTransResult.class, transResult).QRCodeOrder());

            mPresenter.handleResult(payResult);
        } catch (Exception ex) {
            showHintDialog(ex.getMessage());
            LoggerUtils.getLogger().error(ex.getMessage(), ex);
        }
    }

    private void handleIcbcCancellationResult(Object... args) {
        if (args == null || args.length != 3) {
            LoggerUtils.getLogger().debug("handleIcbcCancellationResult_工行返回数据不合法");
            return;
        }

        try {
            IcbcPaymentProvider provider = (IcbcPaymentProvider) paymentProvider;
            PayResult payResult = provider.handleResult(args);

            mPresenter.cancelPaySuccess(mPresenter.getSale().getLastPay());
        } catch (Exception ex) {
            showHintDialog(ex.getMessage());
            LoggerUtils.getLogger().error(ex.getMessage(), ex);
        }
    }

    @Override
    protected void onDestroy() {
        LoggerUtils.getLogger().debug("----------onDestroy-----------PayActivity----------");
        //记录当前不处于支付过程中
        App.getInstance().isPaying = false;
        super.onDestroy();
    }

    @Override
    public void setIsClickPayFalse() {
        //易收银不需要实现
    }
}
