/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.activity.ysy.pay;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hipos.payment.PayMethod;

import java.util.Locale;

import butterknife.BindView;

/**
 * 选择支付方式的 Activity。
 *
 * @author zhangsai 2018-01-16 HIPOSAPP-277
 * @author dukunbiao(null)  2019-10-21  重构
 */
@ActivityLayoutInject(R.layout.activity_pay_method_select)
public class PayMethodSelectActivity extends BaseActivity implements View.OnClickListener {

    private LinearLayout lytSelected;       // 当前选择的支付方式的布局
    private PayMethod mSelectedPayMethod;   // 当前选择的支付方式

    @BindView(R.id.txtSelect)
    public TextView txtSelect;             // 使用何种支付方式

    @BindView(R.id.lytGoBack)
    public LinearLayout lytGoBack;

    @BindView(R.id.lytSelect)
    public LinearLayout lytSelect;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        PayMethodService.createFullLayout(this, this);

        lytGoBack.setOnClickListener(this);
        lytSelect.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.lytGoBack:
                goBack();
                break;
            case R.id.lytSelect:
                selectPayMethod();
                break;
            default:
                switchPayMethod(v);
                break;
        }
    }

    private void goBack() {
        finish();
    }

    private void switchPayMethod(View v) {
        LinearLayout lytCurrent = (LinearLayout) v;

        if (lytSelected != null) {
            lytSelected.setBackgroundResource(R.drawable.border);
        } else {
            lytSelect.setBackgroundColor(getResources().getColor(R.color.salesBtn));
        }

        lytSelected = lytCurrent;
        lytSelected.setBackgroundResource(R.drawable.border_red);

        mSelectedPayMethod = (PayMethod) lytSelected.getTag();

        if (mSelectedPayMethod.name().endsWith("支付")) {
            txtSelect.setText(String.format(Locale.CHINESE, "使用 %s", mSelectedPayMethod.name()));
        } else {
            txtSelect.setText(String.format(Locale.CHINESE, "使用 %s 支付", mSelectedPayMethod.name()));
        }
    }

    private void selectPayMethod() {
        if (mSelectedPayMethod == null) {
            return;
        }

        Bundle bundle = new Bundle();
        bundle.putSerializable("PayMethod", mSelectedPayMethod);

        Intent intent = new Intent();
        intent.putExtras(bundle);
        PayMethodSelectActivity.this.setResult(1, intent);
        finish();
    }
}
