/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.activity.ysy.pay;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.crm.vip.VerifyType;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.presenter.pay.CouponPresenter;
import com.hisense.hiaposcmp.view.IView.ICouponView;
import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.UsableCoupon;
import com.hisense.pos.scanner.IScanner;
import com.hisense.pos.scanner.ScannerCallback;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * SCRM券核销
 *
 * @author xieliyan    2019-08-02 HIPOSAPP-1238
 * @author dukunbiao(null)  2019-10-21  重构
 */
@ActivityLayoutInject(R.layout.activity_coupon_addition)
public class ScrmCouponUseActivity extends BaseMvpActivity<ICouponView, CouponPresenter> implements ICouponView {

    @BindView(R.id.edtCouponNo)
    public EditText edtCouponNo;

    @BindView(R.id.edtCheckCode)
    public EditText edtCheckCode;

    @BindView(R.id.btnCancel)
    public Button btnCancel;

    @BindView(R.id.btnConfirm)
    public Button btnConfirm;

    @BindView(R.id.imgScan)
    public ImageView imgScan;

    @BindView(R.id.lytCheckCode)
    public LinearLayout mLytCheckCode;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        mLytCheckCode.setVisibility(View.GONE);
        mScanner = getScanner(this);
        mPresenter.initData(this.getIntent());
    }

    @Override
    protected CouponPresenter createPresenter() {
        return new CouponPresenter();
    }

    @OnClick(R.id.btnCancel)
    public void onClickCancel() {
        finish();
    }

    @OnClick(R.id.btnConfirm)
    public void onClickConfirm() {
        if (StringUtils.isEmpty(edtCouponNo.getText().toString())) {
            showHintDialog("请输入券号");
            return;
        }

        mPresenter.offlineConsumeCerti(edtCouponNo.getText().toString());
    }

    @OnClick(R.id.imgScan)
    public void onClickScan() {
        mScanner.scan(new ScannerCallback() {
            @Override
            public void onSuccess(final String s) {
                mScanner.close();
                edtCouponNo.setText(s);
                edtCouponNo.setSelection(edtCouponNo.getText().toString().length());
            }

            @Override
            public void onError(final Throwable t) {
                LoggerUtils.getLogger().error("SCRM券扫描失败:" + t.toString());
                showHintDialog("SCRM券扫描失败:" + t.getMessage());
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            edtCouponNo.setText(mScanner.getScanResult(data));
            edtCouponNo.setSelection(edtCouponNo.getText().toString().length());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    public void couponCalcSuccess(int position, UsableCoupon usableCoupon) {

    }

    @Override
    public void needVerifyType(VerifyType verifyType) {

    }

    @Override
    public void queryVipCouponsSuccess(List<Coupon> coupons) {

    }

    @Override
    public void couponUse1Success(Collection<UsableCoupon> usableCoupons, Collection<Coupon> coupons) {
        Intent intent = new Intent();
        intent.putExtra("usableCoupon", (Serializable) usableCoupons);

        setResult(ActivityConstants.RESULT_PAY_TO_COUPON_SUCCESS, intent);
        finish();
    }

    @Override
    public void calcCouponsSuccess() {

    }
}
