package com.hisense.hiaposcmp.activity.ysy.refund;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.MainActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PayFinishedActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PayMethodSelectActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.constant.refund.RefundConstants;
import com.hisense.hiaposcmp.presenter.refund.RefundPresenter;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.tool.NumberHandler;
import com.hisense.hiaposcmp.tool.UpdateTextButton;
import com.hisense.hiaposcmp.view.IView.refund.IRefundView;
import com.hisense.hipos.coupon.UsableCoupon;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.PayResult;
import com.hisense.pos.scanner.IScanner;
import com.hisense.pos.scanner.ScannerCallback;
import com.hisense.webapi.Callback;
import com.ums.AppHelper;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.OnClick;

import static com.hisense.hiaposcmp.constant.ActivityConstants.REQUEST_OTHER_PAYMETHOD_REFUND;
import static com.hisense.hiaposcmp.constant.ActivityConstants.REQUEST_REFUND_FINISHED;
import static com.hisense.hiaposcmp.constant.ActivityConstants.REQUEST_UMS_REFUND_CONFIRM;
import static com.hisense.hiaposcmp.constant.ActivityConstants.RESULT_SELECT_PAY_METHOD;
import static com.hisense.hiaposcmp.constant.ActivityConstants.RESULT_UMS_REFUND_CANCEL;

/**
 * 退货
 *
 * @author xieliyan    2017-05-10
 * @author gaoweisheng 2017-05-10
 * @author xieliyan    2017-05-20
 * @author xieliyan    2017-08-20
 * @author xieliyan    2017-08-22
 * @author xileiyan    2017-09-07 HIPOSAPP-149 判断数据表中该笔流水的Tag值是否为5（正在上传）
 * @author xieliyan    2017-09-09 HIPOSAPP-203 使用其他支付方式支付，重新回到支付界面，需付金额大于0时，确定按钮可用
 * @author xieliyan    2017-09-11 HIPOSAPP-152 解决连续点击导致流水重复上传的问题
 * @author xieliyan    2017-09-13 HIPOSAPP-133 电子发票（青岛海信广场航信接口）
 * @author xieliyan    2017-09-18 HIPOSAPP-158 修复本地上传流水签名错误问题
 * @author xieliyan    2017-10-11 HIPOSAPP-163 银行卡隔日退货tsalsalepay表中没有存储payno
 * @author xieliyan    2017-10-11 HIPOSAPP-166 流水上传成功后打印小票
 * @author zhangsai    2017-10-23 HIPOSAPP-187 升级获取赢商通配置的WebAPI调用
 * @author xieliyan    2017-10-27 HIPOSAPP-166 流水上传成功后打印小票(取消该需求）
 * @author xieliyan    2017-10-30 HIPOSAPP-183 银行卡隔日退货tsalsalepay表中没有存储payno：银联卡的remark记录错误
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author xileiyan    2017-10-31 HIPOSAPP-204 退款时，现金退款金额不允许大于支付时现金金额
 * @author xieliyan    2017-11-16 HIPOSAPP-217 优化使用与银联相关的支付方式的部分代码，可支持多个微信/支付宝/银联卡组合退款
 * @author xieliyan    2017-11-16 HIPOSAPP-218 厦门本地会员卡退款
 * @author xieliyan    2017-11-17 HIPOSAPP-220 退款成功后弹出成功的对话框
 * @author zhangsai    2017-12-21 HIPOSAPP-250 通过 SaleService 获取当前结账日期
 * @author zhangsai    2017-12-21 HIPOSAPP-253 通过 PaymentService 获取支付方式
 * @author xieliyan    2017-12-21 HIPOSAPP-254 控制需退金额大小
 * @author xieliyan    2018-01-02 HIPOSAPP-262 支持建行收单支付（银联卡，微信，支付宝）
 * @author zhangsai    2018-01-16 HIPOSAPP-276 退货流水记录的应收合计应与原流水一致
 * @author zhangsai    2018-01-16 HIPOSAPP-277 根据支付方式个数动态创建支付方式布局
 * @author zhangsai    2018-01-23 HIPOSAPP-294 修复金额较大时自动转换为科学计数法导致无法上传流水的问题
 * @author xieliyan    2018-01-22 HIPOSAPP-290 修复优惠商品退货时程序异常退出的问题
 * @author zhangsai    2018-01-31 HIPOSAPP-306 修复上传流水失败 - 失败原因：未提交结账日期的问题
 * @author zhangsai    2018-02-02 HIPOSAPP-315 通过 PointsService 查询积分
 * @author xieliyan    2018-02-05 HIPOSAPP-318 储值卡支付 - 余额存在小数无法继续进行支付
 * @author xieliyan    2018-02-08 HIPOSAPP-301 交易完成退款后自动上传流水，无需用户手工点击"完成"按钮
 * @author xieliyan    2018-03-13 HIPOSAPP-350 支持一段式会员券退货
 * @author xieliyan    2018-03-14 HIPOSAPP-353 修复取消部分产品退货 - 已经取消的产品仍然出现在小票上面且价格为0.0的缺陷
 * @author guolina     2018-03-29 HIPOSAPP-365 修复intent bundle未绑定导致的退货闪退问题
 * @author guolina     2018-04-02 HIPOSAPP-365 数据传输未分类导致的储值卡退款闪退；参数未传输导致的无法获取会员服务和签名错误
 * @author xieliyan    2018-04-18 HIPOSAPP-408 支持米雅支付退款
 * @author zhangsai    2018-06-11 HIPOSAPP-509 增加退货时各种支付方式的可退金额控制
 * @author zhangsai    2018-06-12 HIPOSAPP-513 修复需退金额为空字符串导致的解析异常
 * @author guolina     2018-06-13 HIPOSAPP-396 添加退货时积分原路退回
 * @author guolina     2018-06-21 HIPOSAPP-507 避免微信支付宝退款时连续点击确认按钮导致的提示退款失败
 * @author guolina     2018-06-22 HIPOSAPP-484 退货网络连接异常弹框设置为点击周边不可取消
 * @author zhangsai    2018-07-02 HIPOSAPP-626 初始化交易时获取电子发票配置参数
 * @author guolina     2018-07-09 HIPOSAPP-632 修复现金多次支付时退款，未达到最大现金支付金额时提示现金退款不允许超过支付时金额
 * @author guolina     2018-07-11 HIPOSAPP-662 修复退款时，先手动积分退款，再校验码储值卡退款提示密码错误的问题
 * @author lizhixin    2018-07-12 HIPOSAPP-663 对接工行收单通道-工行卡积分退款功能
 * @author zhangsai    2018-07-23 HIPOSAPP-685 优化储值卡退款
 * @author zhangsai    2018-07-23 HIPOSAPP-686 优化积分退款
 * @author guolina     2018-08-15 HIPOSAPP-729 解决手动上传会员流水时因会员卡号未传递导致的上传流水失败
 * @author guolina     2018-08-17 HIPOSAPP-737 解决退货小票积分未初始化。
 * @author guolina     2018-08-21 HIPOSAPP-742 解决部分退货金额不对的问题
 * @author guolina     2018-08-22 HIPOSAPP-756 增加实时积分和原路退回开关
 * @author zhangsai    2018-08-21 HIPOSAPP-752 Sale流水增加结账日期和退货商品以用于生成电子发票地址
 * @author guolina     2018-08-30 HIPOSAPP-671 修复退款过程中切换退款方式结果出错的问题
 * @author guolina     2018-09-03 HIPOSAPP-759 修复因储值卡最大可退金额与退款金额精确位数不一致导致的无法退款
 * @author guolina     2018-09-04 HIPOSAPP-763 修复银联卡撤销未付金额没刷新的问题
 * @author guolina     2018-09-26 HIPOSAPP-770 支持销售/退款后增加储值卡和积分余额打印
 * @author guolina     2018-10-19 HIPOSAPP-792 积分原路退回逻辑更改
 * @author guolina     2018-10-19 HIPOSAPP-795 积分原路退回使用优惠后价格而不是原价
 * @author guolina     2018-10-19 HIPOSAPP-786 修改可退金额为0时的提示语
 * @author wangyaogang 2018-11-12 HIPOSAPP-821 支持中行退款(银联卡,微信,支付宝)
 * @author guolina     2018-11-15 HIPOSAPP-772 整单退货支持赠券退回
 * @author wangyaogang 2018-11-16 HIPOSAPP-828 修复一笔订单中,多次使用同一张银联卡支付时,不能正常退货的问题
 * @author guolina     2018-11-22 HIPOSAPP-835 多任务同步改用CountDownLatch，解决打印慢的问题
 * @author wangyaogang 2018-12-01 HIPOSAPP-821 更新中行退货逻辑(当日撤销,隔日退款)
 * @author wangyaogang 2018-12-04 HIPOSAPP-837 支持微信,支付宝直连交易
 * @author wangyaogang 2018-12-05 HIPOSAPP-868 修改流水上传签名规则,改为所有参数按字典序排序
 * @author zhangsai    2018-12-07 HIPOSAPP-888 使用IPaymentProvider完成撤销/退款
 * @author zhangsai    2018-02-01 HIPOSAPP-898 根据当日撤销/隔日退货返回的交易凭证号/交易参考号进行支付反向操作
 * @author guolina     2018-11-26 HIPOSAPP-902 读取本地未上传流水表时去掉条数限制
 * @author wangyaogang 2018-12-17 HIPOSAPP-901 修复直连支付时微信/支付宝退款成功后应用闪退问题
 * @author wangyaogang 2018-12-19 HIPOSAPP-877 衢州东方-储值预制卡刷卡支付支持。
 * @author zhangsai    2018-12-21 HIPOSAPP-699 优化退货逻辑
 * @author zhangsai    2018-12-26 HIPOSAPP-931 优化退货流水上传逻辑，改用 SaleApplicationService 上传流水
 * @author wangyaogang 2018-12-27 HIPOSAPP-876 中行银联二维码支付对接,增加云闪付支付方式
 * @author zhangsai    2019-01-03 HIPOSAPP-958 删除电子发票配置初始化，使用由 SaleReturnActivity 传入的配置
 * @author guolina     2018-09-26 HIPOSAPP-839 打印支持聚合支付优惠
 * @author guolina     2019-01-21 HIPOSAPP-976 支付和退款流水记录终端号
 * @author guolina     2019-03-06 HIPOSAPP-1041 Sale代替Trade，优化代码
 * @author guolina     2019-03-14 HIPOSAPP-1052 支持其他支付方式
 * @author guolina     2019-03-25 HIPOSAPP-1012 流水上传失败提示优化
 * @author guolina     2019-04-02 HIPOSAPP-1072 修复部分退货时储值卡积分支付可退金额错误
 * @author guolina     2019-04-09 HIPOSAPP-1074 支持储值卡/积分动态码支付
 * @author guolina     2019-04-09 HIPOSAPP-1082 修复积分录入会员密码后的闪退
 * @author wangyaogang 2019-05-09 HIPOSAPP-1086 支持银联扫码支付
 * @author wangyaogang 2019-05-14 HIPOSAPP-1095 易收银各类Toast提示信息改为弹窗提示,方便记录
 * @author wangyaogang 2019-05-20 HIPOSAPP-1106 积分原路返回确认接口参数调整,saleNo由原流水号改为退货流水号
 * @author wangyaogang 2019-05-27 HIPOSAPP-1139 去掉"商户优惠金额”和“平台优惠金额”的弹框提示
 * @author wangyaogang 2019-05-29 HIPOSAPP-1135 可配置付款码查询时是否需要密码
 * @author wangyaogang 2019-06-05 HIPOSAPP-1160 修复退货时点击底部完成按钮导致的系统崩溃
 * @author wangyaogang 2019-06-10 HIPOSAPP-1135 储值卡/积分 查询/退款接口增加isVerifyPwd字段
 * @author zhangsai    2019-06-12 HIPOSAPP-1141 退款与支付交易一一对应；同一笔支付可多次退款，但不能超过原支付金额
 * @author zhangsai    2019-06-13 HIPOSAPP-1169 退款逻辑(HIPOSAPP-1141)改为由 ReturnSale.refund(Payment) 实现
 * @author wangyaogang 2019-06-18 HIPOSAPP-1136 储值卡退款时根据是否限制原卡退货计算可退最大金额
 * @author zhangsai    2019-06-18 HIPOSAPP-1170 优化满减退款逻辑；删除从 SaleReturnActivity 传入的 Sale，改用 ReturnSale 的相关属性
 * @author wangyaogang 2019-06-19 HIPOSAPP-1171 储值卡/积分卡查询,退款时增加校验码cardVerifyCode字段,且各开关不再互斥
 * @author wangyaogang 2019-06-26 HIPOSAPP-1180 储值卡/积分卡更改为根据接口确定验证类型(动态付款码仍根据本地开关确定),校验参数封装为CardSecurity
 * @author wangyaogang 2019-07-17 HIPOSAPP-1214 储值卡/积分卡传值优化,卡类型为7时,isVerifyPwd值取决于开关状态,非7默认1
 * @author xieliyan    2019-08-02 HIPOSAPP-1240 对接SCRM-券退款，与会员券相同，仅记录
 * @author wangyaogang 2019-08-02 HIPOSAPP-1237 防止短时间内多次响应操作请求,完成按钮
 * @author wangyaogang 2019-08-06 HIPOSAPP-1229 退货打印实时积分
 * @author wangyaogang 2019-08-07 HIPOSAPP-1255 退货时积分/赠券原路退回逻辑调整,失败时,增加提示,让用户选择是否继续
 * @author wangyaogang 2019-08-07 HIPOSAPP-1257 若已点击过确定,则再次预判失败时默认确定,不再提示
 * @author wangyaogang 2019-08-08 HIPOSAPP-1259 对接海信支付退款结果查询接口
 * @author wangyaogang 2019-08-09 HIPOSAPP-1264 调整online接口超时时间,在判断网络状态有问题时,立刻弹框提示
 * @author xieliyan    2019-08-05 HIPOSAPP-1277 对接SCRM-获取会员卡验证方式:请求参数增加payMethod
 * @author wangyaogang 2019-08-15 HIPOSAPP-1279 优化退货逻辑,调整加载框显示时机,防止多次点击完成按钮触发多次退货
 * @author wangyaogang 2019-08-19 HIPOSAPP-1225 银联商务增加支付查询
 * @author wangyaogang 2019-10-08 HIPOSAPP-1289 对接利客来一点通支付
 * @author wangyaogang 2019-10-10 HIPOSAPP-1309 温州时代-海信Pay时,支付宝走收单行,微信默认
 * @author xieliyan    2019-10-18 HIPOSAPP-1328 新增建行直连通道
 * @author wangyaogang 2019-10-17 HIPOSAPP-1324 一点通支付不再限制具体支付通道,且修改remark
 * @author xieliyan    2019-10-24 HIPOSAPP-1329 建联聚合支付，退款时ZFNo的支付方式也应该带过来
 * @author xieliyan    2019-10-31 HIAPOSCMP-254 重构
 * @author guolina     2019-10-30 HIPOSAPP-1332 银行卡和建行直连的退款金额不可以编译
 * @author wangyaogang 2019-10-30 HIAPOSCMP-425 退款金额框可编辑,完善HIPOSAPP-1332任务
 */
@ActivityLayoutInject(R.layout.activity_pay)
public class SaleRefundActivity extends BaseMvpActivity<IRefundView, RefundPresenter> implements IRefundView {

    /**
     * 当前选择的支付方式
     */
    private LinearLayout llSelectedPayMethod;
    /**
     * 退款确定按钮
     */
    @BindView(R.id.btnPay)
    public Button mBtnRefund;
    /**
     * 完成按钮
     */
    @BindView(R.id.btnFinish)
    public Button mBtnFinish;
    /**
     * 待退金额
     */
    @BindView(R.id.txtPayAmount)
    public EditText mTxtRefundAmount;
    /**
     * 合计
     */
    @BindView(R.id.txtTotal)
    public TextView mTxtTotal;
    /**
     * 应退金额
     */
    @BindView(R.id.txtTotalDue)
    public TextView mTxtTotalDue;
    /**
     * 未退金额
     */
    @BindView(R.id.txtTotalUnpaid)
    public TextView mTxtTotalUnRefund;
    /**
     * 已退金额
     */
    @BindView(R.id.txtTotalPaid)
    public TextView mTxtTotalRefund;
    /**
     * 返回
     */
    @BindView(R.id.btnGoBack)
    public LinearLayout mBtnGoBack;
    /**
     * 退款标题
     */
    @BindView(R.id.txtTitle)
    public TextView mTxtTitle;
    /**
     * 退款
     */
    @BindView(R.id.txtPayTitle)
    public TextView mTxtPayTitle;
    /**
     * 应退
     */
    @BindView(R.id.txtTotalTitle)
    public TextView mTxtTotalTitle;
    /**
     * 未退
     */
    @BindView(R.id.txtUnpaidTitle)
    public TextView mTxtUnpaidTitle;
    /**
     * 已退
     */
    @BindView(R.id.txtPaidTitle)
    public TextView mTxtPaidTitle;
    /**
     * 支付/退款列表
     */
    @BindView(R.id.lvwSalePayItems)
    public ListView lvwSaleRefundItems;
    /**
     * 扩展支付方式
     */
    @BindView(R.id.lytExpand)
    public LinearLayout mLytExpand;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initLayout();

        try {
            Thread.sleep(200);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        initPresenter();

        mScanner = getScanner(this);
    }

    @Override
    protected RefundPresenter createPresenter() {
        return new RefundPresenter();
    }

    /**
     * 初始化控件默认值
     */
    private void initLayout() {
        NumberHandler.setPoint(mTxtRefundAmount, 2);
        mTxtRefundAmount.setFocusable(true);
        mTxtRefundAmount.setFocusableInTouchMode(true);
        mTxtRefundAmount.requestFocus();
        mTxtTotalUnRefund.setTextColor(getResources().getColor(R.color.color_paid));
        mTxtTotalRefund.setTextColor(getResources().getColor(R.color.color_refund));
        mTxtTitle.setText(RefundConstants.REFUND_TITLE);
        mTxtPayTitle.setText(RefundConstants.REFUND_TITLE_TXT);
        mTxtTotalTitle.setText(RefundConstants.REFUND_TITLE_TOTAL);
        mTxtUnpaidTitle.setText(RefundConstants.REFUND_TITLE_UNPAY_TOTAL);
        mTxtPaidTitle.setText(RefundConstants.REFUND_TITLE_PAID_TOTAL);
        mBtnRefund.setTag(0);
        mTxtTotal.setText(getReturnSale().getTotalRecv());
    }

    /**
     * 初始化控件默认值
     */
    private void initPresenter() {
        //初始化赢商通配置
        mPresenter.initYstConfig();
        //初始化米雅配置
        mPresenter.initMiYaConfig();
        //初始化ReturnViewModel
        mPresenter.initPayments();
        //退款后刷新页面
        mPresenter.refreshAfterRefund(null);
        //获取支付方式
        mPresenter.getPayMethods();
        //初始化数据库服务
        mPresenter.initSaleRepository();
        //清空优惠和积分
        mPresenter.clearPoints();
    }

    /**
     * 返回支付通道提供器
     *
     * @return IPaymentProvider
     */
    @Override
    public IPaymentProvider getPaymentProvider() {
        return getPaymentProvider(this, mPresenter.selectedPayMethod().remark());
    }

    /**
     * 退款支付方式适配器
     */
    @Override
    public void setAdapter() {
        lvwSaleRefundItems.setAdapter(mPresenter.adapter());
    }

    /**
     * 设置显示的待退款金额。
     *
     * @param refunding 待退款金额
     */
    @Override
    public void setRefundingText(String refunding) {
        mTxtRefundAmount.setText(refunding);
        mTxtRefundAmount.setSelection(refundTextValue().length());
    }

    /**
     * 返回待退款金额
     *
     * @return String 待退款金额
     */
    @Override
    public String refundTextValue() {
        return mTxtRefundAmount.getText().toString().trim();
    }

    /**
     * 支付方式图标监听
     *
     * @return OnClickListener 监听器
     */
    @Override
    public View.OnClickListener paymentClick() {
        return (view) -> {
            if (!mBtnRefund.isEnabled()) {
                return;
            }
            LinearLayout layout = (LinearLayout) view;
            if (llSelectedPayMethod != null) {
                llSelectedPayMethod.setBackgroundResource(R.drawable.border);
            }
            llSelectedPayMethod = layout;
            llSelectedPayMethod.setBackgroundResource(R.drawable.border_red);
            PayMethod method = (PayMethod) llSelectedPayMethod.getTag();
            //显示最大可退金额可编辑, 撤销时,此处的金额只是用来查找原始交易,撤销就是全部撤销,金额不影响最后结果
            /*try {
                boolean mIsSameDate = WebApi.formatDate(new Date()).equals(WebApi.formatDate(DateUtils.dateParse(getReturnSale().getSaleModel().getSaleTime())));
                if ((method.isUccbCard() || method.isUnionPay()) && mIsSameDate && GeneralSettings.INSTANCE.getPaymentChannel().isCCB()) {
                    mTxtRefundAmount.setEnabled(false);
                } else {
                    mTxtRefundAmount.setEnabled(true);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }*/
            mPresenter.selectPayMethod(method);
        };
    }

    /**
     * 返回监听
     */
    @OnClick(R.id.btnGoBack)
    public void onClickBack() {
        if (mainSaleModel.getReturnSaleModel().getPays().size() > 0) {
            showHintDialog("已经进行了退货，不能返回");
        } else {
            onBackPressed();
        }
    }

    /**
     * 扩展监听
     */
    @OnClick(R.id.lytExpand)
    public void onClickExpand() {
        Intent intent = new Intent(SaleRefundActivity.this, PayMethodSelectActivity.class);
        startActivityForResult(intent, RESULT_SELECT_PAY_METHOD);
    }

    /**
     * 支付监听
     */
    @OnClick(R.id.btnPay)
    public void onClickRefund() {
        mBtnRefund.setEnabled(false);
        LoggerUtils.getLogger().debug("refund有效点击了确定");
        mPresenter.refund();
        new Handler().postDelayed(() -> mBtnRefund.setEnabled(true), 1500);
    }

    /**
     * 支付完成监听
     */
    @OnClick(R.id.btnFinish)
    public void onClickFinish() {
        complete();
    }

    /**
     * 跳转到其他支付方式
     */
    @Override
    public void goToOtherRefund() {
        Intent intent = new Intent();
        intent.putExtra("total_unpaid", refundTextValue());
        intent.putExtra("paymethod", mPresenter.selectedPayMethod());
        intent.putExtra("returnSale", getReturnSale());
        intent.putExtra("listPayments", mPresenter.getListPayments());
        intent.setClass(App.getContext(), OtherPayMethodRefundActivity.class);
        startActivityForResult(intent, REQUEST_OTHER_PAYMETHOD_REFUND);
    }

    /**
     * 跳转到券退款
     */
    @Override
    public void goToCouponRefund(int requestCode, String maxRefund) {
        Intent intentQuery = new Intent();
        intentQuery.putExtra("fYTui", refundTextValue());
        intentQuery.putExtra("maxRefund", maxRefund);
        intentQuery.setClass(SaleRefundActivity.this, CouponRefundActivity.class);
        startActivityForResult(intentQuery, requestCode);
    }

    /**
     * 退款成功后刷新界面
     */
    @Override
    public void refreshAfterRefund() {
        mPresenter.getAdapter().notifyDataSetChanged();
        refreshTotal();
        if (BigDecimalUtils.isEquals(getReturnSale().getTotalRecv(), getReturnSale().getTotalPaid())) {
            mTxtRefundAmount.setEnabled(false);
            mBtnFinish.setBackgroundResource(R.color.color_amount);
            mBtnFinish.setText("完成");
            mBtnFinish.setEnabled(false);
            PayFinishedActivity.afterRefund(this, REQUEST_REFUND_FINISHED);
        }
    }

    @Override
    public void refreshTotal() {
        try {
            mTxtTotalDue.setText(getReturnSale().getTotalRecv());           // 应退
            mTxtTotalUnRefund.setText(getReturnSale().getTotalUnPaid());// 未退
            mTxtTotalRefund.setText(getReturnSale().getTotalPaid());    // 已退
            mBtnFinish.setText(getReturnSale().getTotalUnPaid());
            String maxRefund = mPresenter.getMaxRefund(mPresenter.selectedPayMethod());
            String refund = BigDecimalUtils.ternaryOperatorLess(String.valueOf(maxRefund), getReturnSale().getTotalUnPaid());
            setRefundingText(refund);//退款
            UpdateTextButton.setOnTextChange(mTxtRefundAmount, refund);
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("更新金额异常" + e.toString());
        }

    }

    /**
     * 打开摄像头扫描 outTradeNo
     */
    @Override
    public void openCamera() {
        mScanner.scan(new ScannerCallback() {
            @Override
            public void onSuccess(final String s) {
                mScanner.close();
                mPresenter.payRefund(s);
            }

            @Override
            public void onError(final Throwable t) {
                showHintDialog(t.getMessage());
            }
        });
    }

    /**
     * 跳转到银联通道退款确认
     */
    @Override
    public void goToUnionRefundConfirm(double amount, String traceNo, String refNo) {
        Bundle bundle = new Bundle();
        bundle.putDouble(RefundConstants.PARAM_AMOUNT, amount);
        bundle.putString(RefundConstants.PARAM_TRACE_NO, traceNo);
        bundle.putString(RefundConstants.PARAM_REF_NO, refNo);
        bundle.putString(RefundConstants.PARAM_SALE_TIME, getReturnSale().getSaleModel().getSaleTime());

        Intent intent = new Intent();
        intent.setClass(SaleRefundActivity.this, UnionRefundActivity.class);
        intent.putExtras(bundle);

        startActivityForResult(intent, REQUEST_UMS_REFUND_CONFIRM);
    }

    /**
     * 返回主页面。
     */
    @Override
    public void goToMainActivity() {
        Intent intent = new Intent(SaleRefundActivity.this, MainActivity.class);
        startActivity(intent);
        finish();
    }

    /**
     * 退款完成，上传退货流水。
     */
    private void complete() {

        if (BigDecimalUtils.isEquals(mTxtTotalRefund.getText().toString(), mTxtTotalDue.getText().toString())) {
            if (mPresenter.hasUploaded()) {
                LoggerUtils.getLogger().debug("已上传退货流水");
                goToMainActivity();
                return;
            }
            LoggerUtils.getLogger().debug("准备上传退货流水");
            mPresenter.hasUploaded(true);

            mPresenter.uploadSale();
            mBtnFinish.setEnabled(true);


        } else {
            mBtnFinish.setEnabled(false);
        }
    }

    /**
     * 调用Activity后的处理。
     *
     * @param requestCode 请求编号。
     * @param resultCode  返回编号。
     * @param data        返回数据。
     */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        hideLoadingDialog();

        mBtnRefund.setEnabled(true);
        if (requestCode == ActivityConstants.REQUEST_UMS_REFUND_CONFIRM) {
            if (resultCode == ActivityConstants.RESULT_UMS_REFUND_COMMIT) {
                Bundle bundle = data.getExtras();
                String refundAmount = "";
                if (bundle.containsKey(RefundConstants.PARAM_AMOUNT)) {
                    refundAmount = bundle.getString(RefundConstants.PARAM_AMOUNT);
                }
                double amount = Double.valueOf(StringUtils.ternaryOperator(refundAmount));
                String traceNo = bundle.getString(RefundConstants.PARAM_TRACE_NO);
                String refNo = bundle.getString(RefundConstants.PARAM_REF_NO);
                String termNo = bundle.getString(RefundConstants.PARAM_TERM_NO);

                HashMap<String, String> params = new HashMap<>();
                params.put("PAY_NO", mPresenter.oldSalePayment().getBuyerLogonId());
                params.put("TERM_NO", termNo);

                mPresenter.refund(amount, traceNo, refNo, params);
            } else if (resultCode == RESULT_UMS_REFUND_CANCEL) {
                showHintDialog("用户取消退款操作");
            }
        } else if (mPresenter.paymentProvider() != null && requestCode == mPresenter.paymentProvider().requestCode()) {
            try {
                PayResult result = mPresenter.paymentProvider().handleResult(data);
                Map<String, String> map = AppHelper.filterTransResult(data);

                LoggerUtils.getLogger().debug("saleRefund银联商务：" + map);
                String payNo = result.cardNo();
                if (mPresenter.selectedPayMethod().isMobilePay() || mPresenter.selectedPayMethod().isUccbScan()) {
                    if (null == result.payType()) {
                        payNo = result.cardNo();
                    } else if (result.payType().indexOf("微信") != -1 || result.payType().indexOf("WEPAY") != -1) {
                        payNo = result.cardNo() + "\n(01-微信)";
                    } else if (result.payType().indexOf("支付宝") != -1 || result.payType().indexOf("ALIPAY") != -1) {
                        payNo = result.cardNo() + "\n(02-支付宝)";
                    } else if (result.payType().indexOf("云闪付") != -1 || result.payType().indexOf("UNIONPAY") != -1) {
                        payNo = result.cardNo() + "\n(03-云闪付)";
                    } else {
                        payNo = result.cardNo() + "\n(" + result.payType() + ")";
                    }
                }

                SalePayModel salePayModel = new SalePayModel(mPresenter.selectedPayMethod(), payNo,
                        String.valueOf(result.amount()), result.traceNo(), result.refNo(), null,
                        "0", getReturnSale().getPays().size() - 1);

                Map<String, String> params = new HashMap<>();
                params.put("TERM_NO", mPresenter.termNo());

                LoggerUtils.getLogger().debug("银联商务cardNo：" + result.cardNo());
                LoggerUtils.getLogger().debug("银联商务refNo：" + result.refNo());
                LoggerUtils.getLogger().debug("银联商务traceNo：" + result.traceNo());

                mPresenter.refreshAfterRefund(salePayModel, params);
            } catch (Exception ex) {
                LoggerUtils.getLogger().error(ex.getMessage(), ex);
                showHintDialog(ex.getMessage());
            }
        } else if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            String scanCode = mScanner.getScanResult(data);
            LoggerUtils.getLogger().debug("扫描结果:" + scanCode);
            if (mPresenter.selectedPayMethod().isYdt()) {
                mPresenter.payRefund(scanCode);
            }
        } else if (AppHelper.PRINT_REQUEST_CODE == requestCode) {
            Map<String, String> map = AppHelper.filterTransResult(data);
            if (map.get("transData") != null) {
                try {
                    String sJson = map.get("transData");
                    LoggerUtils.getLogger().debug("银联商务支付结果:" + sJson);
                    JSONObject jsonObject = new JSONObject(sJson);

                    if (jsonObject.get("resCode") != null) {
                        if (jsonObject.get("resCode").toString().equals("QZ")) {
                            showHintDialog("打印机缺纸，请在流水查询中进行重打印操作");

                        } else {
                            showHintDialog(jsonObject.get("resDesc").toString());
                        }
                    } else {
                        showHintDialog("打印失败，返回resCode为空");
                    }
                } catch (Exception ex) {
                    LoggerUtils.getLogger().debug("打印失败，返回transData为空：" + ex.toString());
                }

            } else {
                showHintDialog("交易失败，返回transData为空");
            }

            onResume();
        } else if ((requestCode == ActivityConstants.REQUEST_PAY_TO_CARD && resultCode == ActivityConstants.RESULT_REFUND_TO_CARD_SUCCESS) ||
                (requestCode == ActivityConstants.REQUEST_PAY_TO_POINTS && resultCode == ActivityConstants.RESULT_REFUND_TO_POINTS_SUCCESS)) {
            mPresenter.oldSalePayment(null);
            SalePayModel salePayModel = getReturnSale().getLastPay();
            getReturnSale().removeLastPay();
            mPresenter.refreshAfterRefund(salePayModel);
        } else if (requestCode == ActivityConstants.REQUEST_REFUND_TO_COUPON) {
            if (resultCode == ActivityConstants.RESULT_REFUND_COUPON_CONFIRM) {
                Bundle bundle = data.getExtras();
                String qNo = bundle.getString("qNo");
                String qValue = bundle.getString("qValue");
                double amount = Math.abs(Double.parseDouble(qValue));
                SalePayModel salePayModel = new SalePayModel();
                salePayModel.setRemark(mPresenter.selectedPayMethod().remark());
                salePayModel.setPayType(mPresenter.selectedPayMethod().payType());
                salePayModel.setPayName(mPresenter.selectedPayMethod().name());
                salePayModel.setPayCode(mPresenter.selectedPayMethod().code());
                salePayModel.setBuyerLogonId(qNo);
                salePayModel.setTotalPaid(amount);
                salePayModel.setTotalRecv(amount);
                mPresenter.refreshAfterRefund(salePayModel);

            } else if (resultCode == ActivityConstants.RESULT_REFUND_COUPON_CANCEL) {
                showHintDialog("用户取消了券退款");
            }
        } else if (requestCode == REQUEST_OTHER_PAYMETHOD_REFUND && resultCode == ActivityConstants.RESULT_OTHER_PAYMETHOD_REFUND) {
            Bundle bundle = data.getExtras();
            String refunding = bundle.getString("amount");
            String payNo = bundle.getString("payNo");
            SalePayModel salePayModel = new SalePayModel(mPresenter.selectedPayMethod(), payNo, refunding);
            mPresenter.refreshAfterRefund(salePayModel);
        } else if (requestCode == ActivityConstants.REQUEST_REFUND_TO_SCRM_COUPON) {
            if (resultCode == ActivityConstants.RESULT_REFUND_COUPON_CONFIRM) {
                Bundle bundle = data.getExtras();
                final String qNo = bundle.getString("qNo");
                final String qValue = bundle.getString("qValue");
                List<UsableCoupon> usableCouponScrm = new ArrayList<>();
                com.hisense.hipos.coupon.Coupon coupon = new com.hisense.hipos.coupon.Coupon.Builder().coupon(qNo).build();
                UsableCoupon usableCoupon = new UsableCoupon(qNo, coupon, null);
                usableCouponScrm.add(usableCoupon);
                com.hisense.crm.webapi.coupon.CouponService.scrmCouponCancel(usableCouponScrm, getSale(), null, new Callback<Object>() {
                    @Override
                    public void onSuccess(Object o) {
                        hideProgressDialog();
                        double amount = Math.abs(Double.parseDouble(qValue));
                        SalePayModel salePayModel = new SalePayModel(mPresenter.selectedPayMethod(), qNo, String.valueOf(amount));
                        mPresenter.refreshAfterRefund(salePayModel);
                    }

                    @Override
                    public void onError(Throwable throwable) {
                        hideProgressDialog();
                        showHintDialog("SCRM会员券退款失败：" + throwable.getMessage() + getReturnSale().getSaleNo());
                        LoggerUtils.getLogger().debug("SCRM会员券退款异常：" + throwable.getMessage());
                    }
                });
            } else if (resultCode == 99) {
                showHintDialog("用户取消了券退款");
            }
        } else if (requestCode == REQUEST_REFUND_FINISHED && resultCode == RESULT_OK) {
            complete();
        } else if (requestCode == RESULT_SELECT_PAY_METHOD) {
            if (resultCode == 1) {
                PayMethod method = (PayMethod) data.getExtras().getSerializable("PayMethod");
                PayMethodService.selectPayMethod(this, method, paymentClick());
            }
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME || keyCode == KeyEvent.KEYCODE_MENU) {
            if (getReturnSale().getPays().size() > 0) {
                showHintDialog("已经进行了退货，不能返回");
                return false;
            } else {
                finish();
                return true;
            }
        } else {
            return super.onKeyDown(keyCode, event);
        }
    }

    @Override
    protected void onDestroy() {
        hideProgressDialog();
        LoggerUtils.getLogger().debug("onDestroy....hideProgressDialog");
        super.onDestroy();
    }
}
