/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.refund;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.MainActivity;
import com.hisense.hiaposcmp.activity.ysy.refund.viewModel.ReturnItemViewModel;
import com.hisense.hiaposcmp.adapter.SaleReturnItemsAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.layout.SwitchViewWatcher;
import com.hisense.hiaposcmp.presenter.refund.SaleReturnPresenter;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.refund.ISaleReturnView;
import com.hisense.hipos.model.ReturnSaleModel;
import com.hisense.hipos.model.ReturnSalePluModel;
import com.hisense.pos.scanner.IScanner;

import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 退货
 *
 * @author xieliyan    2017-05-10
 * @author xieliyan    2017-10-17 HIPOSAPP-177 退货时非整单退货,小票上只显示顾客退货的商品:将不需要退的商品价格置为0
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author zhangsai    2017-11-15 HIPOSAPP-212
 * @author xieliyan    2017-12-08 HIPOSAPP-237 激光扫码（一维码）
 * @author zhangsai    2018-01-16 HIPOSAPP-276 退货流水记录的应收合计应与原流水一致
 * @author zhangsai    2018-01-23 HIPOSAPP-296 退货流水不允许退货
 * @author xieliyan    2018-02-05 HIPOSAPP-214 "扫一扫"图片改为由 Android 绘制
 * @author xieliyan    2018-02-27 HIPOSAPP-338 修复HI98使用激光扫码设备请求多次的异常
 * @author xieliyan    2018-03-01 HIPOSAPP-342 修复商品数量为小数时异常退出的问题
 * @author zhangsai    2018-03-07 HIPOSAPP-347 优化流水查询输入框，新增扫码和文本清除
 * @author xieliyan    2018-03-14 HIPOSAPP-354 修复退货时银行卡凭证号不自动带出，上传流水签名错误的问题
 * @author zhangsai    2018-03-29 HIPOSAPP-371 修复设备识别错误导致的扫码闪退问题
 * @author xieliyan    2018-04-11 HIPOSAPP-388 修复单例模式引起的内存泄漏
 * @author zhangsai    2018-06-12 HIPOSAPP-514 修复先查询正常流水再查询退货流水时退货流水也可退货的缺陷（HIPOSAPP-296）
 * @author guolina     2018-06-13 HIPOSAPP-396 添加退货时积分原路退回
 * @author zhangsai    2018-07-27 HIPOSAPP-699 重写退货逻辑，使用 SaleService 查询流水并使用 ReturnSale 完成退货计算
 * @author guolina     2018-08-15 HIPOSAPP-729 解决手动上传会员流水时因会员卡号未传递导致的上传流水失败
 * @author guolina     2018-08-22 HIPOSAPP-756 增加实时积分和原路退回开关
 * @author guolina     2018-11-15 HIPOSAPP-772 整单退货支持赠券退回
 * @author guolina     2018-10-19 HIPOSAPP-795 积分原路退回使用优惠后价格而不是原价
 * @author guolina     2018-11-29 HIPOSAPP-847 赠券使用情况提示语修改
 * @author guolina     2018-11-29 HIPOSAPP-849 前笔流水的卡面号数据清除，避免后续非会员数据调取积分原路退回接口
 * @author zhangsai    2018-12-21 HIPOSAPP-699 优化退货逻辑
 * @author guolina     2018-12-25 HIPOSAPP-850 获取新流水号兼容POS中间件,规则可以在中间件设置
 * @author zhangsai    2018-12-26 HIPOSAPP-939 UI 新增会员姓名/会员卡类型；改用 SaleRepository 查询流水状态
 * @author zhangsai    2019-01-03 HIPOSAPP-958 根据电子发票二维码地址配置生成随机数
 * @author wangyaogang 2019-01-21 HIPOSAPP-970 修复选择退货商品界面,对复选框操作时,其他商品数量恢复最大值的问题
 * @author zhangsai    2019-01-30 HIPOSAPP-1002 使用 IScanner 扫描器实例扫描
 * @author guolina     2019-03-21 HIPOSAPP-1056 万科小票打印字段完善
 * @author wangyaogang 2019-05-14 HIPOSAPP-1095 易收银各类Toast提示信息改为弹窗提示,方便记录
 * @author wangyaogang 2019-06-17 HIPOSAPP-1098 初始化ReturnSale时增加AuthNo字段
 * @author zhangsai    2019-06-18 HIPOSAPP-1170 删除向 SaleRefundActivity 传入 Sale 对象
 * @author wangyaogang 2019-07-01 HIPOSAPP-1189 修复获取扫码结果时key值错误的问题
 * @author wangyaogang 2019-08-02 HIPOSAPP-1237 防止短时间内多次响应操作请求,退货按钮
 * @author wangyaogang 2019-08-07 HIPOSAPP-1255 退货时积分/赠券原路退回逻辑调整,失败时,增加提示,让用户选择是否继续
 * @author wangyaogang 2019-08-07 HIPOSAPP-1257 若已点击过确定,则再次预判失败时默认确定,不再提示
 * @author wangyaogang 2019-08-22 HIPOSAPP-1286 流水查询后验证会员时传卡面号
 * @author xieliyan    2019-11-01 HIAPOSCMP-254 退款重构
 * @author xieliyan    2019-12-16
 */
@ActivityLayoutInject(R.layout.activity_sale_return)
public class SaleReturnActivity extends BaseMvpActivity<ISaleReturnView, SaleReturnPresenter> implements ISaleReturnView {
    /**
     * 原交易流水号
     */
    @BindView(R.id.btnGoBack)
    public LinearLayout btnGoBack;
    /**
     * 原交易流水号
     */
    @BindView(R.id.edtSaleNo)
    public EditText edtSaleNo;
    /**
     * 退货流水号
     */
    @BindView(R.id.txtSaleNo)
    public TextView txtSaleNo;
    /**
     * 会员布局
     */
    @BindView(R.id.lytVip)
    public LinearLayout lytVip;
    /**
     * 会员卡布局
     */
    @BindView(R.id.lytVipCard)
    public LinearLayout lytVipCard;
    /**
     * 非会员布局
     */
    @BindView(R.id.lytNonVip)
    public LinearLayout lytNonVip;
    /**
     * 会员卡号
     */
    @BindView(R.id.txtVipCardNo)
    public TextView txtVipCardNo;
    /**
     * 会员卡类型名称
     */
    @BindView(R.id.txtVipTypeName)
    public TextView txtVipTypeName;
    /**
     * 会员名称
     */
    @BindView(R.id.txtVipName)
    public TextView txtVipName;
    /**
     * 券号
     */
    @BindView(R.id.txtTotalReturn)
    public TextView txtTotalReturn;
    /**
     * 合计实收
     */
    @BindView(R.id.txtTotal)
    public TextView txtTotal;
    /**
     * 全选
     */
    @BindView(R.id.imgSelectAll)
    public ImageView imgSelectAll;
    /**
     * 退货商品数量布局
     */
    @BindView(R.id.lytReturnCount)
    public LinearLayout lytReturnCount;
    /**
     * 退货商品数量
     */
    @BindView(R.id.txtReturnCount)
    public TextView txtReturnCount;
    /**
     * 原交易商品数量
     */
    @BindView(R.id.txtTotalCount)
    public TextView txtTotalCount;
    /**
     * 清空流水号
     */
    @BindView(R.id.lytClearSaleNo)
    public RelativeLayout lytClearSaleNo;
    /**
     * 扫描条码
     */
    @BindView(R.id.lytScanForSaleNo)
    public RelativeLayout lytScanForSaleNo;
    /**
     * 查询
     */
    @BindView(R.id.lytQuery)
    public RelativeLayout lytQuery;
    /**
     * 全选
     */
    @BindView(R.id.lytSelectAll)
    public LinearLayout lytSelectAll;
    /**
     * 退货
     */
    @BindView(R.id.lytReturn)
    public LinearLayout lytReturn;
    /**
     * 退货商品listview
     */
    @BindView(R.id.lvwSaleItems)
    public ListView lvwReturnItems;
    /**
     * 是否点击退货按钮
     */
    private volatile boolean hasReturned;

    /**
     * 退货商品适配器
     */
    private SaleReturnItemsAdapter saleReturnItemsAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mScanner = getScanner(this);
        mPresenter.saveAuthNo();
        mainSaleModel.returnSaleModel(null);
        edtSaleNoListener();
        adapter();
        updateVip(null);
    }

    @Override
    protected SaleReturnPresenter createPresenter() {
        return new SaleReturnPresenter();
    }

    /**
     * 返回
     */
    @OnClick(R.id.btnGoBack)
    public void onClickBack() {
        LoggerUtils.getLogger().debug("点击返回键");
        onBackPressed();
    }

    /**
     * 退货商品适配器
     */
    @OnClick(R.id.lytQuery)
    public void onClickQuery() {
        mPresenter.querySale(edtSaleNo.getText().toString());
    }

    /**
     * 退货商品适配器
     */
    @OnClick(R.id.lytClearSaleNo)
    public void onClickClearSaleNo() {
        edtSaleNo.setText("");
    }

    /**
     * 扫描流水号条码
     */
    @OnClick(R.id.lytScanForSaleNo)
    public void onClickScanForSaleNo() {
        mPresenter.scanForSaleNo();
    }

    /**
     * 全选
     */
    @OnClick(R.id.lytSelectAll)
    public void onClickSelectAll() {
        changeSelectAllState();
    }

    /**
     * 点击退货按钮
     */
    @OnClick(R.id.lytReturn)
    public void onClickReturn() {
        try {
            LoggerUtils.getLogger().debug("return点击了退货");
            if (hasReturned) {
                return;
            }
            LoggerUtils.getLogger().debug("return有效点击了退货");
            hasReturned = true;

            mPresenter.refund();
        } finally {
            hasReturned = false;
        }
    }

    /**
     * 更新流水号
     */
    @Override
    public void updateSaleNo(String saleNo) {
        txtSaleNo.setText(saleNo);
    }

    /**
     * 更新合计信息。
     *
     * @param returnCount   退货数量
     * @param totalCount    原交易流水合计商品数量
     * @param totalReceived 原交易流水合计实收金额
     * @param totalReturn   合计退款金额
     */
    @Override
    public void updateTotal(String returnCount, String totalCount, String totalReceived, String totalReturn) {
        txtTotal.setText(totalReceived);
        txtTotalCount.setText(String.valueOf(totalCount));
        this.updateTotal(returnCount, totalReturn);
        lytReturnCount.setVisibility(BigDecimalUtils.isGreater0(totalCount) ? View.VISIBLE : View.GONE);
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 使用退货流水更新合计信息。
     *
     * @param returnSaleModel 退货流水
     */
    @Override
    public void updateTotal(ReturnSaleModel returnSaleModel) {
        this.updateTotal(returnSaleModel.calcQuantity(), returnSaleModel.getTotalRecv());
    }

    /**
     * 使用指定数据更新合计。
     *
     * @param returnCount 退货数量
     * @param totalReturn 合计退款金额
     */
    @Override
    public void updateTotal(String returnCount, String totalReturn) {
        if (mPresenter.getReturnSaleModel() != null && mPresenter.getReturnSaleModel().isReturnAll()) {
            imgSelectAll.setImageResource(R.drawable.ic_check_checked);
        } else {
            imgSelectAll.setImageResource(R.drawable.ic_check_normal);
        }
        txtReturnCount.setText(String.valueOf(returnCount));
        txtTotalReturn.setText(totalReturn);
    }


    @Override
    public IScanner iScanner() {
        return mScanner;
    }

    /**
     * 更改全选状态。
     */
    private void changeSelectAllState() {
        if (saleReturnItemsAdapter == null || mPresenter.getReturnSaleModel() == null) {
            return;
        }

        boolean checkAll = true;
        if (mPresenter.getReturnSaleModel().isReturnAll()) {
            checkAll = false;
        }

        for (ReturnItemViewModel item : mPresenter.getListSalesItemData()) {
            item.changeCheckState(checkAll);
        }

        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 更改商品选择状态。
     */
    private void changeItemCheckState() {
        mPresenter.addCheckedItems();
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 多退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnMore(int position) {
        //  mPresenter.getListSalesItemData().get(position).returnSaleItem().returnMore();

        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();

        mPresenter.getReturnSaleModel().returnMore(position, returnSalePluModel);
        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 少退一件商品。
     *
     * @param position 商品在列表中的位置（从0开始）
     */
    private void returnLess(int position) {
        // mPresenter.getListSalesItemData().get(position).returnSaleItem().returnLess();
        ReturnSalePluModel returnSalePluModel = mPresenter.getListSalesItemData().get(position).returnSaleItem();

        mPresenter.getReturnSaleModel().returnLess(position, returnSalePluModel);
//        if (returnSalePluModel.isWeightOrEquivalent()) {
//            mPresenter.getReturnSaleModel().changeQuantity(position+1,0);
//        } else {
//            mPresenter.getReturnSaleModel().changeQuantity(position+1,Integer.parseInt(returnSalePluModel.getQuantity()));
//        }

        updateTotal(mPresenter.getReturnSaleModel());
        saleReturnItemsAdapter.notifyDataSetChanged();
    }

    /**
     * 输入流水号后触发查询流水事件
     */
    private void edtSaleNoListener() {
        edtSaleNo.addTextChangedListener(new SwitchViewWatcher(lytClearSaleNo, lytScanForSaleNo));
        edtSaleNo.setImeOptions(EditorInfo.IME_ACTION_DONE);
        edtSaleNo.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int actionId, KeyEvent keyEvent) {
                if (actionId == EditorInfo.IME_ACTION_DONE) {
                    mPresenter.querySale(edtSaleNo.getText().toString());
                }
                return false;
            }
        });
        edtSaleNo.setText(SaleNoService.getMax(this, Config.org_code, Config.pos_no));
        edtSaleNo.setSelection(edtSaleNo.length());
        edtSaleNo.requestFocus();
    }

    /**
     * 退货商品适配器
     */
    @Override
    public void adapter() {
        saleReturnItemsAdapter = new SaleReturnItemsAdapter(this, mPresenter.saleItem(), new ReturnItemAdapterHandler(this));
        lvwReturnItems.setAdapter(saleReturnItemsAdapter);

    }

    /**
     * 选择的退货商品列表
     */
    private List<ReturnItemViewModel> getPresenterReturnModels() {
        return mPresenter.getListSalesItemData();
    }

    /**
     * 退货商品适配器处理程序。
     */
    public class ReturnItemAdapterHandler extends Handler {
        private SaleReturnActivity activity;

        ReturnItemAdapterHandler(SaleReturnActivity activity) {
            this.activity = activity;
        }

        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);

            // 少退一件
            if (msg.what == SaleReturnItemsAdapter.SALE_ITEM_QUANTITY_DECREASED) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                this.activity.returnLess(position);
            }

            // 多退一件
            if (msg.what == SaleReturnItemsAdapter.SALE_ITEM_QUANTITY_INCREASED) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                this.activity.returnMore(position);
            }

            // 修改退款金额
            if (msg.what == SaleReturnItemsAdapter.EDIT_SINGLE_ITEM_TOTAL) {
                Bundle bundle = msg.getData();
                int position = bundle.getInt("position");
                double returnTotal = bundle.getDouble("returnTotal");
                this.activity.getPresenterReturnModels().get(position).returnSaleItem().returnTotal(returnTotal);
                this.activity.updateTotal(mPresenter.getReturnSaleModel());
            }

            // 更改选择状态
            if (msg.what == SaleReturnItemsAdapter.CHECKBOX_SINGLE_ITEM_COUNT) {
                this.activity.changeItemCheckState();
            }
        }
    }

    /**
     * 更新会员布局
     */
    @Override
    public void updateVip(Vip vip) {
        if (vip == null) {
            lytVip.setVisibility(View.GONE);
            lytVipCard.setVisibility(View.GONE);
            lytNonVip.setVisibility(View.VISIBLE);
        } else {
            lytVip.setVisibility(View.VISIBLE);
            lytVipCard.setVisibility(View.VISIBLE);
            lytNonVip.setVisibility(View.GONE);

            txtVipCardNo.setText(vip.card().cardFaceNo());
            txtVipTypeName.setText(vip.card().cardType().name());
            txtVipName.setText(vip.name());

            if (vip.projects().size() > 0) {
                mPresenter.getReturnSaleModel().setLastUsablePoint(String.format("%s", vip.projects().get(0).usablePoints()));
            } else {
                mPresenter.getReturnSaleModel().setLastUsablePoint("0");
            }
        }
    }

    @Override
    public void gotoRefundActivity() {

        CommonTools.goTo(this, SaleRefundActivity.class);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            updateSaleNo(mScanner.getScanResult(data));
            mPresenter.querySale(mScanner.getScanResult(data));

        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            LoggerUtils.getLogger().debug("点击设备返回键");
            CommonTools.exit(this, MainActivity.class);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }


    @Override
    protected void onResume() {
        super.onResume();
    }
}
