/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.activity.ysy.report;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.constant.report.ReportConstants;
import com.hisense.hiaposcmp.dialog.TimePicker;
import com.hisense.hiaposcmp.presenter.ReportPresenter;
import com.hisense.hiaposcmp.view.IView.IReportView;
import com.hisense.hipos.report.SaleReport;
import com.hisense.hipos.report.ShopSaleReport;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.report.DepReportResultData;
import com.hisense.hipos.webapi.report.PluReportResultData;

import java.util.Date;
import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;


/**
 * @author wangyaogang 2019-09-06 HIPOSAPP-1292 部门报表
 */
@ActivityLayoutInject(R.layout.activity_department_report)
public class DepartmentReportActivity extends BaseMvpActivity<IReportView, ReportPresenter> implements IReportView {

    // 返回按钮
    @BindView(R.id.llGoBack)
    LinearLayout llGoBack;

    // 打印按钮
    @BindView(R.id.llPrint)
    LinearLayout llPrint;

    // 页面数据位空时的提示信息
    @BindView(R.id.txtEmpty)
    TextView txtEmpty;

    // 页面容器
    @BindView(R.id.llReportContainer)
    LinearLayout llReportContainer;

    // 部门编码
    @BindView(R.id.txtDep)
    TextView txtDep;

    // 销售商品列表
    @BindView(R.id.lvwSaleItems)
    ListView lvwSaleItems;

    // 合计金额
    @BindView(R.id.txtTotal)
    TextView txtTotal;

    //查询报表
    @BindView(R.id.btn_query)
    Button mBtnQuery;

    //开始日期
    @BindView(R.id.tx_begin_time)
    TextView mTxBeginTime;

    @Override
    protected ReportPresenter createPresenter() {
        return new ReportPresenter();
    }

    /**
     * 判断是否有报表数据，如果没有则显示默认提示信息
     */
    @Override
    public void showCashierData(boolean isShowData) {
        if (isShowData) {
            llReportContainer.setVisibility(View.VISIBLE);
            txtEmpty.setVisibility(View.GONE);

        } else {
            llReportContainer.setVisibility(View.GONE);
            txtEmpty.setVisibility(View.VISIBLE);
            mPresenter.setDepShopSaleReport(null);
        }
    }

    @Override
    public void showSaleReport(SaleReport report) {

    }

    @Override
    public void showDepReport(DepReportResultData report) {
        mPresenter.setDepShopSaleReport(report);
        lvwSaleItems.setAdapter(mPresenter.departAdapter());
        if (null == report) {
            txtTotal.setText("");
        } else {
            txtTotal.setText(String.format(Locale.CHINA, "%.2f", Double.parseDouble(report.totalRecv)));
        }

    }

    @Override
    public void showPluReport(PluReportResultData report) {

    }

    @Override
    public void showShopSaleReport(ShopSaleReport report) {

    }

    @Override
    public void accountingDateSaleSuccess(String accDate) {

    }

    @Override
    public Activity getActivity() {
        return this;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        txtDep.setText(Context.shopCode());
        mTxBeginTime.setText(TimePicker.getTime(new Date()));
        showCashierData(false);
    }

    @OnClick(R.id.llGoBack)
    public void onClickBack() {
        finish();
    }

    @OnClick(R.id.llPrint)
    public void onClickPrint() {
        mPresenter.printDepPort(ReportConstants.REPORT_DEPART, mTxBeginTime.getText().toString());
    }

    @OnClick(R.id.btn_query)
    public void onClickQuery() {
        //判断日期
        mPresenter.getDepReport(mTxBeginTime.getText().toString(), GeneralSettings.INSTANCE.isNoShopLimits() ? "*" : Context.shopCode());
    }

    @OnClick(R.id.tx_begin_time)
    public void onClickTime() {
        TimePicker.timePicker(mTxBeginTime);
    }

    @Override
    public TranType tranType() {
        return TranType.Sale;
    }
}
