/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.report;

import android.os.Bundle;
import android.widget.LinearLayout;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.presenter.ReportPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IReportView;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.user.Privileges;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 报表查询。
 *
 * @author xieliyan    2017-08-18
 * @author xieliyan    2017-09-01 选择不同的报表传入不同的报表类型
 * @author zhangsai    2018-12-28 HIPOSAPP-946 消息参数由 reportType 改为 tranType
 * @author wangyaogang 2019-01-16 HIPOSAPP-936 功能权限由CMP5控制下发,尤其是【查询】和【报表】中的功能权限
 */
@ActivityLayoutInject(R.layout.activity_report_entry)
public class ReportEntryActivity extends BaseMvpActivity<IReportView, ReportPresenter> {

    // 总交易报表
    @BindView(R.id.llSaleReport)
    public LinearLayout llSaleReport;

    // 收银员报表
    @BindView(R.id.llCashierSaleReport)
    public LinearLayout llCashierSaleReport;

    // 专柜报表
    @BindView(R.id.llShopSaleReport)
    public LinearLayout llShopSaleReport;

    // 预销售报表
    @BindView(R.id.llPreSaleReport)
    public LinearLayout llPreSaleReport;

    // 返回按钮
    @BindView(R.id.btnGoBack)
    public LinearLayout btnGoBack;

    //部门报表
    @BindView(R.id.llDepartmentReport)
    LinearLayout llDepartmentReport;

    //商品销售汇总报表
    @BindView(R.id.llGoodsReport)
    LinearLayout llGoodsReport;

    @Override
    protected ReportPresenter createPresenter() {
        return new ReportPresenter();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @OnClick(R.id.btnGoBack)
    public void onClickBack() {
        onBackPressed();
    }

    @OnClick(R.id.llSaleReport)
    public void onClickSaleReport() {
        if (hasPrivilege(Privileges.REPORT_SALE)) {
            CommonTools.gotoActivity(SaleReportActivity.class, "tranType", TranType.Sale.value());
        } else {
            showHintDialog("没有总交易报表查询权限");
        }
    }

    @OnClick(R.id.llCashierSaleReport)
    public void onClickCashierSaleReport() {
        if (hasPrivilege(Privileges.REPORT_CASHIER)) {
            CommonTools.gotoActivity(CashierReportActivity.class);
        } else {
            showHintDialog("没有收银员报表查询权限");
        }
    }

    @OnClick(R.id.llShopSaleReport)
    public void onClickShopSaleReport() {
        if (hasPrivilege(Privileges.REPORT_DEPARTMENT)) {
            CommonTools.gotoActivity(ShopSaleReportActivity.class);
        } else {
            showHintDialog("没有专柜报表查询权限");
        }
    }

    @OnClick(R.id.llPreSaleReport)
    public void onClickPreSaleReport() {
        if (hasPrivilege(Privileges.REPORT_PRE_SALE)) {
            CommonTools.gotoActivity(SaleReportActivity.class, "tranType", TranType.PreSale.value());
        } else {
            showHintDialog("没有预销售报表查询权限");
        }
    }

    @OnClick(R.id.llDepartmentReport)
    public void onClickDepartmentReport() {
        CommonTools.gotoActivity(DepartmentReportActivity.class);
    }

    @OnClick(R.id.llGoodsReport)
    public void onClickGoodsReport() {
        CommonTools.gotoActivity(PluReportActivity.class);
    }
}
