/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.report;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.report.ReportConstants;
import com.hisense.hiaposcmp.presenter.ReportPresenter;
import com.hisense.hiaposcmp.view.IView.IReportView;
import com.hisense.hipos.report.SaleReport;
import com.hisense.hipos.report.ShopSaleReport;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.report.DepReportResultData;
import com.hisense.hipos.webapi.report.PluReportResultData;

import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 专柜销售报表查询。
 *
 * @author fujiaxin 2017-03-14
 * @author zhangsai 2017-12-21 HIPOSAPP-250 改由通过 SaleService 获取当前结账日期
 * @author zhangsai 2018-12-28 HIPOSAPP-946 改用 ReportService 查询销售报表
 */
@ActivityLayoutInject(R.layout.activity_report_sale_shop)
public class ShopSaleReportActivity extends BaseMvpActivity<IReportView, ReportPresenter> implements IReportView {

    // 返回按钮
    @BindView(R.id.llGoBack)
    public LinearLayout llGoBack;

    // 打印按钮
    @BindView(R.id.llPrint)
    public LinearLayout llPrint;

    // 页面数据位空时的提示信息
    @BindView(R.id.txtEmpty)
    public TextView txtEmpty;

    // 页面容器
    @BindView(R.id.llReportContainer)
    public LinearLayout llReportContainer;

    // 合计金额
    @BindView(R.id.txtShopCode)
    public TextView txtShopCode;

    // 销售商品列表
    @BindView(R.id.lvwSaleItems)
    public ListView lvwSaleItems;

    // 合计金额
    @BindView(R.id.txtTotal)
    public TextView txtTotal;

    @Override
    protected ReportPresenter createPresenter() {
        return new ReportPresenter();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        txtShopCode.setText(Context.shopCode());
        mPresenter.accountingDateSale(ReportConstants.REPORT_SHOP, null);
    }

    @Override
    public void showCashierData(boolean isShowData) {
        if (isShowData) {
            llReportContainer.setVisibility(View.VISIBLE);
            txtEmpty.setVisibility(View.GONE);

        } else {
            llReportContainer.setVisibility(View.GONE);
            txtEmpty.setVisibility(View.VISIBLE);
            mPresenter.setShopSaleReport(null);
        }
    }

    @Override
    public void showSaleReport(SaleReport report) {

    }

    @Override
    public void showDepReport(DepReportResultData report) {

    }

    @Override
    public void showPluReport(PluReportResultData report) {

    }

    @Override
    public void showShopSaleReport(ShopSaleReport report) {
        mPresenter.setShopSaleReport(report);
        lvwSaleItems.setAdapter(mPresenter.shopReportAdapter());
        if (null == report) {
            txtTotal.setText("");
        } else {
            txtTotal.setText(String.format(Locale.CHINESE, "%.2f", report.total()));
        }

    }

    @Override
    public void accountingDateSaleSuccess(String accDate) {

    }

    @OnClick(R.id.llGoBack)
    public void onClickBack() {
        finish();
    }

    @OnClick(R.id.llPrint)
    public void onClickPrint() {
        mPresenter.printShopReport();
    }

    @Override
    public Activity getActivity() {
        return this;
    }

    @Override
    public TranType tranType() {
        return TranType.Sale;
    }
}
