/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.sale;

import android.content.Intent;
import android.os.Bundle;
import android.widget.LinearLayout;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.common.UpLogActivity;
import com.hisense.hiaposcmp.activity.ysy.card.CardBalanceCardAndPointsQueryActivity;
import com.hisense.hiaposcmp.activity.ysy.vip.VipPointsCardAndPointsQueryActivity;
import com.hisense.hiaposcmp.activity.ysy.vip.VipQueryActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.presenter.EmptyPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.IEmptyView;
import com.hisense.hipos.user.Privileges;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 查询主界面。
 *
 * @author xieliyan    2017-03-27
 * @author zhangsai    2017-10-30 HIPOSAPP-198
 * @author zhangsai    2017-11-15 HIPOSAPP-212
 * @author wangyaogang 2019-01-16 HIPOSAPP-936 功能权限由CMP5控制下发,尤其是【查询】和【报表】中的功能权限
 */
@ActivityLayoutInject(R.layout.activity_query)
public class QueryActivity extends BaseMvpActivity<IEmptyView, EmptyPresenter> implements IEmptyView {

    @BindView(R.id.btnGoBack)
    LinearLayout mBtnGoBack;
    @BindView(R.id.llQueryVip)
    LinearLayout mLlQueryVip;
    @BindView(R.id.llQueryCardBalance)
    LinearLayout mLlQueryCardBalance;
    @BindView(R.id.llQueryVipPoints)
    LinearLayout mLlQueryVipPoints;
    @BindView(R.id.llQuerySale)
    LinearLayout mLlQuerySale;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    protected EmptyPresenter createPresenter() {
        return new EmptyPresenter();
    }

    private void goToActivity(Class cls) {
        Intent intent = new Intent();
        intent.setClass(QueryActivity.this, cls);
        startActivity(intent);
    }

    @OnClick(R.id.btnGoBack)
    public void onBtnGoBackClicked() {
        onBackPressed();
    }

    @OnClick(R.id.llQueryVip)
    public void onLlQueryVipClicked() {
        if (hasPrivilege(Privileges.REPORT_VIP_BALANCE)) {
            goToActivity(VipQueryActivity.class);
        } else {
            showHintDialog("没有会员查询权限");
        }
    }

    @OnClick(R.id.llQueryCardBalance)
    public void onLlQueryCardBalanceClicked() {
        if (hasPrivilege(Privileges.QUERY_CARD_BALANCE)) {
            goToActivity(CardBalanceCardAndPointsQueryActivity.class);
        } else {
            showHintDialog("没有储值卡余额查询权限");
        }
    }

    @OnClick(R.id.llQueryVipPoints)
    public void onLlQueryVipPointsClicked() {
        if (hasPrivilege(Privileges.QUERY_VIP_POINTS)) {
            goToActivity(VipPointsCardAndPointsQueryActivity.class);
        } else {
            showHintDialog("没有积分余额查询权限");
        }
    }

    @OnClick(R.id.llQuerySale)
    public void onLlQuerySaleClicked() {
        if (hasPrivilege(Privileges.QUERY_SALE)) {
            goToActivity(SaleQueryActivity.class);
        } else {
            showHintDialog("没有流水查询权限");
        }
    }

    @OnClick(R.id.llUploadLog)
    public void onLlUploadLogClicked() {
        CommonTools.gotoActivity(UpLogActivity.class);
    }
}


