/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.sale;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.core.content.res.ResourcesCompat;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.pay.PayActivity;
import com.hisense.hiaposcmp.activity.ysy.vip.VipLoginActivity;
import com.hisense.hiaposcmp.adapter.SaleItemYsyAdapter;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.ActivityConstants;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.layout.SwitchViewWatcher;
import com.hisense.hiaposcmp.presenter.sale.SalePresenter;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.swipe.SwipeMenuCreator;
import com.hisense.hiaposcmp.swipe.SwipeMenuItem;
import com.hisense.hiaposcmp.swipe.SwipeMenuListView;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.tool.ScanKeyEventHelper;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.util.NetUtils;
import com.hisense.hiaposcmp.view.IView.sale.ISaleView;
import com.hisense.hiaposcmp.view.MyFloatView;
import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.GiftCoupon;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.sale.TranType;
import com.hisense.pos.scanner.IScanner;
import com.hisense.pos.scanner.ScannerCallback;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 销售。
 *
 * @author caokai      2017-01-18
 * @author fujiaxin    2017-03-02
 * @author caokai      2017-03-16 HIPOSAPP-18
 * @author xieliyan    2017-04-19
 * @author xieliyan    2017-05-20
 * @author xieliyan    2017-09-06 HIPOSAPP-149 流水重复上传造成的异常，如果流水正在上传中，不允许再次上传
 * @author xieliyan    2017-09-12 HIPOSAPP-133 支付完成后保存本地流水时，将发票的提取码存储在本地数据库tsalsale表的udp4字段
 * @author xieliyan    2017-09-13 HIPOSAPP-133 打开启用发票打印机时获取url地址和提取码
 * @author xieliyan    2017-09-18 HIPOSAPP-158 修复本地上传流水签名错误问题
 * @author xieliyan    2017-10-11 HIPOSAPP-166 流水上传成功后打印小票(取消该需求）
 * @author xieliyan    2017-10-12 HIPOSAPP-168 新交易开始，初始化变量
 * @author xieliyan    2017-10-16 HIPOSAPP-149 流水状态更改
 * @author xieliyan    2017-10-17 HIPOSAPP-175 在会员登录界面录入会员卡面号，进入销售界面后仍然显示非会员
 * @author xieliyan    2017-10-17 HIPOSAPP-180 显示当前会员卡类别
 * @author xieliyan    2017-10-18 HIPOSAPP-181 赠券打印说明格式调整
 * @author xieliyan    2017-10-27 HIPOSAPP-166 流水上传成功后打印小票(取消该需求
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author xieliyan    2017-12-06 HIPOSAPP-236 商品列表加密处理
 * @author xieliyan    2017-12-08 HIPOSAPP-237 激光扫码（一维码）
 * @author zhangsai    2017-12-21 HIPOSAPP-250 改由通过 SaleService 获取当前结账日期
 * @author zhangsai    2017-12-28 HIPOSAPP-259 使用序列化的 Vip 初始化会员信息
 * @author zhangsai    2018-01-11 HIPOSAPP-271 优化生成流水号的代码，改为从 tSaleNo 表获取
 * @author zhangsai    2018-01-11 HIPOSAPP-275 商品查询输入框文本变化时显示清除按钮
 * @author zhangsai    2018-01-11 HIPOSAPP-284 支付撤销后销售商品列表根据原流水重新初始化
 * @author xieliyan    2018-01-29 HIPOSAPP-303 控制查询商品触发条件
 * @author xieliyan    2018-02-05 HIPOSAPP-214 "扫一扫"图片改为由 Android 绘制
 * @author xieliyan    2018-02-06 HIPOSAPP-319 修复异常关闭易收银程序，打印小票中包含之前未交易的商品信息的问题
 * @author zhangsai    2018-02-08 HIPOSAPP-321 支持称重商品
 * @author xieliyan    2018-02-24 HIPOSAPP-336 修复支付完成APP闪退的问题
 * @author xieliyan    2018-02-27 HIPOSAPP-338 修复HI98使用激光扫码设备请求多次的异常
 * @author xieliyan    2018-02-05 HIPOSAPP-318 储值卡支付 - 余额存在小数无法继续进行支付
 * @author xieliyan    2018-02-24 HIPOSAPP-308 销售页面商品搜索框增加扫码按钮
 * @author zhangsai    2018-02-28 HIPOSAPP-339 修复添加多个商品后删除靠前的商品导致优惠记录数据错误的问题
 * @author xieliyan    2018-04-11 HIPOSAPP-388 修复单例模式引起的内存泄漏
 * @author xieliyan    2018-04-13 HIPOSAPP-387 修复先输入商品再会员优惠后价格为0的商品显示在列表中的问题
 * @author xieliyan    2018-04-16 HIPOSAPP-398 修复优惠后商品价格为0的商品时APP闪退的问题
 * @author guolina     2018-05-21 HIPOSAPP-446 新增实时积分
 * @author xieliyan    2018-05-28 HIPOSAPP-462 修复长时间停留在销售界面，交易类型参数被回收导致的流水上传失败问题
 * @author xieliyan    2018-05-28 HIPOSAPP-463 修复长时间停留在销售界面，再次查询商品时提示未获取结账日期的问题
 * @author guolina     2018-06-01 HIPOSAPP-479 添加tranType打印和赋值
 * @author lizhixin    2018-06-02 HIPOSAPP-482 修复打印小票时有一定几率出现重复商品信息的问题
 * @author zhangsai    2018-06-13 HIPOSAPP-519 设置商品的 pluType 商品类型
 * @author zhangsai    2018-06-15 HIPOSAPP-538 改由通过 SaleService 计算赠券
 * @author zhangsai    2018-06-15 HIPOSAPP-539 通过 SaleService 异步获取当前结账日期并初始化交易
 * @author zhangsai    2018-06-15 HIPOSAPP-540 打印时复制一份交易，避免成功上传流水后清空数据导致小票打印缺商品/支付
 * @author zhangsai    2018-06-16 HIPOSAPP-552 上传流水时增加服务在线状态检测和自动重试机制
 * @author zhangsai    2018-06-20 HIPOSAPP-565 删除传递给 PayActivity 的满减促销参数
 * @author zhangsai    2018-06-20 HIPOSAPP-545 上传流水返回时从消息中获取流水号和会员卡号（兼容正常流水和本地流水上传）
 * @author zhangsai    2018-06-21 HIPOSAPP-576 删除满减促销（商品优惠）逻辑，转到支付页面统一进行满减
 * @author zhangsai    2018-06-29 HIPOSAPP-605 添加第一件商品时重新初始化交易，使交易日期与实际发生日期保持一致
 * @author zhangsai    2018-06-29 HIPOSAPP-607 开始支付后不允许添加商品
 * @author zhangsai    2018-07-02 HIPOSAPP-626 初始化交易时获取电子发票配置参数
 * @author zhangsai    2018-07-03 HIPOSAPP-625 会员登录后检查交易是否初始化
 * @author zhangsai    2018-07-04 HIPOSAPP-644 修复由于未知原因交易未初始化时更新合计导致的闪退
 * @author zhangsai    2018-07-12 HIPOSAPP-664 支付撤销返回后初始化交易时同时初始化会员信息；且使用储值卡/积分成功支付后，撤销时保存流水号
 * @author guolina     2018-07-23 HIPOSAPP-677 页面已销毁dialog依然在运行导致的闪退
 * @author guolina     2018-08-07 HIPOSAPP-661 修复传参错误导致的销售流水在预销售菜单页面手动上传流水，流水表中Trantype变为了9
 * @author guolina     2018-08-13 HIPOSAPP-719 会员流水手动重新上传时实现实时积分
 * @author guolina     2018-08-14 HIPOSAPP-720 修复服务端已经返回了积分字段的值，但小票上面打印出来为空的问题
 * @author guolina     2018-08-17 HIPOSAPP-740 修复因传参错误导致的手动上传流水实时积分值错误
 * @author guolina     2018-08-17 HIPOSAPP-739 修复因未获取焦点导致的销售界面软键盘没自动弹出
 * @author zhangsai    2018-08-20 HIPOSAPP-743 修复上传流水时偶发不打印小票的问题
 * @author guolina     2018-08-22 HIPOSAPP-736 修复因快速多次点击上传流水导致的等待框不消失
 * @author guolina     2018-08-22 HIPOSAPP-756 增加实时积分和原路退回开关
 * @author guolina     2018-08-30 HIPOSAPP-440 修复录入商品后第二天结算流水日期错误
 * @author guolina     2018-09-26 HIPOSAPP-770 支持销售/退款后增加储值卡和积分余额打印
 * @author guolina     2018-09-26 HIPOSAPP-760 添加大码商品时，若sale为空则提示重试，避免闪退
 * @author guolina     2018-09-26 HIPOSAPP-761 修复会员登陆后的偶发性闪退
 * @author guolina     2018-10-19 HIPOSAPP-785 结算按钮添加误多次点击过滤
 * @author guolina     2018-10-19 HIPOSAPP-792 积分原路退回逻辑更改
 * @author guolina     2018-11-14 HIPOSAPP-823 小票增加礼品券打印
 * @author guolina     2018-11-15 HIPOSAPP-772 整单退货支持赠券退回
 * @author guolina     2018-11-22 HIPOSAPP-835 多任务同步改用CountDownLatch，解决打印慢的问题
 * @author guolina     2018-11-26 HIPOSAPP-902 读取本地未上传流水表时去掉条数限制
 * @author guolina     2018-11-29 HIPOSAPP-844 修复因赠券返回信息未保存到打印数据导致的不打印赠券问题
 * @author wangyaogang 2018-12-06 HIPOSAPP-885 商品查询接口调
 * @author zhangsai    2018-12-14 HIPOSAPP-797 设置流水支付UDP2字段记录工行收单终端号
 * @author zhangsai    2018-12-19 HIPOSAPP-698 交易商品类型改为 ISaleItem
 * @author zhangsai    2018-12-26 HIPOSAPP-931 优化流水上传和本地流水上传逻辑，改用 SaleApplicationService 上传流水
 * @author zhangsai    2019-01-03 HIPOSAPP-958 根据电子发票二维码地址配置生成随机数
 * @author zhangsai    2019-01-07 HIPOSAPP-957 商品查询接口支持会员促销
 * @author guolina     2019-01-09 HIPOSAPP-916 查询商品优惠接口调整
 * @author guolina     2019-01-24 HIPOSAPP-977 条码称重商品支持商品促销和会员促销
 * @author wangyaogang 2019-01-30 HIPOSAPP-994 衢州东方-商品数量支持手工录入
 * @author zhangsai    2019-01-30 HIPOSAPP-1002 使用 IScanner 扫描器实例扫描
 * @author guolina     2019-02-12 HIPOSAPP-1009 修复会员促销添加错误
 * @author guolina     2019-02-13 HIPOSAPP-1015 商品查询返回促销类型为会员促销时不添加商品到缓存
 * @author guolina     2019-02-25 HIPOSAPP-1029 去掉TicketPluBean.java文件，优化代码
 * @author guolina     2019-03-06 HIPOSAPP-1041 Sale代替Trade，优化代码
 * @author wangyaogang 2019-03-06 HIPOSAPP-1037 修复上传流水时发生异常导致流水号不更新的问题
 * @author wangyaogang 2019-03-06 HIPOSAPP-1044 修复ProgressDialog关闭时系统崩溃的问题
 * @author guolina     2019-03-25 HIPOSAPP-1012 流水上传失败提示优化
 * @author guolina     2019-03-21 HIPOSAPP-1056 万科小票打印字段完善
 * @author wangyaogang 2019-05-13 HIPOSAPP-1087 控制每台机器收款的小数位
 * @author wangyaogang 2019-05-14 HIPOSAPP-1094 易收银前台能否销售根据中间件返回的商品状态进行处理,且去掉商品缓存
 * @author wangyaogang 2019-05-14 HIPOSAPP-1095 易收银各类Toast提示信息改为弹窗提示,方便记录
 * @author wangyaogang 2019-05-15 HIPOSAPP-1087 优化[控制每台机器收款的小数位]逻辑,去掉isNeedRound
 * @author wangyaogang 2019-06-11 HIPOSAPP-1129 修复总清后仍打印之前登录会员积分信息的问题
 * @author wangyaogang 2019-06-13 HIPOSAPP-1134 增加剩余可用券Map
 * @author wangyaogang 2019-07-08 HIPOSAPP-1190 优化赠券开关设置,去掉【启用赠送礼品券】
 * @author wangyaogang 2019-08-02 HIPOSAPP-1237 防止短时间内多次响应操作请求,结算按钮
 * @author xieliyan    2019-08-15 HIPOSAPP-1280 对接SCRM-打印赠券时区分礼品券和金额券
 * @author dukunbiao(null)  2019-10-08  重构
 * @author guolina     2019-10-21 HIPOSAPP-1317 利客来未上传流水自动上传
 * @author guolina     2019-11-07 HIPOSAPP-1338 使用EventBus在自动上传流水结束后刷新销售界面红点
 * @author guolina     2019-12-11 HIAPOSCMP-421 会员积分展示允许16位，避免超过8位科学记数法
 */
@ActivityLayoutInject(R.layout.activity_sale)
public class SaleActivity extends BaseMvpActivity<ISaleView, SalePresenter> implements ISaleView, ScanKeyEventHelper.OnScanSuccessListener, View.OnFocusChangeListener {

    public static Map<String, Collection<GiftCoupon>> giftCouponMap = new HashMap<>();//礼品券
    public static Map<String, Collection<Coupon>> couponMap = new HashMap<>();
    public static Map<String, Collection<Coupon>> remainedCouponMap = new HashMap<>();//核销后剩余可用券

    private SaleItemYsyAdapter saleItemAdapter;

    private MyFloatView myFV = null;
    // 重新上传流水时，用于记录‘重传流水号’
    private Boolean floatViewFlag = true;

    private int FLOW_VIEW_X = 800;
    private int FLOW_VIEW_Y = 350;

    @BindView(R.id.edtPlu)
    public EditText edtPlu;

    @BindView(R.id.txtTotal)
    public TextView txtTotal;

    @BindView(R.id.lytCheckout)
    public LinearLayout lytCheckout;

    @BindView(R.id.txtTotalCount)
    public TextView txtTotalCount;

    @BindView(R.id.txtSaleNo)
    public TextView txtSaleNo;

    @BindView(R.id.lytVip)
    public LinearLayout lytVip;

    @BindView(R.id.lytNonVip)
    public LinearLayout lytNonVip;

    @BindView(R.id.lytVipCard)
    public LinearLayout lytVipCard;

    @BindView(R.id.lytVipPoints)
    public LinearLayout lytVipPoints;

    @BindView(R.id.txtVipCardNo)
    public TextView txtVipCardNo;

    @BindView(R.id.txtVipName)
    public TextView txtVipName;

    @BindView(R.id.txtVipTypeName)
    public TextView txtVipTypeName;

    @BindView(R.id.txtVipPointsUsable)
    public TextView txtVipPointsUsable;

    @BindView(R.id.txtVipPointsBalance)
    public TextView txtVipPointsBalance;

    @BindView(R.id.txtAssistant)
    public EditText txtAssistant;

    @BindView(R.id.lytAssistant)
    public LinearLayout lytAssistant;

    @BindView(R.id.scanLayout)
    public LinearLayout scanLayout;

    @BindView(R.id.lytClearPlu)
    public RelativeLayout lytClearPlu;

    @BindView(R.id.lytScanPlu)
    public RelativeLayout lytScanPlu;

    @BindView(R.id.salesItem)
    public SwipeMenuListView lvwSaleItems;

    @BindView(R.id.lytUpload)
    public RelativeLayout lytUpload;

    public TranType tranType = TranType.Sale;

    private List<BaseSalePluModel> mSaleItems = null;       // 当前交易商品。交易结束后置清空

    private volatile boolean mIsUploading;
    private volatile boolean mIsPaying;

    private volatile boolean hasCheckOut;               //是否点击过结算

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
        initValue();
        initAdapter();
        clearAllUseData();
    }

    @Override
    protected SalePresenter createPresenter() {
        return new SalePresenter();
    }

    /**
     * 接收自动上传流水结束消息
     */
    @Subscribe(threadMode = ThreadMode.MAIN, sticky = false)
    public void onEvent(String event) {
        if ("refresh".equals(event)) {
            mPresenter.refreshUnloadPoint(lytUpload);
        }
    }

    private void init() {
        isNotShowExitDialog = true;
        floatViewFlag = true;

        mScanner = getScanner(this);

        lytCheckout.setEnabled(true);
        lytAssistant.setVisibility(GeneralSettings.INSTANCE.isCashierEnabled() ? View.VISIBLE : View.GONE);
        lytVip.setVisibility(View.GONE);
        lytVipCard.setVisibility(View.GONE);
        lytVipPoints.setVisibility(View.GONE);
        lytNonVip.setVisibility(View.VISIBLE);
        scanLayout.setVisibility(View.GONE);
        EventBus.getDefault().register(this);
    }

    private void initValue() {
        Bundle bundle = this.getIntent().getExtras();
        Vip vip = null;
        if (bundle != null) {
            String sTranType = bundle.getString("tranType");
            if (!StringUtils.isEmpty(sTranType)) {
                tranType = TranType.valueOfType(sTranType);
                GeneralSettings.INSTANCE.setTranType(sTranType);
            }

            vip = (Vip) this.getIntent().getSerializableExtra("vip");
        }
        if (tranType == TranType.PreSale) {
            lvwSaleItems.setBackgroundResource(R.drawable.presale_bg_bmp);
        }

        mIsPaying = false;
        mPresenter.createNewSale(vip, tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                updateVipInfo(mPresenter.getSale().getVip());
                txtSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String message) {
                showHintDialog(message);
            }
        });
    }

    private void initAdapter() {
        mSaleItems = new ArrayList<>();

        //绑定输入商品编码查询事件
        edtPlu.addTextChangedListener(new SwitchViewWatcher(lytClearPlu, lytScanPlu));
        edtPlu.requestFocus();
        edtPlu.setImeOptions(EditorInfo.IME_ACTION_DONE);
        edtPlu.setOnEditorActionListener((textView, actionId, keyEvent) -> {
            if (actionId == EditorInfo.IME_ACTION_DONE) {
                //调用服务获取商品信息
                if (!StringUtils.isEmpty(edtPlu.getText().toString()) && !mIsPaying) {
                    mPresenter.pluQueryWithCheck(edtPlu.getText().toString().trim());
                }
            }
            return false;
        });

        //左划删除商品项
        SwipeMenuCreator creator = (menu) -> {
            SwipeMenuItem deleteItem = new SwipeMenuItem(getApplicationContext());
            deleteItem.setBackground(R.color.salesBtn);
            deleteItem.setWidth(CommonUtils.dp2Px(this, 90));
            deleteItem.setTitle("删除");
            deleteItem.setTitleSize(18);
            deleteItem.setTitleColor(Color.WHITE);

            menu.addMenuItem(deleteItem);
        };

        lvwSaleItems.setMenuCreator(creator);
        lvwSaleItems.setOnMenuItemClickListener((position, menu, index) -> {
            //index的值就是在SwipeMenu依次添加SwipeMenuItem顺序值，类似数组的下标。
            //从0开始，依次是：0、1、2、3...
            if (index == 0) {
                lvwSaleItems.smoothCloseMenu();
                mPresenter.getSale().removePlu(position);
                mSaleItems.remove(position);

                saleItemAdapter.notifyDataSetChanged();
                updateTotal();
            }
            // false : 当用户触发其他地方的屏幕时候，自动收起菜单。
            // true : 不改变已经打开菜单的样式，保持原样不收起。
            return false;
        });

        // 监测用户在ListView的SwipeMenu侧滑事件。
        lvwSaleItems.setOnSwipeListener(new SwipeMenuListView.OnSwipeListener() {
            @Override
            public void onSwipeStart(int pos) {
                LoggerUtils.getLogger().debug("位置:" + pos + ",开始侧滑...");
            }

            @Override
            public void onSwipeEnd(int pos) {
                LoggerUtils.getLogger().debug("位置:" + pos + ",侧滑结束.");
            }
        });

        //设置listView适配器
        saleItemAdapter = new SaleItemYsyAdapter(this, mSaleItems, new SaleItemsAdapterHandler(this));
        //设置Adapter显示数据
        lvwSaleItems.setAdapter(saleItemAdapter);
    }

    @OnClick(R.id.lytClear)
    public void onClickClear() {
        LoggerUtils.getLogger().debug("总清");

        clearAllUseData();
        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                updateTotal();
            }

            @Override
            public void onError(String err) {
                showHintDialog(err);
            }
        });
    }

    @OnClick(R.id.lytUpload)
    public void onClickUpload() {
        mPresenter.reSubmit();
    }

    @OnClick(R.id.lytCheckout)
    public void onClickCheckout() {
        if (isFastClick()) {
            return;
        }

        if (!lytCheckout.isEnabled() || hasCheckOut) {
            return;
        }

        hasCheckOut = true;
        lytCheckout.setEnabled(false);

        mPresenter.checkSaleNo();
    }

    @OnClick(R.id.lytNonVip)
    public void onClickNonVip() {
        //允许登录，在返回后的处理不同
        LoggerUtils.getLogger().debug("进入销售后录入会员");
        Intent intent = new Intent(SaleActivity.this, VipLoginActivity.class);
        Bundle loginFlag = new Bundle();
        loginFlag.putString("afterLogin", "1");
        intent.putExtras(loginFlag);
        startActivityForResult(intent, ActivityConstants.REQUEST_SALE_TO_VIP_LOGIN);
    }

    @OnClick(R.id.lytClearPlu)
    public void onClickClearPlu() {
        edtPlu.setText("");
    }

    @OnClick(R.id.lytScanPlu)
    public void onClickScanPlu() {
        scan();
    }

    @OnClick({R.id.lytVip, R.id.lytVipCard})
    public void onClickVip() {
        mPresenter.reCalcVipDiscount();
    }

    @Override
    public void onScanSuccess(String barcode) {

    }

    @Override
    public void checkoutSuccess() {
        hasCheckOut = false;
        lytCheckout.setEnabled(true);

        for (final BaseSalePluModel pluModel : mSaleItems) {
            mPresenter.pluQuery(pluModel.getPluCode());
        }

        txtSaleNo.setText(mPresenter.getSale().getSaleNo());
        updateAdapter();
        updateTotal();
    }

    @Override
    public void checkoutError() {
        hasCheckOut = false;
        lytCheckout.setEnabled(true);
    }

    @Override
    public void hideShoppingCartPrompt() {

    }

    @Override
    public void showShoppingCartPrompt() {

    }

    @Override
    public void addPlu(int position, BaseSalePluModel salePluModel) {
        mSaleItems.add(salePluModel);
        saleItemAdapter.notifyDataSetChanged();
    }

    @Override
    public void removePlu(int position) {

    }

    @Override
    public void changeQuantity(int position) {

    }

    public void updateTotal() {
        if (mPresenter.getSale() != null) {
            updateTotal(mPresenter.getSale().calcCount(), mPresenter.getSale().getTotalDsc(), mPresenter.getSale().getTotalRecv());
        } else {
            updateTotal(0, "0.00", "0.00");
        }
    }

    @Override
    public void updateTotal(int count, String totalDsc, String totalRecv) {
        if (count != 0) {
            txtTotalCount.setText(String.format(Locale.CHINESE, "(%d)", count));
            txtTotalCount.setVisibility(View.VISIBLE);
        } else {
            txtTotalCount.setVisibility(View.GONE);
        }

        txtTotal.setText(totalRecv);
        if (count > 0) {
            LoggerUtils.getLogger().debug(String.format(Locale.CHINESE, "商品: %d，小计: %s", count, totalRecv));
        }

        edtPlu.setText("");

        txtSaleNo.setText(mPresenter.getSale().getSaleNo());
    }

    @Override
    public void updateAdapter() {
        if (saleItemAdapter != null) {
            saleItemAdapter.setData(mPresenter.getSale().getPlus());
            saleItemAdapter.notifyDataSetChanged();
        }
    }

    @Override
    public void updateVipInfo(Vip vip) {
        if (vip == null) {
            return;
        }

        mPresenter.getSale().setVip(vip);

        LoggerUtils.getLogger().info(String.format(Locale.CHINESE, "会员[%s]登录", vip.card().cardFaceNo()));

        lytVip.setVisibility(View.VISIBLE);
        lytVipCard.setVisibility(View.VISIBLE);
        lytVipPoints.setVisibility(View.VISIBLE);
        lytNonVip.setVisibility(View.GONE);

        txtVipCardNo.setText(vip.card().cardFaceNo());
        txtVipTypeName.setText(vip.card().cardType().name());
        String vipName = vip.name();
        if (!TextUtils.isEmpty(vipName)) {
            vipName = vipName.length() == 2 ? vipName.substring(0, 1) + "*" : vipName.length() >= 3 ? vipName.substring(0, 1) + "*" + vipName.substring(2) : vipName;
        }
        txtVipName.setText(vipName);


        DecimalFormat df = new DecimalFormat("0.##");
        if (vip.projects().size() > 0) {
            txtVipPointsUsable.setText(df.format(vip.projects().get(0).usablePoints()));
            txtVipPointsBalance.setText(df.format(vip.projects().get(0).usableBalance()));
            mPresenter.getSale().setLastUsablePoint(df.format(vip.projects().get(0).usablePoints()));
            mPresenter.getSale().setVipPoints(df.format(vip.projects().get(0).usablePoints()));
        } else if (vip.card() != null && vip.card().usablePoints() > 0) {
            txtVipPointsUsable.setText(df.format(vip.card().usablePoints()));
            txtVipPointsBalance.setText(df.format(vip.card().usableBalance()));
            mPresenter.getSale().setLastUsablePoint(df.format(vip.card().usablePoints()));
            mPresenter.getSale().setVipPoints(df.format(vip.card().usablePoints()));
        } else {
            txtVipPointsUsable.setText("0");
            txtVipPointsBalance.setText("0");
            mPresenter.getSale().setLastUsablePoint("0");
            mPresenter.getSale().setVipPoints("0");
        }
    }

    @Override
    public void callPayActivity() {
        hasCheckOut = true;
        lytCheckout.setEnabled(false);

        Bundle bundle = new Bundle();

        Intent billPay = new Intent(SaleActivity.this, PayActivity.class);
        billPay.putExtras(bundle);

        mIsPaying = true;
        startActivityForResult(billPay, ActivityConstants.REQUEST_SALE_TO_PAY);
    }

    @Override
    public void promotionCalcSuccess(View view) {

    }

    @Override
    public void callGiftActivity() {

    }

    @Override
    public void scrollListToBottom() {

    }

    @Override
    public void scrollListToPosition(int position) {
        try {
            if (position >= 0) {
                lvwSaleItems.smoothScrollToPosition(position);
            }
        } catch (Exception e) {
            CommonTools.toastLong("滚动失败:" + e.getMessage());
        }
    }

    @Override
    public void setPluDeleteEnabled(boolean decreaseEnabled) {

    }

    @Override
    public void backToWelcomeActivity() {

    }

    @Override
    public void showBagsPopupWindow() {

    }

    @Override
    public void hideBagsPopupWindow() {

    }

    /**
     * 创建悬浮球
     */
    private void createView() {
        myFV = new MyFloatView(getApplicationContext());
        myFV.setBackground(ResourcesCompat.getDrawable(getResources(), R.drawable.bg_scanner, null));
        myFV.setText(R.string.sale_scanner);
        myFV.setTextColor(getResources().getColor(R.color.button_text));
        myFV.setGravity(Gravity.CENTER);
        MyFloatView.configFloat(myFV, FLOW_VIEW_X, FLOW_VIEW_Y);
        myFV.setOnClickListener((arg) -> {
            if (!mIsUploading) {
                scan();
            }
        });
    }

    @Override
    protected void onPause() {
        //销毁悬浮窗口
        FLOW_VIEW_X = MyFloatView.wmParams.x;
        FLOW_VIEW_Y = MyFloatView.wmParams.y;
        MyFloatView.wm.removeView(myFV);
        floatViewFlag = true;
        GeneralSettings.INSTANCE.setTranType(String.valueOf(tranType.value()));
        super.onPause();
        LoggerUtils.getLogger().debug("----------onPause-----------SaleActivity----------");
    }

    @Override
    protected void onResume() {
        //设置悬浮窗
        if (floatViewFlag) {
            createView();
            floatViewFlag = false;
        }
        lytAssistant.setVisibility(GeneralSettings.INSTANCE.isCashierEnabled() ? View.VISIBLE : View.GONE);

        tranType = TranType.valueOfType(GeneralSettings.INSTANCE.getTranType());

        mPresenter.refreshUnloadPoint(lytUpload);
        hasCheckOut = false;
        lytCheckout.setEnabled(true);
        super.onResume();
        LoggerUtils.getLogger().debug("----------onResume-----------SaleActivity----------");
    }

    @Override
    public void onDestroy() {
        if (SaleActivity.couponMap != null) {
            SaleActivity.couponMap.clear();
        }
        if (SaleActivity.giftCouponMap != null) {
            SaleActivity.giftCouponMap.clear();
        }
        if (SaleActivity.remainedCouponMap != null) {
            SaleActivity.remainedCouponMap.clear();
        }
        EventBus.getDefault().unregister(this);
        LoggerUtils.getLogger().debug("----------onDestroy-----------SaleActivity----------");
        super.onDestroy();
    }

    @Override
    public void onFocusChange(View v, boolean b) {
        if (v.getId() == R.id.edtPlu) {
            lytClearPlu.setVisibility(b ? View.VISIBLE : View.GONE);
        }
    }

    @SuppressLint("NewApi")
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // 商品录入：大码商品，或称重商品（直接录入商品编码）
        if (requestCode == ActivityConstants.REQUEST_SALE_TO_SET_PLU_PRICE && resultCode == ActivityConstants.RESULT_SALE_TO_SET_PLU_PRICE) {
            addPluNoCode(data);
        } else if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            this.onScan(mScanner.getScanResult(data));
        } else if (requestCode == ActivityConstants.REQUEST_SALE_TO_VIP_LOGIN && resultCode == ActivityConstants.RESULT_SALE_TO_VIP_LOGIN) {
            updateVipInfo(data);
        } else if (requestCode == ActivityConstants.REQUEST_SALE_TO_PAY && resultCode == ActivityConstants.RESULT_SALE_TO_PAY) {
            salePaySuccess(data);
        } else if (ActivityConstants.REQUEST_SALE_TO_PAY == requestCode && resultCode == RESULT_CANCELED) {
            salePayCancel(data);
        }

        mIsPaying = false;
        updateAdapter();
        updateTotal();
        super.onActivityResult(requestCode, resultCode, data);
    }

    private void addPluNoCode(Intent data) {
        Bundle bundle = data.getExtras();
        if (bundle == null) {
            return;
        }

        BaseSalePluModel pluModel = (BaseSalePluModel) bundle.getSerializable("plu");

        mPresenter.checkPluVipDiscount(pluModel);
    }

    private void updateVipInfo(Intent data) {
        Vip vip = (Vip) data.getSerializableExtra("vip");
        if (mPresenter.getSale() != null) {
            updateVipInfo(vip);
            mPresenter.reCalcVipDiscount();
        } else {
            mPresenter.createNewSale(vip, tranType, new UniCallback() {
                @Override
                public void onSuccess(String s) {
                    updateVipInfo(vip);
                    mPresenter.reCalcVipDiscount();
                }

                @Override
                public void onError(String message) {
                    showHintDialog(message);
                }
            });
        }
    }

    private void salePaySuccess(Intent data) {
        try {
            hasCheckOut = false;
            lytCheckout.setEnabled(true);
            mIsUploading = true;

            mPresenter.saleSubmit();
        } catch (Exception ex) {
            LoggerUtils.getLogger().error("流水上传异常：" + ex.toString());

            //获取新的流水号
            SaleNoService.abandon();
            mPresenter.resetSaleModel();
            submitFail("流水上传异常：" + ex.getMessage());

            showHintDialog("流水上传失败,请点击右上角上传流水重试");
        }
    }

    private void salePayCancel(Intent data) {
        hasCheckOut = false;
        lytCheckout.setEnabled(true);

        LoggerUtils.getLogger().info("pay返回sale：RESULT_CANCELED,也可能是异常,默认cancel");
        if (mPresenter.getSale() != null) {
            boolean isVipServiceCalled = false;

            if (data != null) {
                isVipServiceCalled = data.getBooleanExtra("isVipServiceCalled", true);
            }
            if (isVipServiceCalled) {
                // 只有使用储值卡/积分成功支付后，撤销时才保存流水号，避免使用同一流水号再次支付时，会员服务报错（存在相同流水号的交易）。
                SaleNoService.save(this, mPresenter.getMainSaleModel().getShopInfo().getOrgCode(),
                        mPresenter.getSale().getPosNo(), mPresenter.getSale().getSaleNo());
            }
        }

        if (!NetUtils.isNetworkAvailable()) {
            showHintDialog("网络异常，检查流水号失败");
            return;
        }

        mPresenter.createNewSale(mPresenter.getSale().getVip(), tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                updateVipInfo(mPresenter.getSale().getVip());
                mPresenter.getSale().clearPlu();
                for (BaseSalePluModel pluModel : mSaleItems) {
                    mPresenter.getSale().addPlu(pluModel);
                }

                mPresenter.reCalcVipDiscount();

                saleItemAdapter.notifyDataSetChanged();
                updateTotal();
            }

            @Override
            public void onError(String message) {
                clearAllUseData();
            }
        });
    }

    private void clearAllUseData() {
        mPresenter.getSale().clearPlu();
        mSaleItems.clear();
        saleItemAdapter.notifyDataSetChanged();

        updateTotal(0, "0.00", "0.00");
        //todo 原则上总清重新生成了流水,不需要清空之前的积分信息
        txtSaleNo.setText("");

        //总清时，将营业员信息总清掉
        txtAssistant.setText("");

        lytVip.setVisibility(View.GONE);
        lytVipCard.setVisibility(View.GONE);
        lytVipPoints.setVisibility(View.GONE);
        lytNonVip.setVisibility(View.VISIBLE);
    }

    @Override
    public void submitSuccess() {
        mPresenter.refreshUnloadPoint(lytUpload);
        mIsUploading = false;

        clearAllUseData();
        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                txtSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String message) {
                showHintDialog(message);
            }
        });
    }

    @Override
    public void submitFail(String msg) {
        //finish();
        mPresenter.refreshUnloadPoint(lytUpload);
        mIsUploading = false;
        // 增加完成本笔交易后处理--清空数据
        clearAllUseData();
        mPresenter.createNewSale(null, tranType, new UniCallback() {
            @Override
            public void onSuccess(String s) {
                txtSaleNo.setText(mPresenter.getSale().getSaleNo());
            }

            @Override
            public void onError(String message) {
                showHintDialog(message);
            }
        });
    }

    @Override
    public void onlineFail(String msg) {
        mPresenter.refreshUnloadPoint(lytUpload);
    }

    @Override
    public void reSubmitSuccess(String msg) {
        mPresenter.refreshUnloadPoint(lytUpload);
    }

    @Override
    public void reSubmitFail(String msg) {
        mPresenter.refreshUnloadPoint(lytUpload);
    }

    @Override
    public void pluQueryNoCode(BaseSalePluModel pluModel) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("plu", pluModel);

        Intent intent = new Intent(SaleActivity.this, SaleItemPriceActivity.class);
        intent.putExtras(bundle);

        startActivityForResult(intent, ActivityConstants.REQUEST_SALE_TO_SET_PLU_PRICE);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME || keyCode == KeyEvent.KEYCODE_MENU) {
            if (mPresenter.getSale() != null && mPresenter.getSale().pluSize() > 0) {
                showHintDialog("已添加商品，请总清后返回");
                return false;
            } else {
                this.finish();
                return true;
            }
        } else {
            return super.onKeyDown(keyCode, event);
        }
    }

    private void scan() {
        mScanner.scan(new ScannerCallback() {
            @Override
            public void onSuccess(final String s) {
                SaleActivity.this.onScan(s);
            }

            @Override
            public void onError(final Throwable t) {
                showHintDialog(t.getMessage());
            }
        });
    }

    @Override
    protected void onScan(String s) {
        super.onScan(s);

        if (edtPlu.hasFocus()) {
            edtPlu.setText(s);

            //FIXME null 这里能不能控制住
            if (mIsPaying) {
                return;
            }

            mPresenter.pluQueryWithCheck(s);
        } else if (txtAssistant.hasFocus()) {
            txtAssistant.setText(s);
        }
    }


    private static class SaleItemsAdapterHandler extends Handler {
        private SaleActivity activity;

        public SaleItemsAdapterHandler(SaleActivity activity) {
            this.activity = activity;
        }

        @Override
        public void handleMessage(Message msg) {
            if (msg.what == SaleItemYsyAdapter.SALE_ITEM_QUANTITY_INCREASED ||
                    msg.what == SaleItemYsyAdapter.SALE_ITEM_QUANTITY_DECREASED ||
                    msg.what == SaleItemYsyAdapter.SALE_ITEM_QUANTITY_MODIFED) {
                this.activity.updateTotal();
            }
        }
    }
}
