/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.sale;

import android.content.Intent;
import android.os.Bundle;
import android.os.Looper;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.ThreadFactoryUtils;
import com.hisense.crm.card.CardNo;
import com.hisense.crm.vip.Vip;
import com.hisense.crm.webapi.vip.VipService;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.layout.SwitchViewWatcher;
import com.hisense.hiaposcmp.layout.WrapContentListView;
import com.hisense.hiaposcmp.presenter.query.SaleQueryPresenter;
import com.hisense.hiaposcmp.print.PrinterHelper;
import com.hisense.hiaposcmp.service.payment.AggregatePaymentChannel;
import com.hisense.hiaposcmp.service.payment.PayMethodService;
import com.hisense.hiaposcmp.service.sale.SaleRepository;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.view.IView.query.ISaleQueryView;
import com.hisense.hipos.model.BaseSaleModel;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.ReturnSaleModel;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.hipos.webapi.pay.PayService;
import com.hisense.pos.payment.IPaymentServiceProvider;
import com.hisense.pos.payment.PaymentProviderException;
import com.hisense.pos.scanner.IScanner;
import com.hisense.pos.scanner.ScannerCallback;
import com.hisense.webapi.Callback;

import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.OnClick;


/**
 * 流水查询
 *
 * @author fujiaxin    2017-03-02
 * @author xieliyan    2017-09-06 HIPOSAPP-135 规范编码，增加重打印类型判断
 * @author xieliyan    2017-09-18 HIPOSAPP-133 电子发票打印：获取url和提取码
 * @author xieliyan    2017-10-13 HIPOSAPP-172 重打印退货签购单：支持多张卡的签购单打印
 * @author xieliyan    2017-10-16 HIPOSAPP-174 两笔交易的退货重打印和消费重打印有冲突：初始化记录签购单次数的变量
 * @author xieliyan    2017-10-17 HIPOSAPP-179 进入后直接显示上一笔交易流水号
 * @author zhangsai    2017-12-21 HIPOSAPP-253 通过 PaymentService 获取支付方式
 * @author xieliyan    2018-01-02 HIPOSAPP-262 支持建行收单重打印（银联卡，微信，支付宝）
 * @author zhangsai    2018-02-24 HIPOSAPP-334 优化流水查询
 * @author xieliyan    2018-03-13 HIPOSAPP-351 修复重打印小票中时间显示异常
 * @author xieliyan    2018-03-19 HIPOSAPP-360 重打印银联签购单，去掉参数extOrderNo
 * @author guolina     2018-03-29 HIPOSAPP-364 修复网速正常情况下进入流水查询页面 一直loading
 * @author xieliyan    2018-04-03 HIPOSAPP-377 修复重复添加交易凭证号造成的重打印不退出问题
 * @author zhangsai    2018-07-02 HIPOSAPP-626 初始化时获取电子发票配置参数
 * @author zhangsai    2018-07-16 HIPOSAPP-668 调整页面结构，商品/支付方式较多时使用ScrollView显示
 * @author zhangsai    2018-07-18 HIPOSAPP-673 修复mSale未初始化导致的闪退
 * @author guolina     2018-08-10 HIPOSAPP-715 流水查询界面添加扫描核销功能
 * @author guolina     2018-08-15 HIPOSAPP-730 修复流水查询界面查询到流水后，清空流水号，点完成，总金额依然显示的问题
 * @author guolina     2018-11-22 HIPOSAPP-835 多任务同步改用CountDownLatch，解决打印慢的问题
 * @author zhangsai    2018-12-07 HIPOSAPP-888 使用IPaymentServiceProvider重打印签购单
 * @author zhangsai    2018-12-19 HIPOSAPP-698 交易商品类型改为 ISaleItem
 * @author zhangsai    2018-12-21 HIPOSAPP-699 优化流水查询逻辑
 * @author zhangsai    2018-12-27 HIPOSAPP-940 改用 SaleRepository 查询交易凭证号
 * @author zhangsai    2019-01-30 HIPOSAPP-1002 使用 IScanner 扫描器实例扫描
 * @author guolina     2019-02-01 HIPOSAPP-1000 修复重打印时因为流水随机数udp4为空导致的不打印
 * @author guolina     2019-03-06 HIPOSAPP-1041 Sale代替Trade，优化代码
 * @author zhangsai    2019-06-12 HIPOSAPP-1166 删除扫码购核销
 * @author zhangsai    2019-06-13 HIPOSAPP-1169 Sale.payments() 属性返回类型改为 ISalePayment
 * @author wangyaogang 2019-11-15 HIAPOSCMP-289 流水查询不再取绝对值
 * @author wangyaogang 2019-11-19 HIAPOSCMP-298 重打印签购单,根据支付方式添加traceNo
 * @author wangyaogang 2019-11-21 HIAPOSCMP-321 未找到可打印签购单的支付方式时进行提示
 * @author wangyaogang 2019-11-26 HIAPOSCMP-338 流水查询后若是会员重新调用会员查询接口更新相关信息(scrm)
 * @author wangyaogang 2019-11-27 HIAPOSCMP-284 海信支付打印签购单
 */
@ActivityLayoutInject(R.layout.activity_sales_query)
public class SaleQueryActivity extends BaseMvpActivity<ISaleQueryView, SaleQueryPresenter> implements ISaleQueryView {

    @BindView(R.id.editCode)
    EditText mEditCode;

    @BindView(R.id.txtEmpty)
    TextView mTxtEmpty;

    @BindView(R.id.list_sales)
    WrapContentListView mListSales;

    @BindView(R.id.txtAllTotal)
    TextView mTxtAllTotal;

    @BindView(R.id.list_sales_pay)
    WrapContentListView mListSalesPay;

    @BindView(R.id.linearContainer)
    ScrollView mLinearContainer;

    @BindView(R.id.lytClearSaleNo)
    RelativeLayout mLytClearSaleNo;

    @BindView(R.id.lytScanSaleNo)
    RelativeLayout mLytScanSaleNo;

    private final Object mMonitor = new Object();
    private IPaymentServiceProvider paymentProvider;
    private List<String> lstTraceNo = new ArrayList<>();
    private List<SalePayModel> lstSalePayment = new ArrayList<>();//存储海信支付的支付信息

    private SaleRepository mSaleRepository;
    private BaseSaleModel sale;// 查出的交易流水

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    /**
     * 数据初始化。
     */
    private void init() {
        getMainSaleModel().reset();

        mScanner = getScanner(this);

        showData(false);

        //查找最大流水号
        mPresenter.getMaxSaleNo();
        //获取发票配置
        mPresenter.getInvoiceConfig();

        paymentProvider = getPaymentServiceProvider(this);
        mSaleRepository = new SaleRepository(this);
    }

    @Override
    protected SaleQueryPresenter createPresenter() {
        return new SaleQueryPresenter();
    }

    private void scan() {
        mScanner.scan(new ScannerCallback() {
            @Override
            public void onSuccess(final String s) {
                SaleQueryActivity.this.onScan(s);
            }

            @Override
            public void onError(final Throwable t) {
                showHintDialog(t.getMessage());
            }
        });
    }

    @Override
    protected void onScan(String s) {
        super.onScan(s);
        mEditCode.setText(s);
        querySale();
    }

    /**
     * 查询流水。
     */
    private void querySale() {
        mListSales.setAdapter(null);
        mListSalesPay.setAdapter(null);
        showData(false);

        mPresenter.querySale(mEditCode.getText().toString());
    }

    /**
     * 更新显示流水数据。
     *
     * @param sale 流水
     */
    private void updateView(BaseSaleModel sale) {
        boolean isReturn = sale instanceof ReturnSaleModel;

        updateSaleItemsView(sale, isReturn);
        updatePaymentView(sale);
        mTxtAllTotal.setText(String.format(Locale.CHINESE, "%.2f", Double.parseDouble(sale.getTotalRecv())));
    }

    /**
     * 更新交易商品信息。
     *
     * @param sale     交易流水
     * @param isReturn 是否退货
     */
    private void updateSaleItemsView(final BaseSaleModel sale, boolean isReturn) {
        ArrayList<Map<String, Object>> mapPlus = new ArrayList<>();
        for (BaseSalePluModel pluModel : sale.getPlus()) {
            Map<String, Object> map = new HashMap<>();
            map.put("name", pluModel.getPluName());
            map.put("model", pluModel.getSpec());
            map.put("unit", pluModel.getUnit());
            map.put("count", Double.parseDouble(pluModel.getQuantity()));
            map.put("price", String.format(Locale.CHINESE, "%.2f", Double.valueOf(pluModel.getPrice()) * (isReturn ? -1 : 1)));
            map.put("total", String.format(Locale.CHINESE, "%.2f", Double.parseDouble(pluModel.getTotalRecv())));
            mapPlus.add(map);
        }

        String[] mapKeys = {"name", "model", "unit", "count", "price", "total"};
        int[] txtView = {R.id.txtName, R.id.txtModel, R.id.txtUnit, R.id.txtCount, R.id.txtPrice, R.id.txtTotal};
        SimpleAdapter adapter = new SimpleAdapter(SaleQueryActivity.this, mapPlus, R.layout.sales_pipeline_item,
                mapKeys, txtView);
        mListSales.setAdapter(adapter);
    }

    /**
     * 更新流水支付信息。
     *
     * @param sale 交易流水
     */
    private void updatePaymentView(final BaseSaleModel sale) {

        if (lstTraceNo.size() > 0) {
            lstTraceNo.clear();
        }
        if (lstSalePayment.size() > 0) {
            lstSalePayment.clear();
        }
        if (sale != null && sale.getPays().size() > 0) {
            ArrayList<Map<String, Object>> mapPays = new ArrayList<>();

            for (SalePayModel salePay : sale.getPays()) {
                Map<String, Object> map = new HashMap<>();
                map.put("payIcon", PayMethodService.getIconByCode(salePay.getPayCode()));
                map.put("payName", salePay.getPayName());
                map.put("value", String.format(Locale.CHINESE, "%.2f", Double.parseDouble(salePay.getTotalPaid())));
                mapPays.add(map);

                SimpleAdapter sales_pay = new SimpleAdapter(SaleQueryActivity.this, mapPays, R.layout.pipeline_pay_item,
                        new String[]{"payIcon", "payName", "value"}, new int[]{R.id.pay_icon, R.id.txtPayName, R.id.txtPayValue});
                mListSalesPay.setAdapter(sales_pay);

                //银联卡,云闪付,建行直连银行卡,建行直连聚合支付,收单行渠道的支付宝和微信 打印trace,ref  ,还有海信Pay的温州时代的支付宝
                if (salePay.getRemark() != null && (PayMethod.isUnionPay(salePay.getRemark())
                        || PayMethod.isUnionCloudPay(salePay.getRemark())
                        || PayMethod.isUccbCard(salePay.getRemark())
                        || PayMethod.isUccbScan(salePay.getRemark())
                        || (AggregatePaymentChannel.isCHANNEL() && (PayMethod.isWxPay(salePay.getRemark()) || PayMethod.isAliPay(salePay.getRemark()) || PayMethod.isMobilePay(salePay.getRemark()))))
                     //   || (AggregatePaymentChannel.isHXPAY() && CommonUtils.isTimesSquare(this) && PayMethod.isAliPay(salePay.getRemark()))
                ) {
//                    String traceNo = getTraceNo(sale.getSaleNo(), salePay.getSerialNo());
                    String traceNo = salePay.getOutTradeNo();
                    if (StringUtils.isNotBlank(traceNo)) {
                        lstTraceNo.add(traceNo);
                    }
                }
                //海信支付的微信, 海信支付的
                if (salePay.getRemark() != null && GeneralSettings.INSTANCE.printHXPayReceipt()) {
                    if ((AggregatePaymentChannel.isHXPAY() && PayMethod.isWxPay(salePay.getRemark()))
                           // || (AggregatePaymentChannel.isHXPAY() && PayMethod.isAliPay(salePay.getRemark()) && !CommonUtils.isTimesSquare(this))
                    ) {
                        lstSalePayment.add(salePay);
                    }
                }

            }
        }

    }

    /**
     * 更新布局。
     *
     * @param show true：布局需要显示 false：不需要显示
     */
    private void showData(final boolean show) {
        if (show) {
            mLinearContainer.setVisibility(View.VISIBLE);
            mTxtEmpty.setVisibility(View.GONE);
        } else {
            mLinearContainer.setVisibility(View.GONE);
            mTxtEmpty.setVisibility(View.VISIBLE);
        }
    }

    /**
     * 获取交易凭证号。
     *
     * @param saleNo   流水号
     * @param serialNo 支付顺序号
     */
    private String getTraceNo(String saleNo, int serialNo) {
        return mSaleRepository.getTraceNoBySerialNo(saleNo, serialNo);
    }

    /**
     * 接收Activity结果值。
     *
     * @param requestCode 请求编号
     * @param resultCode  返回编号
     * @param data        返回数据
     */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        if (paymentProvider.requestCode() == requestCode) {
            try {
                paymentProvider.handleResult(data);

                synchronized (mMonitor) {
                    mMonitor.notify();
                }
            } catch (PaymentProviderException ex) {
                CommonTools.toastShort(SaleQueryActivity.this, "重打签购单失败，" + ex.getMessage());
            } catch (Exception ex) {
                LoggerUtils.getLogger().debug("重打签购单异常：" + ex.getMessage() + "接口返回:" + data);
                CommonTools.toastShort(SaleQueryActivity.this, "重打签购单异常：" + ex.getMessage());
            }

        } else if (IScanner.SCAN_REQUEST == requestCode && RESULT_OK == resultCode) {
            this.onScan(mScanner.getScanResult(data));
        }
    }

    @OnClick({R.id.linearBack, R.id.lytClearSaleNo, R.id.lytScanSaleNo, R.id.btnRePrint, R.id.btnPrint})
    public void onViewClicked(View view) {
        if (isFastClick()) {
            LoggerUtils.getLogger().debug("流水查询快速点击");
            return;
        }
        switch (view.getId()) {
            case R.id.linearBack:
                this.finish();
                break;
            case R.id.lytClearSaleNo:
                mEditCode.setText("");
                break;
            case R.id.lytScanSaleNo:
                scan();
                break;
            case R.id.btnRePrint:
                //重打签购单
                //同时为空,则进行提示
                if (lstTraceNo.isEmpty() && lstSalePayment.isEmpty()) {
                    LoggerUtils.getLogger().debug("未找到可打印签购单的支付方式");
                    CommonTools.toastShort("未找到可打印签购单的支付方式");
                    return;
                }
                //先打印海信支付签购单,再银联支付签购单? 且需要锁,明确知道前者已打印完
                reprintHXReceipt();
                break;
            case R.id.btnPrint:
                //重打小票
                mPresenter.reprintTrade(sale);
                break;
            default:
                break;
        }
    }

    private void printReceipt(final int pos) {
        try {
            final SalePayModel salePayment = lstSalePayment.get(pos);
            LoggerUtils.getLogger().debug("海信支付重打印签购单:" + salePayment.getPayCode());
            showLoadingDialog();
            new Thread(new Runnable() {
                @Override
                public void run() {
                    PrinterHelper.getInstance().printWithStringList(PayService.getPrintContent(sale, null, salePayment), new UniCallback() {
                        @Override
                        public void onSuccess(String msg) {
                            dismissAndCallback(pos);
                        }

                        @Override
                        public void onError(String err) {
                            dismissAndCallback(pos);
                        }
                    });
                }
            }).start();

        } catch (Exception e) {
            LoggerUtils.getLogger().debug("海信支付打印重打印签购单异常:" + e.toString());
            dismissAndCallback(pos);
        }
    }

    private void dismissAndCallback(final int pos) {
        LoggerUtils.getLogger().debug("海信支付打印重打印签购单dismissAndCallback");
        hideLoadingDialog();
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (pos == lstSalePayment.size() - 1) {
                    LoggerUtils.getLogger().debug("海信支付打印完,打印银联签购单");
                    reprintReceipt();
                } else {
                    printReceipt(pos + 1);
                }
            }
        });
    }

    /**
     * 打印海信支付签购单
     */
    private void reprintHXReceipt() {
        if (lstSalePayment.isEmpty()) {
            LoggerUtils.getLogger().debug("无海信支付,打印银联签购单");
            reprintReceipt();
            return;
        }
        printReceipt(0);
    }

    /**
     * 重打印银联卡签购单。
     */
    private void reprintReceipt() {
        if (ListUtils.isEmpty(lstTraceNo)) {
            LoggerUtils.getLogger().debug("未找到可打印签购单的支付方式");
            showHintDialog("未找到可打印签购单的支付方式");
            return;
        }
        ThreadFactoryUtils.getExecutorService("print-%d").execute(() -> {
            Looper.prepare();

            try {
                for (String traceNo : lstTraceNo) {
                    paymentProvider.reprintReceipt(traceNo, null);
                    LoggerUtils.getLogger().debug("交易凭证号" + traceNo);

                    synchronized (mMonitor) {
                        try {
                            mMonitor.wait();
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (Exception ex) {
                showHintDialog(ex.getMessage());
                LoggerUtils.getLogger().error(ex.getMessage(), ex);
            }

            Looper.loop();
        });
    }

    @Override
    public void getMaxSaleNoSuccess(String maxSaleNo) {
        mEditCode.setText(maxSaleNo);
        mEditCode.setSelection(mEditCode.getText().length());
        mEditCode.setImeOptions(EditorInfo.IME_ACTION_DONE);
        mEditCode.addTextChangedListener(new SwitchViewWatcher(mLytClearSaleNo, mLytScanSaleNo));
        mEditCode.requestFocus();
        mEditCode.setOnEditorActionListener((textView, actionId, keyEvent) -> {
            if (actionId == EditorInfo.IME_ACTION_DONE) {
                querySale();
            }
            return false;
        });
    }

    @Override
    public void querySaleSuccess(BaseSaleModel sale) {

        if (sale.isVip()) {
            showLoadingDialog();
            CardNo cardNo = CardNo.cardNo(sale.getVip().getCard().cardFaceNo(), sale.getVip().getCard().cardNoType());
            VipService.vipQuery(cardNo, null, sale.getSaleNo(), new Callback<Vip>() {
                @Override
                public void onSuccess(Vip vip) {
                    hideLoadingDialog();
                    sale.setVip(vip);
                    updateUi(sale);
                }

                @Override
                public void onError(Throwable throwable) {
                    LoggerUtils.getLogger().error("会员查询失败：" + throwable.getMessage());
                    hideLoadingDialog();
                    updateUi(sale);
                }
            });
        } else {
            updateUi(sale);
        }
    }

    /**
     * 刷新页面显示
     *
     * @param sale
     */
    private void updateUi(BaseSaleModel sale) {
        SaleQueryActivity.this.sale = sale;
        showData(true);
        updateView(sale);
    }

    @Override
    public void querySaleFail(String msg) {
        this.sale = null;
        if (msg != null) {
            CommonTools.toastShort(this, msg);
        }
        showData(false);
    }

}
