/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.vip;

import android.os.Bundle;
import android.widget.TextView;

import com.hisense.crm.card.VipCard;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseActivity;
import com.hisense.hiaposcmp.anno.ActivityLayoutInject;

import java.util.Locale;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * 积分查询。
 *
 * @author xieliyan 2017-04-07
 * @author zhangsai 2018-02-02 HIPOSAPP-315
 */
@ActivityLayoutInject(R.layout.activity_card_balance_query)
public class VipPointsBalanceActivity extends BaseActivity {

    @BindView(R.id.txtCardBalance)
    TextView txtCardBalance;

    @BindView(R.id.txtCardFaceNo)
    TextView txtCardFaceNo;

    @BindView(R.id.txtCardType)
    TextView txtCardType;

    @BindView(R.id.txtCardExpiredDate)
    TextView txtCardExpiredDate;

    @BindView(R.id.txtTitle)
    TextView txtTitle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        init();
    }

    private void init() {
        Bundle bundle = this.getIntent().getExtras();
        VipCard card = (VipCard) bundle.getSerializable("card");

        txtTitle.setText("积分余额查询");

        txtCardFaceNo.setText(card.cardFaceNo());
        txtCardType.setText(String.format(Locale.CHINESE, "%s-%s", card.cardType().code(), card.cardType().name()));
        txtCardBalance.setText(String.format(Locale.CHINESE, "%.2f", card.usableBalance()));
        txtCardExpiredDate.setText(card.expireDate());
    }

    @OnClick(R.id.btnGoBack)
    public void onViewClicked() {
        onBackPressed();
    }
}
