/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.activity.ysy.vip;


import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.card.CardNo;
import com.hisense.crm.card.CardNoType;
import com.hisense.crm.card.VipCard;
import com.hisense.crm.vip.Vip;
import com.hisense.crm.vip.VipSex;
import com.hisense.crm.webapi.sms.SmsService;
import com.hisense.crm.webapi.vip.VipService;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.BaseMvpActivity;
import com.hisense.hiaposcmp.activity.ysy.sale.SaleActivity;
import com.hisense.hiaposcmp.presenter.EmptyPresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.TimeCount;
import com.hisense.hiaposcmp.view.IView.IEmptyView;
import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Callback;
import com.hisense.webapi.WebApiException;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import androidx.annotation.IdRes;
import cn.qqtheme.framework.picker.DatePicker;

/**
 * 会员注册
 *
 * @author guolina     2018-04-02
 * @author xieliyan    2018-04-20 HIPOSAPP-411 未注册手机号登录时直接将手机号显示在界面上
 * @author wangyaogang 2019-05-14 HIPOSAPP-1095 易收银各类Toast提示信息改为弹窗提示,方便记录
 * @author wangyaogang 2019-07-02 HIPOSAPP-1180 校验参数封装为CardSecurity
 * @author wangyaogang 2019-11-12 HIAPOSCMP-258 会员注册迁移
 */
public class VipRegisterActivity extends BaseMvpActivity<IEmptyView, EmptyPresenter> implements IEmptyView {
    private static final String TAG = VipRegisterActivity.class.getSimpleName();
    public final static int VIP_LOGIN_RESULT = 3;
    private EditText edtTelNo;
    private TextView txtGetCheckCode;
    private EditText edtCheckCode;
    private RadioGroup rg;
    private RadioButton rbtnFemale;
    private RadioButton rbtnMale;
    private EditText edtBirthday;
    private EditText edtName;
    private String initBirthday = "1980-01-01"; // 初始化生日
    private TimeCount mTimeCount;
    private LinearLayout lytSkip;         //跳过按钮
    private LinearLayout lytBack;         //返回按钮
    private Button btnReg;
    private VipSex sex = VipSex.Female;
    private Boolean isReSend;
    private String mTranType = "";           // 是否预销售
    private boolean mIsFromSale = false;    // 是否从销售界面进入
    private String retCheckCode = ""; //系统返回的验证码
    private String mBufferPhoneNo = "";//与验证码对应的手机号
    private String phoneNo = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vip_register);
        Intent intent = this.getIntent();
        if (intent != null) {
            mTranType = intent.getStringExtra("tranType");
            mIsFromSale = intent.getBooleanExtra("isFromSale", false);
            if (intent.getExtras() != null && intent.getExtras().containsKey("phoneNo")) {
                phoneNo = intent.getStringExtra("phoneNo");
            }
        }
        LoggerUtils.getLogger().debug("mIsFromSale: " + mIsFromSale);
        isReSend = false;
        lytBack = (LinearLayout) findViewById(R.id.btnGoBack);
        lytBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBackPressed();
            }
        });

        lytSkip = (LinearLayout) findViewById(R.id.lnRegister);
        lytSkip.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish(null);
            }
        });
        edtTelNo = (EditText) findViewById(R.id.et_telNo);
        edtTelNo.setText(phoneNo);
        edtTelNo.setSelection(edtTelNo.getText().toString().length());
        edtTelNo.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                isReSend = false;
            }

            @Override
            public void afterTextChanged(Editable s) {
                isReSend = false;
            }
        });
        txtGetCheckCode = (TextView) findViewById(R.id.tvGetCode);
        txtGetCheckCode.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                sendCheckCode();
            }
        });
        edtCheckCode = (EditText) findViewById(R.id.et_veriCode);
        edtName = (EditText) findViewById(R.id.et_name);
        edtBirthday = (EditText) findViewById(R.id.inputDate);
        edtBirthday.setText(initBirthday);
        edtBirthday.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onStartTimePicker();
            }
        });

        rg = (RadioGroup) findViewById(R.id.rg);
        rg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, @IdRes int checkedId) {

                if (checkedId == R.id.male) {
                    sex = VipSex.Male;
                } else {
                    sex = VipSex.Female;
                }
            }
        });
        rbtnFemale = (RadioButton) findViewById(R.id.female);
        rbtnMale = (RadioButton) findViewById(R.id.male);
        initView();
        btnReg = (Button) findViewById(R.id.btnReg);
        btnReg.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (CardNo.MobileOrDefault(edtTelNo.getText().toString()).getType() != CardNoType.Mobile) {
                    CommonTools.toastShort("请输入11位手机号码");
                    return;
                } else if (0 == edtCheckCode.getText().toString().length()) {
                    CommonTools.toastShort("请输入验证码");
                    return;
                }
                try {
                    if (compareCheckCode()) {
                        register();
                    } else {
                        CommonTools.toastShort("验证码错误");
                    }

                } catch (WebApiException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    @Override
    protected EmptyPresenter createPresenter() {
        return new EmptyPresenter();
    }

    /**
     * 自定义性别选择器图片大小位置
     */
    private void initView() {
        Drawable drawable_female = getResources().getDrawable(R.drawable.selector_sex);
        drawable_female.setBounds(0, 0, 40, 40);//大小
        rbtnFemale.setCompoundDrawables(drawable_female, null, null, null);//位置
        Drawable drawable_male = getResources().getDrawable(R.drawable.selector_sex);
        drawable_male.setBounds(0, 0, 40, 40);
        rbtnMale.setCompoundDrawables(drawable_male, null, null, null);
    }

    /**
     * 查询会员。
     *
     * @param cardNo 会员卡号
     */
    private void queryVip(CardNo cardNo) {
        showLoadingDialog();
        VipService.vipQuery(cardNo, null, "", new Callback<Vip>() {
            @Override
            public void onSuccess(Vip vip) {
                hideLoadingDialog();

                if (vip.card().status().isRegistered()) {
                    CommonTools.toastLong(VipRegisterActivity.this, "会员卡已注册，但非正常状态");
                    return;
                } else if (vip.card().status().isSold()) {
                    CommonTools.toastLong(VipRegisterActivity.this, "会员卡已销售，但未开通");
                    return;
                } else if (!vip.card().status().isNormal()) {
                    CommonTools.toastLong(VipRegisterActivity.this, String.format("会员卡%s", vip.card().status().name()));
                    return;
                }

                finish(vip);
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
                LoggerUtils.getLogger().debug("错误信息：" + throwable.getMessage());
                String errMsg = throwable.getMessage();
                // FIX: 如果卡是注销状态，后台返回“注销”，根据返回结果长度判断卡是否已被注销
                if (errMsg != null && errMsg.length() == 2) {
                    errMsg = String.format(Locale.CHINESE, "此卡已%s", errMsg);
                }
                CommonTools.toastShort(errMsg);
            }
        });
    }

    /**
     * 完成会员登录。
     *
     * @param vip 查询到的会员信息
     */
    private void finish(Vip vip) {
        Intent intent;
        if (mIsFromSale) {
            intent = new Intent();
        } else {
            intent = new Intent(VipRegisterActivity.this, SaleActivity.class);
        }

        // 如果使用会员登录，则传入会员信息。非会员登录，无需传入此值。
        if (vip != null) {
            intent.putExtra("vip", vip);
        }

        if (mIsFromSale) {
            VipRegisterActivity.this.setResult(VIP_LOGIN_RESULT, intent);
        } else {
            intent.putExtra("tranType", mTranType);
            startActivity(intent);
        }
        finish();
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        Intent intent = new Intent(VipRegisterActivity.this, VipLoginActivity.class);
        intent.putExtra("tranType", mTranType);
        intent.putExtra("isFromSale", mIsFromSale);
        startActivity(intent);
        finish();
    }

    /**
     * 发送验证码
     */
    private void sendCheckCode() {
        showLoadingDialog();
        String phone = edtTelNo.getText().toString().trim();
        LoggerUtils.getLogger().debug("sendCheckCode: " + CardNo.MobileOrDefault(phone).getType() + "---- " + CardNoType.Mobile);
        if (CardNo.MobileOrDefault(phone).getType() != CardNoType.Mobile) {
            CommonTools.toastShort(this, "请输入11位手机号码");
            hideLoadingDialog();
            return;
        }
        SmsService.send(phone, isReSend, new Callback<String>() {
            @Override
            public void onSuccess(String s) {
                hideLoadingDialog();
                LoggerUtils.getLogger().debug("onSuccess: 验证码 s = " + s);
                mTimeCount = new TimeCount(60000, 1000, txtGetCheckCode);
                mTimeCount.start();
                isReSend = true;
                if (0 != s.trim().length()) {
                    retCheckCode = s;
                }
                mBufferPhoneNo = edtTelNo.getText().toString();
            }

            @Override
            public void onError(Throwable throwable) {
                CommonTools.toastShort("发送失败:" + throwable.getMessage());
                hideLoadingDialog();
            }
        });

    }

    /**
     * 对比验证码
     */
    private boolean compareCheckCode() {
        LoggerUtils.getLogger().debug("compareCheckCode: " + retCheckCode + "  edtCheckCode: " + edtCheckCode.getText().toString());
        if (retCheckCode != null && retCheckCode.equals(edtCheckCode.getText().toString())) {
            return true;

        } else {
            return false;
        }

    }

    /**
     * 会员注册
     */
    private void register() throws WebApiException {

        final String mobilNo = edtTelNo.getText().toString();
        if (!mBufferPhoneNo.equals(mobilNo)) {
            CommonTools.toastShort("手机号已更改，请重新获取验证码");
            return;
        }
        showLoadingDialog();
        Date curDate = new Date(System.currentTimeMillis());
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd", Locale.CHINESE);
        String currentDate = dateFormat.format(curDate);

        String billNo = currentDate + Context.posNo() + retCheckCode;
        String mName = edtName.getText().toString();
        if (mName.equals("")) {
            if (sex.toString().equals("Female")) {
                mName = "X女士";
            } else {
                mName = "Y先生";
            }
        }
        LoggerUtils.getLogger().debug("register: " + mName + "   " + mobilNo + "   " + sex.toString() + "  " + edtBirthday.getText().toString() + "  " + billNo);

        Vip vip = new Vip.Builder(mName)
                .mobile(edtTelNo.getText().toString())
                .sex(sex)
                .birthday(edtBirthday.getText().toString())
                .build();


        VipService.register(billNo, vip, null, new Callback<VipCard>() {
            @Override
            public void onSuccess(VipCard vipCard) {
                if (vipCard == null) {

                    queryVip(CardNo.Mobile(mobilNo));
                } else {
                    CommonTools.toastShort("注册成功");
                    String cardFaceNo = vipCard.cardFaceNo().trim();
                    LoggerUtils.getLogger().debug("cardFaceNo: " + cardFaceNo);
                    queryVip(CardNo.FaceNo(cardFaceNo));
                }

                hideLoadingDialog();
            }

            @Override
            public void onError(Throwable throwable) {
                CommonTools.toastShort("注册失败" + throwable.getMessage());
                hideLoadingDialog();
            }
        });


    }

    /**
     * 选择时间
     */

    public void onStartTimePicker() {
        String str = edtBirthday.getText().toString();//formatter.format(curDate);
        int year = Integer.valueOf(str.substring(0, 4));
        int month = Integer.valueOf(str.substring(5, 7));
        int day = Integer.valueOf(str.substring(8, 10));
        final DatePicker picker = new DatePicker(this);
        picker.setTopPadding(2);
        picker.setGravity(10);
        picker.setRangeStart(1900, 1, 1);  //设置最小时间
        picker.setRangeEnd(2050, 1, 11); //设置最大时间
        picker.setSelectedItem(year, month, day);  //等于 设置 默认时间
        picker.setOnDatePickListener(new DatePicker.OnYearMonthDayPickListener() {
            @Override
            public void onDatePicked(String year, String month, String day) {
                String time = year + "-" + month + "-" + day;
                LoggerUtils.getLogger().debug(time);
                //这里是最后的选择结果
            }
        });
        picker.setOnWheelListener(new DatePicker.OnWheelListener() {
            @Override
            public void onYearWheeled(int index, String year) {
                picker.setTitleText(year + "-" + picker.getSelectedMonth() + "-" + picker.getSelectedDay());
            }

            @Override
            public void onMonthWheeled(int index, String month) {
                picker.setTitleText(picker.getSelectedYear() + "-" + month + "-" + picker.getSelectedDay());
            }

            @Override
            public void onDayWheeled(int index, String day) {
                picker.setTitleText(picker.getSelectedYear() + "-" + picker.getSelectedMonth() + "-" + day);
            }
        });
        View vHeader = View.inflate(this, R.layout.picker_header, null);
        picker.setHeaderView(vHeader);
        View vFooter = View.inflate(this, R.layout.picker_footer, null);
        picker.setFooterView(vFooter);
        Button mCancel = (Button) vFooter.findViewById(R.id.btCancel);
        Button mConfirm = (Button) vFooter.findViewById(R.id.btConfirm);
        mCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                picker.dismiss();
            }
        });
        mConfirm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                edtBirthday.setText(picker.getSelectedYear() + "-" + picker.getSelectedMonth() + "-" + picker.getSelectedDay());
                picker.dismiss();
            }
        });
        picker.setTopLineColor(getResources().getColor(R.color.pickerline));
        picker.setLineColor(getResources().getColor(R.color.pickerline));
        picker.setTextColor(getResources().getColor(R.color.picker_text));
        picker.setLabel(null, null, null);
        picker.show();
    }
}
