package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.bean.BagBean;
import com.hisense.hiaposcmp.bean.BaseEventBean;
import com.hisense.hiaposcmp.constant.EventActions;

import org.greenrobot.eventbus.EventBus;

import java.util.List;

/**
 * 购物袋弹出窗口adapter
 *
 * @author zhuguangsheng
 * Created by zhuguangsheng on 2018/7/2.
 */

public class BagPopupAdapter extends BaseAdapter {
    private LayoutInflater mInflater = null;
    private List<BagBean> lists;
    public Context mContext;
    private PopupWindow mPopupWindow;

    public BagPopupAdapter(Context context, List<BagBean> lists, PopupWindow popupWindow) {
        mInflater = LayoutInflater.from(context);
        this.mContext = context;
        this.lists = lists;
        this.mPopupWindow = popupWindow;
    }

    @Override
    public int getCount() {
        return lists.size();
    }

    @Override
    public BagBean getItem(int position) {
        return lists.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder viewHolder = null;
        if (convertView == null) {
            convertView = mInflater.inflate(R.layout.item_bag_popup, null);

            viewHolder = new ViewHolder();
            viewHolder.itemBagRootLayout = (LinearLayout) convertView.findViewById(R.id.item_bag_root_layout);
            viewHolder.tvPluName = (TextView) convertView.findViewById(R.id.tv_plu_name);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }

        //设置相应的值
        String pluName = lists.get(position).getPluName();
        if (!TextUtils.isEmpty(pluName)) {
            viewHolder.tvPluName.setText(pluName.trim());
        }

        viewHolder.itemBagRootLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String barcode = getItem(position).getBarCode();
                EventBus.getDefault().post(new BaseEventBean(EventActions.SCAN_GOT_BARCODE, barcode));
                mPopupWindow.dismiss();
            }
        });
        return convertView;
    }

    class ViewHolder {
        public LinearLayout itemBagRootLayout;
        public TextView tvPluName;
    }
}