package com.hisense.hiaposcmp.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.R;
import com.hisense.hipos.pay.PayUi;

import java.util.ArrayList;
import java.util.List;


/**
 * 其他支付方式适配器
 *
 * @author xieliyan 2018-12-06
 */
public class PaymethodCustomOtherAdapter extends BaseAdapter {
    /**
     * 其他支付方式列表
     */
    private List<PayUi> payUis = new ArrayList<>();


    public PaymethodCustomOtherAdapter(List<PayUi> payUis) {
        this.payUis = payUis;
    }

    @Override
    public int getCount() {
        return payUis.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        Holder holder;
        if (convertView == null) {
            convertView = LayoutInflater.from(App.getContext()).inflate(R.layout.activity_paymethod_other_gridview, null);
            holder = new Holder();
            holder.item_img = convertView.findViewById(R.id.item_image);
            holder.item_tex = convertView.findViewById(R.id.item_text);
            convertView.setTag(holder);
        } else {
            holder = (Holder) convertView.getTag();
        }


        holder.item_tex.setText(payUis.get(position).getPayName());
        holder.item_img.setImageResource(payUis.get(position).getPayDrawable());


        return convertView;

    }


    private class Holder {
        ImageView item_img;
        TextView item_tex;

        public ImageView getItem_img() {
            return item_img;
        }

        public void setItem_img(ImageView item_img) {
            this.item_img = item_img;
        }

        public TextView getItem_tex() {
            return item_tex;
        }

        public void setItem_tex(TextView item_tex) {
            this.item_tex = item_tex;
        }

    }
}
