package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.hiaposcmp.R;
import com.hisense.hipos.model.SalePluDscModel;

import java.util.ArrayList;
import java.util.List;

/**
 * 销售商品列表adapter
 *
 * @author dukunbiao(null)  2019-12-20  新建
 */
public class PluDscItemStdAdapter extends RecyclerView.Adapter<PluDscItemStdAdapter.ViewHolder> {

    private Context mContext;
    private List<SalePluDscModel> pluDscModels = new ArrayList<>();
    private RecyclerView mRecyclerView;

    public PluDscItemStdAdapter(RecyclerView recyclerView) {
        this.mContext = recyclerView.getContext();
        this.mRecyclerView = recyclerView;
    }

    public void setData(List<SalePluDscModel> pluDscModels) {
        if (pluDscModels != null) {
            this.pluDscModels.clear();
            this.pluDscModels.addAll(pluDscModels);
            notifyDataSetChanged();
        }
    }

    public void addPluDsc(SalePluDscModel pluDscModel) {
        try {
            this.pluDscModels.add(pluDscModel);
            notifyDataSetChanged();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void addPluDscs(List<SalePluDscModel> pluDscModels) {
        try {
            this.pluDscModels.addAll(pluDscModels);
            notifyDataSetChanged();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void clearPluDsc() {
        try {
            this.pluDscModels.clear();
            notifyDataSetChanged();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public int getItemCount() {
        return this.pluDscModels.size();
    }

    @Override
    @NonNull
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(mContext).inflate(R.layout.item_list_sale_std_plu_dsc, parent, false);
        return new PluDscItemStdAdapter.ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        SalePluDscModel pluDscModel;
        try {
            pluDscModel = this.pluDscModels.get(position);
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }

        holder.tvSaleStdPluDscName.setText(pluDscModel.getDscProName());
        holder.itemView.setTag(position);
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        private TextView tvSaleStdPluDscName;

        public ViewHolder(View itemView) {
            super(itemView);
            tvSaleStdPluDscName = itemView.findViewById(R.id.tvSaleStdPluDscName);
        }
    }
}
