package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.common.util.ListUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hipos.model.SalePayModel;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * {功能描述}
 *
 * @author wangyaogang 2020-01-10 HIAPOSCMP-474 查询功能
 * @author wangyaogang 2020-02-20 HIAPOSCMP-543 控件显示隐藏问题
 */
public class QueryStdPayedMethodAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private LayoutInflater mLayoutInflater;
    private List<SalePayModel> payments;

    public QueryStdPayedMethodAdapter(Context context, List<SalePayModel> payments) {
        mLayoutInflater = LayoutInflater.from(context);
        this.payments = payments;
    }

    public void setData(List<SalePayModel> payModels) {
        if (!ListUtils.isEmpty(payModels)) {
            payments.clear();
            payments.addAll(payModels);
            notifyDataSetChanged();
        }
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        return new ContentViewHolder(mLayoutInflater.inflate(R.layout.item_sale_query_paylist, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        if (holder instanceof ContentViewHolder) {
            SalePayModel payModel = payments.get(position);
            if (StringUtils.isEmpty(payModel.getBuyerLogonId())) {
                ((ContentViewHolder) holder).mTvPayNo.setVisibility(View.GONE);
            } else {
                ((ContentViewHolder) holder).mTvPayNo.setVisibility(View.VISIBLE);
            }
            ((ContentViewHolder) holder).mTvPayNo.setText(payModel.getBuyerLogonId());
            ((ContentViewHolder) holder).mTvPayName.setText(payModel.getPayName());
            ((ContentViewHolder) holder).mTvPayTotal.setText(payModel.getTotalPaid());

        }
    }

    @Override
    public int getItemCount() {
        return payments.size();
    }

    //内容 ViewHolder
    public static class ContentViewHolder extends RecyclerView.ViewHolder {
        @BindView(R.id.tv_pay_name)
        TextView mTvPayName;
        @BindView(R.id.tv_pay_no)
        TextView mTvPayNo;
        @BindView(R.id.tv_pay_total)
        TextView mTvPayTotal;

        public ContentViewHolder(View itemView) {
            super(itemView);
            ButterKnife.bind(this, itemView);
        }
    }
}
