package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.graphics.Paint;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.ListUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hipos.model.BaseSalePluModel;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * {功能描述}
 *
 * @author wangyaogang 2020-01-10 HIAPOSCMP-474 查询功能
 */
public class QueryStdPluAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private LayoutInflater mLayoutInflater;
    private List<BaseSalePluModel> mPluList;

    public QueryStdPluAdapter(Context context, List<BaseSalePluModel> mPluList) {
        mLayoutInflater = LayoutInflater.from(context);
        this.mPluList = mPluList;
    }

    public void setData(List<BaseSalePluModel> payModels) {
        if (!ListUtils.isEmpty(payModels)) {
            mPluList.clear();
            mPluList.addAll(payModels);
            notifyDataSetChanged();
        }
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        return new ContentViewHolder(mLayoutInflater.inflate(R.layout.item_sale_query_plulist, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        if (holder instanceof ContentViewHolder) {
            BaseSalePluModel pluModel = mPluList.get(position);

            ((ContentViewHolder) holder).mTvPluName.setText(pluModel.getPluName());
            ((ContentViewHolder) holder).mTvPluSpec.setText(pluModel.getSpec());
            ((ContentViewHolder) holder).mTvPluUnit.setText(pluModel.getUnit());
            ((ContentViewHolder) holder).mTvPluCount.setText(pluModel.getQuantity());
            ((ContentViewHolder) holder).mTvSsTotal.setText(pluModel.getTotalRecv());
            if (BigDecimalUtils.isEquals(pluModel.getTotal(), pluModel.getTotalRecv())) {
                ((ContentViewHolder) holder).mTvYsTotal.setVisibility(View.GONE);
            } else {
                ((ContentViewHolder) holder).mTvYsTotal.setVisibility(View.VISIBLE);
                ((ContentViewHolder) holder).mTvYsTotal.setText(pluModel.getTotal());
                ((ContentViewHolder) holder).mTvYsTotal.getPaint().setFlags(Paint.STRIKE_THRU_TEXT_FLAG | Paint.ANTI_ALIAS_FLAG);
            }
        }
    }

    @Override
    public int getItemCount() {
        return mPluList.size();
    }

    //内容 ViewHolder
    public static class ContentViewHolder extends RecyclerView.ViewHolder {
        @BindView(R.id.tv_plu_name)
        TextView mTvPluName;
        @BindView(R.id.tv_plu_spec)
        TextView mTvPluSpec;
        @BindView(R.id.tv_plu_unit)
        TextView mTvPluUnit;
        @BindView(R.id.tv_plu_count)
        TextView mTvPluCount;
        @BindView(R.id.tv_ss_total)
        TextView mTvSsTotal;
        @BindView(R.id.tv_ys_total)
        TextView mTvYsTotal;

        public ContentViewHolder(View itemView) {
            super(itemView);
            ButterKnife.bind(this, itemView);
        }
    }

}
