package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.hisense.common.util.ListUtils;
import com.hisense.hiaposcmp.R;
import com.hisense.hiaposcmp.activity.ysy.refund.viewModel.RefundViewModel;

import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * {功能描述}
 *
 * @author wangyaogang 2019-12-27 HIAPOSCMP-455 标准版支付功能开发
 */
public class RefundMethodStdAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {


    private LayoutInflater mLayoutInflater;
    private ArrayList<RefundViewModel> payments;



    public RefundMethodStdAdapter(Context context, ArrayList<RefundViewModel> payments) {
        mLayoutInflater = LayoutInflater.from(context);
        this.payments = payments;
    }



    public void setData(List<RefundViewModel> payModels) {
        if (!ListUtils.isEmpty(payModels)) {
            payments.clear();
            payments.addAll(payModels);
            notifyDataSetChanged();
        }
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        return new ContentViewHolder(mLayoutInflater.inflate(R.layout.item_std_refund_method, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        if (holder instanceof ContentViewHolder) {
            RefundViewModel payModel = payments.get(position);

            ((ContentViewHolder) holder).tvPayedNo.setText(payModel.payNo());
            ((ContentViewHolder) holder).tvPayedName.setText(payModel.payName());
            ((ContentViewHolder) holder).tvPayedAmount.setText(payModel.totalPaid());
            ((ContentViewHolder) holder).tvRefund.setText(String.valueOf(payModel.totalRefund()));
            if (StringUtils.isWhitespace(payModel.payNo())) {
                ((ContentViewHolder) holder).tvPayedNo.setVisibility(View.GONE);
            } else {
                ((ContentViewHolder) holder).tvPayedNo.setVisibility(View.VISIBLE);
               ((ContentViewHolder) holder).tvPayedNo.setText(payModel.payNo());
            }
        }
    }

    @Override
    public int getItemCount() {
        return payments.size();
    }

    //内容 ViewHolder
    public static class ContentViewHolder extends RecyclerView.ViewHolder {
        private TextView tvPayedNo, tvPayedName, tvPayedAmount,tvRefund;

        public ContentViewHolder(View itemView) {
            super(itemView);
            tvPayedNo = itemView.findViewById(R.id.txtPayNo);
            tvPayedName = itemView.findViewById(R.id.txtPayName);
            tvPayedAmount = itemView.findViewById(R.id.txtPaid);
            tvRefund=itemView.findViewById(R.id.txtRefund);
        }
    }

    public interface OnItemClickListener {
        void onItemClick(View view, int position);
    }
}
