package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import com.hisense.hiaposcmp.R;
import com.hisense.hipos.model.SalePluDscModel;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by xly on 2019-03-07.
 */
public class SaleProAdapter extends RecyclerView.Adapter<SaleProAdapter.ViewHolder> {

    private Context mContext;
    private List<SalePluDscModel> pluDscs = new ArrayList<>();
    private RecyclerView mRecyclerView;

    public SaleProAdapter(RecyclerView recyclerView) {
        this.mContext = recyclerView.getContext();
        this.mRecyclerView = recyclerView;
    }

    public void setData(List<SalePluDscModel> pluDscList) {
        if (pluDscList != null) {
            pluDscs.clear();
            pluDscs = pluDscList;
            notifyDataSetChanged();
        }
    }

    @Override
    public void onBindViewHolder(ViewHolder viewHolder, int i) {

    }

    @Override
    public int getItemCount() {
        return pluDscs.size();
    }

    @Override
    public void onViewRecycled(ViewHolder holder) {
        super.onViewRecycled(holder);
    }


    @Override
    public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View view = LayoutInflater.from(mContext)
                .inflate(R.layout.adapter_sale_promotion, viewGroup, false);
        ViewHolder viewHolder = new ViewHolder(view);
        return viewHolder;
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position, List<Object> payloads) {
        super.onBindViewHolder(holder, position, payloads);

        if (pluDscs.size() > 0) {
            holder.txtProType.setText(pluDscs.get(position).getDscProName());
            holder.txtProTotal.setText(pluDscs.get(position).getTotalDsc());
        }
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        private TextView txtProType;
        private TextView txtProTotal;

        public ViewHolder(View itemView) {
            super(itemView);
            txtProType = itemView.findViewById(R.id.txt_pro_type_value);
            txtProTotal = itemView.findViewById(R.id.txt_pro_total_value);
        }

    }

}
