package com.hisense.hiaposcmp.adapter;

import com.hisense.hipos.coupon.Coupon;

/**
 * 会员券
 *
 * @author xieliyan 2017-12-15 HIPOSAPP-235
 */

public class VipCoupon {
    /**
     * 赠券的选中状态
     */
    private boolean selected;
    /**
     * 赠券
     */
    private Coupon coupon;

    /**
     * 初始化一个 {@code VipCoupon} 的实例。
     *
     * @param selected 赠券的选中状态
     * @param coupon   赠券
     */
    public VipCoupon(boolean selected, Coupon coupon) {
        this.selected = selected;
        this.coupon = coupon;

    }

    /**
     * 返回赠券是否被选择。
     *
     * @return 赠券是否被选择
     */
    public boolean isSelected() {
        return this.selected;
    }

    /**
     * 返回赠券。
     *
     * @return 赠券
     */
    public Coupon coupon() {
        return this.coupon;
    }

    /**
     * 赠券被选中
     */
    public void select() {
        this.selected = true;
    }

    /**
     * 赠券未被选中
     */
    public void unSelect() {
        this.selected = false;
    }


}
