/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.hisense.crm.vip.VipPointsProject;
import com.hisense.hiaposcmp.R;

import java.util.List;


/**
 * 会员积分方案适配器。
 *
 * @author xieliyan 2017-04-05
 * @author zhangsai 2017-11-15 HIPOSAPP-212 图标适配
 * @author zhangsai 2017-12-27 HIPOSAPP-258 使用 VipPointsProject 集合初始化
 */
public class VipPointsProjectAdapter extends BaseAdapter {
    private LayoutInflater mInflater = null;
    private List<VipPointsProject> mVipPoints;

    public VipPointsProjectAdapter(Context context, List<VipPointsProject> vipPoints) {
        mInflater = LayoutInflater.from(context);
        this.mVipPoints = vipPoints;
    }

    @Override
    public int getCount() {
        return mVipPoints.size();
    }

    @Override
    public Object getItem(int position) {
        Object obj = null;
        if (null != mVipPoints) {
            obj = mVipPoints.get(position);
        }
        return obj;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = mInflater.inflate(R.layout.adapter_vip_points_project, null);
        }

        ((TextView) convertView.findViewById(R.id.txtPlanName))
                .setText(mVipPoints.get(position).name());

        ((TextView) convertView.findViewById(R.id.txtUsablePoints))
                .setText(String.format("%s", mVipPoints.get(position).usablePoints()));

        return convertView;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

}
