package com.hisense.hiaposcmp.auth.util;

import android.text.TextUtils;
import android.util.Log;

import com.hisense.hiaposcmp.auth.algorithm.AESCrypt;
import com.hisense.hiaposcmp.auth.algorithm.Des;

/**
 * Created by zhuguangsheng on 2018/8/1.
 */

public class EncUtil {
    private static final String TAG = EncUtil.class.getSimpleName();

    private static final String DES_DEF_KEY = "ilovehisense";
    private static final String AES_DEF_KEY = "ilovehisense";

    public static boolean isEncMethodSupported(String encMethod) {
        if (TextUtils.isEmpty(encMethod)) {
            return false;
        }

        switch (encMethod) {
            case "000":
            case "001":
            case "002":
                return true;
            default:
                return false;
        }
    }

    /**
     * 加密
     *
     * @param encMethod 加密方法 000 001 002...
     * @param srcStr
     * @return
     * @throws RuntimeException
     */
    public static String enc(String encMethod, final String srcStr) {
        if (TextUtils.isEmpty(encMethod)
                || TextUtils.isEmpty(srcStr)
        ) {
            return "";
        }

        if ("000".equals(encMethod)) {
            return srcStr;
        }

        String ret = "";

        return ret;
    }

    /**
     * 解密
     *
     * @param encMethod
     * @param destStr
     * @return
     * @throws RuntimeException
     */
    public static String dec(String encMethod, final String destStr) {
        if (TextUtils.isEmpty(encMethod)
                || TextUtils.isEmpty(destStr)
        ) {
            return "";
        }

        if ("000".equals(encMethod)) {
            return destStr;
        }

        String ret = "";

        switch (encMethod) {
            case "001":
                try {
                    ret = Des.decrypt2Base64(DES_DEF_KEY, destStr);
                } catch (Exception e) {
                    e.printStackTrace();
                    ret = "DEC_ERR";
                }
                break;
            case "002":
                try {
                    ret = AESCrypt.decrypt(AES_DEF_KEY, destStr);
                } catch (Exception e) {
                    e.printStackTrace();
                    ret = "DEC_ERR";
                }
                break;
        }

        Log.i(TAG, "decrypt ret=" + ret);
        return ret;
    }

}
