package com.hisense.hiaposcmp.auth.util;

import android.text.TextUtils;

import com.hisense.common.util.LoggerUtils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by zhuguangsheng on 2018/7/30.
 */
public class FileUtil {

    public static boolean deleteFilesAtPath(String dirAbsPath, String prefix) {
        boolean ret;

        try {
            List<File> list = findFilesWithPrefix(dirAbsPath, prefix);
            for (File file : list) {

                boolean b = file.delete();
                if (!b) {
                    return false;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }

        ret = true;
        return ret;
    }

    /**
     * @param filePath    文件路径
     * @param charsetName 格式Charset 如UTF-8
     */
    public static StringBuilder readFileAbsolutePath(String filePath, String charsetName) {
        File file = new File(filePath);
        StringBuilder fileContent = new StringBuilder();
        if (file == null || !file.isFile()) {
            return fileContent;
        }

        BufferedReader reader = null;
        try {
            InputStreamReader is = new InputStreamReader(new FileInputStream(file), charsetName);
            reader = new BufferedReader(is);
            String line = null;
            while ((line = reader.readLine()) != null) {
                fileContent.append(line);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return fileContent;
    }

    public static boolean isEmpty(final CharSequence cs) {
        return cs == null || cs.length() == 0;
    }

    /**
     * 在指定路径下查找指定前缀的文件
     *
     * @param filePath SD卡下的路径
     * @param prefix   前缀
     * @return
     */
    public static List<File> findFilesWithPrefix(String filePath, String prefix) {
        List<File> fileList = new ArrayList<>();

        if (TextUtils.isEmpty(prefix)) {
            return fileList;
        }

        File file = new File(filePath);
        File[] subFile = file.listFiles();

        LoggerUtils.getLogger().debug("findFilesWithPrefix:" + subFile);
        if (subFile != null) {
            for (int i = 0; i < subFile.length; i++) {
                // 判断是否为文件夹
                if (!subFile[i].isDirectory()) {
                    String filename = subFile[i].getName();
                    if (filename.startsWith(prefix)) {
                        LoggerUtils.getLogger().info("文件名 ： " + filename);
                        fileList.add(subFile[i]);
                    }

                }
            }
        }
        return fileList;
    }
}
