package com.hisense.hiaposcmp.boot;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.activity.aliland.LoginAliLandActivity;
import com.hisense.hiaposcmp.activity.common.BootUpActivity;
import com.hisense.hiaposcmp.activity.common.LoginActivity;
import com.hisense.hiaposcmp.activity.std.LoginStdActivity;
import com.hisense.hiaposcmp.util.CommonUtils;

/**
 * 启动监听器
 * Created by zhuguangsheng on 2018/5/24.
 */
public class BootReceiver extends BroadcastReceiver {

    private final static String TAG = BootReceiver.class.getSimpleName();
    private static boolean isBootUp = true;

    @Override
    public void onReceive(Context context, Intent intent) {
        Log.i(TAG, "BootReceiver receive broadcast!");
        try {
            if ("android.intent.action.BOOT_COMPLETED".equals(intent.getAction())) {
                startApp(context);
            }
        } catch (Exception e) {
            e.printStackTrace();
            Log.i(TAG, "intent exception, someone may attacking me");
        }
    }

    private void startApp(Context context) {
        if (!isBootUp) {
            return;
        }
        Intent intent=new Intent();
        LoggerUtils.getLogger().debug("app 风格是：" + Custom.current().getName());
        if (CommonUtils.isStdStyle() || CommonUtils.isUniformStyle()) {

            if(CommonUtils.isAliLandStyle()){
                intent = new Intent(context, LoginAliLandActivity.class);
            } else if(CommonUtils.isHsyUniformStyle()){
                LoggerUtils.getLogger().debug("获取风格失败，使用默认hsyuniform风格，即将跳转到启动界面");
                intent = new Intent(context, BootUpActivity.class);
            } else{
                intent = new Intent(context, LoginStdActivity.class);
            }
        }
//        else {
//            intent = new Intent(context, LoginActivity.class);
//        }

        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    public static void setBootUp(boolean bootUp) {
        isBootUp = bootUp;
    }
}

