package com.hisense.hiaposcmp.boot;

import android.text.TextUtils;

import com.hisense.common.util.CustomUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.auth.HiAppConfig;
import com.hisense.hiaposcmp.util.MetaDataUtils;
import com.hisense.hiaposcmp.util.MidConfigUtils;

/**
 * Created by zhuguangsheng on 2018/5/31.
 */

public enum Custom {

    /**
     * 默认定制名
     */
    DEFAULT("default", "默认定制名"),

    /**
     * 慧收银统一版本
     */
    HYSUNIFORM("hsyuniform", "慧收银统一版本"),

    /**
     * 慧收银支付宝版
     */
    HS6500QZDF("hs6500qzdf", "慧收银支付宝版"),
    /**
     * 慧收银支付宝版横屏版
     */
    ALILANDPAY("alilandpay", "慧收银支付宝版横屏版"),
    /**
     * 慧收银微信版
     */
    WXPAY("wxpay", "慧收银微信版"),

    /**
     * 慧收银标准版
     */
    STANDARD("standard", "慧收银标准版"),

    /**
     * 慧收银移动版
     */
    HIPOSAPP("hiposapp", "慧收银移动版");

    private static Custom mCurrent;
    private static Custom mCurrentLocal;

    public static Custom currentLocalBuild() {
        if (mCurrentLocal == null) {
            String apkCustomName = "undefined";
            try {
                apkCustomName = MetaDataUtils.getCustom();
            } catch (Exception e) {
                e.printStackTrace();
            }
            for (Custom c : Custom.values()) {
                if (c.getName().equals(apkCustomName)) {
                    mCurrentLocal = c;
                    break;
                }
            }
            //遍历一圈还是null,就设DEFAULT
            if (mCurrentLocal == null) {
                mCurrentLocal = DEFAULT;
                LoggerUtils.getLogger().error("本地未正确定义分支版本!!!");
            }
        }

        return mCurrentLocal;
    }

    public synchronized static Custom current() {
        if (!"hsyuniform".equals(currentLocalBuild().getName())) {
            return currentLocalBuild();
        }

        String midCustom = MidConfigUtils.getFlavorCustom();
        String acfFileProjectCustom = HiAppConfig.getValue("projectcustom", "");

        if (!TextUtils.isEmpty(midCustom)) {
            //String apkCustomName = "undefined";
            mCurrent = null;
            for (Custom c : Custom.values()) {
                if (c.getName().equals(midCustom)) {
                    mCurrent = c;
                    break;
                }
            }
            //遍历一圈还是null,就设DEFAULT
            if (mCurrent == null) {
                mCurrent = DEFAULT;
                LoggerUtils.getLogger().info("中间件未正确定义分支版本!!!");
            }
        } else if (!TextUtils.isEmpty(HiAppConfig.getValue("projectcustom", ""))) {
            LoggerUtils.getLogger().info("from acfFileProjectCustom get acfFileProjectCustom=" + acfFileProjectCustom);
            mCurrent = null;
            for (Custom c : Custom.values()) {
                if (c.getName().equals(acfFileProjectCustom)) {
                    mCurrent = c;
                    break;
                }
            }
            //遍历一圈还是null,就设DEFAULT
            if (mCurrent == null) {
                mCurrent = DEFAULT;
                LoggerUtils.getLogger().error("acf配置文件未正确定义分支版本!!!");
            }
        } else {
            mCurrent = currentLocalBuild();
        }

        return mCurrent;
    }

    Custom(String name, String desc) {
        this.name = name;
        this.desc = desc;
    }

    String name = "";
    String desc = "";

    public String getName() {
        CustomUtils.setCustomName(name);
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
