/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.cache;

/**
 * 本地缓存。
 *
 * @author zhangsai 2018-01-08
 * @author zhangsai 2018-07-06 HIPOSAPP-649 增加配置项缓存
 * @author guolina  2019-01-14 HIPOSAPP-935 大码商品增加规格缓存
 * @author guolina  2019-03-04 HIPOSAPP-1035 大码商品去掉规格缓存
 */
public final class Cache {
    private static final String KEYS_IC_CARD_PASSWORD = "ICCardPassword";
    private static DailyCache<String> config;           // 配置项

    static {
        config = new DailyCache<>();
    }

    private Cache() {

    }

    /**
     * 返回射频卡读卡密码。
     *
     * @return 射频卡读卡密码
     */
    public static String icCardPassword() {
        return config.get(KEYS_IC_CARD_PASSWORD);
    }

    /**
     * 设置射频卡读卡密码。
     *
     * @param password 射频卡读卡密码
     */
    public static void icCardPassword(String password) {
        config.add(KEYS_IC_CARD_PASSWORD, password);
    }
}
