package com.hisense.hiaposcmp.constant;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.util.MidConfigUtils;

/**
 * 中间件下发的特性相关常量
 *
 * @author zhanghaiyang  2018-12-21
 */
public class FeatureConstants {

    public static String isStartSpeech = "";    //启用语音播放功能
    public static String isPayAuth = "1";         //启用授权

    private static final String IS_START_SPEECH = "isStartSpeech";
    private static final String IS_PAY_AUTH = "isPayAuth";

    //"1 启用", "0 不启用"
    public static final String IS_DISABLE_FEATURE = "0";
    public static final String IS_ENABLE_FEATURE = "1";

    public static void initFeatureConstants() {
        isStartSpeech = MidConfigUtils.getFeatureInMidConfig(IS_START_SPEECH);
        isPayAuth = MidConfigUtils.getFeatureInMidConfig(IS_PAY_AUTH);
        LoggerUtils.getLogger().debug("isPayAuth:" + isPayAuth);
    }
}
