package com.hisense.hiaposcmp.constant;

import com.alibaba.fastjson.JSONObject;
import com.hisense.common.util.JSONUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.util.MidConfigUtils;

/**
 * 设置相关常量
 *
 * @author dukunbiao(null)
 * @author xieliyan    2019-12-25 HIAPOSCMP-444 增加加密授权配置url和productkey存储
 */
public class SettingConstants {

    public static final String PAY_ANT_CHANNEL_MIYA = "MiYa";

    private static final String CONFIG_VERSION = "version";

    //购物袋参数
    private static final String SHOPPING_BAG_BIG = "shopping_bag_big";
    private static final String SHOPPING_BAG_MIDDLE = "shopping_bag_middle";
    private static final String SHOPPING_BAG_SMALL = "shopping_bag_small";

    //中台用参数
    private static final String AIP_URL = "aip_url";
    private static final String AIP_KEY = "aip_key";
    private static final String AIP_APP_ID = "aip_app_id";

    //加密授权参数
    private static final String PAY_AUTH_URL = "pay_auth_url";
    private static final String PAY_AUTH_PRODUCT_KEY = "pay_auth_product_key";

    public static void initSettingConstants() {
        try {
            JSONObject params = MidConfigUtils.loadMidConfigParams();
            if (params == null || JSONUtils.isEmpty(params.getJSONObject("settings"))) {
                return;
            }
        } catch (Exception e) {
            LoggerUtils.getLogger().error("initSettingConstants异常：" + e.toString());
            return;
        }

        GeneralSettings.INSTANCE.setConfigVersion(MidConfigUtils.getSettingInMidConfig(CONFIG_VERSION));

        GeneralSettings.INSTANCE.setSmallBagCode(MidConfigUtils.getSettingInMidConfig(SHOPPING_BAG_SMALL));
        GeneralSettings.INSTANCE.setMiddleBagCode(MidConfigUtils.getSettingInMidConfig(SHOPPING_BAG_MIDDLE));
        GeneralSettings.INSTANCE.setBigBagCode(MidConfigUtils.getSettingInMidConfig(SHOPPING_BAG_BIG));

        GeneralSettings.INSTANCE.setAipUrl(MidConfigUtils.getSettingInMidConfig(AIP_URL));
        GeneralSettings.INSTANCE.setAipKey(MidConfigUtils.getSettingInMidConfig(AIP_KEY));
        GeneralSettings.INSTANCE.setAipAppId(MidConfigUtils.getSettingInMidConfig(AIP_APP_ID));

        GeneralSettings.INSTANCE.setPayAuthUrl(MidConfigUtils.getSettingInMidConfig(PAY_AUTH_URL));
        GeneralSettings.INSTANCE.setPayAuthKey(MidConfigUtils.getSettingInMidConfig(PAY_AUTH_PRODUCT_KEY));
    }
}
