package com.hisense.hiaposcmp.constant.device;

/**
 * 扫描器类型。
 *
 * @author zhangsai 2019-01-18 HIPOSAPP-1002
 */
public enum ScannerType {

    /**
     * 摄像头。
     */
    CAMERA("CAMERA"),

    /**
     * 激光扫描头。
     */
    LASER("LASER");

    private String value;

    /**
     * 初始化一个 ScannerType 枚举。
     *
     * @param value 扫描器类型。
     */
    ScannerType(String value) {
        this.value = value;
    }

    /**
     * 返回扫描器类型。
     *
     * @return 扫描器类型。
     */
    public String value() {
        return this.value;
    }

    /**
     * 扫描器类型是否为摄像头。
     *
     * @return true 表示为摄像头
     */
    public boolean isCamera() {
        return this.equals(ScannerType.CAMERA);
    }

    /**
     * 扫描器类型是否为激光扫描头。
     *
     * @return true 表示为激光扫描头
     */
    public boolean isLaser() {
        return this.equals(ScannerType.LASER);
    }
}
