/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.constant.pay;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.boot.Custom;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.SDCardConstants;
import com.hisense.hiaposcmp.tool.LoadSDCard;
import com.hisense.hiaposcmp.util.MidConfigUtils;

/**
 * AliPay 常量类
 *
 * @author xieliyan 2018-04-28
 * @author dukunbiao(null)  2018-06-01  优化
 * @author dukunbiao(null)  2018-06-15  优化
 */
public class AliConstants {

    public static final String ALI_PAY_URL = "https://openapi.alipay.com/gateway.do";   //支付宝网关（固定）
    public static final String HI_ISV_ALI_PAY_PID = "2088131171249559";    //系统商签的《自助收银业务协作激励协议》账号的pid

    private static String ali_pay_pid;
    private static String ali_pay_app_id;
    private static String ali_pay_third_pid;
    private static String ali_pay_third_token;
    private static String ali_pay_app_private_key;
    private static String ali_pay_ali_public_key;
    private static String ali_pay_device_num;
    private static String ali_pay_subject;

    public static final String ALI_PAY_FORMAT = "json";
    public static final String ALI_PAY_CHARSET = "UTF-8";
    public static final String ALI_PAY_SIGN_TYPE = "RSA2";
    public static final String ALI_PAY_VERSION = "1.0";

    public static final String ALI_FACE_PAY_INITIALIZE = "zoloz.authentication.customer.smilepay.initialize";

    public static final String ALI_PAY_SECURITY_CODE = "security_code";
    public static final String ALI_PAY_BAR_CODE = "bar_code";

    public static final int NOT_FOUND_IGNORE = 2002;

    public static String ali_pay_pid() {
        return ali_pay_pid;
    }

    public static String ali_pay_app_id() {
        return ali_pay_app_id;
    }

    public static String ali_pay_third_pid() {
        return ali_pay_third_pid;
    }

    public static String ali_pay_third_token() {
        return ali_pay_third_token;
    }

    public static String ali_pay_app_private_key() {
        if (StringUtils.isEmpty(ali_pay_app_private_key)) {
            initAppPrivateKey();
        }

        return ali_pay_app_private_key;
    }

    public static String ali_pay_ali_public_key() {
        return ali_pay_ali_public_key;
    }

    public static String ali_pay_device_num() {
        return ali_pay_device_num;
    }

    public static String ali_pay_subject() {
        return ali_pay_subject;
    }

    public static void init() {
        ali_pay_pid = MidConfigUtils.getMidConfigValue("ali_pay_pid");
        ali_pay_app_id = MidConfigUtils.getMidConfigValue("ali_pay_app_id");
        ali_pay_third_pid = MidConfigUtils.getMidConfigValue("ali_pay_sub_pid");
        ali_pay_third_token = MidConfigUtils.getMidConfigValue("ali_pay_auth_token");
        ali_pay_ali_public_key = MidConfigUtils.getMidConfigValue("ali_pay_ali_public_key");
        ali_pay_subject = MidConfigUtils.getMidConfigValue("ali_pay_subject");
        ali_pay_app_private_key = MidConfigUtils.getMidConfigValue("ali_pay_app_private_key");
        ali_pay_device_num = MidConfigUtils.getMidConfigValue("ali_pay_device_num") + Config.pos_no;
    }

    private static void initAppPrivateKey() {
        switch (Custom.current().getName()) {
            case "hs6500qzdf":
                ali_pay_app_private_key = LoadSDCard.loadTxtFile(SDCardConstants.SSPOS_PRIVATE_KEY_PATH);
                break;
            default:
                ali_pay_app_private_key = "";
                break;
        }
    }
}
