package com.hisense.hiaposcmp.constant.pay;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.util.MidConfigUtils;

/**
 * 微信支付相关常量
 *
 * @author dukunbiao(null)  2018-06-29
 */
public class WxConstants {

    private static String wx_pay_appid; //是 公众号ID
    private static String wx_pay_mch_id;    //是 商户号
    private static String wx_face_pay_appid; //是 刷脸公众号ID
    private static String wx_face_pay_mch_id;    //是 刷脸商户号
    private static String wx_pay_sub_appid; //否 子商户公众账号ID(服务商模式)
    private static String wx_pay_sub_mch_id;    //否 子商户号(服务商模式)
    private static String wx_pay_store_id;    //是 门店编号，由商户定义，各门店唯一
    private static String wx_pay_store_name;    //是 门店名称，由商户定义，可用于展示
    private static String wx_pay_device_id; //是 终端设备编号，由商户定义
    private static String wx_pay_md5_key;

    public static final String APPID = "appid";
    public static final String MCH_ID = "mch_id";
    public static final String SUB_APPID = "sub_appid";
    public static final String SUB_MCH_ID = "sub_mch_id";
    public static final String NOW = "now";
    public static final String VERSION = "version";
    public static final String SIGN_TYPE = "sign_type";
    public static final String NONCE_STR = "nonce_str";
    public static final String SIGN = "sign";

    public static final String STORE_ID = "store_id";
    public static final String TELEPHONE = "telephone";
    public static final String STORE_NAME = "store_name";
    public static final String DEVICE_ID = "device_id";
    public static final String ATTACH = "attach";
    public static final String RAWDATA = "rawdata";

    public static final String OUT_TRADE_NO = "out_trade_no";
    public static final String TOTAL_FEE = "total_fee";
    public static final String CASH_FEE = "cash_fee";
    public static final String FACE_AUTHTYPE = "face_authtype";
    public static final String AUTHINFO = "authinfo";
    public static final String PAYRESULT = "payresult";
    public static final String ASKFACRPERMIT = "ask_face_permit";
    public static final String ASKRETPAGE = "ask_ret_page";
    public static final String FACE_CODE = "face_code";
    public static final String OPENID = "openid";

    public static final String RETURN_CODE = "return_code";
    public static final String RETURN_MSG = "return_msg";

    public static final String RETURN_CODE_SUCCESS = "SUCCESS";
    public static final String RETURN_CODE_USER_CANCEL = "USER_CANCEL";
    public static final String PAYRESULT_SUCCESS = "SUCCESS";
    public static final String PAYRESULT_ERROR = "ERROR";

    public static final String VERSION_VALUE = "1";
    public static final String SIGN_TYPE_MD5 = "MD5";
    public static final String CHARSET_UTF8 = "UTF-8";

    public static final String FACE_AUTHTYPE_FACEPAY = "FACEPAY";  //刷脸支付

    public static final String URL_GET_WXPAYFACE_AUTHINFO = "https://payapp.weixin.qq.com/face/get_wxpayface_authinfo";
    public static final String URL_FACEPAY = "https://api.mch.weixin.qq.com/pay/facepay";
    public static final String URL_FACEPAYQUERY = "https://api.mch.weixin.qq.com/pay/facepayquery";

    public static void init() {
        wx_pay_appid = MidConfigUtils.getMidConfigValue("wx_pay_appid");
        wx_pay_mch_id = MidConfigUtils.getMidConfigValue("wx_pay_mch_id");
        wx_face_pay_appid = MidConfigUtils.getMidConfigValue("wx_face_pay_appid");
        wx_face_pay_mch_id = MidConfigUtils.getMidConfigValue("wx_face_pay_mch_id");
        wx_pay_sub_appid = MidConfigUtils.getMidConfigValue("wx_pay_sub_appid");
        wx_pay_sub_mch_id = MidConfigUtils.getMidConfigValue("wx_pay_sub_mch_id");
        wx_pay_store_id = Config.org_code;
        wx_pay_store_name = MidConfigUtils.getMidConfigValue("wx_pay_store_name");
        wx_pay_device_id = Config.shop_code;
        wx_pay_md5_key = MidConfigUtils.getMidConfigValue("wx_pay_md5_key");
    }

    public static boolean reInit() {
        return !StringUtils.areNotEmpty(wx_pay_store_id, wx_pay_device_id, wx_pay_appid, wx_pay_mch_id, wx_face_pay_appid, wx_face_pay_mch_id);
    }

    public static String wx_pay_appid() {
        return wx_pay_appid;
    }

    public static String wx_pay_mch_id() {
        return wx_pay_mch_id;
    }

    public static String wx_face_pay_appid() {
        return wx_face_pay_appid;
    }

    public static String wx_face_pay_mch_id() {
        return wx_face_pay_mch_id;
    }

    public static String wx_pay_sub_appid() {
        return wx_pay_sub_appid;
    }

    public static String wx_pay_sub_mch_id() {
        return wx_pay_sub_mch_id;
    }

    public static String wx_pay_store_id() {
        return wx_pay_store_id;
    }

    public static String wx_pay_store_name() {
        return wx_pay_store_name;
    }

    public static String wx_pay_device_id() {
        return wx_pay_device_id;
    }

    public static String wx_pay_md5_key() {
        return wx_pay_md5_key;
    }
}
