/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.db;

import android.content.Context;

import com.hisense.database.sqlite.OnCreate;
import com.hisense.database.sqlite.OnUpgrade;
import com.hisense.database.sqlite.SQLiteDatabaseProvider;

import java.util.Arrays;
import java.util.Collection;

/**
 * 易收银 SQLite 数据库。
 *
 * @author xieliyan    2017-09-18 HIPOSAPP-158  电子发票打印：存储提取码，修改tSalSale表结构，增加udp1，udp2，udp3，udp4，udp5
 * @author xieliyan    2017-09-18 HIPOSAPP-154  卡冲正：修改tIntPosTradeChongZ表结构，增加udp1
 * @author zhangsai    2018-01-11 HIPOSAPP-271  增加 tSaleNo 流水号表
 * @author xieliyan    2018-03-26 HIPOSAPP-362  增加 tPrintImage 打印图片表
 * @author zhangsai    2018-06-11 HIPOSAPP-512  tSystemConfig修改为tSysCfg，设置Name为单一主键
 * @author zhangsai    2018-07-01 HIPOSAPP-612  增加 tPrnTemplate 打印模板表
 * @author guolina     2018-08-13 HIPOSAPP-719  实时积分增加会员卡号保存到数据库
 * @author zhangsai    2019-05-29 HIPOSAPP-1174 使用 SQLiteDatabaseProvider 初始化本地数据库
 * @author wangyaogang 2019-06-17 HIPOSAPP-1098 tSalSale表增加AuthNo字段
 */
public class PadPosDatabase extends SQLiteDatabaseProvider {
    public PadPosDatabase(Context context) {
        super(context, "padpos.db", 26);
    }

    @OnCreate
    public String create_tSalSale() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSalSale(");
        sb.append("OrgCode varchar(10) not null,");
        sb.append("SaleNo varchar(20) not null,");
        sb.append("PosNo varchar(4) not null,");
        sb.append("SaleDate datetime not null,");
        sb.append("AccDate varchar(10),");
        sb.append("CshID numeric(19, 0) default 0,");
        sb.append("CshCode varchar(6),");
        sb.append("Total numeric(19, 2) not null default 0,");
        sb.append("TotalRecv numeric(19, 2) not null default 0,");
        sb.append("TotalPaid numeric(19, 2) not null default 0,");
        sb.append("TotalChange numeric(19, 2) not null default 0,");
        sb.append("TotalRound numeric(19, 2) not null default 0,");
        sb.append("TranType varchar(1) not null default '1',");
        sb.append("CardNo varchar(40),");
        sb.append("vipCardNo varchar(40),");
        sb.append("CardType varchar(40),");
        sb.append("Tag numeric(5, 0) default 0,");
        sb.append("Remark varchar(100),");
        sb.append("udp1 varchar(100),");
        sb.append("udp2 varchar(100),");
        sb.append("udp3 varchar(100),");
        sb.append("udp4 varchar(100),");
        sb.append("udp5 varchar(100),");
        sb.append("AuthNo varchar(20),");
        sb.append("primary key(OrgCode,SaleNo))");
        return sb.toString();
    }

    @OnCreate
    @OnUpgrade(version = 2)
    public String create_tSalSalePlu() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSalSalePlu(");
        sb.append("OrgCode varchar(10) not null,");
        sb.append("ShopCode varchar(10) not null,");
        //sb.append("ShopId varchar(20) not null,");  //新增专柜ID
        sb.append("SaleNo varchar(20) not null,");
        sb.append("TranType varchar(1) not null default '1',");
        sb.append("PageNo numeric(10, 0) not null default 1,");
        sb.append("ItemNo numeric(10, 0) not null default 1,");
        sb.append("ClkID numeric(19, 0) default 0,");
        sb.append("ClkCode varchar(6),");
        sb.append("PluID varchar(40) not null default '0',");
        sb.append("PluCode varchar(40) not null,");
        sb.append("PluName varchar(40) not null,");
        sb.append("PluType varchar(1) not null default '1',");
        sb.append("BarCode varchar(20),");
        sb.append("BrandCode varchar(20),");                           //新增商品品牌编码
        sb.append("ClassCode varchar(20),");
        sb.append("Unit varchar(6),");
        sb.append("Spec varchar(40),");
        sb.append("DepID numeric(19, 0) not null default 0,");
        sb.append("DepCode varchar(10),");
        sb.append("DepName varchar(100),");
        sb.append("Price numeric(19, 4) not null default 0,");
        sb.append("TagPrice numeric(19, 4) not null default 0,");
        sb.append("Quantity numeric(19, 4) not null default 0,");
        sb.append("Total numeric(19, 2) not null default 0,");
        sb.append("TotalRecv numeric(19, 2) not null default 0,");
        sb.append("TotalDsc numeric(19, 2) not null default 0,");
        sb.append("TotalRound numeric(19, 2) not null default 0,");
        sb.append("InvNo varchar(20),");
        sb.append("Remark varchar(100),");
        sb.append("udp1 varchar(100),");
        sb.append("udp2 varchar(100),");
        sb.append("udp3 varchar(100),");
        sb.append("udp4 varchar(100),");
        sb.append("udp5 varchar(100),");
        sb.append("primary key(OrgCode,SaleNo,PageNo,ItemNo))");
        return sb.toString();
    }

    @OnCreate
    public String create_tSalSalePluDsc() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSalSalePluDsc(");
        sb.append("OrgCode varchar(10) not null,");
        sb.append("SaleNo varchar(20) not null,");
        sb.append("TranType varchar(1) not null default '1',");
        sb.append("PageNo numeric(10, 0) not null default 1,");
        sb.append("ItemNo numeric(10, 0) not null default 1,");
        sb.append("PluID numeric(19, 0) not null default 0,");
        sb.append("PluCode varchar(20) not null,");
        sb.append("PluName varchar(40) not null,");
        sb.append("SerialNo numeric(10, 0) default 0,");
        sb.append("DscType varchar(6),");
        sb.append("DscCode varchar(20),");
        sb.append("DscTotal numeric(19, 2) not null default 0,");
        sb.append("Remark varchar(100),");
        sb.append("primary key(OrgCode,SaleNo,PageNo,ItemNo,SerialNo))");
        return sb.toString();
    }

    @OnCreate
    public String create_tSalSalePay() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSalSalePay(");
        sb.append("OrgCode varchar(10) not null,");
        sb.append("SaleNo varchar(20) not null,");
        sb.append("TranType varchar(1) not null default '1',");
        sb.append("SerialNo numeric(10, 0) default 0,");
        sb.append("PayCode varchar(4) not null,");
        sb.append("PayName varchar(20),");
        sb.append("PayNo varchar(400),");
        sb.append("TotalPaid numeric(19, 2) not null default 0,");
        sb.append("TotalRecv numeric(19, 2) not null default 0,");
        sb.append("Tag numeric(5, 0) default 0,");
        sb.append("UDP1 varchar(100),");
        sb.append("UDP2 varchar(100),");
        sb.append("UDP3 varchar(100),");
        sb.append("UDP4 varchar(100),");     //交易参考号
        sb.append("UDP5 varchar(100),");     //银联凭证号
        sb.append("Remark varchar(100),");
        sb.append("primary key(OrgCode,SaleNo,SerialNo))");
        return sb.toString();
    }

    @OnUpgrade(version = 17)
    public Collection<String> alter_tSalSale_add_udp() {
        return Arrays.asList(
                "alter table tSalSale add udp1",
                "alter table tSalSale add udp2",
                "alter table tSalSale add udp3",
                "alter table tSalSale add udp4",
                "alter table tSalSale add udp5");
    }

    /**
     * 返回创建流水号表的 SQL 语句。
     *
     * @return SQL 语句
     */
    @OnCreate
    @OnUpgrade(version = 19)
    public String create_tSaleNo() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSaleNo( ");
        sb.append("Name varchar(60) not null,");
        sb.append("Value varchar(100),");
        sb.append("primary key(Name))");
        return sb.toString();
    }

    /**
     * 返回创建支付方式表的 SQL 语句。
     *
     * @return SQL 语句
     */
    @OnCreate
    @OnUpgrade(version = 20)
    public String create_tPayMethod() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tPayMethod( ");
        sb.append("Code varchar(60) not null,");
        sb.append("Freq INTEGER,");
        sb.append("primary key(Code))");
        return sb.toString();
    }

    /**
     * 返回保存打印图片表的 SQL 语句。
     *
     * @return SQL 语句
     */
    @OnCreate
    @OnUpgrade(version = 21)
    public static String create_tPrintImage() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tPrintImage( ");
        sb.append("Name varchar(60) not null,");
        sb.append("Timestamp varchar(100),");
        sb.append("Value varchar(100),");
        sb.append("primary key(Name))");
        return sb.toString();
    }

    /**
     * 返回创建配置表的 SQL 语句。
     *
     * @return 创建配置表的 SQL 语句
     */
    @OnCreate
    @OnUpgrade(version = 22)
    public String create_tSysCfg() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tSysCfg( ");
        sb.append("Name varchar(60) not null,");
        sb.append("Value varchar(100),");
        sb.append("primary key(Name))");
        return sb.toString();
    }

    @OnUpgrade(version = 22)
    public String drop_tSystemConfig() {
        return "drop table tSysCfg";
    }

    /**
     * 返回创建打印模板表的 SQL 语句。
     *
     * @return 创建配置表的 SQL 语句
     */
    @OnCreate
    @OnUpgrade(version = 23)
    public String create_tPrnTemplate() {
        StringBuffer sb = new StringBuffer();
        sb.append("create table tPrnTemplate( ");
        sb.append("Type INTEGER not null,");
        sb.append("Content varchar(1000),");
        sb.append("Version INTEGER not null,");
        sb.append("primary key(Type))");
        return sb.toString();
    }

    @OnUpgrade(version = 24)
    public String alter_tSalSale_add_vipCardNo() {
        return "alter table tSalSale add vipCardNo";
    }

    @OnUpgrade(version = 25)
    public Collection<String> alter_tSalSalePlu_add_CargoNo() {
        return Arrays.asList(
                "alter table tSalSalePlu add udp1",
                "alter table tSalSalePlu add udp2",
                "alter table tSalSalePlu add udp3",
                "alter table tSalSalePlu add udp4",
                "alter table tSalSalePlu add udp5");
    }

    @OnUpgrade(version = 26)
    public String alter_tSalSale_add_AuthNo() {
        return "alter table tSalSale add AuthNo";
    }
}
