/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.dialog;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.R;

/**
 * 加载对话框。
 *
 * @author fujiaxin 2017-03-16
 * @author fujiaxin 2017-11-15
 * @author xieliyan 2018-04-03 HIPOSAPP-379 修复余额查询偶发闪退问题
 * @author zhuguangsheng 2018-06-05 为蚂蚁金服改
 */
public class LoadingDialog {

    private Dialog dialog;

    private Context mContext;

    /**
     * 初始化一个 {@code LoadingDialog} 的新实例。
     *
     * @param context 对话框的运行上下文环境
     */
    public LoadingDialog(Context context) {
        mContext = context;

        LayoutInflater inflater = LayoutInflater.from(context);
        View vwLayout = inflater.inflate(R.layout.loading_ant, null);

        ImageView vwImage = vwLayout.findViewById(R.id.img);
        Animation animation = AnimationUtils.loadAnimation(context, R.anim.loading);
        vwImage.startAnimation(animation);

        Dialog loadingDialog = new Dialog(context, R.style.dialog);
        loadingDialog.setCancelable(false);

        LinearLayout layout = vwLayout.findViewById(R.id.dialog_view);
        loadingDialog.setContentView(layout, new LinearLayout.LayoutParams(180, 180));

        dialog = loadingDialog;
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
    }

    /**
     * 关闭对话框。
     */
    public void dismiss() {
        dialog.dismiss();
    }

    /**
     * 显示对话框。
     *
     * @return 当前对话框的实例。
     */
    public LoadingDialog show() {
        if (mContext != null) {
            dialog.show();
        } else {
            String err = "Activity context不存在,不能正常show";
            LoggerUtils.getLogger().error(err);
        }
        return this;
    }
}
