package com.hisense.hiaposcmp.dialog;

import android.graphics.Color;
import android.view.View;
import android.widget.TextView;

import com.bigkoo.pickerview.builder.TimePickerBuilder;
import com.bigkoo.pickerview.listener.OnTimeSelectListener;
import com.hisense.hiaposcmp.App;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

public class TimePicker {
    //上次选择日期
    private static Date lastDate;

    public static void timePicker(final TextView tvTime) {
        timePicker(tvTime, null);
    }

    public static void timePicker(final TextView tvTime, OnTimeSelectedListener onTimeSelectedListener) {
        Calendar startDate = Calendar.getInstance();
        startDate.set(2010, 0, 1);

        //等同于保存上次选择日期
        Calendar nowDate = Calendar.getInstance();
        if (lastDate != null) {
            nowDate.setTime(lastDate);
        }
        // .isDialog(true)      // 加上这句 就在中间显示了
        //时间选择器
        com.bigkoo.pickerview.view.TimePickerView pvTime = new TimePickerBuilder(App.getContext(), new OnTimeSelectListener() {
            @Override
            public void onTimeSelect(Date date, View v) {
                // 这里回调过来的v,就是show()方法里面所添加的 View 参数，如果show的时候没有添加参数，v则为null
                //选择一个日期时,判断另一个日期是否录入,若录入,则比较时间先后,进行提示
                lastDate = date;
                tvTime.setText(getTime(date));
                if (onTimeSelectedListener != null) {
                    onTimeSelectedListener.onSelected();
                }
            }
        })
                //年月日时分秒 的显示与否，不设置则默认全部显示
                .setType(new boolean[]{true, true, true, false, false, false})
                .setSubmitColor(Color.parseColor("#F04B63"))
                .setCancelColor(Color.parseColor("#666666"))
                .setDividerColor(Color.DKGRAY)
                .setContentTextSize(21)
                .setDate(nowDate)
                .isCenterLabel(true)
                .setRangDate(startDate, Calendar.getInstance())
                .setLabel("年", "月", "日", "", "", "")
                .isCyclic(false)
                .setDecorView(null)
                .build();
        pvTime.show();
    }

    public interface OnTimeSelectedListener {
        void onSelected();
    }

    //yyyy-MM-dd 可根据需要自行截取数据显示
    public static String getTime(Date date) {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        return format.format(date);
    }
}
