package com.hisense.hiaposcmp.hs330r;

import android.os.Bundle;
import android.os.RemoteException;
import android.widget.Toast;

import com.hisense.common.util.LoggerUtils;
import com.histonepos.npsdk.bind.Const;
import com.histonepos.npsdk.bind.PrinterConsts;
import com.histonepos.npsdk.printer.IPrinterService;
import com.icbc.smartpos.deviceservice.aidl.IPrinter;

public class HS330RPrintHelper {
    private static HS330RPrintHelper deviceHelper;

    private HS330RPrintHelper() {
    }

    public static HS330RPrintHelper getInstance() {
        if (deviceHelper == null) {
            synchronized (HS330RPrintHelper.class) {
                if (deviceHelper == null) {
                    deviceHelper = new HS330RPrintHelper();

                }
            }
        }
        return deviceHelper;
    }

    private IPrinterService getLocalPrinter() {
        try {
            return IPrinterService.Stub.asInterface(GlobalDefines.sm.getService(Const.PRINTER));
        } catch (RemoteException e) {
            e.printStackTrace();
        }
        return null;
    }

    public IPrinterService getPrinter() {
        IPrinterService printer = getLocalPrinter();
        if (printer == null) {
            LoggerUtils.getLogger().debug("get printer failed!");
            //Toast.makeText(getActivity(), "get printer failed!", Toast.LENGTH_SHORT).show();
            return null;
        }
        // tell sdk the widthmode(58mm or 80mm) of printer in use.
        Bundle bundle = new Bundle();
        String widthType = PrinterConsts.PRT_CFG_VALUE_WIDTH_MODE_58;
        bundle.putString(PrinterConsts.PRT_CFG_KEY_WIDTH_MODE, widthType);
        try {
            printer.setConfig(bundle);
        } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return printer;
    }
}
