/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.pos.payment;

import android.app.Activity;

import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.boc.BocPaymentProvider;
import com.hisense.pos.payment.boc.PayMode;

/**
 * 中行支付工厂类。
 *
 * @author zhangsai    2018-12-18 HIPOSAPP-914
 * @author wangyaogang 2018-12-27 HIPOSAPP-876 中行银联二维码支付对接,增加云闪付支付方式
 */
public class BocPaymentFactory {
    /**
     * 如果支持 {@code payMethodRemark} 表示的支付方式，则返回一个新的 {@code IPaymentProvider} 实例；否则，
     * 返回 null。
     *
     * @param activity        Activity
     * @param payMethodRemark 支付方式备注
     * @return {@code IPaymentProvider} 实例
     */
    public static IPaymentProvider createProvider(Activity activity, String payMethodRemark) {
        IPaymentProvider paymentProvider = null;

        if (PayMethod.isUnionPay(payMethodRemark)) {
            paymentProvider = new BocPaymentProvider(activity, PayMode.UNION_PAY);
        } else if (PayMethod.isAliPay(payMethodRemark)) {
            paymentProvider = new BocPaymentProvider(activity, PayMode.ALIPAY);
        } else if (PayMethod.isWxPay(payMethodRemark)) {
            paymentProvider = new BocPaymentProvider(activity, PayMode.WECHAT_PAY);
        } else if (PayMethod.isUnionCloudPay(payMethodRemark)) {
            paymentProvider = new BocPaymentProvider(activity, PayMode.UNION_CLOUD_PAY);
        }

        return paymentProvider;
    }
}
