/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.pos.payment;

import android.app.Activity;

import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.ccb.CcbScanPayProvider;
import com.hisense.pos.payment.ccb.CcbUnionPayProvider;


/**
 * 建行收单工程类。
 *
 * @author zhangsai 2018-11-27 HIPOSAPP-888
 */
public final class CcbPaymentFactory {
    /**
     * 如果支持 {@code payMethodRemark} 表示的支付方式，则返回一个新的 {@code IPaymentProvider} 实例；否则，
     * 返回 null。
     *
     * @param activity        Activity
     * @param payMethodRemark 支付方式备注
     * @return {@code IPaymentProvider} 实例
     */
    public static IPaymentProvider createProvider(Activity activity, String payMethodRemark) {
        IPaymentProvider paymentProvider = null;

        if (PayMethod.isUnionPay(payMethodRemark)) {
            paymentProvider = new CcbUnionPayProvider(activity);
        } else if (PayMethod.isAliPay(payMethodRemark) || PayMethod.isWxPay(payMethodRemark) || PayMethod.isMobilePay(payMethodRemark)) {
            paymentProvider = new CcbScanPayProvider(activity);
        }

        return paymentProvider;
    }
}
