package com.hisense.hiaposcmp.pos.payment;

import android.app.Activity;

import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.icbc.IcbcInstallmentProvider;
import com.hisense.pos.payment.icbc.IcbcIntegralPurchaseProvider;
import com.hisense.pos.payment.icbc.IcbcPurchaseProvider;
import com.hisense.pos.payment.icbc.IcbcQRPurchaseProvider;

/**
 * {功能描述}
 *
 * @author zhangsai 2018-11-28
 */
public class IcbcPaymentFactory {

    public static IPaymentProvider createProvider(Activity activity, String payMethodRemark) {
        IPaymentProvider paymentProvider = null;

        if (PayMethod.isUnionPay(payMethodRemark)) {
            paymentProvider = new IcbcPurchaseProvider(activity);
        } else if (PayMethod.isAliPay(payMethodRemark)) {
            paymentProvider = new IcbcQRPurchaseProvider(activity);
        } else if (PayMethod.isWxPay(payMethodRemark)) {
            paymentProvider = new IcbcQRPurchaseProvider(activity);
        } else if (PayMethod.isUnionInstallment(payMethodRemark)) {
            paymentProvider = new IcbcInstallmentProvider(activity);
        } else if (PayMethod.isUnionPoints(payMethodRemark)) {
            paymentProvider = new IcbcIntegralPurchaseProvider(activity);
        }

        return paymentProvider;
    }
}
