/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.pos.payment;

import android.app.Activity;

import com.hisense.hipos.payment.PayMethod;
import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.unionpay.payment.ccb.UnionCcbScanPayProvider;
import com.hisense.pos.unionpay.payment.ccb.UnionCcbUnionPayProvider;


/**
 * 建行直连工程类。
 *
 * @author xieliyan  2019-10-18 HIPOSAPP-1328 新增建行直连通道
 */
public final class UnionCcbPaymentFactory {
    /**
     * 如果支持 {@code payMethodRemark} 表示的支付方式，则返回一个新的 {@code IPaymentProvider} 实例；否则，
     * 返回 null。
     *
     * @param activity        Activity
     * @param payMethodRemark 支付方式备注
     * @return {@code IPaymentProvider} 实例
     */
    public static IPaymentProvider createProvider(Activity activity, String payMethodRemark) {
        IPaymentProvider paymentProvider = null;

        if (PayMethod.isUccbCard(payMethodRemark)) {
            paymentProvider = new UnionCcbUnionPayProvider(activity);
        } else if (PayMethod.isUccbScan(payMethodRemark)) {
            paymentProvider = new UnionCcbScanPayProvider(activity);
        }

        return paymentProvider;
    }
}
