package com.hisense.hiaposcmp.pos.print;

import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.hs330r.HS330RPrintProvider;
import com.hisense.pos.hs6500.HS650PrintProvider;
import com.hisense.pos.print.IPrintProvider;
import com.hisense.pos.print.ccb.CcbPrintProvider;
import com.hisense.pos.print.hi98.HI98PrintProvider;
import com.hisense.pos.print.icbc.ICBCPrintProvider;
import com.hisense.pos.sunmit2.printer.SunmiPrintProvider;

/**
 * 打印程序提供器
 *
 * @author lizhixin 20180625 HIPOSAPP-596 新增工行收单功能-读卡
 */
public class PrintProvider {

    public static IPrintProvider createPrintProvider() {
        IPrintProvider iPrintProvider;
        if (Config.isHS330R()) {
            iPrintProvider = new HS330RPrintProvider();
        } else if (GeneralSettings.INSTANCE.getPaymentChannel().isICBC()) {
            //工行打印小票
            iPrintProvider = new ICBCPrintProvider();
        } else if (GeneralSettings.INSTANCE.getPaymentChannel().isCCB()) {
            iPrintProvider = new CcbPrintProvider();
        } else if (GeneralSettings.INSTANCE.getDeviceType().isHI98()) {
            iPrintProvider = new HI98PrintProvider();
        } else if (GeneralSettings.INSTANCE.getDeviceType().isHSX()) {
            iPrintProvider = new HS650PrintProvider();
        } else if (GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            iPrintProvider = new SunmiPrintProvider();
        } else {
            iPrintProvider = new HS650PrintProvider();
        }
        return iPrintProvider;

    }

}
