package com.hisense.hiaposcmp.presenter.auth;

import com.hisense.hiaposcmp.boot.ActivityCollector;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.presenter.BasePresenter;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.view.IView.ILeaveView;
import com.hisense.hipos.webapi.auth.AuthService;
import com.hisense.hipos.webapi.auth.LoginResultData;
import com.hisense.webapi.Callback;

/**
 * @author guolina  2019-10-23  重构
 */
public class LeavePresenter extends BasePresenter<ILeaveView> {

    private long mExitTime;

    /**
     * 登陆。
     */
    public void login(String password, String uuid) {
        showLoadingDialog();
        AuthService.login(Config.user_code, password, uuid, new Callback<LoginResultData>() {
            @Override
            public void onSuccess(LoginResultData loginResult) {
                hideLoadingDialog();
                mMvpView.loginSuccess(loginResult);
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
                showHintDialog(throwable.getMessage());
            }
        });
    }

    /**
     * 如果用户在 2 秒内连续点击系统返回键，则退出登录。
     */
    public void exit() {
        if ((System.currentTimeMillis() - mExitTime) > 2000) {
            CommonTools.toastShort("再次点击退出应用");
            mExitTime = System.currentTimeMillis();
        } else {
            ActivityCollector.finishAll();
            System.exit(0);
        }
    }
}
