package com.hisense.hiaposcmp.presenter.pay;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.DateUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.presenter.BasePresenter;
import com.hisense.hiaposcmp.view.IView.pay.IOtherPayView;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.payment.PayMethod;

/**
 * 其他支付
 *
 * @author dukunbiao(null)  2019-10-18  重构
 */
public class OtherPayPresenter extends BasePresenter<IOtherPayView> {

    private PayMethod mSelectedPayMethod;

    public void otherPay(String totalPaid, String payNo) {
        if (StringUtils.isEmpty(totalPaid)) {
           showHintDialog("请输入支付金额");
            return;
        }

        if (BigDecimalUtils.isGreater(totalPaid, getSale().getTotalUnPaid())) {
           showHintDialog("输入金额不得大于未支付金额");
            return;
        }

        if (BigDecimalUtils.isEquals(totalPaid, "0")) {
           showHintDialog("输入金额不得为0");
            return;
        }

        otherPaySuccess(totalPaid, payNo);
        mMvpView.otherPaySuccess();
    }

    private void otherPaySuccess(String totalPaid, String payNo) {
        mSelectedPayMethod = getSale().getPayMethod();

        SalePayModel payModel = new SalePayModel();
        payModel.setPayCode(mSelectedPayMethod.code());
        payModel.setPayName(mSelectedPayMethod.name());
        payModel.setRemark(mSelectedPayMethod.remark());
        payModel.setPayType(mSelectedPayMethod.payType());
        payModel.setBuyerLogonId(payNo);
        payModel.setOutTradeNo("");
        payModel.setTradeNo("");
        payModel.setPayTime(DateUtils.dateFormat());
        payModel.setTotal(totalPaid);
        payModel.setTotalRecv(totalPaid);
        payModel.setTotalPaid(totalPaid);
        payModel.setTotalDscSelf("0.00");
        payModel.setTotalDscChannel("0.00");
        getSale().addPay(payModel);

        LoggerUtils.getLogger().debug(payModel.getPayName() + payModel.getRemark() + "付款金额：" + payModel.getTotalRecv() +
                ",已付金额：" + getSale().getTotalPaid() +
                ",未付金额：" + getSale().getTotalUnPaid());
    }
}
