package com.hisense.hiaposcmp.presenter.pay;

import com.alibaba.fastjson.JSONObject;
import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.LoggerUtils;
import com.hisense.crm.card.VipCard;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.presenter.BasePresenter;
import com.hisense.hiaposcmp.print.PrinterHelper;
import com.hisense.hiaposcmp.print.printer.impl.LocalPOSPrinter;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.service.sale.SaleRepository;
import com.hisense.hiaposcmp.view.IView.pay.IPaySuccessView;
import com.hisense.hipos.model.MainSaleModel;

/**
 * @author liaoyuping on 2018/7/5.
 * @author dukunbiao(null)  2019-07-25  重构
 */
public class PaySuccessPresenter extends BasePresenter<IPaySuccessView> {

    /**
     * 是否提示打印小票
     */
    public void print() {
        if (GeneralSettings.INSTANCE.isPrintMessage()) {
            showHintConfirm("是否打印小票？", new UniCallback() {
                @Override
                public void onSuccess(String msg) {
                    LocalPOSPrinter.isPrint = true;
                    LoggerUtils.getLogger().debug("选择打印小票" + LocalPOSPrinter.isPrint);
                    printBill();
                }

                @Override
                public void onError(String err) {
                    LocalPOSPrinter.isPrint = false;
                    LoggerUtils.getLogger().debug("选择不打印小票" + LocalPOSPrinter.isPrint);
                    printBill();
                }
            });
        } else {
            LocalPOSPrinter.isPrint = true;
            LoggerUtils.getLogger().debug("默认打印小票" + LocalPOSPrinter.isPrint);
            printBill();
        }
    }

    private void printBill() {
        try {
            PrinterHelper.getInstance().print(MainSaleModel.getInstance().getSaleModel());
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("打印出现异常" + e.toString());
        }
    }

    /**
     * 交易完成后保存交易数据
     */
    public void uSaveData() {
        try {
            SaleNoService.save(mMvpView.getContext(), Config.org_code, Config.pos_no, getSale().getSaleNo());
            if (getSale().getVip() == null || getSale().getVip().card() == null || getSale().getVip().card().vipCardNo() == null) {
                VipCard card = new VipCard.Builder("", null)
                        .cardType("", "")
                        .expireDate("")
                        .status("")
                        .vipCardNo("")
                        .build();

                getSale().addVip(card);
            }
            new SaleRepository(mMvpView.getContext()).save(getMainSaleModel().getSaleModel());
            LoggerUtils.getLogger().error("保存数据成功");

        } catch (Exception e) {
            LoggerUtils.getLogger().error("保存数据出错:" + e.toString());
            LoggerUtils.getLogger().error("出错流水数据:" + JSONObject.toJSONString(getSale()));
        }
    }
}
