package com.hisense.hiaposcmp.presenter.sale;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;

import com.alibaba.fastjson.JSONObject;
import com.hisense.common.boot.GlobalCallback;
import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.DateUtils;
import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.common.util.ThreadFactoryUtils;
import com.hisense.crm.Cashier;
import com.hisense.crm.vip.RealTimePoint;
import com.hisense.crm.vip.Vip;
import com.hisense.crm.webapi.vip.VipService;
import com.hisense.hiaposcmp.activity.ysy.sale.SaleActivity;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.constant.SDCardConstants;
import com.hisense.hiaposcmp.constant.pay.AliConstants;
import com.hisense.hiaposcmp.constant.pay.PayConstants;
import com.hisense.hiaposcmp.pos.print.PrintProvider;
import com.hisense.hiaposcmp.presenter.BasePresenter;
import com.hisense.hiaposcmp.print.Invoice.EInvoice2;
import com.hisense.hiaposcmp.print.PrinterHelper;
import com.hisense.hiaposcmp.print.printer.Printer;
import com.hisense.hiaposcmp.service.sale.SaleApplicationService;
import com.hisense.hiaposcmp.service.sale.SaleNoService;
import com.hisense.hiaposcmp.service.sale.SaleRepository;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.tool.LoadSDCard;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hiaposcmp.util.IFlyTtsUtil;
import com.hisense.hiaposcmp.util.NetUtils;
import com.hisense.hiaposcmp.view.IView.sale.ISaleView;
import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.GiftCoupon;
import com.hisense.hipos.coupon.ICoupon;
import com.hisense.hipos.invoice.models.EInvoiceConfig;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.SaleModel;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.model.SalePluDscModel;
import com.hisense.hipos.model.SalePluModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.hipos.sale.CalcType;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.user.User;
import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.invoice.InvoiceService;
import com.hisense.hipos.webapi.pay.PayResultData;
import com.hisense.hipos.webapi.pay.PayService;
import com.hisense.hipos.webapi.plu.PluAdjustResultData;
import com.hisense.hipos.webapi.plu.PluDeleteResultData;
import com.hisense.hipos.webapi.plu.PluService;
import com.hisense.hipos.webapi.sale.CompletePluDscData;
import com.hisense.hipos.webapi.sale.PromotionCalcModel;
import com.hisense.hipos.webapi.sale.SaleService;
import com.hisense.hipos.webapi.sale.SaleSubmitResultData;
import com.hisense.hipos.webapi.service.OnlineResultData;
import com.hisense.hipos.webapi.service.Service;
import com.hisense.pos.print.IPrintProvider;
import com.hisense.webapi.Callback;
import com.hisense.webapi.RetryCallback;
import com.hisense.webapi.WebApi;
import com.hisense.webapi.WebApiException;
import com.jauker.widget.BadgeView;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.CountDownLatch;

/**
 * 微信销售presenter
 *
 * @author zhuguangsheng   2018-07-02
 * @author xieliyan        2018-07-09
 * @author dukunbiao(null) 2019-07-23  重构
 * @author wangyaogang     2019-12-13 HIAPOSCMP-429 计件商品不弹框
 * @author guolina         2019-12-13 HIAPOSCMP-426 防止商品查询结果返回前loading过早消失
 * @author xieliyan        2020-01-02 HIAPOSCMP-466 商品查询异常时设置提示框倒计时（uniform系列）
 * @author guolina         2020-01-09 HIAPOSCMP-490 慧收银增加整单促销接口
 * @author guolina         2020-01-13 HIAPOSCMP-495 易收银调整整单促销接口
 * @author guolina         2020-01-17 HIAPOSCMP-505 点击结算按钮无反应
 * @author guolina         2020-02-27 HIAPOSCMP-553 与中台联调商品查询和商品促销计算接口
 * @author guolina         2020-03-09 HIAPOSCMP-566 微信自助允许录入商品价格需求
 * @author guolina         2020-03-17 HIAPOSCMP-563 流水上传增加cshName字段
 * @author wangyaogang     2020-04-10 HIAPOSCMP-660 会员限量促销，流水上传前调用交易完成接口更新数量
 * @author guolina         2020-04-21 HIAPOSCMP-649 利客来易收银允许改价需求
 * @author xieliyan        2020-04-22 HIAPOSCMP-693 会员登录后返回销售界面loading不消失
 * @author guolina         2020-04-27 HIAPOSCMP-702 慧收银APP需支持第二件半价促销方案商品合行
 * @author guolina         2020-05-09 HIAPOSCMP-749 销售界面停留一小时以上促销返回错误，超过30分钟重新获取销售时间
 */
public class SalePresenter extends BasePresenter<ISaleView> {

    private PayMethod mSelectedPayMethod;
    private BadgeView badgeView;
    private Boolean isNoCode = false;//查询到的商品是否是大码商品

    public void selectedPayMethod(PayMethod mSelectedPayMethod) {
        this.mSelectedPayMethod = mSelectedPayMethod;
    }

    public void updateAdapterAndUi() {
        mMvpView.updateAdapter();
        mMvpView.updateTotal(0, "0.00", "0.00");

        if (ListUtils.isEmpty(getSale().getPlus())) {
            mMvpView.hideShoppingCartPrompt();
        }
    }

    public void resetSaleModel() {
        getMainSaleModel().reset();

        mMvpView.updateAdapter();
        mMvpView.updateTotal(0, "0.00", "0.00");
        mMvpView.backToWelcomeActivity();
    }

    public void resetSaleModelForYsyUpSale() {
        if (hasCoupons != -1 && hasPoints != -1 && hasUploaded != -1) {
            LoggerUtils.getLogger().debug("券/积分/流水接口全部完成(可能失败或成功),重置:" + hasCoupons + ";" + hasPoints + ";" + hasUploaded);

            resetSaleModel();

            if (hasUploaded == 1) {
                mMvpView.submitSuccess();
            }
            if (hasUploaded == 0) {
                //获取新的流水号
                SaleNoService.abandon();
                mMvpView.submitFail("流水上传失败，请点击右上角上传流水重试");
            }

            hasCoupons = -1;
            hasPoints = -1;
            hasUploaded = -1;
        } else {
            LoggerUtils.getLogger().debug("券/积分/流水接口未全部完成,暂不重置:" + hasCoupons + ";" + hasPoints + ";" + hasUploaded);
        }
    }

    public BaseSalePluModel getItem(int position) {
        return getSale().getPlu(position);
    }

    public void createNewSale(Vip vip, TranType tranType, UniCallback callback) {
        //View是否绑定 如果没有绑定，就不执行网络请求
        if (!isViewAttached()) {
            CommonTools.showUiDialogNoView();
            return;
        }

        /*
         * TODO：某些情况下，cashier对象仍会出现为null的情况。目前没有找到原因，此处强制检查cashier是否为null。
         * 如果为null则使用登录信息重新初始化cashier对象。
         */
        if (Context.cashier() == null) {
            Context.cashier(new User(Config.user_id, Config.user_code, Config.user_name));
            com.hisense.crm.webapi.Context.cashier(new Cashier(Config.user_code, Config.user_name));
        }
        if (Context.cashier() == null) {
            hideLoadingDialog();
            callback.onError("交易初始化失败。请退出重新打开应用");
            return;
        }

        showLoadingDialog();
        SaleService.getAccountingDate(new Callback<String>() {
            @Override
            public void onSuccess(String accDate) {
                hideLoadingDialog();
                createNewSale(accDate, vip, tranType, callback);
            }

            @Override
            public void onError(Throwable throwable) {
                LoggerUtils.getLogger().error("获取结账日期异常:" + throwable.toString());
                callback.onError("获取结账日期异常:" + throwable.getMessage());
                hideLoadingDialog();
            }
        });
    }

    private void createNewSale(String accDate, Vip vip, TranType tranType, UniCallback callback) {
        showLoadingDialog();
        SaleNoService.next(mMvpView.getContext(), accDate, new Callback<String>() {
            @Override
            public void onSuccess(String saleNo) {
                saleBegin(tranType, accDate, saleNo, vip, callback);
                hideLoadingDialog();
            }

            @Override
            public void onError(Throwable throwable) {
                LoggerUtils.getLogger().debug("获取流水号失败：" + throwable.toString());
                callback.onError("获取流水号失败：" + throwable.getMessage());
                hideLoadingDialog();
            }
        });
    }

    private void saleBegin(TranType tranType, String accDate, String saleNo, Vip vip, UniCallback callback) {
        getMainSaleModel().reset();

        SaleModel saleModel = new SaleModel();
        User user = new User(Config.user_id, Config.user_code, Config.user_name);
        saleModel.setCashier(user);
        saleModel.setPosNo(Config.pos_no);
        saleModel.setAccDate(accDate);
        saleModel.setSaleNo(saleNo);
        saleModel.setTranType(tranType);
        saleModel.setSaleDate(WebApi.formatDate(new Date()));
        saleModel.setSaleTime(DateUtils.dateFormat());
        saleModel.setUdp1(user.getUserName());
        saleModel.setUdp4(EInvoice2.random());
        saleModel.setVip(vip);
        getMainSaleModel().saleModel(saleModel);

        if (tranType == TranType.Sale) {
            LoggerUtils.getLogger().info(String.format(Locale.CHINESE, "开始交易[%s]。收银员：%s，结账日期：%s",
                    saleModel.getSaleNo(), saleModel.getCashier().code(), accDate));
        } else {
            LoggerUtils.getLogger().info(String.format(Locale.CHINESE, "【预】开始交易[%s]。收银员：%s，结账日期：%s",
                    saleModel.getSaleNo(), saleModel.getCashier().code(), accDate));
        }

        checkEInvoice(callback);
    }

    /**
     * 检查电子发票配置是否初始化。如果未初始化，则从后台服务端获取电子发票配置。
     *
     * @param callback 检查后的回调方法
     */
    private void checkEInvoice(UniCallback callback) {
        if (!StringUtils.isEmpty(EInvoice2.getBaseUrl())) {
            callback.onSuccess("");
        } else {
            InvoiceService.getConfig(new Callback<EInvoiceConfig>() {
                @Override
                public void onSuccess(EInvoiceConfig eInvoiceConfig) {
                    EInvoice2.setBaseUrl(eInvoiceConfig.baseUrl());
                    GeneralSettings.INSTANCE.setInvoiceUrl(eInvoiceConfig.baseUrl());

                    callback.onSuccess("");
                }

                @Override
                public void onError(Throwable throwable) {
                    LoggerUtils.getLogger().error("获取电子发票服务地址失败:" + throwable.toString());
                    callback.onError("获取电子发票服务地址失败:" + throwable.getMessage());
                }
            });
        }
    }

    public void pluQueryWithCheck(String pluCode) {
        if (getSale() == null || StringUtils.isEmpty(getSale().getAccDate())) {
            showHintDialog("未获取当前结账日期，请返回重试");
            return;
        }

        if (StringUtils.isEmpty(pluCode)) {
            showHintDialog("商品条码不能为空");
            return;
        }

        if (getSale().pluSize() == 0) {
            checkSaleNo(new UniCallback() {
                @Override
                public void onSuccess(String msg) {
                    if (StringUtils.isEmpty(msg)) {
                        mMvpView.checkoutSuccess();
                    }

                    pluQuery(pluCode);
                }

                @Override
                public void onError(String err) {
                    showHintDialog(err);
                }
            });
        } else {
            pluQuery(pluCode);
        }
    }

    public synchronized void pluQuery(String pluCode) {
        if (!isViewAttached()) {
            return;
        }

        if (getSale() == null || StringUtils.isEmpty(getSale().getAccDate())) {
            showHintDialog("未获取当前结账日期，请返回重试");
            return;
        }

        if (StringUtils.isEmpty(pluCode)) {
            showHintDialog("商品条码不能为空");
            return;
        }

        String shopCode = GeneralSettings.INSTANCE.isNoShopLimits() ? "" : Config.shop_code;
        LoggerUtils.getLogger().debug(String.format(Locale.CHINESE, "[%s]查询商品: %s", shopCode, pluCode));
        showLoadingDialog();
        String queryType;
        if (GeneralSettings.INSTANCE.isChangePrice()) {
            queryType = "0";
        } else {
            queryType = "1";
        }
        PluService.pluQuery(queryType, getSale().getSaleNo(), getSale().getVip(), pluCode, shopCode, new Callback<BaseSalePluModel>() {
            @Override
            public void onSuccess(BaseSalePluModel pluModel) {
                pluModel.setPluIncode(pluCode);
                checkPluNoCode(pluModel);
                if (BigDecimalUtils.isEquals0(pluModel.getTagPrice())) {
                    isNoCode = true;
                }
            }

            @Override
            public void onError(Throwable throwable) {
                LoggerUtils.getLogger().debug("商品查询异常:" + throwable.toString() + ":" + pluCode);

                if (CommonUtils.isUniformStyle()) {
                    IFlyTtsUtil.start("商品查询失败,请确认条码扫描正确");
                    showHintDialog("商品查询失败", throwable.getMessage() + ":" + pluCode, true);
                } else {
                    showHintDialog("商品查询失败", throwable.getMessage() + ":" + pluCode);
                }

                hideLoadingDialog();
            }
        });
    }

    private void checkPluNoCode(BaseSalePluModel pluModel) {
        //1、微信自助弹出大码商品录入界面
        if (CommonUtils.isWxStyle()) {
            if (BigDecimalUtils.isEquals0(pluModel.getTagPrice())) {
                if (GeneralSettings.INSTANCE.isNoCodePrice()) {
                    LoggerUtils.getLogger().info("大码商品");
                    hideLoadingDialog();
                    mMvpView.pluQueryNoCode(pluModel);
                } else {
                    LoggerUtils.getLogger().info("商品价格为0");
                    hideLoadingDialog();
                    showHintDialog("商品价格不能为0");
                }

                return;
            }
        } else if (!CommonUtils.isUniformStyle()) {

            //2、后台返回价格为0，弹出大码商品录入界面
            //3、非标准版称重商品，弹出大码商品录入界面（标准版进行称重）
            if (BigDecimalUtils.isEquals0(pluModel.getTagPrice()) || pluModel.isWeightNoCode() || GeneralSettings.INSTANCE.isChangePrice()) {
                LoggerUtils.getLogger().info("进入价格录入界面");
                hideLoadingDialog();
                mMvpView.pluQueryNoCode(pluModel);
                return;
            }

        }

        checkPluVipDiscount(pluModel);
    }

    public void checkPluVipDiscount(BaseSalePluModel pluModel) {
        if (getSale().getVip() != null) {
            if (WebApi.isAmwAndAip() || GeneralSettings.INSTANCE.isChangePrice()) {
                queryVipDiscount2(Arrays.asList(pluModel), new GlobalCallback<PromotionCalcModel>() {
                    @Override
                    public void onSuccess(PromotionCalcModel promotionCalcModel) {
                        hideLoadingDialog();
                        pluModel.clearPluDsc();
                        if (null == promotionCalcModel) {
                            showHintDialog("促销返回信息为空");
                            return;
                        }
                        for (SalePluModel salePluModel : promotionCalcModel.getPlu()) {
                            if (!ListUtils.isEmpty(salePluModel.getPluDscs())) {
                                for (SalePluDscModel salePluDscModel : salePluModel.getPluDscs()) {
                                    pluModel.addPluDsc(salePluDscModel);
                                }

                            }
                        }

                        addPluItem(pluModel);
                    }

                    @Override
                    public void onError(String message) {
                        hideLoadingDialog();
                        //FIXME null 改成中间件返回成功，优惠列表为空
                        if (!StringUtils.isEmpty(message) && message.contains("无促销")) {
                            addPluItem(pluModel);
                            return;
                        }

                        showHintDialog(message);
                    }
                });
            } else {
                queryVipDiscount(Arrays.asList(pluModel), new GlobalCallback<List<SalePluDscModel>>() {
                    @Override
                    public void onSuccess(List<SalePluDscModel> salePluDscModels) {
                        hideLoadingDialog();
                        pluModel.replacePluDsc(0, salePluDscModels.get(0));
                        addPluItem(pluModel);
                    }

                    @Override
                    public void onError(String message) {
                        hideLoadingDialog();
                        //FIXME null 改成中间件返回成功，优惠列表为空
                        if (!StringUtils.isEmpty(message) && message.contains("无促销")) {
                            addPluItem(pluModel);
                            return;
                        }

                        showHintDialog(message);
                    }
                });
            }
        } else {
            hideLoadingDialog();
            addPluItem(pluModel);
        }
    }

    public void reCalcVipDiscount() {
        showLoadingDialog();
        if (WebApi.isAmwAndAip() || GeneralSettings.INSTANCE.isChangePrice()) {
            queryVipDiscount2(getSale().getPlus(), new GlobalCallback<PromotionCalcModel>() {
                @Override
                public void onSuccess(PromotionCalcModel promotionCalcModel) {
                    getSale().clearPluDsc();
                    if (null == promotionCalcModel) {
                        showHintDialog("促销返回信息为空");
                        return;
                    }
                    for (SalePluModel salePluModel : promotionCalcModel.getPlu()) {
                        if (!ListUtils.isEmpty(salePluModel.getPluDscs())) {
                            getSale().updatePluDsc(salePluModel.getPluDscs());
                        }
                    }
                    mMvpView.updateAdapter();
                    updateTotal();
                    hideLoadingDialog();
                }

                @Override
                public void onError(String message) {
                    //FIXME null 改成中间件返回成功，优惠列表为空
                    if (!StringUtils.isEmpty(message) && !message.contains("无促销")) {
                        showHintDialog(message);
                    }
                    hideLoadingDialog();
                }
            });
        } else {
            queryVipDiscount(getSale().getPlus(), new GlobalCallback<List<SalePluDscModel>>() {
                @Override
                public void onSuccess(List<SalePluDscModel> salePluDscModels) {
                    for (SalePluDscModel pluDscModel : salePluDscModels) {
                        for (BaseSalePluModel pluModel : getSale().getPlus()) {
                            if (pluModel.getPluId().equals(pluDscModel.getPluId())) {
                                SalePluDscModel pluDscModelTemp = pluDscModel.clone();
                                pluModel.updateCalcPluDsc(pluDscModelTemp);
                                if (BigDecimalUtils.isLessAndEquals(pluModel.getTotal(), pluDscModelTemp.getTotalDsc())) {
                                    showHintDialog("优惠后商品金额不能为 0");
                                    return;
                                }

                                pluModel.replacePtxsDsc(pluDscModelTemp);
                                getSale().updatePlu(pluModel);
                            }
                        }
                    }

                    mMvpView.updateAdapter();
                    updateTotal();
                    hideLoadingDialog();
                }

                @Override
                public void onError(String message) {
                    //FIXME null 改成中间件返回成功，优惠列表为空
                    if (!StringUtils.isEmpty(message) && !message.contains("无促销")) {
                        showHintDialog(message);
                    }
                    hideLoadingDialog();
                }
            });
        }
    }


    private void queryVipDiscount(List<BaseSalePluModel> pluModels, GlobalCallback<List<SalePluDscModel>> callback) {
        if (mMvpView == null || getSale() == null || getSale().getVip() == null || ListUtils.isEmpty(pluModels)) {
            LoggerUtils.getLogger().debug("未输入商品，不需要促销计算");
            hideLoadingDialog();
            return;
        }

        showLoadingDialog();
        String saleNo = getSale().getSaleNo();
        PluService.pluDiscount(Config.shop_id, saleNo, getSale().getVip(), pluModels, new Callback<List<SalePluDscModel>>() {
            @Override
            public void onSuccess(List<SalePluDscModel> pluDscModels) {
                LoggerUtils.getLogger().error("原会员促销回调成功");
                if (mMvpView != null) {
                    hideLoadingDialog();
                }
                callback.onSuccess(pluDscModels);
            }

            @Override
            public void onError(Throwable throwable) {
                if (mMvpView != null) {
                    hideLoadingDialog();
                }
                LoggerUtils.getLogger().error("获取会员促销失败:" + throwable.toString());

                callback.onError("获取会员促销失败:" + throwable.getMessage());
            }
        });
    }

    private void queryVipDiscount2(List<BaseSalePluModel> pluModels, GlobalCallback<PromotionCalcModel> callback) {
        if (mMvpView == null || getSale() == null || getSale().getVip() == null || ListUtils.isEmpty(pluModels)) {
            LoggerUtils.getLogger().error("获取录入时促销_数据为空返回");
            hideLoadingDialog();
            return;
        }

        showLoadingDialog();
        SaleService.promotionCalc(CalcType.Enter, pluModels, GeneralSettings.INSTANCE.getTotalDiscountWay(), new Callback<PromotionCalcModel>() {
            @Override
            public void onSuccess(PromotionCalcModel promotionCalcModel) {
                LoggerUtils.getLogger().error("获取录入时促销接口成功");
                callback.onSuccess(promotionCalcModel);
                if (mMvpView != null) {
                    hideLoadingDialog();
                }
            }

            @Override
            public void onError(final Throwable throwable) {
                if (mMvpView != null) {
                    hideLoadingDialog();
                }
                LoggerUtils.getLogger().error("获取录入时促销失败:" + throwable.toString());

                callback.onError("获取录入时促销失败:" + throwable.getMessage());
            }
        });
    }

    /**
     * 添加销售商品。
     *
     * @param pluModel 待添加的商品
     */
    private void addPluItem(BaseSalePluModel pluModel) {
        if ("0".equals(pluModel.getTotal())) {
            showHintDialog("商品金额不能为 0");
            return;
        }
        if (isMerge(pluModel)) {
            for (BaseSalePluModel pluModel1 : getSale().getPlus()) {
                if (null == pluModel1.getPluId()) {
                    showHintDialog("商品id不能为空，请先设置商品id");
                    return;
                }
                if (pluModel1.getPluId().equals(pluModel.getPluId()) && TextUtils.isDigitsOnly(pluModel1.getQuantity())) {
                    increase(pluModel1.getItemNo() - 1);
                    LoggerUtils.getLogger().debug(String.format(Locale.CHINESE, "合并商品: %s, 行号：%d", pluModel.getPluCode(), pluModel1.getItemNo()));
                    //showHintDialog("合并商品 编码：" + pluModel1.getPluCode() + "，行号：" + pluModel1.getItemNo());
                    updateTotal();
                    mMvpView.scrollListToPosition(pluModel1.getItemNo() - 1);
                    return;
                }
            }
        }
        getSale().addPlu(pluModel);
        int itemNo = getSale().getPlus().size();
        if (!isViewAttached()) {
            LoggerUtils.getLogger().debug("销售界面被finish");
            return;
        }
        mMvpView.addPlu(itemNo - 1, getSale().getPlus().get(itemNo - 1));
        LoggerUtils.getLogger().debug(String.format(Locale.CHINESE, "添加商品: %s, 行号：%d", pluModel.getPluCode(), itemNo));
        mMvpView.scrollListToBottom();
        updateTotal();
    }

    private Boolean isMerge(BaseSalePluModel pluModel) {
        if (GeneralSettings.INSTANCE.isPluMerge()
                && !GeneralSettings.INSTANCE.isChangePrice()
                && !pluModel.isWeight()
                && !isNoCode
                && TextUtils.isDigitsOnly(pluModel.getQuantity())) {

            return true;
        } else {
            isNoCode = false;
            return false;
        }
    }

    private void updateTotal() {
        mMvpView.updateTotal(getSale().calcCount(), getSale().getTotalDsc(), getSale().getTotalRecv());
    }

    private void removePlu(int position) {
        getSale().removePlu(position);
        mMvpView.removePlu(position);
        mMvpView.updateAdapter();
        updateTotal();
    }

    private void increase(int position) {
        getSale().increasePlu(position);
        mMvpView.changeQuantity(position);
        mMvpView.updateAdapter();
        updateTotal();
    }

    private void decrease(int position) {
        getSale().decreasePlu(position);
        mMvpView.changeQuantity(position);
        mMvpView.updateAdapter();
        updateTotal();
    }

    private void callPay(View view, CalcType calcType) {
        if (getSale().isNotValid() && !GeneralSettings.INSTANCE.isZeroPriceSale()) {
            mMvpView.checkoutError();
            showHintDialog("优惠后金额不能为0");
            return;
        }

        if (!NetUtils.isNetworkAvailable()) {
            mMvpView.checkoutError();
            showHintDialog("网络错误", "请检查网络");
            return;
        }

        //合计时才计算舍分优惠
        if (calcType.isTotal()) {
            abandonFenDsc();
        }
        updateTotal();

        //如果传入的 view != null ，需要回到销售页面，根据调用接口的控件进行不同处理
        if (view != null) {
            mMvpView.promotionCalcSuccess(view);
            return;
        }

        mMvpView.callPayActivity();
    }

    public boolean checkPermissionCode(Intent intent) {
        Bundle bundle = intent.getExtras();

        if (bundle != null && bundle.containsKey("permissionCode")) {
            String permissionCode = bundle.getString("permissionCode");
            if (permissionCode != null && permissionCode.equals(GeneralSettings.INSTANCE.GetPermissionCode())) {
                return true;
            } else {
                hideLoadingDialog();
                showHintDialog("授权码错误");
            }
        } else {
            hideLoadingDialog();
            showHintDialog("获取授权码失败");
        }

        return false;
    }

    public void rePrintBill(String code) {
        if (!code.equals(GeneralSettings.INSTANCE.GetPermissionCode())) {
            showHintDialog("录入的授权码不正确");
            return;
        }

        List<String> printList = LoadSDCard.loadTxtFile(SDCardConstants.PRINTER_BILL_PATH, 1);
        if (printList != null && printList.size() > 0) {

            printList.add(0, "******************重打小票******************");

            IPrintProvider printProvider = PrintProvider.createPrintProvider();

            ThreadFactoryUtils.getExecutorService("print-%d").execute(() -> {
                        try {
                            Printer.print(printProvider, printList, null);
                        } catch (Exception e) {
                            showHintDialog("重打失败", e.getMessage());
                        }
                    }
            );
        } else {
            showHintDialog("未找到上笔流水小票", "请联系收银员");
        }
    }

    public void pluAdjust(int position, boolean add) {
        if (getSale().getPlu(position).isWeightGoods()) {
            showHintDialog("称重商品禁止修改数量");
            return;
        }

        BaseSalePluModel pluModel = getSale().getPlu(position);
        String quantity;
        if (add) {
            quantity = pluModel.increaseQuantity();
        } else {
            quantity = pluModel.decreaseQuantity();
        }

        if (BigDecimalUtils.isLessAndEquals(quantity, "0")) {
            return;
        }

        mMvpView.setPluDeleteEnabled(false);
        PluService.pluAdjust(pluModel, quantity, getSale().getSaleNo(), GeneralSettings.INSTANCE.getOperator(),
                new Callback<PluAdjustResultData>() {
                    @Override
                    public void onSuccess(PluAdjustResultData resultData) {
                        if (add) {
                            increase(position);
                        } else {
                            decrease(position);
                        }

                        mMvpView.setPluDeleteEnabled(true);
                    }

                    @Override
                    public void onError(Throwable throwable) {
                        mMvpView.setPluDeleteEnabled(true);

                        showHintDialog("调整数量失败", throwable.getMessage());
                    }
                });
    }

    public void pluDelete(int position) {
        showLoadingDialog();
        PluService.pluDelete(getSale().getSaleNo(), getSale().getPlu(position), new Callback<PluDeleteResultData>() {
            @Override
            public void onSuccess(PluDeleteResultData pluDeleteResultData) {
                removePlu(position);
                hideLoadingDialog();
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
                LoggerUtils.getLogger().error("商品删除失败:" + throwable.toString());
                showHintDialog("商品删除失败:" + throwable.getMessage());
            }
        });
    }

    public void saleCancel() {
        showLoadingDialog();

        if (getSale() == null || StringUtils.isEmpty(getSale().getSaleNo())) {
            resetSaleModel();
            return;
        }

        SaleService.saleCancel(getSale().getSaleNo(), GeneralSettings.INSTANCE.getOperator(), new Callback<Object>() {
            @Override
            public void onSuccess(Object o) {
                hideLoadingDialog();
                resetSaleModel();
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
                LoggerUtils.getLogger().error("取消交易失败:" + throwable.toString());
                showHintDialog("取消交易失败:" + throwable.getMessage());
            }
        });
    }

    public void checkSaleNo() {
        checkSaleNo((View) null);
    }

    public void checkSaleNo(View view) {
        if (getSale() == null || getSale().pluSize() == 0) {
            LoggerUtils.getLogger().debug("请先录入商品，再结算");
            showHintDialog("请先录入商品，再结算");
            mMvpView.checkoutError();
            return;
        }

        showLoadingDialog();
        checkSaleNo(new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                if (StringUtils.isEmpty(msg)) {
                    mMvpView.checkoutSuccess();
                } else {
                    promotionCalc(view);
                }
            }

            @Override
            public void onError(String err) {
                mMvpView.checkoutError();
                showHintDialog(err);
                hideLoadingDialog();
            }
        });
    }

    public void promotionCalc() {
        promotionCalc(null, CalcType.Total);
    }

    private void promotionCalc(View view) {
        promotionCalc(view, CalcType.Total);
    }

    public void promotionCalc(View view, CalcType calcType) {
        if (getSale() == null) {
            showHintDialog("订单异常，请点击左上方退出按钮重新交易");
            mMvpView.checkoutError();
            return;
        }

        getSale().removeAbandonFenDsc();
        if (getSale().isNotValid() && !GeneralSettings.INSTANCE.isZeroPriceSale()) {
            showHintDialog("待支付金额为0");
            mMvpView.checkoutError();
            return;
        }

        showLoadingDialog();
        SaleService.promotionCalc(calcType, getSale().getPlus(), GeneralSettings.INSTANCE.getTotalDiscountWay(), new Callback<PromotionCalcModel>() {
            @Override
            public void onSuccess(PromotionCalcModel promotionCalcModel) {
                getSale().clearPluDsc();

                for (SalePluModel promotionPluModel : promotionCalcModel.getPlu()) {
                    for (int i = 0; i < getSale().getPlus().size(); i++) {
                        if (promotionPluModel.getItemNo() == getSale().getPlu(i).getItemNo() && promotionPluModel.getPageNo() == getSale().getPlu(i).getPageNo()) {
                            getSale().getPlu(i).setTagPrice(promotionPluModel.getTagPrice());
                            getSale().getPlu(i).setPrice(promotionPluModel.getPrice());
                            getSale().getPlu(i).setQuantity(promotionPluModel.getQuantity());
                            getSale().getPlu(i).setTotal(promotionPluModel.getTotal());
                            getSale().getPlu(i).setTotalRecv(promotionPluModel.getTotalRecv());
                            getSale().getPlu(i).setTotalDsc(promotionPluModel.getTotalDsc());

                            for (SalePluDscModel salePluDscModel : promotionPluModel.getPluDscs()) {
                                getSale().getPlu(i).addPluDsc(salePluDscModel);
                            }
                        }
                    }
                }
                getSale().calcTotal();
                getSale().setPluGiftActions(promotionCalcModel.getPluGiftActions());

                if (calcType.isEnter()) {
                    mMvpView.updateAdapter();
                    updateTotal();
                    hideLoadingDialog();
                    return;
                }

                callPay(view, calcType);
                hideLoadingDialog();
            }

            @Override
            public void onError(final Throwable throwable) {
                hideLoadingDialog();
                mMvpView.checkoutError();

                if (calcType.isEnter()) {
                    showHintDialog("记录录入时促销失败:" + throwable.toString());
                    return;
                }

                LoggerUtils.getLogger().error("调用整单促销计算接口失败:" + throwable.toString());
                showHintConfirm("整单促销计算失败,是否继续支付?\n" + throwable.getMessage(), new UniCallback() {
                    @Override
                    public void onSuccess(String msg) {
                        callPay(view, calcType);
                    }

                    @Override
                    public void onError(String err) {

                    }
                });
            }
        });
    }

    private void abandonFenDsc() {
        getSale().addAbandonFenDsc(GeneralSettings.INSTANCE.getCurrencyPrecision().value());
        mMvpView.updateAdapter();
        updateTotal();
    }

    /**
     * 检查结账日期与流水号日期是否相同
     *
     * @param callback
     */
    private void checkSaleNo(UniCallback callback) {
        showLoadingDialog();
        SaleService.getAccountingDate(new Callback<String>() {
            @Override
            public void onSuccess(String accDate) {
                hideLoadingDialog();
                if (accDate.equals(getSale().getAccDate())) {

                    Date curDate = new Date();
                    int timeVar = 1000 * 60;
                    long Interval = 0;
                    try {
                        Interval = ((curDate.getTime() - DateUtils.dateParse(getSale().getSaleTime()).getTime()) / timeVar);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    if (Interval > 30) {
                        getSale().setSaleTime(DateUtils.dateFormat());
                    }

                    callback.onSuccess(accDate);
                } else {
                    SaleNoService.abandon();
                    createNewSale(accDate, getSale().getVip(), getSale().getTranType(), new UniCallback() {
                        @Override
                        public void onSuccess(String s) {
                            callback.onSuccess(s);
                        }

                        @Override
                        public void onError(String message) {
                            callback.onError(message);
                        }
                    });
                }
            }

            @Override
            public void onError(Throwable throwable) {
                hideLoadingDialog();
                LoggerUtils.getLogger().error("获取结账日期失败:" + throwable.toString());
                callback.onError("获取结账日期失败，请重试:" + throwable.getMessage());
            }
        });
    }

    public void updateAllUi() {
        mMvpView.updateAdapter();
        updateTotal();

        mMvpView.updateVipInfo(getSale().getVip());
    }

    public void addShoppingBag(String pluCode) {
        if (StringUtils.isEmpty(pluCode)) {
            showHintDialog("未配置购物袋条码", "请联系收银员");
            return;
        }

        pluQuery(pluCode);
    }

    private SaleApplicationService saleApplicationService;
    private CountDownLatch printerLatch;                    //同步多个任务，都执行完之后再进行其他任务
    private int hasCoupons;                                 //券是否操作完成，默认-1；成功1；失败0
    private int hasPoints;                                  //积分是否操作完成，默认-1；成功1；失败0
    private int hasUploaded;                                //流水是否上传，默认-1；成功1；失败0

    public void saleSubmit() {
        showLoadingDialog();

        //保存本地流水
        uSaveData();

        Service.online(100, 3000, new RetryCallback<OnlineResultData>() {
            @Override
            public void onSuccess(OnlineResultData service) {
                printerLatch = new CountDownLatch(3);

                mMvpView.hideProgressDialog();

                hasCoupons = -1;
                hasPoints = -1;
                hasUploaded = -1;

                print();

                saleComplete();
                calcCoupons();
                realTimePoint();
                submit();
            }

            @Override
            public void onProgress(int i, final String s) {
                // 报告服务重试状态。由于重试在新线程中运行，显示状态时需同步到UI线程。
                mMvpView.showProgressDialogNoHide(s);
                LoggerUtils.getLogger().info(s);
            }

            @Override
            public void onError(final Throwable throwable) {
                mMvpView.onlineFail(throwable.getMessage());
                // 达到最大重试次数后仍然无法连接服务。由于重试在新线程中运行，显示状态时需同步到UI线程。
                mMvpView.hideProgressDialog();
                showHintDialog("无法上传流水：" + throwable.getMessage());
                LoggerUtils.getLogger().error("无法上传流水：" + throwable.toString());

                hasCoupons = 0;
                hasPoints = 0;
                hasUploaded = 0;
                resetSaleModelForYsyUpSale();
            }
        });
    }

    /**
     * 交易完成，用于更新限量次数
     */
    private void saleComplete() {
        try {
            LoggerUtils.getLogger().debug("进入完成接口逻辑");
            List<CompletePluDscData> pluDsc = new ArrayList<>();
            for (BaseSalePluModel pluModel : getMainSaleModel().getSaleModel().getPlus()) {
                for (int i = 0; i < pluModel.pluDscSize(); i++) {
                    SalePluDscModel pluDscModel = pluModel.getPluDsc(i);

                    CompletePluDscData pluDscData = new CompletePluDscData();
                    pluDscData.setDscCode(pluDscModel.getDscCode());
                    pluDscData.setDscProType(pluDscModel.getDscProType());
                    pluDscData.setDscNum(pluDscModel.getDscNum());
                    pluDscData.setPluCode(pluModel.getPluCode());
                    pluDscData.setGlobalType(pluDscModel.getGlobalType());
                    pluDsc.add(pluDscData);
                }
            }
            if (!ListUtils.isEmpty(pluDsc)) {
                LoggerUtils.getLogger().debug("有优惠，调用完成接口");
                String vipCardNo = getMainSaleModel().getSaleModel().getVip() == null
                        ? null
                        : getMainSaleModel().getSaleModel().getVip().card().vipCardNo();

                SaleService.saleComplete(getMainSaleModel().getSaleModel().getSaleNo(),
                        vipCardNo,
                        getMainSaleModel().getSaleModel().getSaleDate(),
                        pluDsc,
                        new Callback<Object>() {
                            @Override
                            public void onSuccess(Object o) {
                                LoggerUtils.getLogger().debug("完成接口成功");
                            }

                            @Override
                            public void onError(Throwable throwable) {
                                LoggerUtils.getLogger().debug("完成接口失败：" + throwable.getMessage());
                            }
                        });
            } else {
                LoggerUtils.getLogger().debug("无优惠，不调用完成接口");
            }
        } catch (Exception e) {
            NetUtils.printDetail("交易完成逻辑:", e);
        }
    }

    public void print() {
        try {
            PrinterHelper.getInstance().print(getSale(), printerLatch);

            LoggerUtils.getLogger().debug("##########打印锁初始化############");
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("打印出现异常" + e.toString());
        }
    }

    private void calcCoupons() {
        if (!GeneralSettings.INSTANCE.isCalcCoupon()) {
            hasCoupons = 1;
            printerLatch.countDown();
            resetSaleModelForYsyUpSale();
            return;
        }

        LoggerUtils.getLogger().debug("启用赠券");
        SaleService.rebate(new Callback<Collection<ICoupon>>() {
            @Override
            public void onSuccess(Collection<ICoupon> coupons) {
                LoggerUtils.getLogger().debug("赠券接口调用成功");
                Collection<Coupon> couponsTmp = new ArrayList<>();
                Collection<GiftCoupon> giftCouponsTmp = new ArrayList<>();
                for (ICoupon coupon : coupons) {
                    if (coupon instanceof Coupon) {
                        couponsTmp.add((Coupon) coupon);
                    } else if (coupon instanceof GiftCoupon) {
                        giftCouponsTmp.add((GiftCoupon) coupon);
                    }
                }

                SaleActivity.couponMap.put(getSale().getSaleNo(), couponsTmp);
                SaleActivity.giftCouponMap.put(getSale().getSaleNo(), giftCouponsTmp);

                hasCoupons = 1;
                printerLatch.countDown();
                resetSaleModelForYsyUpSale();
            }

            @Override
            public void onError(Throwable t) {
                LoggerUtils.getLogger().error("赠券计算失败：" + t.toString());
                showHintDialog("赠券计算失败：" + t.getMessage());
                hasCoupons = 0;
                printerLatch.countDown();
                resetSaleModelForYsyUpSale();
            }
        });
    }

    private void realTimePoint() {
        if (!(getSale().isVip() && GeneralSettings.INSTANCE.isRealTimePointEnabled())) {
            getSale().setExpensePoint("0");
            getSale().setParkingPoint("0");
            getSale().setCouponPoint("0");
            hasPoints = 1;
            printerLatch.countDown();
            resetSaleModelForYsyUpSale();
            return;
        }

        VipService.realTimePoint(new Callback<RealTimePoint>() {
            @Override
            public void onSuccess(RealTimePoint point) {
                LoggerUtils.getLogger().debug("消费积分：" + point.expense() + "  停车积分：" + point.parking() + "  赠券积分：" + point.coupon());
                getSale().setExpensePoint(point.expense());
                getSale().setParkingPoint(point.parking());
                getSale().setCouponPoint(point.coupon());

                PrinterHelper.getInstance().refreshSaleModel(getSale());
                hasPoints = 1;
                printerLatch.countDown();
                resetSaleModelForYsyUpSale();
            }

            @Override
            public void onError(Throwable throwable) {
                LoggerUtils.getLogger().error("积分实时积分计算失败:" + throwable.toString());
                showHintDialog("积分实时积分计算失败:" + throwable.getMessage());
                hasPoints = 0;
                printerLatch.countDown();
                resetSaleModelForYsyUpSale();
            }
        });
    }

    private void submit() {
        if (saleApplicationService == null) {
            saleApplicationService = new SaleApplicationService(mMvpView.getContext());
        }

        saleApplicationService.upload(getMainSaleModel().getSaleModel(), new Callback<SaleSubmitResultData>() {
            @Override
            public void onSuccess(SaleSubmitResultData submitResultData) {
                if (submitResultData != null) {
                    Collection<Coupon> couponsTmp = new ArrayList<>();
                    Collection<GiftCoupon> giftCouponsTmp = new ArrayList<>();
                    if (submitResultData.iCoupons != null) {
                        for (ICoupon coupon : submitResultData.iCoupons) {
                            if (coupon instanceof Coupon) {
                                couponsTmp.add((Coupon) coupon);
                            } else if (coupon instanceof GiftCoupon) {
                                giftCouponsTmp.add((GiftCoupon) coupon);
                            }

                        }
                    }
                    SaleActivity.couponMap.put(getSale().getSaleNo(), couponsTmp);
                    SaleActivity.giftCouponMap.put(getSale().getSaleNo(), giftCouponsTmp);

                    getSale().setExpensePoint(submitResultData.tradePoints);
                    getSale().setParkingPoint("0");
                    getSale().setCouponPoint("0");
                    getSale().setVipPoints(submitResultData.totalPoints);
                }

                PrinterHelper.getInstance().refreshSaleModel(getSale());
                showHintDialog("上传成功，流水：" + getSale().getSaleNo());
                LoggerUtils.getLogger().debug("流水上传成功:" + getSale().getSaleNo());

                hasUploaded = 1;
                printerLatch.countDown();
                resetSaleModelForYsyUpSale();
            }

            @Override
            public void onError(Throwable throwable) {
                showHintConfirm("流水上传", "流水上传失败:" + throwable.getMessage() + ",请确认流水是否已上传，若未上传请重试", new UniCallback() {
                    @Override
                    public void onSuccess(String msg) {
                        showLoadingDialog();
                        submit();
                    }

                    @Override
                    public void onError(String err) {
                        LoggerUtils.getLogger().error(String.format(Locale.CHINESE, "流水[%s]上传失败: %s",
                                getSale().getSaleNo(), throwable.getMessage()));

                        hasUploaded = 0;
                        printerLatch.countDown();
                        resetSaleModelForYsyUpSale();
                    }
                });
            }
        });
    }

    /**
     * 交易完成后保存交易数据
     */
    private void uSaveData() {
        LoggerUtils.getLogger().error("交易完成后开始保存流水号");
        SaleNoService.save(mMvpView.getContext(), Config.org_code, Config.pos_no, getSale().getSaleNo());
        LoggerUtils.getLogger().error("交易完成后保存流水号成功");
        try {
            new SaleRepository(mMvpView.getContext()).save(getMainSaleModel().getSaleModel());
            LoggerUtils.getLogger().error("保存数据成功");
        } catch (Exception e) {
            LoggerUtils.getLogger().error("保存数据出错:" + e.toString());
            LoggerUtils.getLogger().error("出错流水数据:" + JSONObject.toJSONString(getSale()));
        }
    }

    public void reSubmit() {
        if (saleApplicationService == null) {
            saleApplicationService = new SaleApplicationService(mMvpView.getContext());
        }

        showLoadingDialog();
        saleApplicationService.reSubmit(new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                hideLoadingDialog();
                CommonTools.toastShort(msg);
                mMvpView.reSubmitSuccess(msg);
            }

            @Override
            public void onError(String err) {
                hideLoadingDialog();
                showHintDialog(err);
                mMvpView.reSubmitFail(err);
            }
        });
    }

    /**
     * 刷新未上传流水小红点
     */
    public void refreshUnloadPoint(View view) {
        if (badgeView == null) {
            badgeView = new BadgeView(mMvpView.getContext());
        }
        if (saleApplicationService == null) {
            saleApplicationService = new SaleApplicationService(mMvpView.getContext());
        }
        int count = saleApplicationService.localUnUploadSize();
        if (count > 0) {
            badgeView.setTargetView(view);
            //设置相对位置
            badgeView.setBadgeMargin(0, 5, 15, 0);
            //设置显示未读消息条数
            badgeView.setBadgeCount(count);
        } else {
            badgeView.setVisibility(View.INVISIBLE);
        }
    }

    public void payPay(String totalPaid, String authCode) {
        if (mSelectedPayMethod == null) {
            showHintDialog("支付方式错误，请重新选择支付方式");
            return;
        }

        if (!CommonUtils.authCodeType(authCode).equalsIgnoreCase(mSelectedPayMethod.remark())) {
            showHintDialog("请重新扫" + mSelectedPayMethod.name() + "付款码");
            return;
        }
        showLoadingDialog();
        String scene = AliConstants.ALI_PAY_BAR_CODE;
        String outTradeNo = CommonUtils.genOutTradeNo(Config.org_code, getSale().getSaleNo());
        String saleTime = DateUtils.dateFormat();
        try {
            PayService.payPay(authCode, null, outTradeNo, totalPaid, mSelectedPayMethod.payRemark(), saleTime, scene,
                    "快捷支付", null, GeneralSettings.INSTANCE.getTerminalId(), new Callback<PayResultData>() {
                        @Override
                        public void onSuccess(PayResultData payResultData) {
                            handleResult(payResultData);
                        }

                        @Override
                        public void onError(Throwable throwable) {
                            payPayError(outTradeNo, scene, saleTime, throwable);
                        }
                    });
        } catch (Exception e) {
            showHintDialog("调用下单支付接口异常" + e.getMessage());
            hideLoadingDialog();
            LoggerUtils.getLogger().debug("调用下单支付接口异常" + e.toString());
        }
    }

    private void payPayError(String outTradeNo, String scene, String saleTime, Throwable throwable) {
        hideLoadingDialog();
        LoggerUtils.getLogger().error("下单支付接口调用失败:" + throwable.toString());
        CommonTools.toastShort("下单支付接口调用失败:" + throwable.toString());
        if (NetUtils.isNeedQuery(((WebApiException) throwable).code())) {
            showHintConfirm("订单状态未知，查询请点击【确定】。" + throwable.getMessage(), new UniCallback() {
                @Override
                public void onSuccess(String msg) {
                    LoggerUtils.getLogger().error("下单支付接口调用失败,点击确定" + msg);
                    payQuery(outTradeNo, scene, saleTime);
                }

                @Override
                public void onError(String err) {
                    LoggerUtils.getLogger().error("下单支付接口调用失败:" + err);
                }
            });

            return;
        }

        if (NetUtils.isNetException(throwable.getCause()) || throwable.getMessage().contains(PayConstants.FAILED_TO_CONNECT_TO_IP)) {
            showLoadingDialog();
            // 无法连接服务时，自动重试。当前定义重试次数为100，间隔时间3秒，共等待5分钟。
            Service.online(100, 3000, new RetryCallback<OnlineResultData>() {
                @Override
                public void onSuccess(OnlineResultData service) {
                    hideLoadingDialog();
                    payQuery(outTradeNo, scene, saleTime);
                    LoggerUtils.getLogger().debug("下单支付接口调用失败，继续轮询");
                }

                @Override
                public void onProgress(int i, final String s) {
                    mMvpView.showProgressDialogNoHide(s);
                    LoggerUtils.getLogger().info(s);
                }

                @Override
                public void onError(Throwable throwable) {
                    hideLoadingDialog();
                    mMvpView.hideProgressDialog();
                    showHintDialog("无法查询支付状态,请联系管理员处理");
                }
            });

            return;
        }

        showHintDialog("支付失败", throwable.getMessage());
    }

    private void payQuery(String outTradeNo, String scene, String saleTime) {
        try {
            showLoadingDialog();
            PayService.payQuery(outTradeNo, mSelectedPayMethod.remark(), scene, saleTime, GeneralSettings.INSTANCE.getTerminalId(), new Callback<PayResultData>() {
                @Override
                public void onSuccess(PayResultData payResultData) {
                    handleResult(payResultData);
                }

                @Override
                public void onError(final Throwable throwable) {
                    hideLoadingDialog();
                    payPayError(outTradeNo, scene, saleTime, throwable);
                    LoggerUtils.getLogger().debug("轮询接口调用失败" + throwable.toString());
                }
            });
        } catch (Exception e) {
            hideLoadingDialog();
            LoggerUtils.getLogger().debug("调用下单支付查询接口出现异常" + e.toString());
        }
    }

    private void handleResult(PayResultData payResultData) {
        SalePayModel payModel = new SalePayModel();
        payModel.setPayCode(mSelectedPayMethod.code());
        payModel.setPayName(mSelectedPayMethod.name());
        payModel.setRemark(mSelectedPayMethod.remark());
        payModel.setPayType(mSelectedPayMethod.payType());
//        payModel.setBuyerLogonId(StringUtils.isEmpty(payResultData.getBuyerLogonId()) ? payResultData.getOutTradeNo() : payResultData.getBuyerLogonId());
        //微信一般为openid, 容易认为是乱码,暂统一使用outtradeNo
        payModel.setBuyerLogonId(payResultData.getOutTradeNo());
        payModel.setOutTradeNo(payResultData.getOutTradeNo());
        payModel.setTradeNo(payResultData.getTradeNo());
        payModel.setPayTime(payResultData.getSaleTime());
        payModel.setTotal(payResultData.getTotal());
        payModel.setTotalRecv(payResultData.getTotal());
        payModel.setTotalPaid(payResultData.getTotal());
        payModel.setTotalDscSelf(payResultData.getTotalDscSelf());
        payModel.setTotalDscChannel(payResultData.getTotalDscChannel());
        getSale().addPay(payModel);

        // 弹框结束会尝试上传流水,所以打印完再调起弹框
        printReceipt(payModel, mSelectedPayMethod.isYdt(), new UniCallback() {
            @Override
            public void onSuccess(String msg) {
                LoggerUtils.getLogger().debug("海信支付-支付-签购单");
                paySuccess(payModel);
            }

            @Override
            public void onError(String err) {
                LoggerUtils.getLogger().debug("海信支付-支付-签购单");
                paySuccess(payModel);
            }
        });
    }

    public void paySuccess(SalePayModel payModel) {
        LoggerUtils.getLogger().debug(payModel.getPayName() + payModel.getRemark() + "付款金额：" + payModel.getTotalRecv() +
                ",已付金额：" + getSale().getTotalPaid() +
                ",未付金额：" + getSale().getTotalUnPaid());

        if (BigDecimalUtils.isGreater0(getSale().getTotalUnPaid())) {
            mMvpView.callPayActivity();
            return;
        }

        try {
            saleSubmit();
        } catch (Exception ex) {
            LoggerUtils.getLogger().error("流水上传异常：" + ex.toString());

            //获取新的流水号
            SaleNoService.abandon();
            resetSaleModel();
            mMvpView.submitFail("流水上传异常：" + ex.getMessage());
            showHintDialog("流水上传失败,稍后将会自动重传");
        }
    }

    private void printReceipt(final SalePayModel payment, boolean isYdt, final UniCallback callback) {
        if (isYdt || !GeneralSettings.INSTANCE.printHXPayReceipt() || payment == null || payment.getPayCode() == null) {
            LoggerUtils.getLogger().debug("海信支付原始数据为空或者选项关闭或者一点通,不打印签购单");
            hideAndCallback(callback);
            return;
        }

        try {
            //打印阻塞了主线程,不放在线程内的话,loading框无法正常运行
            new Thread(new Runnable() {
                @Override
                public void run() {
                    LoggerUtils.getLogger().debug("海信支付打印签购单");
                    PrinterHelper.getInstance().printWithStringList(PayService.getPrintContent(getSale(), payment, null), new UniCallback() {
                        @Override
                        public void onSuccess(String msg) {
                            hideAndCallback(callback);
                        }

                        @Override
                        public void onError(String err) {
                            hideAndCallback(callback);
                        }
                    });
                }
            }).start();

        } catch (Exception e) {
            LoggerUtils.getLogger().debug("海信支付打印签购单异常:" + e.toString());
            hideAndCallback(callback);
        }
    }

    private void hideAndCallback(final UniCallback callback) {
        mMvpView.getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                hideLoadingDialog();
                callback.onSuccess("");
            }
        });
    }
}
