/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.print;

import android.app.Activity;
import android.graphics.Paint;

import com.hisense.common.boot.UniCallback;
import com.hisense.common.util.BigDecimalUtils;
import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.common.util.ThreadFactoryUtils;
import com.hisense.hiaposcmp.App;
import com.hisense.hiaposcmp.activity.ysy.sale.SaleActivity;
import com.hisense.hiaposcmp.config.Config;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.print.Invoice.EInvoice2;
import com.hisense.hiaposcmp.print.bean.CouponPrintBean;
import com.hisense.hiaposcmp.print.bean.CouponUnitBean;
import com.hisense.hiaposcmp.print.bean.GiftCouponPrintBean;
import com.hisense.hiaposcmp.print.bean.HxPayCouponPrintBean;
import com.hisense.hiaposcmp.print.bean.PayMethodPrintBean;
import com.hisense.hiaposcmp.print.bean.SalePluDscPrintBean;
import com.hisense.hiaposcmp.print.bean.SalePluPrintBean;
import com.hisense.hiaposcmp.print.bean.SalePrintBean;
import com.hisense.hiaposcmp.print.engine.ITemplateEngine;
import com.hisense.hiaposcmp.print.engine.impl.DefaultTemplateEngine;
import com.hisense.hiaposcmp.print.engine.impl.ExternalTemplateEngine;
import com.hisense.hiaposcmp.print.printer.IPOSPrinter;
import com.hisense.hiaposcmp.print.printer.impl.LocalPOSPrinter;
import com.hisense.hiaposcmp.print.repository.PrintTemplateRepository;
import com.hisense.hiaposcmp.service.payment.AggregatePaymentChannel;
import com.hisense.hiaposcmp.tool.CommonTools;
import com.hisense.hiaposcmp.util.CommonUtils;
import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.CouponType;
import com.hisense.hipos.coupon.GiftCoupon;
import com.hisense.hipos.coupon.HxPayCoupon;
import com.hisense.hipos.model.BaseSaleModel;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.MainSaleModel;
import com.hisense.hipos.model.ReturnSaleModel;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.model.SalePluDscModel;
import com.hisense.hipos.payment.PayMethod;
import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.template.models.PrintTemplate;
import com.hisense.hipos.template.models.PrintTemplateType;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.CountDownLatch;

/**
 * 打印机Helper类
 *
 * @author guanguangjin 2017-02-25
 * @author dengyunpeng  2017-07-17 HIPOSAPP-118 将打印模板保存在本地SQLite数据库
 * @author xieliyan    2017-10-17 HIPOSAPP-176 当手机号作为会员卡号登陆时，隐藏中间四位
 * @author xieliyan    2017-10-30 HIPOSAPP-181 赠券说明格式调整：根据文本宽度换行
 * @author xieliyan    2017-10-31 HIPOSAPP-201 使用枚举实现单例模式:更改调用方法
 * @author xieliyan    2018-04-12 HIPOSAPP-357 设置中增加"会员打印赠券"开关
 * @author guolina      2018-06-29 HIPOSAPP-597 修复数据类型错误导致的打印闪退
 * @author zhangsai     2018-07-01 HIPOSAPP-612 修改打印模板加载逻辑
 * @author lizhixin     2018-07-16 HIPOSAPP-669 修复当有多张赠券时打印小票的赠券总额计算不正确的问题
 * @author guolina      2018-07-23 HIPOSAPP-672 修复小票第二联专柜联打印份数错误
 * @author guolina      2018-08-08 HIPOSAPP-704 生成二维码为空时添加提示
 * @author guolina      2018-08-09 HIPOSAPP-446 优化实时积分
 * @author zhangsai     2018-08-20 HIPOSAPP-744 修改打开APP后直接进入流水查询打印小票闪退的问题
 * @author guolina      2018-09-26 HIPOSAPP-770 支持销售/退款后增加储值卡和积分余额打印
 * @author guolina      2018-11-14 HIPOSAPP-823 小票增加礼品券打印
 * @author guolina      2018-11-22 HIPOSAPP-835 多任务同步改用CountDownLatch，解决打印慢的问题
 * @author guolina      2018-12-11 HIPOSAPP-850 销售预销售小票增加门店名称打印
 * @author guolina      2018-12-27 HIPOSAPP-839 小票增加促销内容打印，支持聚合支付优惠
 * @author guolina      2019-01-09 HIPOSAPP-968 万科小票增加支持商品单价和优惠后单价打印
 * @author guolina      2019-02-25 HIPOSAPP-1022 专柜联打印联数支持设置
 * @author guolina      2019-03-06 HIPOSAPP-1041 Sale代替Trade，优化代码
 * @author guolina      2019-03-21 HIPOSAPP-1056 万科小票打印字段完善
 * @author wangyaogang  2019-05-31 HIPOSAPP-1114 温州时代-小票增加"本笔交易赠送金额券：总额"
 * @author wangyaogang  2019-06-05 HIPOSAPP-1154 易收银销售小票-打印商品"货号"字段
 * @author wangyaogang  2019-06-04 HIPOSAPP-1146 海信广场-在同一时间范围内，不同赠券活动方案可以灵活选择是否打印赠券,根据isPrint判断
 * @author wangyaogang  2019-06-05 HIPOSAPP-1146 调整逻辑:赠券打印,非会员根据开关状态判断,会员根据isPrint判断
 * @author wangyaogang  2019-06-12 HIPOSAPP-1114 温州时代-小票增加"本笔交易赠送金额券：总额",仅统计金额券
 * @author wangyaogang  2019-06-13 HIPOSAPP-1134 打印剩余可用券remainedCouponList
 * @author zhangsai     2019-06-13 HIPOSAPP-1169 Sale.payments() 返回类型改为 ISalePayment 集合
 * @author wangyaogang  2019-06-24 HIPOSAPP-1090 增加礼品券模板,按照指定格式打印礼品券
 * @author wangyaogang  2019-08-05 HIPOSAPP-1232 打印时支付号码隐藏中间几位
 * @author wangyaogang  2019-08-14 HIPOSAPP-1235 易收银销售小票-打印增加规格和单位
 * @author wangyaogang  2019-08-22 	HIPOSAPP-1284 调整打印时隐藏支付号逻辑，只隐藏银行卡号
 * @author xieliyan     2019-10-18 HIPOSAPP-1328 新增建行直连通道
 * @author wangyaogang  2019-11-15 HIAPOSCMP-289 流水查询不再取绝对值
 * @author wangyaogang  2019-11-12 HIPOSAPP-1342 非银联支付禁止打印凭证号、参考号等无效信息
 * @author wangyaogang  2019-11-15  HIPOSAPP-1343 打印换行问题,多行时使用StaticLayout
 * @author wangyaogang  2019-11-26 HIAPOSCMP-342 修复因totalDscSelf为空,拼接打印数据异常,导致打印数据缺失的问题
 * @author wangyaogang  2019-11-26 HIAPOSCMP-344 修复因scrm流水上传完毕数据处理方法未调用导致的券无法打印问题
 * @author wangyaogang 2019-11-28 HIAPOSCMP-357 【慧收银】小票流水号重复(生成barcode自带内容)，公众号及发票地址二维码未打印(无发票开关)
 * @author wangyaogang 2019-11-28 HIAPOSCMP-355 退货相关数据显示负值
 * @author wangyaogang  2019-11-27 HIAPOSCMP-284 海信支付打印签购单
 * @author guolina      2020-02-21 HIAPOSCMP-541 慧收银支持会员积分打印
 * @author guolina      2020-05-18 HIAPOSCMP-702 吉麦隆淘鲜达营销方案对接涉及慧收银调整增加支付明细和赠券打印
 * @author liuyazeng    2020-09-25 HIAPOSCMP-1065 温州时代-会员券管理中根据促销方案的打印方式设置在控制pos5前台或易收银是否打印会员券
 */
public class PrinterHelper {

    private String receiptTemplate;                    // 小票模板

    private String couponTemplate;                     // 赠券模板
    private String giftCouponTemplate;                 // 赠券模板
    private MainSaleModel mainSaleModel = MainSaleModel.getInstance();

    private BaseSaleModel mBaseSaleModel;
    private int index = 0;

    /**
     * 私有构造方法，不允许外部实例化
     */
    private PrinterHelper() {
    }

    /**
     * 获取PrinterHelper实例对象用单例模式
     *
     * @return PrinterHelper实例
     */
    private static volatile PrinterHelper mInstance;

    public static synchronized PrinterHelper getInstance() {
        if (mInstance == null) {
            synchronized (PrinterHelper.class) {
                if (mInstance == null) {
                    mInstance = new PrinterHelper();
                }
            }
        }
        mInstance.init();
        return mInstance;
    }

    /**
     * 用于解决满赠券,实时积分,流水上传等接口执行完顺序不确定,
     * BaseSaleModel数据不对的问题
     *
     * @param baseSaleModel 交易数据
     */
    public void refreshSaleModel(BaseSaleModel baseSaleModel) {
        this.mBaseSaleModel = baseSaleModel;
    }

    private void setSaleModel(BaseSaleModel saleModel) {
        this.mBaseSaleModel = saleModel;
    }

    private BaseSaleModel getSaleModel() {
        return mBaseSaleModel;
    }

    public synchronized void print(BaseSaleModel saleModel, final CountDownLatch printerLatch) {
        printWithTemplate(saleModel, false, printerLatch, App.getContext(), null);
    }

    public synchronized void print(BaseSaleModel saleModel) {
        printWithTemplate(saleModel, false, null, App.getContext(), null);
    }

    public synchronized void reprint(BaseSaleModel saleModel, UniCallback callback) {
        printWithTemplate(saleModel, true, null, App.getContext(), callback);
    }

    private synchronized void printWithTemplate(BaseSaleModel baseSaleModel, boolean isReprint, final CountDownLatch printerLatch, Activity context, UniCallback callback) {

        ThreadFactoryUtils.getExecutorService("print-%d").execute(() -> {

            if (baseSaleModel == null) {
                LoggerUtils.getLogger().debug("printWithTemplate,baseSaleModel == null");
                return;
            }
            setSaleModel(baseSaleModel);
            if (printerLatch != null) {
                try {
                    printerLatch.await();
                } catch (InterruptedException e) {
                    LoggerUtils.getLogger().debug("printerLatch InterruptedException");
                    e.printStackTrace();
                }
            } else {
                LoggerUtils.getLogger().debug("printerLatch == null");
            }
            BaseSaleModel saleModel = getSaleModel();
            if (saleModel == null) {
                LoggerUtils.getLogger().debug("printWithTemplate,saleModel == null");
                return;
            }
            boolean isPreSales = (saleModel.getTranType() == TranType.PreSale);
            boolean isRefund = (saleModel.getClass().equals(ReturnSaleModel.class));
            LoggerUtils.getLogger().debug("printWithTemplate,预销售:" + isPreSales + ",退货:" + isRefund);

            SalePrintBean bean = toPrintUnitBean(saleModel, isReprint, isRefund, context);

            //用于全场收银判断专柜号是否相同(自助不需要判断专柜数)
            int count = 1;
            if (!CommonUtils.isUniformStyle()) {
                if (GeneralSettings.INSTANCE.getReceiptPrintType().isByShop()) {
                    HashMap<String, Integer> map = new HashMap<>();
                    for (BaseSalePluModel pluModel : saleModel.getPlus()) {
                        map.put(pluModel.getShopCode(), 0);
                        //利用HashMap的自动去重 统计不同专柜的个数
                    }
                    count = map.size();
                }
                LoggerUtils.getLogger().debug("专柜数：" + count);
            }

            String invoiceUrl = "";
            if (GeneralSettings.INSTANCE.isPrintInvoice() || CommonUtils.isUniformStyle()) {
                invoiceUrl = EInvoice2.formatUrl(saleModel);
                if (StringUtils.isEmpty(invoiceUrl)) {
                    if (context != null) {
                        // Toast.makeText(context, "发票地址为空", Toast.LENGTH_SHORT).show();
                    }
                    LoggerUtils.getLogger().debug("发票地址为空");
                }
            }
            /**
             * 打印礼品券
             */
            if (!ListUtils.isEmpty(bean.getGiftCouponList())) {
                List<GiftCouponPrintBean> priList = new ArrayList<>();
                for (GiftCouponPrintBean giftCouponPrintBean : bean.getGiftCouponList()) {
                    if (giftCouponPrintBean.isGiftPrintable()) {
                        priList.add(giftCouponPrintBean);
                    }
                }
                bean.setGiftCouponList(priList);
                if (!ListUtils.isEmpty(bean.getGiftCouponList())) {
                    LoggerUtils.getLogger().debug("打印礼品券");
                    List<String> couponPrintList = toPrintList(bean, PrintTemplateType.GiftCoupon);
                    printStringList(couponPrintList, context, IPrintService.PrtPatternType.GIFTCOUPON, invoiceUrl);
                }
            }

            /**
             * 打印满赠券，且已经获取满赠券数据
             */
            if (!ListUtils.isEmpty(bean.getCouponList())) {
                List<CouponUnitBean> printList = new ArrayList<>();
                for (CouponUnitBean couponUnitBean : bean.getCouponList()) {
                    if (couponUnitBean.isPrintable()) {
                        printList.add(couponUnitBean);
                    }
                }
                bean.setCouponList(printList);
                if (!ListUtils.isEmpty(bean.getCouponList())) {
                    List<CouponPrintBean> couponPrintBeanList = new ArrayList<>();
                    HashMap<String, Double> couponPrintBeanMap = new HashMap<>();

                    // 合并相同赠券方案的券，并计算合计赠券金额。
                    for (CouponUnitBean unit : bean.getCouponList()) {
                        String key = unit.getCouponName();
                        if (couponPrintBeanMap.containsKey(key)) {
                            couponPrintBeanMap.put(key, BigDecimalUtils.add(couponPrintBeanMap.get(key), Double.valueOf(unit.getCouponPrice())));
                        } else {
                            couponPrintBeanMap.put(key, Double.valueOf(unit.getCouponPrice()));
                        }
                    }

                    // 将合并后的赠券方案转换为CouponPrintBean打印对象
                    for (String key : couponPrintBeanMap.keySet()) {
                        CouponPrintBean couponPrintBean = new CouponPrintBean();
                        couponPrintBean.setCouponName(key);
                        couponPrintBean.setCouponPrice(String.valueOf(couponPrintBeanMap.get(key)));
                        couponPrintBeanList.add(couponPrintBean);
                    }
                    couponPrintBeanMap.clear();
                    bean.setCouponPrintTiceketList(couponPrintBeanList);

                    if (GeneralSettings.INSTANCE.isPrintCoupon()) {

                        if (!saleModel.isVip()) {
                            //非会员看开关状态
                            LoggerUtils.getLogger().debug("非会员打印赠券");
                            List<String> couponPrintList = toPrintList(bean, PrintTemplateType.Coupon);
                            printStringList(couponPrintList, context, IPrintService.PrtPatternType.COUPON, invoiceUrl);
                        } else {
                            //会员看isPrint值
                            List<CouponUnitBean> tempList = new ArrayList<>();
                            for (CouponUnitBean unitBean : bean.getCouponList()) {
                                if (unitBean.isPrintable()) {
                                    tempList.add(unitBean);
                                }
                            }
                            if (tempList.size() > 0) {
                                LoggerUtils.getLogger().debug("会员打印赠券");
                                bean.setCouponList(tempList);
                                List<String> couponPrintList = toPrintList(bean, PrintTemplateType.Coupon);
                                printStringList(couponPrintList, context, IPrintService.PrtPatternType.COUPON, invoiceUrl);
                            }
                        }
                    }
                }
            }

            /**
             * 打印核销过后剩余可用券,必须在打印完满赠券之后,因为使用了同一个命令,需要覆盖
             */
            if (!ListUtils.isEmpty(bean.getRemainedCouponList())) {
                LoggerUtils.getLogger().debug("打印核销剩余赠券");
                bean.setCouponList(bean.getRemainedCouponList());
                List<String> couponPrintList = toPrintList(bean, PrintTemplateType.Coupon);
                printStringList(couponPrintList, context, IPrintService.PrtPatternType.COUPON, invoiceUrl);
            }

            /**
             * 打印小票
             */
            List<String> voucherPrintList = toPrintList(bean, PrintTemplateType.Receipt);
            if (isRefund && isPreSales) {
                addPreFundHeader(voucherPrintList);
                voucherPrintList.add(1, Integer.toString(count));
            } else if (isRefund) {
                addRefundHeader(voucherPrintList);
                voucherPrintList.add(1, Integer.toString(count));
            } else if (isPreSales) {
                addPreSaleHeader(voucherPrintList);
                voucherPrintList.add(1, Integer.toString(count));
            } else {
                voucherPrintList.add(0, Integer.toString(count));
            }

            printStringList(voucherPrintList, context, IPrintService.PrtPatternType.VOUCHER, invoiceUrl);

            if (callback != null) {
                callback.onSuccess("");
            }
        });
    }

    private void addRefundHeader(List<String> printList) {
        printList.add(0, Config.REFUND);
    }

    private void addPreSaleHeader(List<String> printList) {
        printList.add(0, Config.PRESALE);
    }

    private void addPreFundHeader(List<String> printList) {
        printList.add(0, Config.PREREFUND);
    }

    /**
     * 打印字符串列表
     *
     * @param printList 打印字符串列表
     */
    public void printWithStringList(List<String> printList) {
        // 报表打印默认适用小票打印机，所以当成小票处理了
        printStringList(printList, App.getContext(), IPrintService.PrtPatternType.VOUCHER, "");
    }

    /**
     * 打印字符串列表
     *
     * @param printList 字符串列表
     * @param callback  结果回调,并不准确,但可以表示最终打印方法已调用
     */
    public void printWithStringList(List<String> printList, UniCallback callback) {

        // 报表打印默认适用小票打印机，所以当成小票处理了
        printStringList(printList, App.getContext(), IPrintService.PrtPatternType.VOUCHER, "");
        if (callback != null) {
            callback.onSuccess("");
        }
    }

    /**
     * 调用打印机进行打印作业
     *
     * @param printList 打印数据
     * @param context   系统上下文
     * @param type      打印类型
     */
    private synchronized void printStringList(List<String> printList, Activity context, IPrintService.PrtPatternType type, final String invoiceUrl) {
        boolean localVoucherPrinter = GeneralSettings.INSTANCE.isPrintReceipt();
        IPOSPrinter voucherPrinter;
        IPOSPrinter couponPrinter;

        if (IPrintService.PrtPatternType.VOUCHER == type) {
            if (localVoucherPrinter || GeneralSettings.INSTANCE.getDeviceType().isHSX()
                    || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
                voucherPrinter = new LocalPOSPrinter();
            } else {
                CommonTools.showUiDialog("未启用小票打印机");
                return;
            }
            //  printList= Arrays.asList("[cmd_centerStart, 欢迎光临亿家汇好超市, 2020-01-06 18:18:22, ----------------------------------------------, cmd_centerEnd, 编码/售价  品名/优惠价 数量    优惠额      合计, 33260002     2号购物袋, 0.20       0.20     1.000     0.00      0.20, ----------------------------------------------, 总数量：1, 总应收：0.20, 总实收:0.20, 总优惠：0.00, 会员号:, ----------------------------------------------, 支付方式   支付金额     支付号       商户优惠, 微信人脸    0.20  20200106181836054498, ----------------------------------------------, cmd_centerStart, 单据号：202001061818191246, 门店：05 款台号：0032 上机号:009503, **********亿家汇好用心为您服务!***********, 客服电话:0991-3112111, 监督热线:0996-2048923, 请妥善保管好小票,商品如有质量问题 ,, 七日内凭此票进行退换货,30日内凭此票, 开具发票.欢迎您办理会员卡,优惠更多!, cmd_centerEnd, cmd_paperCut]");
            // 执行打印小票或赠券
            voucherPrinter.print(printList, context, type, invoiceUrl);
        } else if (IPrintService.PrtPatternType.COUPON == type
                || IPrintService.PrtPatternType.GIFTCOUPON == type) {
            couponPrinter = new LocalPOSPrinter();

            // 执行打印小票或赠券
            couponPrinter.print(printList, context, type, invoiceUrl);
        }
    }

    /**
     * 初始化打印Helper
     */
    private void init() {
        // 加载打印模板
        for (PrintTemplateType type : PrintTemplateType.values()) {
            loadTemplate(type);
        }
    }

    /**
     * 加载打印模板
     *
     * @param type 模板类型
     * @author dengyunpeng 2017-7-17 HIPOSAPP-118 将打印模板保存在本地SQLite数据库
     */
    public void loadTemplate(PrintTemplateType type) {
        try {
            PrintTemplateRepository repository = new PrintTemplateRepository(App.getAppContext());
            String template = repository.getTemplate(type);

            if (StringUtils.isEmpty(template)) {
                if (type == PrintTemplateType.Receipt) {
                    template = DEFAULT_RECEIPT_TEMPLATE;
                } else if (type == PrintTemplateType.Coupon) {
                    template = DEFAULT_COUPON_TEMPLATE;
                } else if (type == PrintTemplateType.GiftCoupon) {
                    template = DEFAULT_GIFT_COUPON_TEMPLATE;
                }
                repository.save(new PrintTemplate(type, 0, template));
            }

            setTemplateInCached(type, template);
        } catch (Exception e) {
            e.printStackTrace();
            LoggerUtils.getLogger().debug("loadTemplate加载模板异常:" + e.toString());
        }
    }

    private static final String DEFAULT_RECEIPT_TEMPLATE = "cmd_centerStart\n" +
            "         海信广场零售商品销售凭证\n" +
            "(凭此联自购物起30日内可换开发票)\n" +
            "**************************************\n" +
            "[cmdBool:isRePrint(重打印)]\n" +
            "cmd_centerEnd\n" +
            "                          流水号:\n" +
            "eInvoiceQRCode\n" +
            "\n" +
            "\n" +
            "cmd_centerStart\n" +
            "[saleNo]\n" +
            "cmd_centerEnd\n" +
            "cmd_shopCode\n" +
            "专柜号:[shopCode]    收款员:[cashCode]\n" +
            "----------------------------------------------------\n" +
            "商品名称          数量            金额         专柜号\n" +
            "[cmdLoop:pluList{\n" +
            "(pluName                                    )  \n" +
            "(pluCode  )           (pluCount)      (pluPriceAct  )    (shopCode  )}]\n" +
            "----------------------------------------------------\n" +
            "收款合计:[totalCharge]\n" +
            "找零合计:[change]\n" +
            "会员号:[cardFaceNo]\n" +
            "----------------------------------------------------\n" +
            "支付方式:\n" +
            "[cmdLoop:payMethodList{(payName):(payCount)   (payNo)}]\n" +
            "*****************************************************************\n" +
            "[cmdLoop:couponPrintList{(couponName )          ( couponPrice)}]\n" +
            "*****************************************************************\n" +
            "日    期:[saleDate]\n" +
            "eInvoiceQRCode\n" +
            "cmd_centerStart\n" +

            "请仔细核对信息是否正确，欢迎下次光临！\n" +
            "\n" +
            "第一联   顾客留存\n" +
            "cmd_centerEnd\n" +
            "cmd_paperCut\n" +
            "cmd_centerStart\n" +
            "\n" +
            "         海信广场零售商品销售凭证\n" +
            "(专柜联，凭此联不可换开发票)\n" +
            "**************************************\n" +
            "[cmdBool:isRePrint(重打印)]\n" +
            "cmd_centerEnd\n" +
            "\n" +
            "流水号:[saleNo]\n" +
            "cmd_shopCode\n" +
            "专柜号:[shopCode]    收款员:[cashCode]\n" +
            "----------------------------------------------------\n" +
            "商品名称          数量            金额         专柜号\n" +
            "[cmdLoop:pluList{\n" +
            "(pluName                                    )  \n" +
            "(pluCode  )           (pluCount)      (pluPriceAct  )    (shopCode  )}]\n" +
            "----------------------------------------------------\n" +
            "收款合计:[totalCharge]\n" +
            "找零合计:[change]\n" +
            "会员号:[cardFaceNo]\n" +
            "----------------------------------------------------\n" +
            "支付方式:\n" +
            "[cmdLoop:payMethodList{(payName):(payCount)   (payNo)}]\n" +
            "*****************************************************************\n" +
            "[cmdLoop:couponPrintList{(couponName )          ( couponPrice)}]\n" +
            "*****************************************************************\n" +
            "日    期:[saleDate]\n" +

            "cmd_centerStart\n" +
            "\n" +
            "第二联   专柜留存\n" +
            "cmd_centerEnd\n" +
            "cmd_shop\n" +
            "cmd_paperCut";

    private static final String DEFAULT_COUPON_TEMPLATE = "[cmdLoop:couponList{\n" +
            "cmd_centerStart\n" +
            "青岛海信广场\n" +
            "(couponName)\n" +
            "cmd_textSizeMiddle\n" +
            "赠券面值:(couponPrice)\n" +
            "cmd_textSizeEnd\n" +
            "cmd_centerEnd\n" +
            "\n" +
            "有效时间:(couponExpDateBegin) 至 (couponExpDateEnd)\n" +
            "赠券说明:\n" +
            "(couponText)\n" +
            "======================================\n" +
            "赠券号:\n" +
            "BarCodeFlag\n" +
            "cmd_centerStart\n" +
            "(couponNo)\n" +
            "cmd_centerEnd\n" +
            "校验码:(couponCheckCode)\n" +
            "======================================\n" +
            "cmd_paperCut\n" +
            "}]\n";

    private static final String DEFAULT_GIFT_COUPON_TEMPLATE = "[cmdLoop:giftCouponList{\n" +
            "cmd_centerStart\n" +
            "cmd_textSizeLarge\n" +
            "(couponName)\n" +
            "cmd_textSizeEnd\n" +
            "cmd_centerEnd\n" +
            "赠券号：\n" +
            "BarCodeFlag\n" +
            "cmd_centerStart\n" +
            "(giftNo)\n" +
            "cmd_centerEnd\n" +
            "打印时间:(printTime)\n" +
            "cmd_centerStart\n" +
            "cmd_textSizeLarge\n" +
            "(giftName)    (giftCount)\n" +
            "cmd_textSizeEnd\n" +
            "cmd_textSizeMiddle\n" +
            "以下信息重要,请注意阅读\n" +
            "cmd_textSizeEnd\n" +
            "cmd_centerEnd\n" +
            "(giftRemark)\n" +
            "cmd_paperCut\n" +
            "}]";

    /**
     * 缓存模板
     *
     * @param type     模板类型
     * @param template 模板内容
     */
    private void setTemplateInCached(PrintTemplateType type, String template) {
        switch (type) {
            case Receipt:
                receiptTemplate = template;
                break;
            case Coupon:
                couponTemplate = template;
                break;
            case GiftCoupon:
                giftCouponTemplate = template;
                break;
            default:
                LoggerUtils.getLogger().info("setTemplateInCached()---type WITHOUT corresponding Enum.... type:" + type);
                break;
        }
    }

    /**
     * 获取模板
     *
     * @param type 模板类型
     * @return 模板内容
     */
    public String getTemplate(PrintTemplateType type) {
        switch (type) {
            case Receipt:
                return receiptTemplate;
            case Coupon:
                return couponTemplate;
            case GiftCoupon:
                return giftCouponTemplate;
            default:
                LoggerUtils.getLogger().error("不支持的打印模板类型:" + type.value());
                return null;
        }
    }

    /**
     * 将交易数据转换为打印打印对象
     *
     * @return
     * @author dukunbiao 2018-06-05
     */
    public SalePrintBean toPrintUnitBean(BaseSaleModel saleModel, boolean isReprint, boolean isReturn, Activity context) {
        //Part I 小票部分
        SalePrintBean bean = null;

        try {
            boolean invoiceExchangeable = false;
            int pluNumPerPage = 6;
            int invoiceMaxLine = 27;

            bean = new SalePrintBean();
            bean.setPrtContext(context);
            bean.setSaleNo(StringUtils.trimToEmpty(saleModel.getSaleNo()));
            bean.setPosNo(Config.pos_no);
            bean.setOrgCode(Config.org_code);
            bean.setCasherCode(StringUtils.trimToEmpty(saleModel.getCashier().getUserCode()));
            bean.setShopCode(StringUtils.trimToEmpty(Config.shop_code));
            if (isReprint && mainSaleModel.getShopInfo() != null && !mainSaleModel.getShopInfo().getOrgCode().equals(com.hisense.hipos.webapi.Context.orgCode())) {
                bean.setOrgName("");
            } else {
                bean.setOrgName(com.hisense.hipos.webapi.Context.orgName());
            }
            bean.setInvoiceNo(saleModel.getInvoiceNo());

            if (mainSaleModel.getShopInfo() != null) {
                bean.setShopAddress(mainSaleModel.getShopInfo().getAddress() == null ? "" : mainSaleModel.getShopInfo().getAddress());
                bean.setShopTelephone(mainSaleModel.getShopInfo().getTelephone() == null ? "" : mainSaleModel.getShopInfo().getTelephone());
            } else {
                bean.setShopAddress("未配置");
                bean.setShopTelephone("未配置");
            }
            bean.setSaleDate(StringUtils.trimToEmpty(saleModel.getSaleTime()));
            bean.setRePrint(isReprint);
            bean.setChange(Double.valueOf(saleModel.getTotalChange()));

            if (isReturn) {
                bean.setTotalCount(String.valueOf(-Math.abs(saleModel.calcCount())));//订单商品总件数
                bean.setTotal(-Math.abs(Double.valueOf(saleModel.getTotal())));//订单原总金额
                bean.setTotalCharge(-Math.abs(Double.valueOf(saleModel.getTotalRecv())));//实收
                bean.setTotalDsc(BigDecimalUtils.subtract(Math.abs(Double.parseDouble(saleModel.getTotal())), Math.abs(Double.parseDouble(saleModel.getTotalRecv()))));//订单总优惠
                bean.setDiscount(BigDecimalUtils.subtract(Math.abs(Double.parseDouble(saleModel.getTotal())), Math.abs(Double.parseDouble(saleModel.getTotalRecv()))));//订单总优惠
            } else {
                bean.setTotalCount(String.valueOf(saleModel.calcCount()));//订单商品总件数
                bean.setTotal(Double.valueOf(saleModel.getTotal()));//订单原总金额
                bean.setTotalCharge(Double.valueOf(saleModel.getTotalRecv()));//实收
                bean.setTotalDsc(BigDecimalUtils.subtract(Double.parseDouble(saleModel.getTotalRecv()), Double.parseDouble(saleModel.getTotal())));//订单总优惠
                bean.setDiscount(BigDecimalUtils.subtract(Double.parseDouble(saleModel.getTotalRecv()), Double.parseDouble(saleModel.getTotal())));//订单总优惠
                LoggerUtils.getLogger().info("total:" + Double.valueOf(saleModel.getTotal()));
                LoggerUtils.getLogger().info("totalCharge:" + Double.valueOf(saleModel.getTotalRecv()));
                LoggerUtils.getLogger().info("totalDsc:" + bean.getTotalDsc());
                LoggerUtils.getLogger().info("discount:" + bean.getDiscount());
            }

            String telNum = " ";
            String cardType = "";
            bean.setIsVip(false);
            if (saleModel.getVip() != null) {
                if (saleModel.getVip().card() != null) {
                    if (!StringUtils.isEmpty(saleModel.getVip().card().cardFaceNo())) {
                        cardType = saleModel.getVip().card().cardType().name();
                        if (CommonUtils.verifyPhoneNo(saleModel.getVip().card().cardFaceNo()) == 2) {
                            telNum = StringUtils.asterisk(saleModel.getVip().card().cardFaceNo());
                        } else {
                            telNum = saleModel.getVip().card().cardFaceNo();
                        }
                    }
                    bean.setIsVip(true);
                }
            }
            bean.setCardFaceNo(telNum);
            bean.setCardType(cardType);

            //  实时积分
            bean.setExpensePoint(saleModel.getExpensePoint());
            bean.setParkingPoint(saleModel.getParkingPoint());
            bean.setCouponPoint(saleModel.getCouponPoint());

            bean.setLastUsablePoint(saleModel.getLastUsablePoint());//上次可用积分
            bean.setVipPoints(saleModel.getVipPoints());//当前累计积分
            if (saleModel.getVip() != null) {
                bean.setSumPoints(String.valueOf(saleModel.getVip().card().usablePoints()));//慧收银的会员积分
            }

            if (!isReprint && !ListUtils.isEmpty(saleModel.getPays())) {
                String totalDscSelf = "0";
                String totalDscChannel = "0";
                for (SalePayModel saleModelPay : saleModel.getPays()) {
                    totalDscSelf = BigDecimalUtils.add(totalDscSelf, saleModelPay.getTotalDscSelf() == null ? "0" : saleModelPay.getTotalDscSelf());
                    totalDscChannel = BigDecimalUtils.add(totalDscChannel, saleModelPay.getTotalDscChannel() == null ? "0" : saleModelPay.getTotalDscChannel());
                }

                bean.setTotalDscSelf(totalDscSelf);
                bean.setTotalDscChannel(totalDscChannel);
            }

            bean.setInvoiceExchangeable(invoiceExchangeable);
            bean.setInvPluNumPerPage(pluNumPerPage);

            // 遍历商品列表，将商品转换为PluBean
            if (!ListUtils.isEmpty(saleModel.getPlus())) {
                List<SalePluPrintBean> pluBeanList = new ArrayList<>();
                List<String> shopCodeList = new ArrayList<>();
                List<SalePluDscPrintBean> pluDscBeanList = new ArrayList<>();

                for (BaseSalePluModel pluModel : saleModel.getPlus()) {
                    SalePluPrintBean pluBean = new SalePluPrintBean();
                    try {
                        pluBean.setPluName(StringUtils.trimToEmpty(pluModel.getPluName()));
                        //简称
                        String pluAbbrName;
                        if (StringUtils.isEmpty(pluModel.getPluAbbrName())) {
                            pluAbbrName = pluModel.getPluName();
                        } else {
                            pluAbbrName = pluModel.getPluAbbrName();
                        }
                        pluBean.setPluAbbrName(StringUtils.trimToEmpty(pluAbbrName));
                    } catch (Exception e) {
                        LoggerUtils.getLogger().error("toPrintUnitBean 组装商品异常" + e.toString());
                    }

                    pluBean.setSpec(pluModel.getSpec());
                    pluBean.setUnit(pluModel.getUnit());
                    pluBean.setCargoNo(pluModel.getCargoNo());
                    pluBean.setPluCode(StringUtils.trimToEmpty(pluModel.getPluCode() == null ? pluModel.getBarCode() : pluModel.getPluCode()));
                    pluBean.setPluItemNo(String.valueOf(pluModel.getItemNo()));

                    if (isReturn) {
                        //退货流水和流水查询的退货流水符号不一致,所以统一绝对值再取反
                        pluBean.setPluCount(-Math.abs(Double.parseDouble(pluModel.getQuantity())));
                        pluBean.setPluPriceAct(-Math.abs(Double.parseDouble(pluModel.getTotalRecv())));//商品实收总金额
                        pluBean.setPluPriceAftDsc(-Math.abs(Double.parseDouble(pluModel.getPrice())));//优惠后单价
                        pluBean.setPluPrice(-Math.abs(Double.parseDouble(pluModel.getTagPrice())));//标注单价
                        pluBean.setPluTotal(-Math.abs(Double.parseDouble(pluModel.getTotal())));//商品标注总金额
                        pluBean.setPluDscTotal(BigDecimalUtils.subtract(Math.abs(Double.parseDouble(pluModel.getTotal())), Math.abs(Double.parseDouble(pluModel.getTotalRecv()))));//商品优惠总金额
                    } else {
                        pluBean.setPluCount(Double.parseDouble(pluModel.getQuantity()));
                        pluBean.setPluPriceAct(Double.parseDouble(pluModel.getTotalRecv()));//商品实收总金额
                        pluBean.setPluPriceAftDsc(Double.parseDouble(pluModel.getPrice()));//优惠后单价
                        pluBean.setPluPrice(Double.parseDouble(pluModel.getTagPrice()));//标注单价
                        pluBean.setPluTotal(Double.parseDouble(pluModel.getTotal()));//商品标注总金额
                        pluBean.setPluDscTotal(BigDecimalUtils.subtract(pluModel.getTotalRecv(), pluModel.getTotal()));//商品优惠总金额
                    }

                    pluBean.setShopCode(pluModel.getShopCode());

                    pluBeanList.add(pluBean);
                    shopCodeList.add(pluModel.getShopCode());

                    //  double totalDsc = 0.0;
                    if (pluModel.getPluDscs() != null) {
                        //商品优惠
                        for (SalePluDscModel pluDscModel : pluModel.getPluDscs()) {
                            SalePluDscPrintBean pluDscBean = new SalePluDscPrintBean();
                            pluDscBean.setPluDscName(pluDscModel.getDscProName());
                            pluDscBean.setPluDscTotal(pluDscModel.getTotalDsc());
                            pluDscBean.setPluCode(StringUtils.trimToEmpty(pluModel.getPluCode()));
                            pluDscBean.setItemNo(String.valueOf(pluDscModel.getItemNo()));
                            pluDscBeanList.add(pluDscBean);
                        }
                    }
                }

                bean.setPluDscList(pluDscBeanList);
                bean.setPluList(pluBeanList);
                bean.setShopCodeList(shopCodeList);
            }
            // 遍历商品列表，将商品转换为PluBean
            if (!ListUtils.isEmpty(saleModel.getHxPayCoupons())) {
                List<HxPayCouponPrintBean> hxPayCouponPrintBeans = new ArrayList<>();

                for (HxPayCoupon hxPayCoupon : saleModel.getHxPayCoupons()) {
                    HxPayCouponPrintBean hxPayCouponPrintBean = new HxPayCouponPrintBean();

                    hxPayCouponPrintBean.setCouponAlign(hxPayCoupon.align);
                    hxPayCouponPrintBean.setCouponTag(hxPayCoupon.tag);
                    hxPayCouponPrintBean.setCouponType(hxPayCoupon.type);
                    hxPayCouponPrintBean.setCouponValue(hxPayCoupon.value);
                    hxPayCouponPrintBeans.add(hxPayCouponPrintBean);
                }
                bean.setHxPayCouponList(hxPayCouponPrintBeans);
            }
            // 支付列表
            List<SalePayModel> pays = new ArrayList<>();
            if (!ListUtils.isEmpty(saleModel.getPaysPrint())) {
                for (SalePayModel salePayModel : saleModel.getPays()) {
                    Boolean hasPayList = false;
                    for (SalePayModel salePayModelPrint : saleModel.getPaysPrint()) {
                        if (salePayModel.outTradeNo.equals(salePayModelPrint.outTradeNo)) {
                            pays.add(salePayModelPrint);
                            hasPayList = true;
                        }
                    }
                    if (!hasPayList) {
                        pays.add(salePayModel);
                    }

                }
            } else if (!ListUtils.isEmpty(saleModel.getPays())) {
                for (SalePayModel salePayModel : saleModel.getPays()) {
                    pays.add(salePayModel);
                }
            }
            if (!ListUtils.isEmpty(pays)) {
                List<PayMethodPrintBean> payMethodBeanList = new ArrayList<>();

                for (SalePayModel payModel : pays) {
                    PayMethodPrintBean payMethodBean = new PayMethodPrintBean();
                    payMethodBean.setPayCount(payModel.getTotalPaid());

                    String balance = payModel.getBalance();
                    payMethodBean.setBalance(StringUtils.isEmpty(balance) ? 0 : Double.valueOf(balance));
                    payMethodBean.setPayName(StringUtils.trimToEmpty(payModel.getPayName()));

                    //银行卡 且隐藏,则隐藏中间几位
                    if (payModel.getRemark() != null
                            && (PayMethod.isUnionPay(payModel.getRemark()) || PayMethod.isUccbCard(payModel.getRemark()))
                            && GeneralSettings.INSTANCE.hidePayNoWhenPrint()) {
                        payMethodBean.setPayNo(maskCardNo(StringUtils.trimToEmpty(payModel.getBuyerLogonId())));
                    } else {
                        payMethodBean.setPayNo(StringUtils.trimToEmpty(payModel.getBuyerLogonId()));
                    }

                    //银联卡,云闪付,建行直连银行卡,建行直连聚合支付,收单行渠道的支付宝和微信 打印trace,ref
                    if (payModel.getRemark() != null && (PayMethod.isUnionPay(payModel.getRemark())
                            || PayMethod.isUnionCloudPay(payModel.getRemark())
                            || PayMethod.isUccbCard(payModel.getRemark())
                            || PayMethod.isUccbScan(payModel.getRemark())
                            || (!CommonUtils.isStdStyle() && AggregatePaymentChannel.isCHANNEL() && (PayMethod.isWxPay(payModel.getRemark()) || PayMethod.isAliPay(payModel.getRemark()) || PayMethod.isMobilePay(payModel.getRemark()))))
                        //   || (AggregatePaymentChannel.isHXPAY() && CommonUtils.isTimesSquare(context) && PayMethod.isAliPay(payModel.getRemark()))
                    ) {
                        payMethodBean.setRefNo(payModel.getTradeNo());
                        payMethodBean.setTraceNo(payModel.getOutTradeNo());
                    } else {
                        payMethodBean.setRefNo(null);
                        payMethodBean.setTraceNo(null);
                    }
                    payMethodBean.setPayMDiscount(payModel.getTotalDscSelf());
                    payMethodBean.setPayDiscount(payModel.getTotalDscChannel());
                    payMethodBeanList.add(payMethodBean);
                }

                bean.setPayMethodList(payMethodBeanList);
            }

            /* Part II 发票部分 */
            bean.setInvoiceMaxLine(invoiceMaxLine);
            bean.setInvoiceTransCode(saleModel.getSaleNo() + Config.org_code);
            bean.setInvoiceRandom(saleModel.getUdp4());
            double fpTotal = Double.parseDouble(saleModel.getTotal());
            int iTotal = (int) Math.floor(fpTotal);

            bean.setGrossCharge(fpTotal);
            String sDxTotal = CommonUtils.toChineseChar(String.valueOf(Math.abs(iTotal)));
            bean.setGrossChargeChinese(sDxTotal);


            /* Part III 赠券*/

            //礼品券列表
            if (SaleActivity.giftCouponMap != null
                    && SaleActivity.giftCouponMap.size() > 0
                    && GeneralSettings.INSTANCE.isPrintGiftCoupon()) {
                Collection<GiftCoupon> giftCoupons = SaleActivity.giftCouponMap
                        .get(StringUtils.isEmpty(saleModel.getSaleNo()) ? bean.getSaleNo() : saleModel.getSaleNo());
                List<GiftCouponPrintBean> giftCouponUnitBeanList = new ArrayList<>();
                GiftCouponPrintBean giftCouponBean;
                if (giftCoupons != null && giftCoupons.size() != 0) {
                    for (GiftCoupon giftCoupon : giftCoupons) {
                        giftCouponBean = new GiftCouponPrintBean();
                        giftCouponBean.setCouponName(giftCoupon.name());
                        giftCouponBean.setGiftCouponNo(giftCoupon.no());
                        giftCouponBean.setPrintTime(saleModel.getSaleTime());
                        giftCouponBean.setGiftName(giftCoupon.giftName());
                        giftCouponBean.setGiftCouponCount("" + giftCoupon.count());
                        giftCouponBean.setGiftRemark(giftCoupon.remark());
                        giftCouponBean.setGiftBeginDate(giftCoupon.beginDate());
                        giftCouponBean.setGiftEndDate(giftCoupon.endDate());
                        giftCouponBean.setGiftPrintable(giftCoupon.isPrint());
                        giftCouponUnitBeanList.add(giftCouponBean);
                    }
                }
                bean.setGiftCouponList(giftCouponUnitBeanList);
            }

            // 增加满赠券信息
            if (SaleActivity.couponMap != null
                    && SaleActivity.couponMap.size() > 0) {
                Collection<Coupon> couponBeanList = SaleActivity.couponMap
                        .get(StringUtils.isEmpty(saleModel.getSaleNo()) ? bean.getSaleNo() : saleModel.getSaleNo());
//
                List<CouponUnitBean> couponUnitBeanList = new ArrayList<>();
                CouponUnitBean couponUnitBean;
                BigDecimal couponTotal = BigDecimal.ZERO;
                if (couponBeanList != null && couponBeanList.size() != 0) {
                    for (Coupon coupon : couponBeanList) {
                        couponUnitBean = new CouponUnitBean();
                        couponUnitBean.setCouponName(coupon.name());
                        couponUnitBean.setCouponNo(coupon.no());
                        couponUnitBean.setCouponPrice(String.valueOf(coupon.value()));
                        couponUnitBean.setCheckCode(coupon.checkCode());
                        couponUnitBean.setCouponText(coupon.remark());
                        couponUnitBean.setExpDateBegin(coupon.beginDate());
                        couponUnitBean.setExpDateEnd(coupon.endDate());
                        couponUnitBean.setPrintable(coupon.isPrint());
                        couponUnitBean.setSaleNo(bean.getSaleNo());
                        couponUnitBeanList.add(couponUnitBean);
                        if (coupon.type() == CouponType.Cash) {
                            couponTotal = couponTotal.add(BigDecimal.valueOf(coupon.value()));
                        }
                    }
                }
                bean.setCouponList(couponUnitBeanList);
                bean.setCouponTotalValue(couponTotal.toString());
            }

            /**
             * 添加剩余可用赠券信息
             */
            if (SaleActivity.remainedCouponMap != null
                    && SaleActivity.remainedCouponMap.size() > 0) {
                Collection<Coupon> couponBeanList = SaleActivity.remainedCouponMap
                        .get(StringUtils.isEmpty(saleModel.getSaleNo()) ? bean.getSaleNo() : saleModel.getSaleNo());
                List<CouponUnitBean> couponUnitBeanList = new ArrayList<>();
                CouponUnitBean couponUnitBean;
                if (couponBeanList != null && couponBeanList.size() != 0) {
                    for (Coupon coupon : couponBeanList) {
                        couponUnitBean = new CouponUnitBean();
                        couponUnitBean.setCouponName(coupon.name());
                        couponUnitBean.setCouponNo(coupon.no());
                        couponUnitBean.setCouponPrice(String.valueOf(coupon.value()));
                        couponUnitBean.setCheckCode(coupon.checkCode());
                        couponUnitBean.setCouponText(coupon.remark());
                        couponUnitBean.setExpDateBegin(coupon.beginDate());
                        couponUnitBean.setExpDateEnd(coupon.endDate());
                        couponUnitBean.setPrintable(coupon.isPrint());
                        couponUnitBean.setSaleNo(bean.getSaleNo());
                        couponUnitBeanList.add(couponUnitBean);
                    }
                }
                bean.setRemainedCouponList(couponUnitBeanList);
            }
        } catch (Exception e) {
            StringBuffer sb = new StringBuffer();
            sb.append("toPrintUnitBean 异常:" + e + "\n");
            StackTraceElement[] trace = e.getStackTrace();
            if (trace != null) {
                for (StackTraceElement element : trace) {
                    sb.append(element + "\n");
                }
            }
            LoggerUtils.getLogger().error(sb.toString());
        }

        return bean;
    }

    /**
     * 将PrintUnitBean转换为字符串列表
     *
     * @return 待字符串列表
     */
    private List<String> toPrintList(SalePrintBean bean, PrintTemplateType type) {
        String template = getTemplate(type);
/*        if (Config.isHS330R()) {
            template = this.template;
        }*/
        List<String> printList;
        ITemplateEngine engine;

        if (StringUtils.isEmpty(template)) {
            LoggerUtils.getLogger().debug("模板为空");
            engine = new DefaultTemplateEngine();
        } else {
            engine = new ExternalTemplateEngine();
        }
        LoggerUtils.getLogger().debug("产生打印内容");
        printList = engine.getPrintContent(template, bean, type);
        for (int i = 0; i < printList.size(); i++) {
            if (printList.get(i).equals("hxPayCouponList")) {
                index = i;
                addHxPayCoupons(bean, printList);
                i = index;
            }
        }

        return printList;
    }

    private String template = "cmd_centerStart\n" +
            "测试用 商品销售凭证\n" +
            "门店：[orgCode][orgName]\n" +
            "专柜号:[shopCode]    收款员:[cashCode]\n" +
            "pos号：[posNo]\n" +
            "**************************************\n" +
            "[cmdBool：isRePrint(重打印)]\n" +
            "cmd_centerEnd\n" +
            "流水号：\n" +
            "BarCodeFlag\n" +
            "cmd_centerStart\n" +
            "[saleNo]\n" +
            "cmd_centerEnd\n" +
            "cmd_shopCode\n" +
            "----------------------------------------------------\n" +
            "商品名称    商品编码   数量    单价\n" +
            "发生价      应收        实收    总优惠\n" +
            "单位        规格       货号      部门\n" +
            "[cmdLoop:pluList{\n" +
            "----------------------------------------------------\n" +
            "(pluName)    (pluCode)    (pluCount)    (pluPrice)\n" +
            "(pluPriceAftDsc)    (pluTotal)    (pluPriceAct)    (pluDscTotal)\n" +
            "(unit)    (spec)    (cargoNo)    (shopCode  )}\n" +
            "\n" +
            "优惠名称            优惠金额\n" +
            "cmdLoopDsc:pluDscList{(pluDscName)  (PluDscTotal)}\n" +
            "]\n" +
            "----------------------------------------------------\n" +
            "总件数：[totalCount]\n" +
            "总应收：[total]\n" +
            "总实收:[totalCharge]\n" +
            "找零:[change]\n" +
            "总优惠：[totalDsc]\n" +
            "会员号:[cardFaceNo]\n" +
            "会员卡类型:[cardType]\n" +
            "会员积分：[vipPoints]\n" +
            "上次可用积分:[lastUsablePoint]\n" +
            "本笔交易赠送金额券: [couponTotalValue]\n" +
            "消费积分: [expensePoint]\n" +
            "停车积分: [parkingPoint]\n" +
            "赠券积分: [couponPoint]\n" +
            "商户优惠金额: [totalDscSelf]\n" +
            "平台优惠金额: [totalDscChannel]\n" +
            "----------------------------------------------------\n" +
            "支付方式      支付金额     支付号\n" +
            "余额        凭证号    参考号\n" +
            "商户优惠      平台优惠\n" +
            "[cmdLoop:payMethodList{\n" +
            "(payName)     (payCount)\n" +
            "(payNo)\n" +
            "(balance)\n" +
            "(traceNo)\n" +
            "(refNo)\n" +
            "(payMDiscount)    (payDiscount)\n" +
            "----------------------------------------------------\n" +
            "}]\n" +
            "*****************************************************************\n" +
            "赠券名称              赠券金额\n" +
            "[cmdLoop:couponPrintList{(couponName )          ( couponPrice)}]\n" +
            "*****************************************************************\n" +
            "日    期：[saleDate]\n" +
            "地    址：[shopAddress]\n" +
            "电    话：[shopTelephone]\n" +
            "QRCodeFlag\n" +
            "eInvoiceQRCode\n" +
            "交易码：[invoiceTransCode]\n" +
            "提取码：[invoiceRandom]\n" +
            "cmd_centerStart\n" +
            "扫码申请开发票\n" +
            "请仔细核对信息是否正确，欢迎下次光临！\n" +
            "(凭此联自购物起30日内可换开发票)\n" +
            "第一联   顾客留存\n" +
            "cmd_centerEnd\n" +
            "cmd_paperCut\n";

    private void addHxPayCoupons(SalePrintBean bean, List<String> printList) {
        if (null == bean.getHxPayCouponList()) {
            return;
        }

        for (HxPayCouponPrintBean hxPayCouponPrintBean : bean.getHxPayCouponList()) {
            if (hxPayCouponPrintBean.getCouponType().equalsIgnoreCase("text")) {
                if (hxPayCouponPrintBean.getCouponTag().equalsIgnoreCase("1")) {//标准大小
                    if (hxPayCouponPrintBean.getCouponAlign().equalsIgnoreCase("center")) {
                        printList.add(index + 1, "cmd_centerStart");
                        printList.add(index + 2, "cmd_textSizeMiddle");
                        printList.add(index + 3, hxPayCouponPrintBean.getCouponValue());
                        printList.add(index + 4, "cmd_textSizeEnd");
                        printList.add(index + 5, "cmd_centerEnd");
                        index = index + 5;
                    } else if (hxPayCouponPrintBean.getCouponAlign().equalsIgnoreCase("start")) {
                        printList.add(index + 1, "cmd_textSizeMiddle");
                        printList.add(index + 2, hxPayCouponPrintBean.getCouponValue());
                        printList.add(index + 3, "cmd_textSizeEnd");
                        index = index + 3;
                    }
                } else if (hxPayCouponPrintBean.getCouponTag().equalsIgnoreCase("2")) {//放大
                    if (hxPayCouponPrintBean.getCouponAlign().equalsIgnoreCase("center")) {
                        printList.add(index + 1, "cmd_centerStart");
                        printList.add(index + 2, "cmd_textSizeLarge");
                        printList.add(index + 3, hxPayCouponPrintBean.getCouponValue());
                        printList.add(index + 4, "cmd_textSizeEnd");
                        printList.add(index + 5, "cmd_centerEnd");
                        index = index + 5;
                    } else if (hxPayCouponPrintBean.getCouponAlign().equalsIgnoreCase("start")) {
                        printList.add(index + 1, "cmd_textSizeLarge");
                        printList.add(index + 2, hxPayCouponPrintBean.getCouponValue());
                        printList.add(index + 3, "cmd_textSizeEnd");
                        index = index + 3;
                    }
                }
            } else if (hxPayCouponPrintBean.getCouponType().equalsIgnoreCase("code")) {
                printList.add(index + 1, "QRCodeFlag");
                printList.add(index + 2, "couponQRCode");
                printList.add(index + 3, hxPayCouponPrintBean.getCouponValue());
                index = index + 3;
            } else if (hxPayCouponPrintBean.getCouponType().equalsIgnoreCase("line")) {
                if (hxPayCouponPrintBean.getCouponTag().equalsIgnoreCase("dash")) {//虚线
                    printList.add(index + 1, "----------------------------------------------------");
                    index = index + 1;
                } else if (hxPayCouponPrintBean.getCouponTag().equalsIgnoreCase("empty")) {//空行
                    printList.add(index + 1, "                                                      ");
                    index = index + 1;
                }
//                else if (hxPayCouponPrintBean.getCouponTag().equalsIgnoreCase("solid")){
//                    printList.add(index + 1,"一一一一一一一一一一一一一一一一一一一一一一一一一一一一一一");
//                    index = index + 1;
//                }
            }
        }
    }

    /**
     * 屏蔽银行卡部分号码
     * (按照代码逻辑,实际支付号长度11+时,即隐藏)
     *
     * @return 屏蔽后的银行卡号
     */
    private String maskCardNo(String cardNo) {
        //支付号为空,返回""
        String bankCardNo = "";
        if (StringUtils.isEmpty(cardNo)) {
            return bankCardNo;
        }
        //支付号长度大于10,取前6位,后4位,中间补10个*
        if (org.apache.commons.lang3.StringUtils.length(cardNo) > 10) {
            bankCardNo = org.apache.commons.lang3.StringUtils.substring(cardNo, 0, 6) + "**********"
                    + org.apache.commons.lang3.StringUtils.substring(cardNo, cardNo.length() - 4);
            return bankCardNo;
        }
        return cardNo;
    }

    /**
     * 返回文本宽度
     *
     * @param str
     * @return boolean
     */
    public static int getTextWidth(Paint paint, String str) {
        int iRet = 0;
        if (str != null && str.length() > 0) {
            int len = str.length();
            float[] widths = new float[len];
            paint.getTextWidths(str, widths);
            for (int j = 0; j < len; j++) {
                iRet += (int) Math.ceil(widths[j]);
            }
        }
        return iRet;
    }
}
