/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.print;


/**
 * 小票专柜联打印类型
 *
 * @author guolina 2019-02-26
 */
public enum ReceiptPrintType {
    /**
     * 小票专柜联打印类型为仅打印一份
     */
    OnlyOne("OnlyOne"),
    /**
     * 小票专柜联打印类型为根据专柜数
     */
    ByShop("ByShop");

    private String value;

    /**
     * 初始化一个 ReceiptPrintType 枚举。
     *
     * @param value 打印类型。
     */
    ReceiptPrintType(String value) {
        this.value = value;
    }

    /**
     * 返回打印类型。
     *
     * @return 打印类型。
     */
    public String value() {
        return this.value;
    }

    /**
     * 是否仅打印一份
     *
     * @return true：OnlyOne；false：ByShop
     */
    public boolean isOnlyOne() {
        return this.equals(ReceiptPrintType.OnlyOne);
    }

    /**
     * 是否按专柜数
     *
     * @return true：ByShop；false：OnlyOne
     */
    public boolean isByShop() {
        return this.equals(ReceiptPrintType.ByShop);
    }

}
