/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.print.bean;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.print.anno.PrtPatternAnno;

/**
 * 支付方式Bean，用于打印数据单元。
 *
 * @author guanguangjin 2017-02-05
 * @author guolina      2018-09-26 HIPOSAPP-770 支持销售/退款后增加储值卡和积分余额打印
 */
public class PayMethodPrintBean extends BasePrintBean {

    private String payName;
    private String payNo; //等于 payBuyer
    private double payCount; //等于  payReceipt

    private String payMDiscount;                //商家优惠金额
    private String payDiscount;                 //平台优惠金额

    private String traceNo;     // 交易凭证号
    private String refNo;       // 交易参考号
    private double balance; //支付后可用余额储值卡/积分卡

    /*************************** getter and setter ****************************/

    @PrtPatternAnno(key = "payName")
    public String getPayName() {
        return payName;
    }

    public void setPayName(String payName) {
        this.payName = payName;
    }

    @PrtPatternAnno(key = "payNo")
    public String getPayNo() {
        return payNo;
    }

    public void setPayNo(String payNo) {
        this.payNo = payNo;
    }

    @PrtPatternAnno(key = "traceNo")
    public String getTraceNo() {
        return traceNo;
    }

    public void setTraceNo(String traceNo) {
        this.traceNo = traceNo;
    }

    @PrtPatternAnno(key = "refNo")
    public String getRefNo() {
        return refNo;
    }

    public void setRefNo(String refNo) {
        this.refNo = refNo;
    }

    @PrtPatternAnno(key = "balance")
    public String getBalance() {
        if (balance == 0) {
            return null;
        } else {
            return StringUtils.doubleFormat(balance);
        }
    }

    public void setBalance(double balance) {
        this.balance = balance;
    }

    @PrtPatternAnno(key = "payCount")
    public String getPayCount() {
        return StringUtils.doubleFormat(payCount);
    }

    public void setPayCount(double payCount) {
        this.payCount = payCount;
    }

    public void setPayCount(String payCount) {
        this.payCount = Double.valueOf(payCount);
    }

    @PrtPatternAnno(key = "payMDiscount")
    public String getPayMDiscount() {
        try {
            return Double.parseDouble(payMDiscount) != 0 ? payMDiscount : null;
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return payMDiscount;
        }
    }

    public void setPayMDiscount(String payMDiscount) {
        this.payMDiscount = payMDiscount;
    }

    @PrtPatternAnno(key = "payDiscount")
    public String getPayDiscount() {
        try {
            return Double.parseDouble(payDiscount) != 0 ? payDiscount : null;
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return payDiscount;
        }
    }

    public void setPayDiscount(String payDiscount) {
        this.payDiscount = payDiscount;
    }
}
