/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.print.bean;

import com.hisense.common.util.StringUtils;
import com.hisense.hiaposcmp.constant.GeneralSettings;
import com.hisense.hiaposcmp.print.anno.PrtPatternAnno;

/**
 * 商品信息Bean，用于打印数据单元
 *
 * @author guanguangjin 2017-02-04
 * @author guolina      2019-01-09 HIPOSAPP-968 万科小票增加支持商品单价和优惠后单价打印
 * @author guolina      2019-03-21 HIPOSAPP-1056 万科小票打印字段完善
 * @author wangyaogang  2019-06-05 HIPOSAPP-1154 易收银销售小票-打印商品"货号"字段，增加货号属性
 * @author wangyaogang  2019-08-14 HIPOSAPP-1235 易收银销售小票-打印增加规格和单位
 */
public class SalePluPrintBean extends BasePrintBean {

    private String pluName;                         //商品名称
    private String pluCode;                         //商品编码
    private double pluCount;                        //商品数量
    private String shopCode;                        //柜台号
    private String pluDscName;
    private String itemNo;

    private String pluAbbrName;     // 商品简称
    private double pluPrice;        // 商品标注单价(tagPrice)  //pluUnitPrice
    private double pluPriceAftDsc;  // 商品优惠后单价    //pluPrice
    private double pluTotal;        // 商品标注总金额
    private double pluPriceAct;     // 商品实收总金额
    private double pluDscTotal;     // 商品优惠总金额   //pludsc
    private String cargoNo;         //货号
    private String unit;            // 商品单位
    private String spec;            // 规格

    /*************************** getter and setter ****************************/
    @PrtPatternAnno(key = "unit")
    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    @PrtPatternAnno(key = "spec")
    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    @PrtPatternAnno(key = "cargoNo")
    public String getCargoNo() {
        return cargoNo;
    }

    public void setCargoNo(String cargoNo) {
        this.cargoNo = cargoNo;
    }

    @PrtPatternAnno(key = "pluName", alias = "name")
    public String getPluName() {
        return pluName;
    }

    public void setPluName(String pluName) {
        this.pluName = pluName;
    }

    @PrtPatternAnno(key = "pluAbbrName", alias = "abbrName")
    public String getPluAbbrName() {
        return pluAbbrName;
    }

    public void setPluAbbrName(String pluAbbrName) {
        this.pluAbbrName = pluAbbrName;
    }

    @PrtPatternAnno(key = "pluTotal")
    public String getPluTotal() {
        return StringUtils.doubleFormat(pluTotal);
    }

    public void setPluTotal(double pluTotal) {
        this.pluTotal = pluTotal;
    }

    @PrtPatternAnno(key = "pluPriceAftDsc")
    public String getPluPriceAftDsc() {
        return StringUtils.doubleFormat(pluPriceAftDsc);
    }

    public void setPluPriceAftDsc(double pluPriceAftDsc) {
        this.pluPriceAftDsc = pluPriceAftDsc;
    }

    @PrtPatternAnno(key = "pluDscTotal")
    public String getPluDscTotal() {
        if (GeneralSettings.INSTANCE.getDeviceType().isHSX() || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            return StringUtils.stringPadding(StringUtils.doubleFormat(pluDscTotal), 7, "L");

        } else {
            return StringUtils.doubleFormat(pluDscTotal);
        }
    }

    public void setPluDscTotal(double pluDscTotal) {
        this.pluDscTotal = pluDscTotal;
    }

    public void setPluDscTotal(String pluDscTotal) {
        this.pluDscTotal = Double.valueOf(pluDscTotal);
    }

    @PrtPatternAnno(key = "shopCode")
    public String getShopCode() {
        return shopCode;
    }

    public void setShopCode(String shopCode) {
        this.shopCode = shopCode;
    }


    @PrtPatternAnno(key = "pluCode", alias = "code")
    public String getPluCode() {
        if (GeneralSettings.INSTANCE.getDeviceType().isHSX()  || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            return StringUtils.stringPadding(pluCode, 18, "R");
        } else {
            return pluCode;
        }
    }

    public void setPluCode(String pluCode) {
        this.pluCode = pluCode;
    }

    @PrtPatternAnno(key = "pluCount", alias = "qty")
    public String getPluCount() {
        if (GeneralSettings.INSTANCE.getDeviceType().isHSX()  || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            return StringUtils.stringPadding(StringUtils.doubleFormat(pluCount, "%.3f"), 7, "L");
        } else {
            return StringUtils.doubleFormat(pluCount);
        }
    }

    public void setPluCount(double pluCount) {
        this.pluCount = pluCount;
    }

    public void setPluCount(String pluCount) {
        this.pluCount = Double.valueOf(pluCount);
    }

    @PrtPatternAnno(key = "pluPrice")
    public String getPluPrice() {
        if (GeneralSettings.INSTANCE.getDeviceType().isHSX()  || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            return StringUtils.stringPadding(StringUtils.doubleFormat(pluPrice), 7, "L");
        } else {
            return StringUtils.doubleFormat(pluPrice);
        }
    }

    public void setPluPrice(double pluPrice) {
        this.pluPrice = pluPrice;
    }

    public void setPluPrice(String pluPrice) {
        this.pluPrice = Double.valueOf(pluPrice);
    }

    @PrtPatternAnno(key = "pluPriceAct", alias = "Ss")
    public String getPluPriceAct() {
        if (GeneralSettings.INSTANCE.getDeviceType().isHSX()  || GeneralSettings.INSTANCE.getDeviceType().isSunmiT2()) {
            return StringUtils.stringPadding(StringUtils.doubleFormat(pluPriceAct), 7, "L");
        } else {
            return StringUtils.doubleFormat(pluPriceAct);
        }
    }

    public void setPluPriceAct(double pluPriceAct) {
        this.pluPriceAct = pluPriceAct;
    }

    public void setPluPriceAct(String pluPriceAct) {
        this.pluPriceAct = Double.valueOf(pluPriceAct);
    }

    @PrtPatternAnno(key = "pluDscName")
    public String getPluDscName() {
        return pluDscName;
    }

    public void setPluDscName(String pluDscName) {
        this.pluDscName = pluDscName;
    }

    @PrtPatternAnno(key = "itemNo")
    public String getPluItemNo() {
        return itemNo;
    }

    public void setPluItemNo(String itemNo) {
        this.itemNo = itemNo;
    }
}
