/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.print.printer;


import android.app.Activity;

import com.hisense.hiaposcmp.print.IPrintService;

import java.util.List;

/*******************************************************************************
 * 打印机接口
 *
 * @author guanguangjin 2017-02-20
 * @author xieliyan     2017-08-31   HIPOSAPP-133 增加二维码打印命令eInvoiceQRCode
 * @author xieliyan     2017-09-18   HIPOSAPP-133 电子发票打印：修改打印二维码命令
 * @author wangyaogang  2019-11-27   HIAPOSCMP-284 增加右对齐命令
 * @author guolina      2020-05-18   HIAPOSCMP-702 吉麦隆淘鲜达营销方案对接涉及慧收银调整增加支付明细和赠券打印
 ******************************************************************************/
public interface IPOSPrinter {
    // 打印机命令数组
    String printCMD[] = new String[]{"cmd_lineBreak", "cmd_centerStart", "cmd_centerEnd",
            "cmd_alignRightStart", "cmd_alignRightEnd",
            "cmd_paperCut", "BarCodeFlag", "TitleLogo", "BarCode2Flag", "eInvoiceQRCode",
            "cmd_bold_2_start", "cmd_bold_2_end", "cmd_bold_3_start", "cmd_bold_3_end",
            "cmd_textSizeMiddle", "cmd_textSizeLarge", "cmd_textSizeEnd", "cmd_print_image", "hxPayCouponList", "couponQRCode"};

    /**
     * 打印方法
     *
     * @param printList 打印字符串列表
     * @param context   当前活动对象
     */
    void print(List<String> printList, Activity context, IPrintService.PrtPatternType type, String invoiceUrl);
}
