/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.service.sale;

import android.content.Context;
import android.os.Handler;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.constant.GeneralSettings;

/**
 * 自动检测未上传流水服务。
 *
 * @author guolina     2019-10-21 HIPOSAPP-1317 利客来未上传流水自动上传
 */
public class SaleAutoUploadService {

    private Context context;
    private int time;
    private Handler handler = new Handler();
    private SaleApplicationService saleApplicationService;

    /**
     * 初始化一个 {@code SaleAutoUploadService} 的实例。
     *
     * @param context Context
     */
    public SaleAutoUploadService(Context context) {
        this.context = context;
        saleApplicationService = new SaleApplicationService(context);
    }


    private Runnable task = new Runnable() {
        public void run() {
            // TODOAuto-generated method stub
            time = GeneralSettings.INSTANCE.getTimeOfUpload();
            LoggerUtils.getLogger().debug("上传流水间隔：" + time);
            if (time != 0) {
                handler.postDelayed(this, time * 1000 * 60);
                saleApplicationService.uploadLocalDataAuto();
            }
        }
    };

    /**
     * 开启未上传流水检测线程
     */
    public void startSaleUpload() {

        handler.post(task);//立即调用
    }

    /**
     * 移除未上传流水检测线程
     */
    public void removeSaleUpload() {
        handler.removeCallbacks(task);
        LoggerUtils.getLogger().debug("移除线程");
    }


}
