package com.hisense.hiaposcmp.service.sale;

import android.app.IntentService;
import android.content.Intent;

import com.hisense.common.util.ListUtils;
import com.hisense.common.util.LoggerUtils;
import com.hisense.hipos.model.BaseSaleModel;
import com.hisense.hipos.webapi.sale.SaleSubmitResultData;
import com.hisense.webapi.Callback;

import java.util.List;

import androidx.annotation.Nullable;

/**
 * 流水自动上传服务
 *
 * @author xieliyan 2018-08-02 HIAPOS-5
 */
public class SaleService extends IntentService {

    private SaleApplicationService saleApplicationService;

    public SaleService() {
        super("SaleService");
    }

    @Override
    protected void onHandleIntent(@Nullable Intent intent) {
        reSubmit();
    }

    public void reSubmit() {

        saleApplicationService = new SaleApplicationService(this);

        List<BaseSaleModel> notUploadSales = saleApplicationService.getNotUploadSales();
        if (ListUtils.isEmpty(notUploadSales)) {
            return;
        }
        for (BaseSaleModel notUploadSale : notUploadSales) {
            try {
                saleApplicationService.upload(notUploadSale, new Callback<SaleSubmitResultData>() {
                    @Override
                    public void onSuccess(SaleSubmitResultData submitResultData) {
                        LoggerUtils.getLogger().info("流水重传成功:" + notUploadSale.getSaleNo());
                    }

                    @Override
                    public void onError(Throwable throwable) {
                        LoggerUtils.getLogger().error("流水重传失败:" + throwable.toString());
                    }
                });
            } catch (Exception e) {
                LoggerUtils.getLogger().error("获取重传流水信息异常:" + e.toString());
                break;
            }
        }
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
    }
}
