package com.hisense.hiaposcmp.util;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hipos.webapi.RSAService;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class FileUtils {

    public static void writeFileContent(String fileName,String content){
        File file = new File(fileName);
        FileWriter writer=null;
        if (!file.exists()) {
            try {
                file.createNewFile();

                writer = new FileWriter(file);
                if (null != content) {
                    writer.write(content);
                }
                writer.flush();

            } catch (IOException e) {
                LoggerUtils.getLogger().debug("创建文件异常" + e.toString());
                e.printStackTrace();
            }finally {
                if (writer != null) {
                    try {
                        writer.close();
                    } catch (IOException e1) {
                        e1.printStackTrace();
                    }
                }
            }
        }else {
            LoggerUtils.getLogger().debug("文件已存在" );
        }
    }



    public static String readFileContent(String fileName) {
        File file = new File(fileName);
        if(!file.exists()){
           return null;
        }
        BufferedReader reader = null;
        StringBuffer sbf = new StringBuffer();
        try {
            reader = new BufferedReader(new FileReader(file));
            String tempStr;
            while ((tempStr = reader.readLine()) != null) {
                sbf.append(tempStr);
            }
            reader.close();
            return sbf.toString();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
        return sbf.toString();
    }
}
