package com.hisense.hiaposcmp.util;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;

import com.hisense.common.util.LoggerUtils;
import com.hisense.hiaposcmp.App;

/**
 * Created by zhuguangsheng on 2018/5/7.
 */

public class MetaDataUtils {

    public final static String METAKEY_CUSTOM = "APP_CUSTOM";        //定制名,对应后台的渠道概念

    /**
     * 获取指定的meta String信息
     * 对了规范对meta信息的读取，设为private不对外开放,具体获取的meta请写函数包装
     *
     * @param metaName
     * @return
     * @throws Exception
     */
    private static String getMetaStringData(String metaName) throws Exception {
        Context context = App.getAppContext();
        if (context == null) {
            throw new Exception("meta上下文不存在");
        }

        ApplicationInfo appInfo;
        String metaString = "";
        try {
            appInfo = context.getPackageManager()
                    .getApplicationInfo(context.getPackageName(),
                            PackageManager.GET_META_DATA);
            metaString = appInfo.metaData.getString(metaName);
            if (CommonUtils.isWriteOk()){
                LoggerUtils.getLogger().info("metaString=" + metaString);
            }

            if (metaString != null) {
                return metaString;
            } else {
                if (CommonUtils.isWriteOk()){
                    LoggerUtils.getLogger().error("not define meta:");
                }
                throw new Exception("未定义meta:" + metaName);
            }
        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
            throw new Exception("获取meta失败");
        }
    }

    /**
     * 获取项目定制名
     *
     * @return
     * @throws Exception
     */
    public static String getCustom() throws Exception {
        return getMetaStringData(METAKEY_CUSTOM);
    }
}
