package com.hisense.hiaposcmp.util;

import com.alibaba.fastjson.JSONObject;
import com.hisense.common.util.JSONUtils;
import com.hisense.common.util.StringUtils;
import com.hisense.hipos.webapi.config.ConfigResultData;

/**
 * 中间件配置
 *
 * @author zhuguangsheng on 2018/10/15.
 */
public class MidConfigUtils {

    private static final String MIDCONFIG_SP_KEY = "midconfig";

    public static void initMidConfigParams() {
        try {
            SpUtils.put(MIDCONFIG_SP_KEY, "");
        } catch (Exception e) {

        }
    }

    public static void saveMidConfigParams(ConfigResultData configResultData) {
        JSONObject resultData = JSONUtils.javaBeanToJSON(configResultData);
        if (resultData == null) {
            return;
        }

        try {
            SpUtils.put(MIDCONFIG_SP_KEY, resultData.toString());
        } catch (Exception e) {

        }
    }

    public static JSONObject loadMidConfigParams() {
        JSONObject params = new JSONObject();
        String value;
        try {
            value = (String) SpUtils.get(MIDCONFIG_SP_KEY, "{}");
            params = JSONObject.parseObject(value);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return params;
    }

    public static synchronized String getMidConfigValue(String keyName) {
        String name;
        try {
            JSONObject params = loadMidConfigParams();
            name = params.getString(keyName);
            if (name == null) {
                name = "";
            }
        } catch (Exception e) {
            name = "";
        }
        return name;
    }

    public static String getFlavorCustom() {
        String name;
        try {
            JSONObject params = loadMidConfigParams();
            name = params.getString("projectcustom");
            if (name == null) {
                name = "";
            }
        } catch (Exception e) {
            name = "";
        }

        return name;
    }

    public static synchronized String getFeatureInMidConfig(String key) {
        String featureValue;
        try {
            JSONObject params = loadMidConfigParams();
            JSONObject features = params.getJSONObject("features");
            if (JSONUtils.isEmpty(features)) {
                featureValue = "0";
            } else {
                featureValue = features.getString(key);
                if (StringUtils.isEmpty(featureValue)) {
                    featureValue = "0";
                }
            }
        } catch (Exception e) {
            featureValue = "0";
        }

        return featureValue;
    }

    public static synchronized String getSettingInMidConfig(String key) {
        String settingValue;
        try {
            JSONObject params = loadMidConfigParams();
            JSONObject settings = params.getJSONObject("settings");
            if (JSONUtils.isEmpty(settings)) {
                settingValue = "";
            } else {
                settingValue = settings.getString(key);
                if (settingValue == null) {
                    settingValue = "";
                }
            }
        } catch (Exception e) {
            settingValue = "";
        }

        return settingValue;
    }
}
