/***************************************************************************************************
 * Copyright (c) 2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hiaposcmp.util;

import java.io.File;

/*******************************************************************************
 * 功能说明：root检测
 * 版权说明：青岛海信智能商用系统有限公司  版权所有
 * 创建：    fujiaxin 2017-03-14
 * 修改：
 ******************************************************************************/

public class RootTools {

    private static String LOG_TAG = RootTools.class.getName();

    public static boolean isDeviceRooted() {
//        if (checkRootMethod1()) {
//            return true;
//        }
        if (checkRootMethod2() || checkRootMethod3() || isRooted()) {
            return true;
        }
        return false;
    }

    public static boolean checkRootMethod1() {
        String buildTags = android.os.Build.TAGS;

        if (buildTags != null && buildTags.contains("test-keys")) {
            return true;
        }
        return false;
    }

    public static boolean checkRootMethod2() {
        try {
            File file = new File("/system/app/Superuser.apk");
            if (file.exists()) {
                return true;
            }
        } catch (Exception e) {
        }

        return false;
    }

    public static boolean checkRootMethod3() {
        if (new ExecShell().executeCommand(ExecShell.SHELL_CMD.check_su_binary) != null) {
            return true;
        } else {
            return false;
        }
    }

    /*
     * 通过判断是否存在su文件来决断系统是否已经root
     * */
    public static boolean isRooted() {
        boolean rootState = false;
        String Paths[] = {"/system/bin/su", "/system/xbin/su", "/system/sbin/su", "/sbin/su", "/vendor/bin/su"};
        try {
            for (String s : Paths) {
                if (new File(s).isFile()) {
                    rootState = true;
                    break;
                } else {
                    rootState = false;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return rootState;
    }
}