package com.hisense.hiaposcmp.view;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.DashPathEffect;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PathEffect;
import android.util.AttributeSet;
import android.view.View;

/**
 * 自定义虚线
 *
 * @author xieliyan 2017-12-11
 */

public class DashedLineView extends View {
    /**
     * 构建实例
     *
     * @param context 上下文
     * @param attrs   特征
     */
    public DashedLineView(Context context, AttributeSet attrs) {
        super(context, attrs);

    }

    /**
     * 绘图
     *
     * @param canvas 画布
     */
    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        Paint paint = new Paint();
        paint.setStyle(Paint.Style.STROKE);
        paint.setColor(Color.LTGRAY);
        Path path = new Path();
        path.moveTo(0, 10);
        path.lineTo(480, 10);
        PathEffect effects = new DashPathEffect(new float[]{5, 5, 5, 5}, 1);
        paint.setPathEffect(effects);
        canvas.drawPath(path, paint);
    }
}
