package com.hisense.hiaposcmp.view.IView.sale;

import android.view.View;

import com.hisense.crm.vip.Vip;
import com.hisense.hiaposcmp.view.IView.IBaseView;
import com.hisense.hipos.model.BaseSalePluModel;

/**
 * 微信的销售view
 *
 * @author zhuguangsheng on 2018/7/2.
 * @author dukunbiao(null)  2019-07-23  重构
 */
public interface ISaleView extends IBaseView {

    /**
     * 隐藏购物车提示
     */
    void hideShoppingCartPrompt();

    /**
     * 展示购物车提示
     */
    void showShoppingCartPrompt();

    /**
     * 显示购物袋弹出窗口
     */
    void showBagsPopupWindow();

    /**
     * 隐藏购物袋弹出窗口
     */
    void hideBagsPopupWindow();

    /**
     * 更新所有总计信息
     *
     * @param count     数量
     * @param totalDsc  优惠金额
     * @param totalRecv 实收金额
     */
    void updateTotal(int count, String totalDsc, String totalRecv);

    /**
     * 更新商品列表适配器
     */
    void updateAdapter();

    /**
     * 增加商品
     *
     * @param position
     * @param salePluModel
     */
    void addPlu(int position, BaseSalePluModel salePluModel);

    /**
     * 删除商品
     *
     * @param position
     */
    void removePlu(int position);

    /**
     * 调整商品数量
     *
     * @param position
     */
    void changeQuantity(int position);

    /**
     * 更新会员信息
     *
     * @param vip
     */
    void updateVipInfo(Vip vip);

    /**
     * 调起支付界面
     */
    void callPayActivity();

    /**
     * 满减接口调用成功
     *
     * @param view
     */
    void promotionCalcSuccess(View view);

    /**
     * 调起加价换购界面
     */
    void callGiftActivity();

    /**
     * 把列表卷动到最下面
     */
    void scrollListToBottom();
    /**
     * 把列表卷动到指定位置
     */
    void scrollListToPosition(int position);

    /**
     * 商品数量调整是否能使用
     *
     * @param decreaseEnabled
     */
    void setPluDeleteEnabled(boolean decreaseEnabled);

    /**
     * 回到欢迎界面
     */
    void backToWelcomeActivity();

    /**
     * 大码商品
     *
     * @param pluModel
     */
    void pluQueryNoCode(BaseSalePluModel pluModel);

    /**
     * 检查结账日期成功
     */
    void checkoutSuccess();

    /**
     * 检查结账日期失败
     */
    void checkoutError();

    /**
     * 流水上传成功
     */
    void submitSuccess();

    /**
     * 流水上传失败
     *
     * @param msg
     */
    void submitFail(String msg);

    /**
     * 流水重新上传成功
     *
     * @param msg
     */
    void reSubmitSuccess(String msg);

    /**
     * 流水重新上传失败
     *
     * @param msg
     */
    void reSubmitFail(String msg);

    /**
     * 心跳检测失败
     *
     * @param msg
     */
    void onlineFail(String msg);
}
