/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hiaposcmp.view;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.RectF;
import android.util.AttributeSet;
import android.view.View;

import com.hisense.hiaposcmp.R;

/**
 * 锯齿边缘
 *
 * @author xieliyan 2018-03-16 HIPOSAPP-359
 */
public class SawtoothView extends View {

    private Paint paint = new Paint();

    public SawtoothView(Context context, AttributeSet attrs) {
        super(context, attrs);

        paint.setColor(getResources().getColor(R.color.vip_coupon_sawtooth));
        //消除锯齿
        paint.setAntiAlias(true);
        paint.setStrokeWidth(0);
        paint.clearShadowLayer();
        //设置镂空（方便查看效果）
        paint.setStyle(Paint.Style.FILL);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        int size = 20;
        int width = 2;
        int halfWidth = getWidth() / 2;
        for (int i = 0; i <= getHeight(); i += size) {
            int j = i / size;
            Path path = new Path();
            path.moveTo(halfWidth, j * (size + width));
            path.addArc(new RectF(0, j * (size + width), halfWidth + 30, j * (size + width) + size), 90, 180);
            canvas.drawPath(path, paint);
        }
    }
}
