package com.hisense.common.util;

import com.hisense.common.Context;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import de.mindpipe.android.logging.log4j.LogConfigurator;

/**
 * @author xly on 2019-03-21.
 * @author dukunbiao(null)  2019-09-06  重构
 * @author guolina          2020-04-24  HIAPOSCMP-728 tradelog未重新登陆的情况下跨天，要新建文件
 */
public class LoggerUtils {

    public static final String LOG_PATH = Context.logPath()+"tradelog/";
    public static final String PRE_LOG_NAME = "TradeLog-";
    public static final String SUF_LOG_NAME = ".log";

    private static Logger logger;
    private static LogConfigurator logConfigurator;

    public static Logger getLogger() {
        if (logConfigurator == null || !logConfigurator.getFileName().substring(LOG_PATH.length() + 9,LOG_PATH.length() + 19).equals(DateUtils.dateFormat("yyyy-MM-dd"))) {
            init();
        }

        if (logger == null) {
            logger = Logger.getLogger("TradeLog");
        }

        return logger;
    }

    private static void init() {
        if (logConfigurator == null || !logConfigurator.getFileName().substring(LOG_PATH.length() + 9,LOG_PATH.length() + 19).equals(DateUtils.dateFormat("yyyy-MM-dd"))) {
            logConfigurator = new LogConfigurator();
        }

        logConfigurator.setMaxBackupSize(1024);
        logConfigurator.setFileName(LOG_PATH + PRE_LOG_NAME + DateUtils.dateFormat("yyyy-MM-dd") + SUF_LOG_NAME);
        logConfigurator.setRootLevel(Level.ALL);
        logConfigurator.setLevel("org.apache", Level.ERROR);
        logConfigurator.configure();
    }

    public static String getMessage(String position, String method, String content) {
        return "[" + position + "]" + "\n" + "方法：" + method + "\n" + "参数：" + content + "\n";
    }

}
