package com.hisense.common.util;

import com.hisense.common.common.utils.Signature;
import com.hisense.common.constant.CommonConstants;

import java.util.Map;

/**
 * 签名、验签
 *
 * @author dukunbiao(null)  2018-07-02
 */
public class SignUtils {

    public static String signCreate(Map<String, String> responseParams, String privateKey, String charset, String signType) {
        switch (signType.toUpperCase()) {
            case CommonConstants.SIGN_TYPE_MD5:
                return Signature.MD5sign(responseParams, privateKey, charset);
            case CommonConstants.SIGN_TYPE_RSA:
                return Signature.rsaSign(responseParams, privateKey, charset);
            case CommonConstants.SIGN_TYPE_RSA2:
                return Signature.rsa256Sign(responseParams, privateKey, charset);
            default:
                return null;
        }
    }
}
