/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.card;

import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.util.List;


/**
 * 购买储值卡请求数据
 *
 * @author lizhixin 2019-04-08 HIORP-130
 */
public class CardBuyRequestData {


    /**
     * 组织号
     */
    public String orgCode;

    /**
     * 会员卡号
     */
    public String cardNo;

    /**
     * 1-卡面号； 3-会员卡ID
     */
    public int cardNoType;

    /**
     * 订单号
     */
    public String billNo;

    /**
     * 销售数量
     */
    public String saleCount;

    /**
     * 总金额
     */
    public String total;

    /**
     * 折扣金额（优惠掉的金额）
     */
    public String dscTotal;

    /**
     * 实收金额
     */
    public String payTotal;

    /**
     * 明细信息
     */
    public List<CardBuyItemRequestData> items;

    /**
     * 支付信息
     */
    public List<CardBuyPayRequestData> pay;

    /**
     * 返回新的WebApi请求
     *
     * @return WebApi请求
     */
    public static Request<CardBuyRequestData> request(String orgCode, String cardNo, int cardNoType, String billNo, String saleCount, String total, String dscTotal, String payTotal, List<CardBuyItemRequestData> items, List<CardBuyPayRequestData> pay) {
        CardBuyRequestData requestData = new CardBuyRequestData();
        requestData.orgCode = orgCode;
        requestData.cardNo = cardNo;
        requestData.cardNoType = cardNoType;
        requestData.billNo = billNo;
        requestData.saleCount = saleCount;
        requestData.total = total;
        requestData.dscTotal = dscTotal;
        requestData.payTotal = payTotal;
        requestData.items = items;
        requestData.pay = pay;

        StringBuilder builder = new StringBuilder();
        builder.append("{orgCode:");
        builder.append(orgCode);
        builder.append(",cardNo:");
        builder.append(cardNo);
        builder.append(",cardNoType:");
        builder.append(cardNoType);
        builder.append(",billNo:");
        builder.append(billNo);
        builder.append(",saleCount:");
        builder.append(saleCount);
        builder.append(",total:");
        builder.append(total);
        builder.append(",dscTotal:");
        builder.append(dscTotal);
        builder.append(",payTotal:");
        builder.append(payTotal);
        builder.append(",items:[");
        for (CardBuyItemRequestData item : items) {
            builder.append(item.toString());
        }
        builder.append("]");
        builder.append(",pay:[");
        for (CardBuyPayRequestData item : pay) {
            builder.append(item.toString());
        }
        builder.append("]");
        builder.append("}");
        System.out.println(builder.toString());

        return WebApi.sign(requestData);
    }
}
