/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.card;

import com.hisense.crm.card.CardNo;
import com.hisense.crm.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;


/**
 * 卡赠送请求数据
 *
 * @author guanguangjin 2019-04-05 HIORP-121
 */
public class CardGiftRequestData {

    /**
     * 卡面号
     */
    public String cardFaceNo;

    /**
     * 组织号
     */
    public String orgCode;

    /**
     * 赠送人卡号
     * 0-卡内号
     * 1-卡面号
     * 2-手机号
     * 3-会员卡ID
     */
    public String fromCardNo;

    /**
     * 赠送人卡类型
     */
    public Integer fromCardNoType;

    /**
     * 受赠人卡号
     */
    public String toCardNo;

    /**
     * 受赠人卡类型
     * 0-卡内号
     * 1-卡面号
     * 2-手机号
     * 3-会员卡ID
     */
    public Integer toCardNoType;


    /**
     * 返回新的WebApi请求
     *
     * @param cardFaceNo 卡面号
     * @param fromCardNo 赠送人卡号
     * @param toCardNo   受赠人卡号
     * @return WebApi请求
     */
    public static Request<CardGiftRequestData> request(String cardFaceNo, CardNo fromCardNo, CardNo toCardNo) {
        CardGiftRequestData requestData = new CardGiftRequestData();
        requestData.cardFaceNo = cardFaceNo;
        requestData.orgCode = Context.orgCode();
        requestData.fromCardNo = fromCardNo.value();
        requestData.fromCardNoType = fromCardNo.getTypeCode();
        requestData.toCardNo = toCardNo.value();
        requestData.toCardNoType = toCardNo.getTypeCode();

        return WebApi.sign(requestData);
    }
}
