/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.card;

import com.hisense.crm.card.CardNo;
import com.hisense.crm.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 储值卡付款码请求数据
 *
 * @author guanguangjin 2019-04-05 HIORP-128 储值卡付款码
 */
public class CardPayCodeRequestData {

    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 卡号
     */
    public String cardNo;

    /**
     * 卡号类型
     */
    public Integer cardNoType;


    /**
     * 创建新的WebApi请求
     *
     * @param cardNo 付款卡号
     * @return WebApi 请求
     */
    public static Request<CardPayCodeRequestData> request(CardNo cardNo) {
        CardPayCodeRequestData requestData = new CardPayCodeRequestData();
        requestData.orgCode = Context.orgCode();
        requestData.cardNo = cardNo.value();
        requestData.cardNoType = cardNo.getTypeCode();

        return WebApi.sign(requestData);
    }
}
