/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.card;

import com.hisense.crm.card.Card;

/**
 * 储值卡查询的返回结果。
 *
 * @author zhangsai    2017-10-09
 * @author wangyaogang 2019-10-08 HIPOSAPP-1305 储值卡消费可限制品牌品类
 */
final class CardQueryResultData {
    /**
     * 卡面号
     */
    public String cardFaceNo;
    /**
     * 卡号
     */
    public String cardNo;
    /**
     * 卡状态
     */
    public String cardStatus;
    /**
     * 卡类型编码
     */
    public String cardType;
    /**
     * 卡类型名称
     */
    public String cardTypeName;
    /**
     * 有效期
     */
    public String expireDate;
    /**
     * 可用余额
     */
    public String usableTotal;
    /**
     * 会员卡号
     */
    public String vipCardNo;
    /**
     * 使用范围控制,
     * 0 – 不控制
     * 1 – 提货
     * 2 – 限制商品使用范围
     */
    public String useLimit;

    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 储值卡信息
     */
    public static Card handleResult(CardQueryResultData resultData) {
        return new Card.Builder(resultData.cardFaceNo, resultData.cardNo)
                .setCardStatus(resultData.cardStatus)
                .setCardType(resultData.cardType, resultData.cardTypeName)
                .setExpireDate(resultData.expireDate)
                .setUsableTotal(Double.valueOf(resultData.usableTotal))
                .setVipCardNo(resultData.vipCardNo)
                .setUseLimit(resultData.useLimit)
                .build();
    }
}
