package com.hisense.crm.webapi.card;

import com.hisense.crm.Cashier;
import com.hisense.crm.card.CardNo;
import com.hisense.crm.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * Created by caokai on 2019/2/18.
 */

public class CardRechargeRequestData {
    /**
     * 结账日期。
     */
    public String accDate;
    /**
     * 单据号。
     */
    public String billNo;
    /**
     * 卡号。
     */
    public String cardNo;
    /**
     * 卡类型。
     */
    public int cardNoType;
    /**
     * 收款员编码。
     */
    public String cshCode;
    /**
     * 收款员名称。
     */
    public String cshName;
    /**
     * 部门编码。
     */
    public String depCode;
    /**
     * 充值金额。
     */
    public double depositTotal;
    /**
     * 组织号。
     */
    public String orgCode;
    /**
     * 支付方式编码。
     */
    public String payCode;
    /**
     * 支付方式名称。
     */
    public String payName;
    /**
     * 外部支付订单号。
     */
    public String payNo;
    /**
     * 支付金额。
     */
    public double payTotal;
    /**
     * 收款机号。
     */
    public String posNo;
    /**
     * 赠送金额。
     */
    public double presentTotal;
    /**
     * 交易日期。
     */
    public String saleDate;
    /**
     * 是否赠送。0-不支持赠送；1-整单赠送；2-赠送
     */
    public int isPresent;

    public static Request<CardRechargeRequestData> request(CardNo cardNo, Cashier cashier,
                                                           Double total, Double giftTotal, String refPayNo, String accDate) {
        CardRechargeRequestData requestData = new CardRechargeRequestData();
        requestData.cardNo = cardNo.value();
        requestData.cardNoType = cardNo.getTypeCode();
        requestData.orgCode = Context.orgCode();
        requestData.posNo = Context.posNo();
        requestData.cshCode = cashier != null ? cashier.getCode() : "";
        requestData.cshName = cashier != null ? cashier.getName() : "";
//        requestData.payCode = payment.payCode();
//        requestData.payName = payment.payName();
//        requestData.payTotal = payment.amount();
//        requestData.saleDate = payment.payTime();
//        requestData.billNo = payment.saleNo();
        requestData.depositTotal = total;
        requestData.presentTotal = giftTotal;
        requestData.payNo = refPayNo;
        requestData.accDate = accDate;
        requestData.isPresent = 2;//支持充值有赠送金额和无赠送金额的情况

        return WebApi.sign(requestData);
    }

}
