/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.coupon;

import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 会员优惠券绑定请求数据
 *
 * @author lizhixin 2019-05-28 会员优惠券绑定接口
 */
public class CouponBindRequestData {


    /**
     * 促销单号
     */
    public String billNo;

    /**
     * 用户openId
     */
    public String openId;

    /**
     * 券面额
     */
    public String couponValue;

    /**
     * 券类型编码
     */
    public String typeCode;

    /**
     * 会员卡面号
     */
    public String cardFaceNo;

    /**
     * 有效开始日期
     */
    public String beginDate;

    /**
     * 有效结束日期
     */
    public String endDate;

    /**
     * 领用数量
     */
    public String count;

    /**
     * 返回新的WebApi请求
     *
     * @return WebApi请求
     */
    public static Request<CouponBindRequestData> request(String billNo, String openId, String couponValue, String typeCode, String cardFaceNo, String beginDate, String endDate, String count) {
        CouponBindRequestData requestData = new CouponBindRequestData();
        requestData.billNo = billNo;
        requestData.openId = openId;
        requestData.couponValue = couponValue;
        requestData.typeCode = typeCode;
        requestData.cardFaceNo = cardFaceNo;
        requestData.beginDate = beginDate;
        requestData.endDate = endDate;
        requestData.count = count;
        System.out.println("POS中间件会员优惠券绑定接口请求参数：" + requestData.toString());

        return WebApi.sign(requestData);
    }

    @Override
    public String toString() {
        return new StringBuilder()
                .append("{billNo:")
                .append(billNo)
                .append(",openId:")
                .append(openId)
                .append(",couponValue:")
                .append(couponValue)
                .append(",typeCode:")
                .append(typeCode)
                .append(",cardFaceNo:")
                .append(cardFaceNo)
                .append(",beginDate:")
                .append(beginDate)
                .append(",endDate:")
                .append(endDate)
                .append(",count:")
                .append(count)
                .append("}")
                .toString();
    }

}
