/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.coupon;

import com.hisense.crm.webapi.Context;
import com.hisense.hipos.coupon.UsableCoupon;
import com.hisense.hipos.model.SaleModel;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.util.ArrayList;
import java.util.Collection;


/**
 * SCRM券撤销请求数据。
 *
 * @author xieliyan  2019-08-02
 */
public class ScrmCouponCancelRequestData {

    private String orgCode;//门店编码
    private String oldSaleNo;//水号
    private ArrayList<String> qNo;//券号
    private String vipCardNo;

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getOldSaleNo() {
        return oldSaleNo;
    }

    public void setOldSaleNo(String oldSaleNo) {
        this.oldSaleNo = oldSaleNo;
    }

    public ArrayList<String> getqNo() {
        return qNo;
    }

    public void setqNo(ArrayList<String> qNo) {
        this.qNo = qNo;
    }

    public String getVipCardNo() {
        return vipCardNo;
    }

    public void setVipCardNo(String vipCardNo) {
        this.vipCardNo = vipCardNo;
    }

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param usableCoupons 已核销的券
     * @return WebAPI 请求。
     */
    public static Request<ScrmCouponCancelRequestData> request(Collection<UsableCoupon> usableCoupons, SaleModel saleModel, SalePayModel payModel) {
        ScrmCouponCancelRequestData requestData = new ScrmCouponCancelRequestData();
        ArrayList<String> qNoList = new ArrayList<>();
        for (UsableCoupon usableCoupon : usableCoupons) {
            qNoList.add(usableCoupon.coupon().no());
        }
        requestData.setqNo(qNoList);
        requestData.setOrgCode(Context.orgCode());
        requestData.setOldSaleNo(saleModel.getSaleNo());
        if (payModel != null) {
            requestData.setVipCardNo(payModel.cardNo.value());
        } else {
            requestData.setVipCardNo(saleModel.getVip().card().cardFaceNo());
        }

        return WebApi.sign(requestData);
    }
}
