/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.coupon;


import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.CouponType;
import com.hisense.hipos.coupon.SaleItemShare;
import com.hisense.hipos.coupon.UsableCoupon;
import com.hisense.hipos.model.MainSaleModel;
import com.hisense.hipos.model.SaleModel;

import java.util.List;

/**
 * SCRM券核销响应数据。
 *
 * @author xieliyan  2019-08-02
 */

public class ScrmCouponUseResultData {

    private String thisConsumeAmount;         // 本笔核销金额
    private String billNo;  // crm支付流水号
    private String consumeNo; // 被核销的券号
    private String isShare; //券核销金额是否分摊到商品:1-分摊到商品；0-作为支付方式记录
    private List<ScrmCouponUseResultPlu> plu;//商品分摊

    public String getThisConsumeAmount() {
        return thisConsumeAmount;
    }

    public void setThisConsumeAmount(String thisConsumeAmount) {
        this.thisConsumeAmount = thisConsumeAmount;
    }

    public String getBillNo() {
        return billNo;
    }

    public void setBillNo(String billNo) {
        this.billNo = billNo;
    }

    public String getConsumeNo() {
        return consumeNo;
    }

    public void setConsumeNo(String consumeNo) {
        this.consumeNo = consumeNo;
    }

    public String getIsShare() {
        return isShare;
    }

    public void setIsShare(String isShare) {
        this.isShare = isShare;
    }

    public List<ScrmCouponUseResultPlu> getPlu() {
        return plu;
    }

    public void setPlu(List<ScrmCouponUseResultPlu> plu) {
        this.plu = plu;
    }

    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 赠券的可用余额及商品分摊
     */
    public static UsableCoupon handleResult(String qNo, ScrmCouponUseResultData resultData) {
        SaleModel saleModel = MainSaleModel.getInstance().getSaleModel();
        if (resultData != null) {
            Coupon coupon = new Coupon.Builder()
                    .coupon(qNo, CouponType.valueOf(0))
                    .checkCode("")
                    .values(Double.valueOf(resultData.getThisConsumeAmount()))
                    .available(Double.valueOf(resultData.getThisConsumeAmount()))
                    .endsAt("")
                    .build();

            UsableCoupon usableCoupon = new UsableCoupon(qNo, coupon, null);
            usableCoupon.use(Double.valueOf(resultData.getThisConsumeAmount()));

            if (resultData.plu != null) {
                for (ScrmCouponUseResultPlu plu : resultData.plu) {
                    SaleItemShare share = new SaleItemShare.Builder()
                            .item(1, Integer.parseInt(plu.getSerialNo()))
                            .plu(plu.getPluCode(), plu.getPluId())
                            .share(Double.valueOf(plu.getqShare()))
                            //FIXME null 这个返回参数可能有问题，不了解这个接口
                            .total(saleModel.getPlu(Integer.parseInt(plu.getSerialNo())).getTotalRecv(), saleModel.getPlu(Integer.parseInt(plu.getSerialNo())).getTotalPaid())
                            .build();
                    usableCoupon.addShare(share);
                }
            }

            return usableCoupon;
        }
        return null;
    }
}
