/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.points;

import com.hisense.crm.card.VipCard;
import com.hisense.webapi.WebApiException;

/**
 * 积分查询的返回结果。
 *
 * @author zhangsai    2017-10-10
 * @author zhangsai    2018-02-02 HIPOSAPP-315
 * @author zhangsai    2018-02-02 HIPOSAPP-631  未返回积分方案时抛出异常"没有积分卡记录"
 * @author wangyaogang 2019-08-15 HIPOSAPP-1278 调整积分查询接口，增加pointsConRatio积分支付换算比例
 */
final class PointsQueryResultData {
    /**
     * 会员卡卡面号
     */
    public String cardFaceNo;
    /**
     * 会员卡类型编码
     */
    public String cardType;
    /**
     * 会员卡类型名称
     */
    public String cardTypeName;
    /**
     * 会员卡有效期
     */
    public String expireDate;
    /**
     * 可用积分
     */
    public String usablePoints;
    /**
     * 积分可抵扣金额
     */
    public String usableBalance;
    /**
     * 会员卡号
     */
    public String vipCardNo;
    /**
     * 会员姓名
     */
    public String vipName;
    /**
     * 可用金额
     */
    public String usableTotal;

    /**
     * 积分支付换算比例
     */
    public String pointsConRatio;

    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 储值卡信息
     */
    public static VipCard handleResult(PointsQueryResultData resultData) {
        return new VipCard.Builder(resultData.cardFaceNo, resultData.vipName)
                .cardType(resultData.cardType, resultData.cardTypeName)
                .expireDate(resultData.expireDate)
                .usable(Double.valueOf(resultData.usablePoints), Double.valueOf(resultData.usableBalance))
                .usableTotal(Double.valueOf(resultData.usableTotal))
                .vipCardNo(resultData.vipCardNo)
                .pointsConRatio(resultData.pointsConRatio)
                .build();
    }
}
