package com.hisense.crm.webapi.points;

/**
 * 积分原路返回预判的请求的退货商品。
 *
 * @author zhangsai 2018-05-22
 * @author panghuanwei 2019-12-19 积分原路返回预判，请求的退货商品，增加属性
 * @author wangyaogang 2020-03-24 HIPOSAPP-1393 积分原路返回预判接口调整
 */
final class RegressPlu {
    /**
     * 部门编码
     */
    public String depCode;
    /**
     * 部门名称
     */
    public String depName;
    /**
     * 行号
     */
    public int itemNo;
    /**
     * 页号
     */
    public int pageNo;
    /**
     * 商品编码
     */
    public String pluCode;
    /**
     * 商品名称
     */
    public String pluName;
    /**
     * 发生价格
     */
    public String price;
    /**
     * 数量
     */
    public String quantity;
    /**
     * 商品原价
     */
    public String tagPrice;
    /**
     * 应收金额
     */
    public String total;
    /**
     * 优惠金额
     */
    public String totalDsc;
    /**
     * 实收金额
     */
    public String totalRecv;
    /**
     * 品牌编码
     */
    public String brandCode;
    /**
     * 品类编码
     */
    public String classCode;

    /**
     * 初始化一个 {@code RegressPlu} 的实例。
     */
    public RegressPlu() {

    }

    /**
     * 初始化一个 {@code RegressPlu} 的实例。
     *
     * @param depCode   部门编码
     * @param depName   部门编码
     * @param itemNo    行号
     * @param pageNo    页号
     * @param pluCode   商品编码
     * @param pluName   商品名称
     * @param price     发生价格
     * @param quantity  数量
     * @param tagPrice  商品原价
     * @param total     应收金额
     * @param totalDsc  优惠金额
     * @param totalRecv 退货金额
     * @param brandCode 品牌编码
     * @param classCode 品类编码
     */
    public RegressPlu(String depCode, String depName, int itemNo, int pageNo,
                      String pluCode, String pluName, String price, String quantity,
                      String tagPrice, String total, String totalDsc, String totalRecv,
                      String brandCode, String classCode) {
        this.depCode = depCode;
        this.depName = depName;
        this.itemNo = itemNo;
        this.pageNo = pageNo;
        this.pluCode = pluCode;
        this.pluName = pluName;
        this.price = price;
        this.quantity = quantity;
        this.tagPrice = tagPrice;
        this.total = total;
        this.totalDsc = totalDsc;
        this.totalRecv = totalRecv;
        this.brandCode = brandCode;
        this.classCode = classCode;
    }
}
