/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.sms;

import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 发送短信验证码的请求数据。
 *
 * @author zhangsai 2018-04-04 HIPOSAPP-380
 */
final class SendRequestData {
    /**
     * 手机号。
     */
    public String mobile;
    /**
     * 是否重新发送。0-否；1-重发。
     */
    public int retry;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param mobile 手机号
     * @param retry  是否重新发送
     * @return WebAPI 请求。
     */
    public static Request<SendRequestData> request(String mobile, boolean retry) {
        SendRequestData requestData = new SendRequestData();
        requestData.mobile = mobile;
        requestData.retry = retry ? 1 : 0;

        return WebApi.sign(requestData);
    }
}
