/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.sms;

import com.hisense.crm.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * 短信服务。
 *
 * @author zhangsai 2018-04-04 HIPOSAPP-380
 */
public class SmsService {

    private SmsService() {
        // NO CODE HERE. 避免初始化。
    }

    /**
     * 发送短信验证码。
     *
     * @param mobile   手机号
     * @param retry    是否重发验证码短信。第一次请求时 {@code retry} 应为 false；用户请求重发时为 true
     * @param callback 发送短信验证码的回调方法
     */
    public static void send(String mobile, boolean retry, final com.hisense.webapi.Callback<String> callback) {
        Request<SendRequestData> request = SendRequestData.request(mobile, retry);
        WebApi.requestAsync(WebApi.create(ISmsService.class).send(request), new Callback<Result<SendResultData>>() {
            @Override
            public void onResponse(Call<Result<SendResultData>> call, Response<Result<SendResultData>> response) {
                callback.onSuccess(RSAService.decrypt(response.body().data.checkCode));
            }

            @Override
            public void onFailure(Call<Result<SendResultData>> call, Throwable t) {
                callback.onError(t);
            }
        },SendResultData.class);
    }
}
