/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.trans;

import com.hisense.crm.card.CardNo;
import com.hisense.crm.card.CardPayResult;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * {交易服务}
 *
 * @author wangyaogang 2019-05-24
 */
public final class TransService {

    /**
     * 支付结果查询
     * 404代表无此交易，2代表原交易处理失败，其他为失败
     *
     * @param cardNo   支付卡号
     * @param callback 回调
     */
    public static void check(CardNo cardNo, SalePayModel payModel, final com.hisense.webapi.Callback<CardPayResult> callback) {
        Request<TransactionCheckRequestData> request = TransactionCheckRequestData.request(cardNo, payModel);
        WebApi.requestAsync(WebApi.create(com.hisense.crm.webapi.trans.ITransService.class).check(request), new Callback<Result<TransactionResultData>>() {
            @Override
            public void onResponse(Call<Result<TransactionResultData>> call, Response<Result<TransactionResultData>> response) {
                CardPayResult cardPayResult = new CardPayResult(
                        response.body().data.refNo,
                        response.body().data.tranTime,
                        response.body().data.balance);
                callback.onSuccess(cardPayResult);
            }

            @Override
            public void onFailure(Call<Result<TransactionResultData>> call, Throwable t) {
                callback.onError(t);
            }
        },TransactionResultData.class);
    }
}
