/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.trans;

import com.hisense.crm.card.CardNo;
import com.hisense.crm.webapi.Context;
import com.hisense.crm.webapi.RSAService;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * {支付结果查询请求}
 *
 * @author wangyaogang 2019-05-23 HIPOSAPP-1124 请求储值卡支付时增加交易查询避免网络问题导致单边账
 */
public class TransactionCheckRequestData {
    /**
     * 卡号
     */
    public String cardNo;
    /**
     * 卡号类型
     */
    public int cardNoType;
    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 收款机号
     */
    public String posNo;
    /**
     * 流水号
     */
    public String saleNo;
    /**
     * 顺序号
     */
    public int serialNo;

    /**
     * 支付时间
     */
    public String tranTime;

    /**
     * 商户订单号
     */
    public String outTradeNo;
    /**
     * 支付方式类型
     */
    public String payMethod;

    public static Request<TransactionCheckRequestData> request(CardNo cardNo, SalePayModel payModel) {
        TransactionCheckRequestData requestData = new TransactionCheckRequestData();
        requestData.cardNo = RSAService.encrypt(cardNo.value());
        requestData.cardNoType = cardNo.getTypeCode();
        requestData.orgCode = RSAService.encrypt(Context.orgCode());
        requestData.posNo = RSAService.encrypt(Context.posNo());
        requestData.saleNo = RSAService.encrypt(payModel.getSaleNoTemp());
        requestData.serialNo = payModel.getSerialNo();
        requestData.tranTime = payModel.getPayTime();
        requestData.outTradeNo = payModel.getOutTradeNo();
        requestData.payMethod = payModel.getRemark();

        return WebApi.sign(requestData);
    }
}
