/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.vip;

import com.hisense.crm.card.VipCard;
import com.hisense.crm.vip.Vip;

/**
 * 会员注册的返回结果。
 *
 * @author zhangsai 2018-04-04 HIPOSAPP-381
 */
final class RegisterResultData {
    /**
     * 卡面号
     */
    public String cardFaceNo;
    /**
     * 卡类型编码
     */
    public String cardType;
    /**
     * 卡类型名称
     */
    public String cardTypeName;
    /**
     * 会员卡号
     */
    public String vipCardNo;


    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param vip        注册会员信息
     * @param resultData 会员注册接口返回结果
     * @return 新注册会员卡信息
     */
    public static VipCard handleResult(Vip vip, RegisterResultData resultData) {
        if (resultData == null) {
            return null;
        }

        return new VipCard.Builder(resultData.cardFaceNo, vip.name())
                .cardType(resultData.cardType, resultData.cardTypeName)
                .vipCardNo(resultData.vipCardNo)
                .build();
    }
}
