/***************************************************************************************************
 * Copyright (c) 2003-2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.webapi.vip;

import com.hisense.crm.card.CardNo;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 查询卡的验证方式的请求数据。
 *
 * @author wangyaogang 2019-06-26 HIPOSAPP-1180 增加会员验证方式查询接口
 * @author xieliyan    2019-08-05 HIPOSAPP-1277 对接SCRM-获取会员卡验证方式:请求参数增加payMethod
 */
final class VerifyTypeRequestData {
    /**
     * 会员卡号
     */
    public String cardNo;

    /**
     * 会员卡类型
     * 0 - 卡内号
     * 1 - 卡面号
     * 2 - 手机号
     * 7 - 付款码
     */
    public int cardNoType;

    public String payMethod;
    /**
     * CRM类型
     */
    public String crmType;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param cardNo 卡号
     * @return WebAPI 请求。
     */
    public static Request<VerifyTypeRequestData> request(CardNo cardNo, String payMethod) {
        VerifyTypeRequestData requestData = new VerifyTypeRequestData();
        requestData.cardNo = cardNo.value();
        requestData.cardNoType = cardNo.getTypeCode();
        requestData.payMethod = payMethod;
        if (WebApi.isAmwAndAip()) {
           requestData.crmType = "CRM6";
        }
        return WebApi.sign(requestData);
    }
}
