/***************************************************************************************************
 * Copyright (c) 2003-2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.webapi.vip;

import com.hisense.crm.vip.VerifyType;

/**
 * 查询卡的验证方式的返回结果。
 *
 * @author wangyaogang 2019-06-26 HIPOSAPP-1180 增加会员验证方式查询接口
 */

public class VerifyTypeResultData {
    /**
     * 会员卡号
     */
    public String vipCardNo;
    /**
     * 卡面号
     */
    public String cardFaceNo;
    /**
     * 是否需要消费密码
     * 0-不需要
     * 1-需要
     */
    public String isVerifyPwd;
    /**
     * 会员卡面号后几位校验位数
     * 0-不校验
     * 其他值表示需要校验卡的后几位
     */
    public String isVerifyNoCheck;
    /**
     * 卡面号校验码位数
     * 0-不校验
     * 其他值表示卡校验码的位数
     */
    public String isVerifyCode;

    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 查询卡的验证方式的返回结果
     * @return 会员卡验证类型
     */
    public static VerifyType handleResult(VerifyTypeResultData resultData) {
        return new VerifyType.Builder(!"0".equals(resultData.isVerifyPwd),
                !"0".equals(resultData.isVerifyNoCheck),
                !"0".equals(resultData.isVerifyCode))
                .vipCardNo(resultData.vipCardNo)
                .cardFaceNo(resultData.cardFaceNo)
                .cardFaceNoCheckLength(Integer.parseInt(resultData.isVerifyNoCheck))
                .verifyCodeLength(Integer.parseInt(resultData.isVerifyCode))
                .build();
    }
}
