/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.card;

import java.io.Serializable;

/**
 * 卡类型。
 *
 * @author zhangsai 2017-10-10
 */
public class CardType implements Serializable {
    // 卡类型编码
    private String typeCode;
    // 卡类型名称
    private String typeName;

    /**
     * 初始化一个 {@code CardType} 的实例。
     * @param code 卡类型编码。
     * @param name 卡类型名称。
     */
    public CardType(String code, String name) {
        this.typeCode = code;
        this.typeName = name;
    }

    /**
     * 返回卡类型编码。
     * @return 卡类型编码。
     */
    public String code() {
        return this.typeCode;
    }

    /**
     * 返回卡类型名称。
     * @return 卡类型名称。
     */
    public String name() {
        return this.typeName;
    }
}
