/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.card;


/**
 * IC 卡类型。
 *
 * @author zhangsai 2017-10-10
 */
public enum IcCardType {
    /**
     * SLE4442 格式接触式IC卡。
     */
    SLE4442(1),

    /**
     * Mifare1 格式非接触式射频卡。
     */
    Mifare1(2);

    private int value;

    /**
     * 初始化一个 IcCardType 枚举。
     *
     * @param value IC 卡类型的对应值。
     */
    IcCardType(int value) {
        this.value = value;
    }

    /**
     * 返回指定 IC 卡类型的对应值。
     *
     * @return IC 卡类型的对应值。
     */
    public int value() {
        return this.value;
    }




}
