/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.crm.card;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 储值卡限制品牌品类消费 plu  bean
 *
 * @author wangyaogang 2019-10-10
 * @author wangyaogang 2019-10-15 HIPOSAPP-1318 储值卡限制品牌/品类消费逻辑调整,不再限制只可使用一次,每次支付完进行分摊,查询时传未支付金额
 */
public class UseLimitPlu implements Serializable {
    /**
     * 品牌编码
     */
    public String brandCode;
    /**
     * 品类编码
     */
    public String classCode;
    /**
     * 部门编码
     */
    public String depCode;
    /**
     * 专柜编码
     */
    public String shopCode;
    /**
     * 行号
     */
    public int itemNo;
    /**
     * 页号
     */
    public int pageNo;
    /**
     * 商品编码
     */
    public String pluCode;
    /**
     * 待支付金额
     */
    public String total;
    /**
     * 支付参考金额
     */
    public String totalLimit;

    /**
     * 优惠金额, 计算分摊时使用
     */
    private BigDecimal totalDiscount = BigDecimal.ZERO;

    public BigDecimal totalDiscount() {
        return totalDiscount;
    }

    public void totalDiscount(BigDecimal totalDiscount) {
        this.totalDiscount = totalDiscount;
    }

    public UseLimitPlu() {
    }
}
