/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.vip;

/**
 * 实时积分的积分信息。
 *
 * @author guolina 2018-07-05
 */
public final class RealTimePoint {
    // 赠券积分
    private String coupon;
    // 消费积分
    private String expense;
    // 停车积分
    private String parking;

    /**
     * 初始化一个 {@code RealTimePoint} 的实例。
     *
     * @param coupon  赠券积分。
     * @param expense 消费积分。
     * @param parking 停车积分。
     */
    public RealTimePoint(String coupon, String expense, String parking) {
        this.coupon = coupon;
        this.expense = expense;
        this.parking = parking;
    }

    /**
     * 返回赠券积分。
     *
     * @return 赠券积分。
     */
    public String coupon() {
        return this.coupon;
    }

    /**
     * 返回消费积分。
     *
     * @return 消费积分。
     */
    public String expense() {
        return this.expense;
    }

    /**
     * 返回停车积分。
     *
     * @return 停车积分。
     */
    public String parking() {
        return this.parking;
    }

}
