/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.crm.vip;

/**
 * 会员性别。
 *
 * @author zhangsai 2017-10-12
 */
public enum  VipSex {
    /**
     * 男
     */
    Male(0),

    /**
     * 女
     */
    Female(1),

    /**
     * 未知
     */
    Unknown(2);

    // 表示会员性别的值
    private final int value;

    /**
     * 初始化一个 {@code VipStatus} 的实例。
     * @param value 表示会员性别的值
     */
    VipSex(int value) {
        this.value = value;
    }

    /**
     * 返回会员性别的对应值。
     */
    public int value() {
        return value;
    }

    /**
     * 将 {@code int} 值转换为对应的 {@code VipSex}。异常值默认返回 VipSex.Unknown。
     * @param value 要转换的值。
     * @return 会员性别。
     */
    public static VipSex valueOf(int value) {
        switch (value) {
            case 0:
                return VipSex.Male;
            case 1:
                return VipSex.Female;
            default:
                return VipSex.Unknown;
        }
    }
}
