package com.hisense.hipos.webapi.app;

import com.hisense.hipos.webapi.auth.LoginResultData;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * APP更新接口
 *
 * @author dukunbiao(null)  2020-02-24
 */
public class AppService {

    public static void checkUpdate(final String applicationId, final String version,
                                   final com.hisense.webapi.Callback<CheckUpdateResultData> callback) {
        Request<CheckUpdateRequestData> request = CheckUpdateRequestData.request(applicationId, version);
        WebApi.requestAsync(WebApi.create(IAppService.class).checkUpdate(request), new Callback<Result<CheckUpdateResultData>>() {
            @Override
            public void onResponse(Call<Result<CheckUpdateResultData>> call, Response<Result<CheckUpdateResultData>> response) {
                if (response.body() == null) {
                    callback.onError(new Throwable("检查APP更新接口返回信息为空"));
                    return;
                }

                callback.onSuccess(response.body().data);
            }

            @Override
            public void onFailure(Call<Result<CheckUpdateResultData>> call, Throwable t) {
                callback.onError(t);
            }
        }, CheckUpdateResultData.class);
    }
}
