/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.auth;

import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 修改登录密码的请求数据。
 *
 * @author zhangsai 2017-09-07
 * @author zhangsai 2017-10-27
 */
class ChangePasswordData {
    /**
     * 新登录密码
     */
    public String newPassword;
    /**
     * 原登录密码
     */
    public String oldPassword;
    /**
     * 收款员编码
     */
    public String userCode;

    /**
     * 返回一个新的 WebAPI 请求。
     * @param userCode    收款员编码。
     * @param oldPassword 原登录密码。
     * @param newPassword 新登录密码。
     * @return WebAPI 请求。
     */
    public static Request request(final String userCode,
                                  final String oldPassword,
                                  final String newPassword) {
        ChangePasswordData data = new ChangePasswordData();
        data.userCode = RSAService.encrypt(userCode);
        data.oldPassword = RSAService.encrypt(oldPassword);
        data.newPassword = RSAService.encrypt(newPassword);

        return WebApi.sign(data);
    }
}
