/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.auth;

import com.hisense.webapi.Request;
import com.hisense.webapi.Result;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.POST;

/**
 * 认证服务的 retrofit 接口。
 *
 * @author zhangsai    2017-09-02
 * @author zhangsai    2017-09-07 修改登录密码接口。
 * @author wangyaogang 2019-01-07 HIPOSAPP-851 用户账号权限控制优化
 */
interface IAuthService {

    /**
     * 收款员登录。
     *
     * @param request 收款员登录请求。
     * @return 收款员登录的 retrofit 调用。
     */
    @POST("api/auth/login")
    Call<Result<LoginResultData>> login(@Body Request<LoginRequestData> request);

    /**
     * 修改登录密码。
     *
     * @param request 修改登录密码请求。
     * @return 修改登录密码的 retrofit 调用。
     */
    @POST("api/auth/changePassword")
    Call<Result> changePassword(@Body Request<ChangePasswordData> request);

    /**
     * 查询账号权限
     *
     * @param request 查询权限请求
     * @return 查询权限请求的 retrofit 调用。
     */
    @POST("api/auth/privilege")
    Call<Result<PrivilegeResultData>> queryPrivileges(@Body Request<PrivilegeRequestData> request);
}
