/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.auth;

import com.hisense.hipos.user.User;
import com.hisense.hipos.webapi.Context;

import lombok.Data;

/**
 * 收款员登录返回结果。
 *
 * @author zhangsai 2017-09-07
 * @author zhangsai 2017-10-20
 * @author guolina  2018-12-11  HIPOSAPP-850 登录接口增加返回门店名称
 */
@Data
public class LoginResultData {

    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 门店名称
     */
    public String orgName;
    /**
     * 专柜编码
     */
    public String shopId;
    /**
     * 收款员编码
     */
    public String userCode;
    /**
     * 收款员
     */
    public String userId;
    /**
     * 收款员ID名称
     */
    public String userName;

    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 身份验证结果
     */
    public static LoginResultData handlerResult(LoginResultData resultData) {
        if (resultData == null) {
            return null;
        }

        User user = new User(resultData.userId, resultData.userCode, resultData.userName);
        Context.cashier(user);
        Context.orgName(resultData.orgName);

        return resultData;
    }
}
