/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.auth;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 获取收银员权限列表
 *
 * @author wangyaogang 2019-01-03 HIPOSAPP-851 用户账号权限控制
 */
@Data
public class PrivilegeRequestData {

    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 收款员id
     */
    public String userId;

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param userId 收款员id
     * @return WebAPI 请求
     */
    public static Request<PrivilegeRequestData> request(final String userId) {
        PrivilegeRequestData data = new PrivilegeRequestData();
        data.orgCode = Context.orgCode();
        data.userId = userId;

        return WebApi.sign(data);
    }
}
