package com.hisense.hipos.webapi.auth;

import com.hisense.hipos.user.User;

import java.util.ArrayList;
import java.util.Collection;

import lombok.Data;

/**
 * {获取收银员权限列表的返回数据
 *
 * @author wangyaogang 2019-01-07 HIPOSAPP-851 用户账号权限控制优化
 */
@Data
public class PrivilegeResultData {

    /**
     * 收款员编码
     */
    public String userCode;
    /**
     * 收款员
     */
    public String userId;

    /**
     * 权限列表
     */
    public ArrayList<PrivilegeCode> privilege;

    /**
     * 返回结果包装成User
     *
     * @param resultData 接口返回数据
     * @return User实例
     */
    public static User handlerResult(PrivilegeResultData resultData) {
        if (resultData == null) {
            return null;
        }

        Collection<String> privilegeList = new ArrayList<>();
        if (resultData.privilege != null) {
            for (PrivilegeCode privilegeCode : resultData.privilege) {
                privilegeList.add(privilegeCode.code);
            }
        }

        User user = new User(resultData.userId, resultData.userCode, "");
        user.setPrivilegeList(privilegeList);

        return user;
    }
}
