package com.hisense.hipos.webapi.config;

import com.hisense.webapi.Callback;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 中间件配置服务
 *
 * @author zhuguangsheng 2018-10-12
 */
public class ConfigService {

    public static void configDownload(String orgCode, String posNo, String configVersion,
                                      final Callback<ConfigResultData> callback) {
        Request<ConfigRequestData> request = ConfigRequestData.request(orgCode, posNo, configVersion);

        WebApi.requestAsync(WebApi.create(IConfigService.class).configDownload(request), new retrofit2.Callback<Result<ConfigResultData>>() {
            @Override
            public void onResponse(Call<Result<ConfigResultData>> call, Response<Result<ConfigResultData>> response) {
                if (response.body() == null) {
                    callback.onError(new Throwable("下载配置文件返回参数为空"));
                    return;
                }

                callback.onSuccess(response.body().data);
            }

            @Override
            public void onFailure(Call<Result<ConfigResultData>> call, Throwable t) {
                callback.onError(t);
            }
        }, ConfigResultData.class);
    }
}
