/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.coupon;

import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 赠券原路退回请求数据。
 *
 * @author guolina 2018-11-15 HIPOSAPP-772 整单退货支持赠券退回
 */
class CouponReturnRequestData {

    /**
     * 流水号
     */
    public String saleNo;
    /**
     * 组织编码
     */
    public String orgCode;


    public static Request<CouponReturnRequestData> request(String saleNo) {
        CouponReturnRequestData data = new CouponReturnRequestData();
        data.orgCode = RSAService.encrypt(Context.orgCode());
        data.saleNo = RSAService.encrypt(saleNo);
        return WebApi.sign(data);
    }
}
