/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.coupon;

/**
 * 赠券原路退回返回数据。
 *
 * @author guolina 2018-11-23 HIPOSAPP-772 整单退货支持赠券退回
 */
class CouponReturnResultData {

    /**
     * 原交易产生送券的使用情况
     */
    public CouponRebate rebate;

    /**
     * 原交易使用赠券情况
     */
    public CouponSale sale;


    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 如果返回结果包含赠券使用情况则解析后直接返回。否则，返回 null。
     */
    public static CouponUsedData handleResult(CouponReturnResultData resultData) {
        CouponUsedData couponUsedData = null;
        if (resultData != null) {
            CouponRebate rebate = new CouponRebate();
            rebate.totalCount = resultData.rebate.totalCount;
            rebate.usedTotal = resultData.rebate.usedTotal;

            CouponSale sale = new CouponSale();
            sale.usedCount = resultData.sale.usedCount;

            couponUsedData = new CouponUsedData.Builder(rebate, sale).build();
        }
        return couponUsedData;
    }
}
