/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.coupon;

import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 赠券的解锁请求数据。
 *
 * @author zhangsai 2017-10-17
 * @author zhangsai 2018-02-13 HIPOSAPP-331
 */
class CouponUnlockRequestData {
    /**组织编码*/
    public String orgCode;
    /**券号*/
    public String qNo;
    /**流水号*/
    public String saleNo;

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param saleNo 流水号
     * @param qNo    券号
     * @return WebAPI 请求
     */
    public static Request<CouponUnlockRequestData> request(final String saleNo, final String qNo) {
        CouponUnlockRequestData requestData = new CouponUnlockRequestData();
        requestData.orgCode = RSAService.encrypt(Context.orgCode());
        requestData.qNo = RSAService.encrypt(qNo);
        requestData.saleNo = RSAService.encrypt(saleNo);

        return WebApi.sign(requestData);
    }
}
