/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.invoice;

import com.hisense.hipos.invoice.models.EInvoiceConfig;
import com.hisense.webapi.Callback;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;
import com.hisense.webapi.WebApiException;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 电子发票服务。
 *
 * @author zhangsai 2017-12-20
 * @author zhangsai 2018-07-02 HIPOSAPP-626
 */
public class InvoiceService {

    private InvoiceService() {
        // NO CODE HERE. 避免初始化。
    }

    /**
     * 返回电子发票的服务地址。
     *
     * @param callback 回调方法
     */
    public static void getConfig(final Callback<EInvoiceConfig> callback) {
        Request<ConfigRequestData> request = ConfigRequestData.request();

        WebApi.requestAsync(WebApi.create(IInvoiceService.class).config(request),
                new retrofit2.Callback<Result<ConfigResultData>>() {

                    @Override
                    public void onResponse(Call<Result<ConfigResultData>> call,
                                           Response<Result<ConfigResultData>> response) {
                        callback.onSuccess(ConfigResultData.handleResult(response.body().data));
                    }

                    @Override
                    public void onFailure(Call<Result<ConfigResultData>> call, Throwable t) {
                        callback.onError(t);
                    }
                },ConfigResultData.class);
    }
}
