/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.log;

import com.hisense.webapi.Callback;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;
import com.hisense.webapi.WebApiException;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 日志上传服务
 *
 * @author guolina 2019-04-01
 */
public class LogService {

    /**
     * 日志上传
     *
     * @param message  日志
     * @param logType  日志类型
     * @param callback 日志上传的回调方法
     * @throws WebApiException 如果 WebAPI 执行过程中产生错误或返回错误。
     */
    public static void upload(String message, String logType,
                              final Callback<Object> callback) throws WebApiException {

        Request<LogUploadRequestData> request = LogUploadRequestData.request(message, logType);

        WebApi.requestAsync(WebApi.create(ILogService.class).upload(request), new retrofit2.Callback<Result<Object>>() {
            @Override
            public void onResponse(Call<Result<Object>> call, Response<Result<Object>> response) {
                callback.onSuccess(new Object());
            }

            @Override
            public void onFailure(Call<Result<Object>> call, Throwable t) {
                callback.onError(t);
            }
        },Object.class);
    }
}
