/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.log;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.text.SimpleDateFormat;
import java.util.Date;


/**
 * 日志上传请求数据
 *
 * @author guolina 2019-04-01
 */

class LogUploadRequestData {
    /**
     * 日志内容
     */
    public String logContent;
    /**
     * 日志类型
     */
    public String logType;
    /**
     * 操作日期
     */
    public String oprDate;
    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 收款机号
     */
    public String posNo;
    /**
     * 用户编码
     */
    public String userCode;
    /**
     * 用户id
     */
    public String userId;
    /**
     * 用户姓名
     */
    public String userName;


    /**
     * 返回一个新的 WebAPI 请求。(支付）
     *
     * @return WebAPI 请求
     */
    public static Request<LogUploadRequestData> request(String message, String logType) {
        LogUploadRequestData data = new LogUploadRequestData();
        data.logContent = message;
        data.logType = logType;

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        data.oprDate = format.format(new Date());
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();
        data.userCode = Context.cashier().code();
        data.userId = Context.cashier().id();
        data.userName = Context.cashier().name();

        return WebApi.sign(data);
    }
}
