/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.payment;

import com.hisense.hipos.payment.PayMethod;

import java.util.ArrayList;
import java.util.List;

/**
 * 查询支付方式的返回结果。
 *
 * @author zhangsai 2017-12-21
 */
class PayMethodsResultData {
    /**
     * 支付方式编码
     */
    public String code;
    /**
     * 支付方式名称
     */
    public String name;
    /**
     * 备注
     */
    public String remark;
    /**
     * 支付类型
     */
    public String payType;


    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultData 接口返回数据
     * @return 身份验证结果
     */
    public static List<PayMethod> handlerResult(List<PayMethodsResultData> resultData) {
        List<PayMethod> payMethods = new ArrayList<>();
        if (resultData != null) {
            for (PayMethodsResultData payMethodData : resultData) {
                PayMethod payMethod = new PayMethod(payMethodData.code, payMethodData.name);
                payMethod.remark(payMethodData.remark);
                payMethod.payType(payMethodData.payType);
                payMethods.add(payMethod);
            }
        }

        return payMethods;
    }
}
