/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.payment;

import com.hisense.hipos.payment.PayMethod;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * 支付服务。
 *
 * @author zhangsai 2017-12-21
 */
public class PaymentService {

    /**
     * 查询支付方式。
     *
     * @param callback 查询支付方式的回调方法。
     */
    public static void getPayMethods(final com.hisense.webapi.Callback<List<PayMethod>> callback) {
        Request<PayMethodsRequestData> request = PayMethodsRequestData.request();
        WebApi.requestAsync(WebApi.create(IPaymentService.class).getPayMethods(request), new Callback<Result<List<PayMethodsResultData>>>() {
            @Override
            public void onResponse(Call<Result<List<PayMethodsResultData>>> call, Response<Result<List<PayMethodsResultData>>> response) {
                List<PayMethod> payMethods = PayMethodsResultData.handlerResult(response.body().data);
                callback.onSuccess(payMethods);
            }

            @Override
            public void onFailure(Call<Result<List<PayMethodsResultData>>> call, Throwable t) {
                callback.onError(t);
            }
        },PayMethodsResultData.class);
    }
}
