/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.plu;

import com.hisense.webapi.Request;
import com.hisense.webapi.Result;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.POST;

/**
 * 商品服务的 retrofit 接口。
 *
 * @author zhangsai 2017-09-02
 */
interface IPluService {

    /**
     * 查询商品。
     *
     * @param request 查询商品的请求。
     * @return 查询商品的 retrofit 调用。
     */
    @POST("api/plu/query")
    Call<Result<List<PluQueryResultData>>> query(@Body Request<PluQueryRequestData> request);

    /**
     * 查询商品优惠。
     *
     * @param request 获取商品优惠的请求。
     * @return 获取商品优惠的 retrofit 调用。
     */
    @POST("api/plu/discount")
    Call<Result<List<PluDiscountResultData>>> discount(@Body Request<PluDiscountRequestData> request);

    /**
     * 调整商品数量
     *
     * @param request 调整商品数量请求
     * @return 商品数量调整的 retrofit 调用
     */
    @POST("api/plu/adjust")
    Call<Result<PluAdjustResultData>> pluAdjust(@Body Request<PluRequestData> request);

    /**
     * 取消商品
     *
     * @param request 取消商品请求
     * @return 取消商品请求的 retrofit 调用
     */
    @POST("api/plu/remove")
    Call<Result<PluDeleteResultData>> pluDelete(@Body Request<PluDeleteRequestData> request);
}
