package com.hisense.hipos.webapi.plu;

import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 删除商品请求数据
 *
 * @author xieliyan 2018-06-05
 * @author xieliyan 2018-07-06 对接家乐福接口
 */
@Data
public class PluDeleteRequestData {

    public String operators;
    public String password;
    public PluData plu;
    public String posNo;
    public String saleNo;

    /**
     * 商品删除-针对海信JAVA中间件
     *
     * @return WebAPI 请求
     */
    public static Request<PluDeleteRequestData> request(String saleNo, BaseSalePluModel pluModel) {
        PluDeleteRequestData data = new PluDeleteRequestData();
        data.plu = new PluData();
        data.saleNo = RSAService.encrypt(saleNo);
        data.plu.itemNo = String.valueOf(pluModel.getItemNo());
        data.plu.pluCode = pluModel.getPluCode();
        data.plu.barCode = pluModel.getBarCode();
        data.plu.pageNo = String.valueOf(pluModel.getPageNo());

        return WebApi.sign(data);
    }
}
