/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.plu;

import com.hisense.common.util.ListUtils;
import com.hisense.hipos.model.SalePluDscModel;

import java.util.ArrayList;
import java.util.List;

/**
 * 查询商品优惠的返回结果。
 *
 * @author zhangsai 2017-09-03
 * @author zhangsai 2018-01-08 增加处理 WebAPI 返回数据的工厂方法。
 * @author guolina  2018-12-21 HIPOSAPP-839  小票增加促销打印
 * @author guolina  2019-03-26 HIPOSAPP-1068  修复因字段名字错误导致的不打印
 */
class PluDiscountResultData {
    /**
     * 商品ID
     */
    public String pluId;

    /**
     * 是否参与满减促销
     * 0 - 不参与
     * 1 - 参与
     */
    public int isTotalDsc;

    /**
     * 优惠类型
     * 0 - 优惠率
     * 1 - 优惠价格
     */
    public String dscType;
    /**
     * 促销单号
     */
    public String dscCode;
    /**
     * 优惠率
     */
    public String dscRate;
    /**
     * 优惠价格
     */
    public String dscPrice;

    /**
     * 促销名称
     */
    public String dscProName;
    /**
     * 促销类型
     */
    public String dscProType;

    public static List<SalePluDscModel> handleResult(List<PluDiscountResultData> resultDataList) {
        if (ListUtils.isEmpty(resultDataList)) {
            return null;
        }

        List<SalePluDscModel> pluDscModels = new ArrayList<>();
        for (PluDiscountResultData resultData : resultDataList) {
            SalePluDscModel pluDscModel = new SalePluDscModel();
            pluDscModel.setDscType(resultData.dscType);
            pluDscModel.setDscCode(resultData.dscCode);
            pluDscModel.setDscProType(resultData.dscProType);
            pluDscModel.setDscProName(resultData.dscProName);
            pluDscModel.setDscPrice(resultData.dscPrice);
            pluDscModel.setDscRate(resultData.dscRate);
            pluDscModel.setPluId(resultData.pluId);

            pluDscModels.add(pluDscModel);
        }

        return pluDscModels;
    }
}
