package com.hisense.hipos.webapi.plu;

import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 商品数量调整请求参数
 *
 * @author xieliyan 2018-05-24
 */
@Data
public class PluRequestData {

    public String cshCode;              //收银员编码
    public String orgCode;              //组织编码
    public String shopCode;             //专柜编码
    public String pluCode;              //商品编码
    public PluData plu;                 //商品信息
    public String saleNo;               //当前流水号
    public String posNo;
    public PluVipRequest vip;

    /**
     * 调整商品数量
     *
     * @param pluModel 商品
     * @param saleNo   流水号
     * @return WebAPI 请求
     */
    public static Request<PluRequestData> request(BaseSalePluModel pluModel, String quantity, String saleNo, String operator) {
        PluRequestData data = new PluRequestData();

        if (operator != null && operator.length() > 0) {
            data.cshCode = operator;
        }

        data.saleNo = RSAService.encrypt(saleNo);

        data.plu = new PluData();
        data.plu.pluCode = pluModel.getBarCode();
        data.plu.pluId = pluModel.getPluId();
        data.plu.quantity = quantity;
        data.plu.itemNo = Integer.toString(pluModel.getItemNo());

        return WebApi.sign(data);
    }
}
