/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.report;

import com.hisense.webapi.Request;
import com.hisense.webapi.Result;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.POST;

/**
 * 报表查询的 retrofit 接口。
 *
 * @author zhangsai 2017-09-06
 * @author zhangsai 2018-12-28 HIPOSAPP-946 新增专柜报表。
 */
interface IReportService {

    /**
     * 返回总交易报表。
     *
     * @param request 获取总交易报表的请求。
     * @return 获取总交易报表的 retrofit 调用。
     */
    @POST("api/report/sale")
    Call<Result<SaleReportResultData>> sale(@Body Request<SaleReportRequestData> request);

    /**
     * 返回预销售报表。
     *
     * @param request 获取预销售报表的请求。
     * @return 获取预销售报表的 retrofit 调用。
     */
    @POST("api/report/presale")
    Call<Result<SaleReportResultData>> presale(@Body Request<SaleReportRequestData> request);

    /**
     * 返回收款员报表。
     *
     * @param request 获取收款员报表的请求。
     * @return 获取收款员报表的 retrofit 调用。
     */
    @POST("api/report/cashier")
    Call<Result<SaleReportResultData>> cashier(@Body Request<SaleReportRequestData> request);

    /**
     * 返回专柜报表。
     *
     * @param request 获取专柜报表的请求。
     * @return 获取专柜报表的 retrofit 调用。
     */
    @POST("api/report/shop")
    Call<Result<List<ShopSaleReportResultItem>>> shop(@Body Request<ShopSaleReportRequestData> request);
    /**
     * 返回商品销售报表。
     *
     * @param request 获取商品销售报表的请求。
     * @return 获取商品销售报表的 retrofit 调用。
     */
    @POST("api/report/plu")
    Call<Result<PluReportResultData>> plu(@Body Request<PluReportRequestData> request);

    /**
     * 返回部门销售报表。
     *
     * @param request 获取部门销售报表的请求。
     * @return 获取部门销售报表的 retrofit 调用。
     */
    @POST("api/report/dep")
    Call<Result<DepReportResultData>> dep(@Body Request<PluReportRequestData> request);
}
