/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.report;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 商品报表查询请求数据。
 *
 * @author wangyaogang 2019-09-25 增加商品销售汇总报表
 * @author wangyaogang 2019-10-17 HIPOSAPP-1324 全场收银时,shopcode传 *
 */
class PluReportRequestData {
    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 专柜编码
     */
    public String shopCode;

    /**
     * 收款机号
     */
    public String posNo;
    /**
     * 开始日期
     * 格式：yyyy-MM-dd
     */
    public String bgnDate;
    /**
     * 结束日期
     * 格式：yyyy-MM-dd
     */
    public String endDate;


    /**
     * 返回一个新的 WebAPI 请求。
     * 只允许查询一天的数据,起止时间相同
     *
     * @param bgnDate 开始日期
     * @return WebAPI 请求
     */
    public static Request<PluReportRequestData> request(String bgnDate, String shopCode) {
        PluReportRequestData data = new PluReportRequestData();

        data.orgCode = Context.orgCode();
        data.shopCode = shopCode;
        data.posNo = Context.posNo();
        data.bgnDate = bgnDate;
        data.endDate = bgnDate;

        return WebApi.sign(data);
    }
}
