/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.report;

import com.hisense.hipos.sale.TranType;
import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 销售报表查询请求数据。
 *
 * @author zhangsai 2017-09-06
 */
class SaleReportRequestData {
    /**收款员编码*/
    public String cshCode;
    /**组织编码*/
    public String orgCode;
    /**收款机号*/
    public String posNo;
    /**查询日期*/
    public String queryDate;
    /**交易类型*/
    public String tranType;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param queryDate 查询日期
     * @param tranType  交易类型
     * @return WebAPI 请求
     */
    public static Request<SaleReportRequestData> request(String queryDate, TranType tranType) {
        return request(null, queryDate, tranType);
    }

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param cshCode   收银员
     * @param queryDate 查询日期
     * @param tranType  交易类型
     * @return WebAPI 请求
     */
    public static Request<SaleReportRequestData> request(String cshCode, String queryDate, TranType tranType) {
        SaleReportRequestData data = new SaleReportRequestData();
        if (cshCode != null) {
            data.cshCode = cshCode;
        }
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();
        data.queryDate = queryDate;
        data.tranType = String.valueOf(tranType.value());

        return WebApi.sign(data);
    }
}
