/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 查询当前结账日期的请求数据。
 *
 * @author zhangsai 2017-09-03
 * @author zhangsai 2018-01-24 HIPOSAPP-302
 */
@Data
public class AccountingDateRequestData {
    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 收款机号
     */
    public String posNo;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @return WebAPI 请求
     */
    public static Request<AccountingDateRequestData> request() {
        AccountingDateRequestData data = new AccountingDateRequestData();
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();

        return WebApi.sign(data);
    }
}
