/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.util.Date;

/**
 * 日结请求数据。
 *
 * @author zhangsai 2017-09-07
 * @author zhangsai 2018-01-24 HIPOSAPP-302
 */
class AccountingRequestData {
    /**
     * 当前营业日
     */
    public String acctDate;

    /**
     * 收银员编码
     */
    public String cshCode;

    /**
     * 收银员ID
     */
    public String cshId;

    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 收款机号
     */
    public String posNo;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @return WebAPI 请求
     */
    public static Request<AccountingRequestData> request() {
        AccountingRequestData data = new AccountingRequestData();
        data.acctDate = WebApi.formatDate(new Date());
        data.cshCode = Context.cashier().code();
        data.cshId = Context.cashier().id();
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();

        return WebApi.sign(data);
    }
}
