package com.hisense.hipos.webapi.sale;

import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 礼品券核销请求数据。
 *
 * @author yuminghao 2020-10-10
 */
public class CertiConsumeRequestData {

    // 组织号
    public String orgCode;
    // 礼品券码
    public String certiCode;
    // 流水号
    public String saleNo;
    // 业务单据号
    public String bizBillNo;
    // 订单金额
    public String origOrderAmount;
    // 优惠券实际使用金额
    public String consumeAmount;
    // 会员ID
    public String vipInfoId;
    // 参数签名
    public String sign;

    public static Request<CertiConsumeRequestData> request(String orgCode, String certiCode, String saleNo, String bizBillNo, String origOrderAmount, String consumeAmount, String vipInfoId, String sign) {
        CertiConsumeRequestData data = new CertiConsumeRequestData();
        data.orgCode = orgCode;
        data.certiCode = certiCode;
        data.saleNo = saleNo;
        data.bizBillNo = bizBillNo;
        data.origOrderAmount = origOrderAmount;
        data.consumeAmount = consumeAmount;
        data.vipInfoId = vipInfoId;
        data.sign = sign;
        return WebApi.sign(data);
    }
}
