package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.plu.PluQueryResultData;

import java.util.List;

import lombok.Data;

/**
 * 礼品券查询返回数据。
 *
 * @author yuminghao 2020-09-30
 */
@Data
public class CertiDtlQueryResultData {
    public String certiId;        // 优惠券ID
    public String certiCode;      // 优惠券码
    public String certiName;      // 优惠券名称
    public String certiStatus;    // 优惠券状态：0-未使用、1-已使用、2-已过期、3-锁定、4-作废
    public String certiType;      // 优惠券类型：0-金额券、1-折扣券、2-计次券、3-礼品券
    public String certiMe;        // 券面额（单位为元）
    public String startTime;      // 生效时间
    public String endTime;        // 失效时间
    public String desc;           // 优惠券说明
    public String vipInfoId;      // 会员ID（仅会员券返回）
    public String vipCode;        // 会员号（仅会员券返回）
    public String vipName;        // 会员姓名（仅会员券返回）
    public String mobile;         // 会员手机号（仅会员券返回）
    public String vipLvlCode;     // 会员等级编码（仅会员券返回）
    public String vipLvlName;     // 会员等级名称（仅会员券返回）
    public String vipPricGrade;   // 会员价格等级（0-表示不启用，仅会员券返回）
    public String sendOrgCode;    // 该优惠券发放门店编码
    public String sendOrgName;    // 该优惠券发放门店名称
    public String canGrant;       // 是否可转赠：0-不可转赠、1-可转赠
    public String useScence;      // 使用场景：0-任意场景、1-线下(pos)、2-线上
    public String crosUseType;    // 跨券类型使用方式：0-允许混合使用、1-不允许与其它券混合使用
    public String limitCount;     // 优惠券使用商品数量范围限制,预留字段默认0
    public String apportionType;  // 券核销记录方式：0-记支付方式；1-按优惠分摊到商品明细
    public String includeType;    // 优惠券使用商品范围限制：0-全场通用、1-单品、2-品类、3-品牌

    public String consumeOrgCode; // 该优惠券被核销的门店代码（仅已核销的券才返回）
    public String consumeOrgName; // 该优惠券被核销的门店名称（仅已核销的券才返回）
    public String consumelTime;	  // 该优惠券被核销的时间（仅已核销的券才返回）
    public String consumeOrderNo; // 该优惠券被核销的订单流水号（仅已核销的券才返回）
    public String consumeOrderAmount; // 该优惠券被核销的订单金额（仅已核销的券才返回）
    public String consumeAmount;  // 该优惠券被核销的实际金额（仅已核销的券才返回）

    public String lpPayCode;   //礼品券作为支付方式记录的支付方式编码
    public String lpPayName;   //礼品券作为支付方式记录的支付方式名称
    public String lpDscCode;   //礼品券作为优惠记录的优惠编码
    public String lpDscName;   //礼品券作为优惠记录的优惠名称

    public List<PluQueryResultData> productData;    // includeType=1时有效

    // 优惠券状态：0-未使用、1-已使用、2-已过期、3-锁定、4-作废
    public String getRealCertiStatus(){
        if (certiStatus == null){
            return "";
        }
        switch (certiStatus){
            case "0":
                return "未使用";
            case "1":
                return "已使用";
            case "2":
                return "已过期";
            case "3":
                return "锁定";
            case "4":
                return "作废";
        }
        return "";
    }

    // 优惠券类型：0-金额券、1-折扣券、2-计次券、3-礼品券
    public String getRealCertiType(){
        if (certiType == null){
            return "";
        }
        switch (certiType){
            case "0":
                return "金额券";
            case "1":
                return "折扣券";
            case "2":
                return "计次券";
            case "3":
                return "礼品券";
        }
        return "";
    }
}
