package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.util.List;

import lombok.Data;

/**
 * 全场限量查询接口请求参数
 *
 * @author wangyaogang 2020-03-23
 */
@Data
public class GlobalTypeQueryRequestData {

    public String orgCode;//组织编码
    public String posNo;//收款机号
    public String saleNo;//流水号
    public String vipCardNo;//会员卡号
    public String saleDate;//销售日期
    public List<GlobalTypeQueryPluDscData> pluDsc; //商品优惠


    /**
     * 返回一个新的 WebAPI 请求
     *
     * @param saleNo    流水号
     * @param vipCardNo 会员卡号
     * @param saleDate  销售日期
     * @param pluDsc    商品优惠
     * @return WebAPI 请求
     */
    public static Request<GlobalTypeQueryRequestData> request(String saleNo, String vipCardNo, String saleDate, List<GlobalTypeQueryPluDscData> pluDsc) {
        GlobalTypeQueryRequestData data = new GlobalTypeQueryRequestData();
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();
        data.saleNo = saleNo;
        data.vipCardNo = vipCardNo;
        data.saleDate = saleDate;
        data.pluDsc = pluDsc;

        return WebApi.sign(data);
    }
}
