package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 新流水号请求数据。
 *
 * @author guolina 2018-12-25 HIPOSAPP-850 获取新流水号兼容POS中间件,规则可以在中间件设置
 */
class NewSaleNoRequestData {

    /**
     * 结账日期
     */
    public String accDate;

    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 收款机号
     */
    public String posNo;


    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @return WebAPI 请求
     */
    public static Request<NewSaleNoRequestData> request(String accDate) {
        NewSaleNoRequestData data = new NewSaleNoRequestData();
        data.accDate = accDate;
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();

        return WebApi.sign(data);
    }
}
