/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 流水查询请求数据。
 *
 * @author zhangsai 2018-02-24 HIPOSAPP-334
 * @author guolina  2020-05-26 HIPOSAPP-1408 重打小票限制为本收款台需求
 */
public class RptSaleQueryRequestData {

    /**
     * 组织编码。
     */
    public String orgCode;

    /**
     * 流水号。
     */
    public String saleNo;

    /**
     * posNo。
     */
    public String posNo;

    /**
     * 查询日期 格式：yyyy-MM-dd
     */
    public String queryDate;

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param saleNo 流水号
     * @param queryDate 查询日期
     * @return WebAPI 请求
     */
    public static Request<RptSaleQueryRequestData> request(String saleNo, String posNo, String queryDate) {
        RptSaleQueryRequestData data = new RptSaleQueryRequestData();
        data.orgCode = Context.orgCode();
        data.saleNo = saleNo;
        data.posNo = posNo;
        data.queryDate = queryDate;

        return WebApi.sign(data);
    }
}
