package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 交易开始请求参数
 *
 * @author xieliyan 2018-05-24
 */
@Data
public class SaleBeginRequestData {

    public String accDate;//结账日期
    public String cshCode;//收银员编码
    public String orgCode;//组织编码
    public String posNo;//收款机号
    public String cdKey;
    public String wuuid;
    public String invoiceNo;  //小票号

    /**
     * 返回一个新的 WebAPI 请求
     *
     * @param accDate 结账日期
     * @return WebAPI 请求
     */
    public static Request<SaleBeginRequestData> request(String accDate, String cdkey, String operator, String mac) {
        SaleBeginRequestData data = new SaleBeginRequestData();
        data.accDate = accDate;
        data.cdKey = cdkey;
        data.cshCode = operator;
        data.orgCode = Context.orgCode();
        data.posNo = Context.posNo();
        data.wuuid = mac;

        return WebApi.sign(data);
    }
}
