package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import lombok.Data;

/**
 * 交易取消请求参数
 *
 * @author xieliyan 2018-05-24
 */
@Data
public class SaleCancelRequestData {

    public String cshCode;                  //收银员编码
    public String saleNo;                   //当前流水号
    public String operators;                //管理员编码
    public String password;                 //管理员密码
    public String posNo;                    //pos机号

    /**
     * 取消交易-针对JAVA中间件
     * 返回一个新的 WebAPI 请求。
     *
     * @param saleNo 流水号
     * @return WebAPI 请求
     */
    public static Request<SaleCancelRequestData> request(String saleNo, String operator) {
        SaleCancelRequestData data = new SaleCancelRequestData();
        data.cshCode = operator;
        data.saleNo = RSAService.encrypt(saleNo);

        return WebApi.sign(data);
    }
}
