package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

/**
 * 核销请求数据。
 * @author guolina 2018-08-10 HIPOSAPP-715 流水查询界面添加扫描核销功能
 */
class SaleCertifyRequestData {

    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 收款机号
     */
    public String posNo;

    /**
     * 流水号
     */
    public String saleNo;

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @return WebAPI 请求
     */
    public static Request<SaleCertifyRequestData> request(String saleNo) {
        SaleCertifyRequestData data = new SaleCertifyRequestData();
        data.saleNo = RSAService.encrypt(saleNo);
        data.orgCode = RSAService.encrypt(Context.orgCode());
        data.posNo = RSAService.encrypt(Context.posNo());

        return WebApi.sign(data);
    }
}
