/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.model.BaseSaleModel;
import com.hisense.hipos.model.MainSaleModel;
import com.hisense.hipos.model.SalePayModel;
import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;

import java.util.ArrayList;

import lombok.Data;

/**
 * 交易流水支付信息。
 *
 * @author zhangsai 2018-02-24 HIPOSAPP-334
 * @author zhangsai 2018-07-24 HIPOSAPP-698
 */
@Data
public class SalePayData {
    /**
     * 组织编码
     */
    public String orgCode;

    /**
     * 支付方式编码
     */
    public String payCode;

    /**
     * 支付方式名称
     */
    public String payName;

    /**
     * 支付号
     */
    public String payNo;

    /**
     * 流水号
     */
    public String saleNo;

    /**
     * 顺序号
     */
    public String serialNo;

    /**
     * 支付合计
     */
    public String totalPaid;

    /**
     * 实收合计
     */
    public String totalRecv;

    /**
     * 交易类型
     */
    public String tranType;

    /**
     * 备注
     */
    public String remark;

    /**
     * 支付类型
     */
    public String payType;
    /**
     * 扩展属性
     */
    public String udp1;
    /**
     * 扩展属性
     */
    public String udp2;
    /**
     * 扩展属性
     */
    public String udp3;
    /**
     * 扩展属性
     */
    public String udp4;
    /**
     * 扩展属性
     */
    public String udp5;

    public static ArrayList<SalePayData> buildSalePayData(BaseSaleModel saleModel) {
        ArrayList<SalePayData> payDataList = new ArrayList<>();

        for (SalePayModel payModel : saleModel.getPays()) {
            SalePayData payData = new SalePayData();
            payData.orgCode = Context.orgCode();
            payData.payCode = RSAService.encrypt(payModel.getPayCode());
            payData.payName = payModel.getPayName();
            payData.payNo = RSAService.encrypt(payModel.getBuyerLogonId());
            payData.saleNo = RSAService.encrypt(saleModel.getSaleNo());
            payData.serialNo = String.valueOf(payModel.getSerialNo());
            payData.totalPaid = RSAService.encrypt(payModel.getTotalPaid());
            payData.totalRecv = RSAService.encrypt(payModel.getTotalRecv());
            payData.tranType = String.valueOf(saleModel.getTranType().value());
            payData.payType = payModel.getPayType();
            payData.remark = payModel.getRemark();
            payData.udp1 = payModel.getUdp1();
            payData.udp2 = payModel.getUdp2();
            payData.udp3 = payModel.getUdp3();
            payData.udp4 = payModel.getUdp4();
            payData.udp5 = payModel.getOutTradeNo();

            payDataList.add(payData);
        }

        return payDataList;
    }

    public static ArrayList<SalePayData> buildSalePayData(ArrayList<SalePayData> pay) {
        ArrayList<SalePayData> payDataList = new ArrayList<>();

        for (SalePayData payData : pay) {
            payData.payCode = RSAService.encrypt(payData.getPayCode());
            payData.payNo = RSAService.encrypt(payData.getPayNo());
            payData.saleNo = RSAService.encrypt(payData.getSaleNo());
            payData.totalPaid = RSAService.encrypt(payData.getTotalPaid());
            payData.totalRecv = RSAService.encrypt(payData.getTotalRecv());

            payDataList.add(payData);
        }

        return payDataList;
    }
}
