/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.sale;

import com.hisense.hipos.model.BaseSaleModel;
import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.SalePluDscModel;
import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;

import java.util.ArrayList;

import lombok.Data;

/**
 * 交易流水商品优惠信息。
 *
 * @author zhangsai 2017-09-07
 * @author zhangsai 2018-07-24 HIPOSAPP-698
 * @author guolina  2018-12-21 HIPOSAPP-839 小票增加促销打印
 */
@Data
public class SalePluDiscountData {
    /**
     * 优惠编码
     */
    public String dscCode;
    /**
     * 优惠名称
     */
    public String dscName;
    /**
     * 优惠类型
     */
    public String dscType;
    /**
     * 商品行号
     */
    public String itemNo;
    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 商品页号
     */
    public String pageNo;
    /**
     * 商品编码
     */
    public String pluCode;
    /**
     * 商品ID
     */
    public String pluId;
    /**
     * 商品名称
     */
    public String pluName;
    /**
     * 流水号
     */
    public String saleNo;
    /**
     * 顺序号
     */
    public String serialNo;
    /**
     * 合计优惠
     */
    public String totalDsc;
    /**
     * 交易类型
     */
    public String tranType;
    /**
     * 备注
     */
    public String remark;
    /**
     * 扩展属性
     */
    public String udp1;
    /**
     * 扩展属性
     */
    public String udp2;
    /**
     * 扩展属性
     */
    public String udp3;
    /**
     * 扩展属性
     */
    public String udp4;
    /**
     * 扩展属性
     */
    public String udp5;

    public static ArrayList<SalePluDiscountData> buildSalePluDscData(BaseSaleModel saleModel) {
        ArrayList<SalePluDiscountData> pluDscDataList = new ArrayList<>();

        for (BaseSalePluModel pluModel : saleModel.getPlus()) {
            for (int i = 0; i < pluModel.pluDscSize(); i++) {
                SalePluDscModel pluDscModel = pluModel.getPluDsc(i);

                SalePluDiscountData pluDiscountData = new SalePluDiscountData();
                pluDiscountData.dscCode = pluDscModel.getDscCode();
                pluDiscountData.dscName = pluDscModel.getDscProName();
                pluDiscountData.dscType = pluDscModel.getDscProType();
                pluDiscountData.orgCode = Context.orgCode();
                pluDiscountData.itemNo = String.valueOf(pluDscModel.getItemNo());
                pluDiscountData.pageNo = String.valueOf(pluModel.getPageNo());
                pluDiscountData.pluCode = RSAService.encrypt(pluModel.getPluCode());
                pluDiscountData.pluId = RSAService.encrypt(pluModel.getPluId());
                pluDiscountData.pluName = pluModel.getPluName();
                pluDiscountData.saleNo = RSAService.encrypt(saleModel.getSaleNo());
                pluDiscountData.serialNo = String.valueOf(pluDscModel.getSerialNo());
                pluDiscountData.totalDsc = RSAService.encrypt(pluDscModel.getTotalDsc());
                pluDiscountData.tranType = String.valueOf(saleModel.getTranType().value());
                pluDiscountData.remark = pluDscModel.getRemark();
                pluDiscountData.udp1 = pluDscModel.getUdp1();
                pluDiscountData.udp2 = pluDscModel.getUdp2();
                pluDiscountData.udp3 = pluDscModel.getUdp3();
                pluDiscountData.udp4 = pluDscModel.getUdp4();
                pluDiscountData.udp5 = pluDscModel.getUdp5();

                pluDscDataList.add(pluDiscountData);
            }
        }

        return pluDscDataList;
    }

    public static ArrayList<SalePluDiscountData> buildSalePluDscData(ArrayList<SalePluDiscountData> pluDsc) {
        ArrayList<SalePluDiscountData> pluDscDataList = new ArrayList<>();

        for (SalePluDiscountData pluDiscountData : pluDsc) {
            pluDiscountData.pluCode = RSAService.encrypt(pluDiscountData.getPluCode());
            pluDiscountData.pluId = RSAService.encrypt(pluDiscountData.getPluId());
            pluDiscountData.saleNo = RSAService.encrypt(pluDiscountData.getSaleNo());
            pluDiscountData.totalDsc = RSAService.encrypt(pluDiscountData.getTotalDsc());

            pluDscDataList.add(pluDiscountData);
        }

        return pluDscDataList;
    }
}
