/***************************************************************************************************
 * Copyright (c) 2019 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.webapi.sale;


import com.hisense.hipos.coupon.ICoupon;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * 流水上传返回数据（对接SCRM）
 *
 * @author xieliyan  2019-07-31
 */
public class SaleSubmitResultData {

    public String tradePoints;//	本笔交易积分
    public String totalPoints;//	会员总积分
    public List<SaleRebateResultCoupon> coupons;//赠券信息
    public Collection<ICoupon> iCoupons;

    public static SaleSubmitResultData handleResult(SaleSubmitResultData resultData) {
        if (resultData == null) {
            return null;
        }
        SaleSubmitResultData saleSubmitResultData = new SaleSubmitResultData();
        saleSubmitResultData.tradePoints = resultData.tradePoints;
        saleSubmitResultData.totalPoints = resultData.totalPoints;
        saleSubmitResultData.coupons = new ArrayList<>();
        saleSubmitResultData.iCoupons = new ArrayList<>();
        if (resultData.coupons != null) {
            saleSubmitResultData.iCoupons = SaleRebateResultCoupon.handleResult(resultData.coupons);
        }

        return saleSubmitResultData;
    }
}
