package com.hisense.hipos.webapi.sale;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.hipos.model.SalePluDscModel;
import com.hisense.hipos.plu.PluDsc;

import java.util.ArrayList;
import java.util.List;

import lombok.Data;

/**
 * 整单促销计算接口
 */
@Data
public class TotalReductionModel {

    private String totalDsc;
    private List<SalePluDscModel> pluDscs;

    public static TotalReductionModel handleResult(TotalReductionResultData resultData) {
        if (resultData == null) {
            return null;
        }

        TotalReductionModel totalReductionModel = new TotalReductionModel();
        totalReductionModel.totalDsc = resultData.totalDsc;

        totalReductionModel.pluDscs = new ArrayList<>();
        for (PluDsc pluDsc : resultData.pluDsc) {
            SalePluDscModel pluDscModel = new SalePluDscModel();
            pluDscModel.setDscType("1");
            pluDscModel.setDscCode(pluDsc.getDscCode());
            pluDscModel.setDscProType(pluDsc.getDscProType());
            pluDscModel.setDscProName(pluDsc.getDscProName());
            pluDscModel.setDscNum(pluDsc.getDscNum());
            pluDscModel.setPageNo(pluDsc.getPageNo());
            pluDscModel.setItemNo(pluDsc.getItemNo());
            pluDscModel.setTotalDsc(pluDsc.getTotalDsc());
            if (BigDecimalUtils.isNotEquals0(pluDsc.getTotalDsc())) {
                totalReductionModel.pluDscs.add(pluDscModel);
            }
        }


        return totalReductionModel;
    }
}
