package com.hisense.hipos.webapi.shop;

import com.hisense.hipos.sale.models.ShopInfo;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;

import java.util.List;

import retrofit2.Call;
import retrofit2.Response;

/**
 * Created by xly on 2019-03-26.
 */

public class ShopService {

    public static void shopList(final com.hisense.webapi.Callback<ShopInfo> callback) {
        Request<ShopListRequestData> request = ShopListRequestData.request();
        WebApi.requestAsync(WebApi.create(IShopService.class).shopList(request), new retrofit2.Callback<Result<List<ShopInfo>>>() {
            @Override
            public void onResponse(Call<Result<List<ShopInfo>>> call, Response<Result<List<ShopInfo>>> response) {
                if (response.body() == null || response.body().data == null ||
                        response.body().data.size() == 0 || response.body().data.get(0) == null) {
                    callback.onError(new Throwable("获取门店信息返回参数为空"));
                    return;
                }

                callback.onSuccess(response.body().data.get(0));
            }

            @Override
            public void onFailure(Call<Result<List<ShopInfo>>> call, Throwable t) {
                callback.onError(t);
            }
        },ShopInfo.class);
    }
}
