/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.vip;

import com.hisense.hipos.model.BaseSalePluModel;
import com.hisense.hipos.model.MainSaleModel;
import com.hisense.hipos.model.SaleModel;
import com.hisense.hipos.webapi.Context;
import com.hisense.webapi.Request;
import com.hisense.webapi.WebApi;

import java.util.ArrayList;
import java.util.List;


/**
 * 会员赠券查询请求数据。
 *
 * @author zhangsai 2017-11-22
 * @author zhangsai 2018-12-19 HIPOSAPP-698 交易商品类型改为 ISaleItem
 */
class VipCouponsRequestData {
    /**
     * 会员卡面号
     */
    public String cardFaceNo;
    /**
     * 组织编码
     */
    public String orgCode;
    /**
     * 销售商品
     */
    public List<VipCouponsRequestPlu> plu;
    /**
     * 销售日期
     */
    public String saleTime;

    /**
     * 返回一个新的 WebAPI 请求。
     *
     * @param cardFaceNo 会员卡面号
     * @return WebAPI 请求
     */
    public static Request<VipCouponsRequestData> request(String cardFaceNo) {
        MainSaleModel mainSaleModel = MainSaleModel.getInstance();
        SaleModel saleModel = mainSaleModel.getSaleModel();

        VipCouponsRequestData data = new VipCouponsRequestData();
        data.cardFaceNo = cardFaceNo;
        data.orgCode = Context.orgCode();
        data.saleTime = saleModel.getSaleTime();

        data.plu = new ArrayList<>();
        for (BaseSalePluModel pluModel : saleModel.getPlus()) {
            VipCouponsRequestPlu requestPlu = new VipCouponsRequestPlu();
            requestPlu.brandCode = pluModel.getBrandCode();
            requestPlu.classCode = pluModel.getClassCode();
            requestPlu.pluCode = pluModel.getPluCode();
            requestPlu.pluId = pluModel.getPluId();
            requestPlu.depCode = pluModel.getDepCode();
            requestPlu.shopCode = pluModel.getShopCode();

            data.plu.add(requestPlu);
        }

        return WebApi.sign(data);
    }
}
