/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.vip;

import com.hisense.hipos.coupon.Coupon;
import com.hisense.hipos.coupon.CouponType;

/**
 * 会员赠券查返回结果的可使用赠券。
 *
 * @author zhangsai    2017-11-22
 * @author wangyaogang 2019-07-03 HIPOSAPP-1130 会员所有赠券信息查询记录券类型
 */
class VipCouponsResultCoupon {
    /**
     * 使用截止日期
     */
    public String endDate;
    /**
     * 余额
     */
    public String qAvailable;
    /**
     * 校验码
     */
    public String qCheckCode;
    /**
     * 赠券名称
     */
    public String qName;
    /**
     * 券号
     */
    public String qNo;
    /**
     * 面额或折扣
     */
    public String qValue;
    /**
     * 券类型
     */
    public String qType;


    /**
     * 处理 WebAPI 接口返回数据。
     *
     * @param resultCoupon 接口返回的赠券信息
     * @return 可用赠券
     */
    public static Coupon handlerResult(VipCouponsResultCoupon resultCoupon) {
        return new Coupon.Builder()
                .coupon(resultCoupon.qNo, resultCoupon.qCheckCode, resultCoupon.qName)
                .values(Double.valueOf(resultCoupon.qValue))
                .balance(Double.valueOf(resultCoupon.qAvailable))
                .endsAt(resultCoupon.endDate)
                .type(CouponType.valueOf(Integer.valueOf(resultCoupon.qType != null ? resultCoupon.qType : "0")))
                .build();
    }
}
