/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.yst;

import com.hisense.hipos.webapi.Context;
import com.hisense.hipos.webapi.RSAService;
import com.hisense.hipos.yst.YstConfig;

/**
 * 查询赢商通配置的返回结果。
 *
 * @author zhangsai 2017-09-02
 * @author zhangsai 2017-10-23
 */
class ConfigResultData {
    /**赢商通账号*/
    public String account;
    /**加密密钥*/
    public String key;
    /**服务地址*/
    public String url;

    /**
     * 处理 WebAPI 接口返回数据。
     * @param resultData 接口返回数据
     * @return 赢商通配置
     */
    public static YstConfig handlerResult(ConfigResultData resultData) {
        if (resultData != null) {
            String account = resultData.account;

            if (account == null || account.trim().length() == 0) {
                account = Context.orgCode();
            }

            return new YstConfig.Builder(resultData.url)
                    .account(account, RSAService.decrypt(resultData.key))
                    .build();
        }

        return null;
    }
}
