/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.webapi.yst;

import com.hisense.hipos.yst.YstConfig;
import com.hisense.webapi.Callback;
import com.hisense.webapi.Request;
import com.hisense.webapi.Result;
import com.hisense.webapi.WebApi;
import com.hisense.webapi.WebApiException;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 赢商通服务。
 *
 * @author zhangsai 2017-09-03
 * @author zhangsai 2017-10-23 增加获取赢商通配置异步调用
 */
public class YstService {

    private YstService() {
        // NO CODE HERE. 避免初始化。
    }

    /**
     * 返回赢商通配置。
     *
     * @param callback 回调方法
     */
    public static void getConfig(final Callback<YstConfig> callback) {
        Request<ConfigRequestData> request = ConfigRequestData.request();

        WebApi.requestAsync(WebApi.create(IYstService.class).config(request),
                new retrofit2.Callback<Result<ConfigResultData>>() {

            @Override
            public void onResponse(Call<Result<ConfigResultData>> call,
                                   Response<Result<ConfigResultData>> response) {
                YstConfig config = ConfigResultData.handlerResult(response.body().data);
                callback.onSuccess(config);
            }

            @Override
            public void onFailure(Call<Result<ConfigResultData>> call, Throwable t) {
                callback.onError(t);
            }
        },ConfigResultData.class);
    }
}
