/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.coupon;

/**
 * 赠券接口。
 *
 * @author zhangsai    2018-11-13 HIPOSAPP-822
 * @author wangyaogang 2019-06-12 HIPOSAPP-1114 增加type()赠券类型方法
 * @author wangyaogang 2019-06-24 HIPOSAPP-1090 增加获取活动描述方法
 */
public interface ICoupon {

    /**
     * 返回赠券名称。
     *
     * @return 赠券名称
     */
    String name();

    /**
     * 返回券号。
     *
     * @return 券号
     */
    String no();

    /**
     * 返回使用开始日期。
     *
     * @return 使用开始日期
     */
    String beginDate();

    /**
     * 返回使用截止日期。
     *
     * @return 使用截止日期
     */
    String endDate();

    /**
     * 返回是否打印赠券。
     *
     * @return true 表示打印；false 表示不打印
     */
    boolean isPrint();

    /**
     * 返回备注。
     *
     * @return 备注
     */
    String remark();

    /**
     * 返回赠券类型。
     *
     * @return 赠券类型
     */
    CouponType type();

    /**
     * 返回活动描述。
     *
     * @return 活动描述
     */
    String couponDesc();

}
