/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.coupon;

import java.io.Serializable;

/**
 * 待核销的已锁定赠券。
 *
 * @author zhangsai 2017-10-17
 */
public class LockedCoupon implements Serializable {
    // 赠券
    private Coupon coupon;
    // 促销赠送编号
    private String proNo;


    /**
     * 初始化一个 {@code LockedCoupon} 的实例。
     * @param proNo     促销赠送编号
     * @param coupon    赠券
     */
    public LockedCoupon(String proNo, Coupon coupon) {
        this.coupon = coupon;
        this.proNo = proNo;
    }


    /**
     * 返回赠券。
     * @return 赠券
     */
    public Coupon coupon() {
        return this.coupon;
    }

    /**
     * 返回促销赠送编号。
     * @return 促销赠送编号
     */
    public String proNo() {
        return this.proNo;
    }
}
