/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.invoice.models;

import com.hisense.hipos.sale.models.ISale;

import java.util.Date;
import java.util.Locale;

/**
 * 山西太原电子发票（由山西航信提供）。
 *
 * @author zhangsai 2018-07-02 HIPOSAPP-626
 * @author zhangsai 2018-12-19 HIPOSAPP-698 交易类型改为 ISale
 * @author zhangsai 2019-01-03 HIPOSAPP-958 改用 EInvoiceDefault 生成电子发票二维码地址
 */
public class EInvoice1401 extends EInvoice implements IEInvoice {

    /**
     * 初始化一个 {@code EInvoice1401} 的实例。
     *
     * @param baseUrl 电子发票地址
     */
    EInvoice1401(String baseUrl) {
        super(baseUrl);
    }

    /**
     * 格式化电子发票提取地址。
     *
     * @param sale     交易流水
     * @param saleTime 交易完成时间
     * @return 该笔流水的电子发票提取地址
     */
    @Override
    public String formatUrl(ISale sale, Date saleTime) {
        // 例如：http://59.49.33.116/xxglxt1/api/order/ewmcodejump?code=1042018051013521800019393
        // 其中，code为提取码，格式为：组织号+年月日时分秒+收款机号+4位随机码
        String url = String.format(Locale.CHINESE, "%s?code=[orgCode][date:yyyyMMddHHmmss][posNo][random:4]", this.baseUrl);
        return new EInvoiceDefault(url).formatUrl(sale, saleTime);
    }
}
