/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.invoice.models;

import com.hisense.hipos.sale.models.ISale;

import java.util.Date;
import java.util.Locale;

/**
 * 山东青岛电子发票（由青岛航信提供）。
 *
 * @author zhangsai 2018-07-02 HIPOSAPP-626
 * @author zhangsai 2018-12-19 HIPOSAPP-698 交易类型改为 ISale
 * @author zhangsai 2019-01-03 HIPOSAPP-958 改用 EInvoiceDefault 生成电子发票二维码地址
 */
public class EInvoice3702 extends EInvoice implements IEInvoice {

    /**
     * 初始化一个 {@code EInvoice3702} 的实例。
     *
     * @param baseUrl 电子发票地址
     */
    EInvoice3702(String baseUrl) {
        super(baseUrl);
    }

    /**
     * 格式化电子发票提取地址。
     *
     * @param sale     交易流水
     * @param saleTime 交易完成时间
     * @return 该笔流水的电子发票提取地址
     */
    @Override
    public String formatUrl(ISale sale, Date saleTime) {
        // 格式：http://n1b5947011.51mypc.cn/WebKaiPiao/index.action?m=getFpUrlByQRCode&lsh=2018070300020009&tqm=8838&csdm=1008
        // 其中：
        // - lsh: 流水号
        // - tqm: 提取码
        // - csdm： 组织编码
        String url = String.format(Locale.CHINESE, "%s&lsh=[saleNo]&tqm=[random:4]&csdm=[orgCode]", this.baseUrl);
        return new EInvoiceDefault(url).formatUrl(sale, saleTime);
    }
}
