/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.invoice.models;

/**
 * 电子发票配置。
 *
 * @author zhangsai 2018-07-02 HIPOSAPP-626
 */
public class EInvoiceConfig {
    private int cityCode;   // 城市代码
    private String baseUrl; // 电子发票地址

    /**
     * 初始化一个 {@code EInvoiceConfig} 的实例。
     *
     * @param cityCode 城市代码
     * @param baseUrl  电子发票地址
     */
    public EInvoiceConfig(int cityCode, String baseUrl) {
        this.cityCode = cityCode;
        this.baseUrl = baseUrl;
    }


    /**
     * 返回电子发票签发城市代码。
     *
     * @return 电子发票签发城市代码
     */
    public int cityCode() {
        return this.cityCode;
    }

    /**
     * 返回电子发票地址。
     *
     * @return 电子发票地址
     */
    public String baseUrl() {
        return this.baseUrl;
    }
}
