/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.invoice.models;

import com.hisense.hipos.sale.models.ISale;

import java.io.Serializable;
import java.util.Date;

/**
 * 电子发票接口。
 *
 * @author zhangsai 2018-07-02 HIPOSAPP-626
 * @author zhangsai 2018-12-19 HIPOSAPP-698 交易类型改为 ISale
 * @author zhangsai 2018-12-21 HIPOSAPP-699 支持 Serializable 序列化
 * @author zhangsai 2019-01-03 HIPOSAPP-958 新增random()生成提取码方法
 */
public interface IEInvoice extends Serializable {
    /**
     * 格式化电子发票提取地址。
     *
     * @param sale 交易流水
     * @return 该笔流水的电子发票提取地址
     */
    String formatUrl(ISale sale);

    /**
     * 格式化电子发票提取地址。
     *
     * @param sale     交易流水
     * @param saleTime 交易完成时间
     * @return 该笔流水的电子发票提取地址
     */
    String formatUrl(ISale sale, Date saleTime);


    /**
     * 随机生成电子发票提取码。
     *
     * @return 电子发票提取码
     */
    String random();
}
