package com.hisense.hipos.model;

import com.hisense.hipos.sale.models.ShopInfo;

import lombok.Getter;

@Getter
public class MainSaleModel {

    private SaleModel saleModel;
    private ReturnSaleModel returnSaleModel;
    private ShopInfo shopInfo;

    private static volatile MainSaleModel mInstance;

    public static synchronized MainSaleModel getInstance() {
        if (mInstance == null) {
            synchronized (MainSaleModel.class) {
                if (mInstance == null) {
                    mInstance = new MainSaleModel();
                }
            }
        }

        return mInstance;
    }

    public void saleModel(SaleModel saleModel) {
        this.saleModel = saleModel;
    }

    public void returnSaleModel(ReturnSaleModel returnSaleModel) {
        this.returnSaleModel = returnSaleModel;
    }

    public void shopInfo(ShopInfo shopInfo) {
        this.shopInfo = shopInfo;
    }

    public void reset() {
        saleModel = null;
        returnSaleModel = null;
    }
}
