package com.hisense.hipos.model;

import com.hisense.common.util.BigDecimalUtils;
import com.hisense.crm.card.CardNo;
import com.hisense.crm.card.CardSecurity;

import java.io.Serializable;

import lombok.Data;

/**
 * 重构之后的 SalePayModel
 *
 * @author dukunbiao(null)  2019-08-16
 */
@Data
public class SalePayModelBase implements Serializable {

    public String payCode;                             //支付方式编码
    public String payName;                             //支付方式名称
    public String remark;                              //备注,支付方式
    public String payType;                             //支付方式类型

    public String buyerLogonId;                        //买家支付账号，payNo
    public String outTradeNo;                          //商户订单号，traceNo
    public String tradeNo;                             //平台订单号，refNo
    public String mchId;                                //商户号
    public String saleNoTemp;                          //临时流水号，卡、积分支付撤销后再次支付要求流水号不能重复，这里保存每次支付生成的临时流水号

    public CardSecurity cardSecurity;                  //卡验证方式
    public CardNo cardNo;                              //卡号信息
    public String balance;                             //余额

    public String payTime;                             //支付时间，yyyy-MM-dd hh:mm:ss

    public int serialNo;                               //顺序号

    public String total;                               //应收金额
    public String totalRecv;                           //实收金额
    public String totalPaid;                           //支付金额
    public String totalDscSelf;                        //商户优惠金额
    public String totalDscChannel;                     //平台优惠金额

    public String udp1;                                //扩展字段1
    public String udp2;                                //扩展字段2
    public String udp3;                                //扩展字段3
    public String udp4;                                //扩展字段4
    public String udp5;                                //扩展字段5

    public SalePayModelBase() {

    }

    public void setUdp1(String udp1) {
        this.payType = this.udp1 = udp1;
    }

    public void setUdp4(String udp4) {
        this.tradeNo = this.udp4 = udp4;
    }

    public void setUdp5(String udp5) {
        this.outTradeNo = this.udp5 = udp5;
    }

    public void setPayType(String payType) {
        this.payType = this.udp1 = payType;
    }

    public void setOutTradeNo(String outTradeNo) {
        this.outTradeNo = this.udp5 = outTradeNo;
    }

    public void setTradeNo(String tradeNo) {
        this.tradeNo = this.udp4 = tradeNo;
    }

    public void setTotal(String total) {
        this.total = BigDecimalUtils.decimalFormat(total);
    }

    public void setTotalRecv(String totalRecv) {
        this.totalRecv = BigDecimalUtils.decimalFormat(totalRecv);
    }

    public void setTotalPaid(String totalPaid) {
        this.totalPaid = BigDecimalUtils.decimalFormat(totalPaid);
    }

    public void setTotalDscSelf(String totalDscSelf) {
        this.totalDscSelf = BigDecimalUtils.decimalFormat(totalDscSelf);
    }

    public void setTotalDscChannel(String totalDscChannel) {
        this.totalDscChannel = BigDecimalUtils.decimalFormat(totalDscChannel);
    }

    public void setTotal(double total) {
        this.total = BigDecimalUtils.decimalFormat(total);
    }

    public void setTotalRecv(double totalRecv) {
        this.totalRecv = BigDecimalUtils.decimalFormat(totalRecv);
    }

    public void setTotalPaid(double totalPaid) {
        this.totalPaid = BigDecimalUtils.decimalFormat(totalPaid);
    }

    public void setTotalDscSelf(double totalDscSelf) {
        this.totalDscSelf = BigDecimalUtils.decimalFormat(totalDscSelf);
    }

    public void setTotalDscChannel(double totalDscChannel) {
        this.totalDscChannel = BigDecimalUtils.decimalFormat(totalDscChannel);
    }
}
