package com.hisense.hipos.model;

import com.hisense.common.util.BigDecimalUtils;

import java.io.Serializable;

import lombok.Data;

/**
 * 重构之后的 SalePluDscModel
 *
 * @author dukunbiao(null)  2019-08-16
 */
@Data
public class SalePluDscModel implements Serializable, Cloneable {

    private String dscType;                             //0折扣率 1优惠价
    private String dscCode;                             //优惠单号
    private String dscProType;                          //优惠类型
    private String dscProName;                          //优惠名称
    private String dscNum;                              //优惠数量
    private String dscPrice;                            //发生价
    private String dscTotal;                            //发生总价
    private String dscRate;                             //优惠率
    public String globalType;                         // 全局限量类型

    private String pluId;                               //商品ID，用于通过pluId匹配优惠
    private String pluCode;                               //商品code，用于通过plucode匹配优惠

    private int pageNo;                                 //页号
    private int itemNo;                                 //行号
    private int serialNo;                               //顺序号

    private String totalDsc;                            //优惠合计

    private String remark;                              //备注
    private String udp1;                                //扩展字段1
    private String udp2;                                //扩展字段2
    private String udp3;                                //扩展字段3
    private String udp4;                                //扩展字段4
    private String udp5;                                //扩展字段5

    public SalePluDscModel() {

    }

    public SalePluDscModel(String dscCode, String dscProType, String dscProName, String totalDsc) {
        this.dscType = "1";
        this.dscCode = dscCode;
        this.dscProType = dscProType;
        this.dscProName = dscProName;
        this.totalDsc = totalDsc;
    }

    public SalePluDscModel(String dscType, String dscCode, String dscProType, String dscProName, String dscPrice, String dscRate) {
        this.dscType = dscType;
        this.dscCode = dscCode;
        this.dscProType = dscProType;
        this.dscProName = dscProName;
        this.dscPrice = dscPrice;
        this.dscRate = dscRate;
    }

    public SalePluDscModel(String dscType, String dscCode, String dscProType, String dscProName, String dscNum, String dscPrice, String dscTotal) {
        this.dscType = dscType;
        this.dscCode = dscCode;
        this.dscProType = dscProType;
        this.dscProName = dscProName;
        this.dscNum = dscNum;
        this.dscPrice = dscPrice;
        this.dscTotal = dscTotal;
    }

    public boolean isPtxsDsc() {
        return "10".equals(this.dscProType) || "20".equals(this.dscProType) || "94".equals(this.dscProType) || "18".equals(this.dscProType);
    }

    public void setDscPrice(String dscPrice) {
        this.dscPrice = BigDecimalUtils.decimalFormat(dscPrice);
    }

    public void setDscTotal(String dscTotal) {
        this.dscTotal = BigDecimalUtils.decimalFormat(dscTotal);
    }

    public void setTotalDsc(String totalDsc) {
        this.totalDsc = BigDecimalUtils.decimalFormat(totalDsc);
    }

    public void setDscPrice(double dscPrice) {
        this.dscPrice = BigDecimalUtils.decimalFormat(dscPrice);
    }

    public void setDscTotal(double dscTotal) {
        this.dscTotal = BigDecimalUtils.decimalFormat(dscTotal);
    }

    public void setTotalDsc(double totalDsc) {
        this.totalDsc = BigDecimalUtils.decimalFormat(totalDsc);
    }

    @Override
    public SalePluDscModel clone() {
        try {
            return (SalePluDscModel) super.clone();
        } catch (CloneNotSupportedException e) {
            SalePluDscModel pluDscModel = new SalePluDscModel();
            pluDscModel.dscType = this.dscType;
            pluDscModel.dscCode = this.dscCode;
            pluDscModel.dscProType = this.dscProType;
            pluDscModel.dscProName = this.dscProName;
            pluDscModel.dscNum = this.dscNum;
            pluDscModel.dscPrice = this.dscPrice;
            pluDscModel.dscTotal = this.dscTotal;
            pluDscModel.dscRate = this.dscRate;
            pluDscModel.pluId = this.pluId;
            pluDscModel.pageNo = this.pageNo;
            pluDscModel.itemNo = this.itemNo;
            pluDscModel.serialNo = this.serialNo;
            pluDscModel.totalDsc = this.totalDsc;
            pluDscModel.remark = this.remark;
            pluDscModel.udp1 = this.udp1;
            pluDscModel.udp2 = this.udp2;
            pluDscModel.udp3 = this.udp3;
            pluDscModel.udp4 = this.udp4;
            pluDscModel.udp5 = this.udp5;

            return pluDscModel;
        }
    }
}
