package com.hisense.hipos.payment;

/**
 * 支付渠道
 * Created by zhuguangsheng on 2018/9/3.
 */

public enum PayChannel {
    HS("1001","HS","海信"),
    FUJI("1002","FUJI","富基"),
    ANTF("1003","ANTF","蚂蚁金服直连"),
    WXPAY("1004","WXPAY","微信支付直连"),
    ;

    PayChannel(String id, String channel, String desc){
        this.channelId = id;
        this.channelName = channel;
        this.channelDesc = desc;
    };

    public static PayChannel ofChannelName(String channelName) {
        for (PayChannel type : PayChannel.values()) {
            if (channelName.equals(type.getChannelName())) {
                return type;
            }
        }
        return null;
    }

    /**
     * id应该是唯一
     */
    String channelId = "";
    /**
     * name相当于是英文助记符
     */
    String channelName = "";
    /**
     * 渠道描述
     */
    String channelDesc = "";

    public String getChannelId() {
        return channelId;
    }

    public void setChannelId(String channelId) {
        this.channelId = channelId;
    }

    public String getChannelName() {
        return channelName;
    }

    public void setChannelName(String channelName) {
        this.channelName = channelName;
    }

}
