/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.plu;

/**
 * 优惠类型。
 *
 * @author zhangsai 2017-10-12
 */
public enum DiscountType {
    /**
     * 折扣率
     */
    Rate(0),

    /**
     * 优惠价
     */
    Price(1);


    // 表示优惠类型的值。
    private final int type;


    /**
     * 初始化一个 {@code DiscountType} 的实例。
     * @param type 表示优惠类型的值。
     */
    DiscountType(int type) {
        this.type = type;
    }


    /**
     * 返回优惠类型的值。
     * @return 优惠类型的值。
     */
    public int value() {
        return this.type;
    }

}
