package com.hisense.hipos.report;

import com.hisense.hipos.model.SalePluModel;


/**
 * 专柜销售报表商品项。
 *
 * @author zhangsai 2018-12-28 HIPOSAPP-946
 */
public final class ShopSaleReportItem {

    // 销售商品
    private SalePluModel plu;
    // 实收金额
    private double totalRecv;

    /**
     * 初始化一个 {@code ShopSaleReportItem} 的实例。
     *
     * @param plu       销售商品
     * @param totalRecv 实收金额
     */
    public ShopSaleReportItem(SalePluModel plu, double totalRecv) {
        this.plu = plu;
        this.totalRecv = totalRecv;
    }

    /**
     * 返回销售商品。
     */
    public SalePluModel plu() {
        return this.plu;
    }

    /**
     * 返回实收金额。
     */
    public double totalRecv() {
        return this.totalRecv;
    }
}
