/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.sale;

/**
 * 货币精度。
 *
 * @author wangyaogang 2019-05-13 HIPOSAPP-1087 控制每台机器收款的小数位
 */
public enum CurrencyPrecision {
    /**
     * 角
     */
    TenCent(1),

    /**
     * 分
     */
    Cent(2);

    private int value;

    /**
     * 初始化一个 CurrencyPrecision 枚举。
     *
     * @param value 指定的计算精度
     */
    CurrencyPrecision(int value) {
        this.value = value;
    }

    /**
     * 返回计算精度。
     *
     * @return 计算精度的对应值。
     */
    public int value() {
        return this.value;
    }

    /**
     * 将 {@code int} 值转换为对应的 {@code CurrencyPrecision}。默认为角 1。
     *
     * @param value 要转换的值。
     * @return 计算精度。
     */
    public static CurrencyPrecision valueOf(int value) {
        switch (value) {
            case 2:
                return CurrencyPrecision.Cent;
            case 1:
            default:
                return CurrencyPrecision.TenCent;
        }
    }
}
