/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.sale;

/**
 * 定义交易商品优惠的接口。
 *
 * @author zhangsai 2018-06-21 HIPOSAPP-576
 * @author guolina  2018-12-21 HIPOSAPP-839 小票增加促销打印
 */
public interface ISaleItemDiscount {
    /**
     * 返回顺序号。
     *
     * @return 顺序号
     */
    int serialNo();

    /**
     * 返回优惠单号。
     *
     * @return 优惠单号
     */
    String dscCode();

    /**
     * 返回优惠名称。
     *
     * @return 优惠名称
     */
    String dscName();

    /**
     * 返回优惠类型。
     *
     * @return 优惠类型
     */
    String dscType();

    /**
     * 返回商品合计优惠金额。
     *
     * @return 商品合计优惠金额
     */
    double totalDsc();
}
