/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.sale;

import java.io.Serializable;

/**
 * 提供销售商品顺序号的接口。
 *
 * @author zhangsai    2017-11-22
 * @author wangyaogang 2019-02-02 HIPOSAPP-990 优化退货流水添加行号的逻辑,保证最终流水从给定初始值开始
 */
public interface ISaleItemNoProvider extends Serializable {

    /**
     * 返回当前的顺序号。
     *
     * @return 当前的顺序号
     */
    int current();

    /**
     * 返回最小值。
     *
     * @return 最小值
     */
    int min();


    /**
     * 在当前顺序号基础上减去 1。
     */
    void decrease();

    /**
     * 返回当前的顺序号，并在当前顺序号基础上自动加 1。
     *
     * @return 当前的顺序号
     */
    int next();

    /**
     * 重置当前行号提供器
     */
    void reset();
}
