/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.sale.models;

/**
 * 商定天下/商海纵横系统的流水顺序号提供程序。
 *
 * @author zhangsai 2018-01-11 HIPOSAPP-271
 */
public class CmpSerialNoProvider {

    /**
     * 根据当前值计算下一个顺序号。
     *
     * @param serialNo 顺序号的当前值
     * @return 下一个顺序号
     */
    public int next(int serialNo) {
        if (serialNo < SerialNo.MIN_VALUE) {
            return SerialNo.MIN_VALUE;
        } else if (serialNo >= SerialNo.MAX_VALUE) {
            return SerialNo.MIN_VALUE;
        } else {
            return serialNo + 1;
        }
    }

    /**
     * 流水顺序号
     */
    private static class SerialNo {
        private static final int MAX_VALUE = 9999;  // 顺序号最大值
        private static final int MIN_VALUE = 1;     // 顺序号最小值
    }
}
