/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.sale.models;

/**
 * 流水顺序号资源库接口。
 *
 * @author zhangsai 2018-01-11 HIPOSAPP-271
 */
public interface ISerialNoRepository {

    /**
     * 返回指定收款机的当前流水顺序号。
     *
     * @param orgCode 门店编码
     * @param posNo   收款机号
     * @return 指定收款机的当前流水顺序号。-1 表示没有对应的记录。
     */
    int get(String orgCode, String posNo);

    /**
     * 保存流水顺序号。
     *
     * @param orgCode  组织编码
     * @param posNo    收款机号
     * @param serialNo 流水顺序号
     */
    void save(String orgCode, String posNo, int serialNo);
}
