/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.hipos.template.models;

/**
 * 打印图片
 *
 * @author xieliyan 2018-03-26
 */

public class PrintImage {
    /**
     * 客户端图片的名称
     */
    private String name;
    /**
     * 客户端图片状态
     */
    private int state;
    /**
     * 客户端图片的修改时间戳
     */
    private int timestamp;

    public PrintImage(String name, int timestamp) {
        this.name = name;
        this.timestamp = timestamp;
    }

    /**
     * 初始化一个 {@code PrintImage} 的实例。
     *
     * @param name      图片名称
     * @param state     图片状态
     * @param timestamp 图片修改时间戳
     */
    public PrintImage(String name, int state, int timestamp) {
        this.name = name;
        this.state = state;
        this.timestamp = timestamp;
    }

    /**
     * 返回图片名字。
     *
     * @return 图片名字。
     */
    public String name() {
        return this.name;
    }

    /**
     * 返回图片状态。
     *
     * @return 图片状态。
     */
    public int state() {
        return this.state;
    }

    /**
     * 返回图片修改时间戳。
     *
     * @return 图片修改时间戳。
     */
    public int timeStamp() {
        return this.timestamp;
    }
}
