/***************************************************************************************************
 * Copyright (c) 2003-2017 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.hipos.template.models;

/**
 * 打印模板。
 *
 * @author zhangsai 2017-10-12
 */
public class PrintTemplate {
    // 模板内容
    private String content;
    // 模板的当前版本号
    private int version;
    // 模板类型
    private PrintTemplateType type;

    /**
     * 初始化一个 {@code PrintTemplate} 的实例。
     *
     * @param type    模板类型
     * @param version 模板内容版本
     * @param content 模板内容
     */
    public PrintTemplate(PrintTemplateType type, int version, String content) {
        this.type = type;
        this.content = content;
        this.version = version;
    }

    /**
     * 返回模板内容。
     *
     * @return 模板内容。
     */
    public String content() {
        return this.content;
    }

    /**
     * 返回模板类型。
     *
     * @return 模板类型。
     */
    public PrintTemplateType templateType() {
        return this.type;
    }

    /**
     * 返回模板内容版本。
     *
     * @return 模板内容版本。
     */
    public int version() {
        return this.version;
    }
}
