/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.pos.payment.boc;

/**
 * 支付模式。
 *
 * @author zhangsai    2018-12-17 HIPOSAPP-914
 * @author wangyaogang 2018-12-27 HIPOSAPP-876 中行银联二维码支付对接,增加云闪付支付方式
 */
public enum PayMode {
    /**
     * 银行卡收单。
     */
    UNION_PAY(1),
    /**
     * 云闪付(银联二维码)。
     */
    UNION_CLOUD_PAY(3),
    /**
     * 支付宝（收单行渠道）
     */
    ALIPAY(6),
    /**
     * 微信支付（收单行渠道）
     */
    WECHAT_PAY(7);

    private int mode;

    PayMode(int mode) {
        this.mode = mode;
    }

    /**
     * 返回支付模式对应的值。
     */
    public int value() {
        return this.mode;
    }
}
