/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.pos.card.ccb;

import com.ccb.deviceservice.aidl.IDeviceService;
import com.hisense.common.util.LoggerUtils;
import com.hisense.pos.card.CardNoCallback;
import com.hisense.pos.card.M1Card;

/**
 * 用于读取CRM制卡标准1.0的 Mifare1 非接触式磁卡读取器。
 *
 * @author zhangsai 2018-04-25
 */
class M1CardReaderV1 extends M1CardReader {


    public M1CardReaderV1(IDeviceService deviceService) {
        super(deviceService);
    }

    /**
     * 使用读卡密码读取卡内数据。
     *
     * @param password 读卡密码
     * @param callback 读取卡号的回调方法
     */
    @Override
    protected void innerRead(String password, CardNoCallback callback) {
        String pwd = password + "FFFFFF";
        byte[] data = super.readData(0, M1Card.BLOCK_CARD_NO, pwd);
        String cardNo = M1Card.decrypt(new String(data));
        LoggerUtils.getLogger().debug("ccb_M1CardReaderV1卡号:" + cardNo);
        if (!"".equals(cardNo) && !isRead) {
            isRead = true;
            callback.onSuccess(cardNo);
        }
    }
}
