package com.hisense.pos.print.hi98;

import android.graphics.Bitmap;

import com.hisense.common.util.LoggerUtils;
import com.hisense.pos.print.IPrintProvider;
import com.hisense.pos.spiprinter.SpiPrinter;

import static com.hisense.pos.spiprinter.SpiPrinter.FONT_ATTR_NORMAL;

/**
 * 建行打印提供程序
 *
 * @author xieliyan  2019-11-13
 */
public class HI98PrintProvider implements IPrintProvider {


    private SpiPrinter printer ;



    @Override
    public boolean initPrinter(int prnBaudRate, int prnPort, int prnType, int feedLine) {
        printer = new SpiPrinter();
        return true;

    }

    @Override
    public void cutPaper() {

    }

    @Override
    public void closePrinter() {

    }

    @Override
    public void addText(String text, int align, int font) {
        try {
            printer.Printer_TextStr(text, font, FONT_ATTR_NORMAL, align);
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("添加文本异常" + e.getMessage());
        }

    }

    @Override
    public void addBarCode(String barCode) {

    }

    @Override
    public void addQrCode(String qrCode, int offset, int expectedHeight) {

    }


    @Override
    public void addImage(byte[] imageData, Bitmap bitmap, int offset, int width, int height) {
        try {
            printer.Printer_Image(bitmap, 0);
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("启动打印文本异常" + e.getMessage());
        }
    }

    @Override
    public int getStatus() {
        try {
            printer.Printer_init();
            return printer.Printer_getStatus();
        } catch (Exception e) {
            LoggerUtils.getLogger().debug("获取打印状态异常" + e.getMessage());
            return -1;
        }
    }

    @Override
    public void feedLine(int lines) {

    }

    @Override
    public void startPrint() {

    }

//    @Override
//    public void startPrintText() {
//        try {
//            printer.Printer_Start();
//        } catch (Exception e) {
//            LoggerUtils.getLogger().debug("启动打印文本异常" + e.getMessage());
//        }
//    }
}
