package com.icbc.smartpos.transservice.aidl;

/**
 * 交易流程回调接口
 * @author: icbc
 */
interface TransHandler {

    /**
     * 交易结束
     * @param transResult - 交易结果数据
     * <ul>
     * <li>RESULT(int) -         结果类型：(0)-成功; (1)-失败; (-1)-异常</li>
     * <li>DESCRIPTION(String) - 交易结果/失败信息描述 </li>
     * <li>TRANS_SEQUENCE(long) - 交易顺序号 </li>
     * <li>TRANS_TYPE(int) -     交易类型 </li>
     * <li>TRANS_NAME(String) -  交易名称 </li>
     * <li>RSP_NO(String) -      主机返回码 </li>
     * <li>TRACE(String) -       终端流水号 </li>
     * <li>BATCH_NUM(String) -   终端批次号 </li>
     * <li>REF_NO(String) -      检索参考号 </li>
     * <li>PAN(String) -         交易卡号 </li>
     * <li>DATETIME(String) -    交易时间（yyyyMMddHHmmss） </li>
     * <li>AUTH_ID(String) -     授权码 </li>
     * <li>AMOUNT(long) -        交易金额(分) </li>
     * <li>RET_AMT(long) -       清算金额(分) </li>
     * <li>FEE_AMT(long) -       小费金额(分) </li>
     * <li>SHILDED_PAN(String) - 主机返回的屏蔽后卡号 </li>
     * <li>DINGDAN_NO(String) -  主机返回的二维码订单编号 </li>
     * <li>EXP_DATE(String) -    卡片有效期（MMYY） </li>
     * <li>CUST_NAME(String) -   商户名称 </li>
     * <li>CUST_NO(String) -     商户号 </li>
     * <li>TERM_NO(String) -     终端号 </li>
     * <li>TC(String) -          TC证书 </li>
     * <li>DCCTRANS(boolean) -   DCC标识 </li>
     * <li>CURRENCY_NAME(String) -外币币种 </li>
     * <li>DCC_AMT(long) -       外币金额(分) </li>
     * <li>EXCHANGE_RATE(String) -汇率 </li>
     * <li>CARD_NAME(String) -   汉字卡种信息 </li>
     * <li>CARD_ISSUER(String) - 发卡行名称 </li>
     * <li>CARD_ORG(String) -    卡组织名称 </li>
     * <li>CARD_INPUT_MODE(int) - 卡输入方式,1-刷卡；2-插卡；3-触卡；4-手输卡号；5-二维码 </li>
     *
     * </ul>
     */
    void onFinish(in Bundle baseResult, in Bundle transResult, in Bundle extraInfo);
}