/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.payment.icbc;

import android.app.Activity;

import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.PayRequest;
import com.hisense.pos.payment.PaymentHandler;
import com.hisense.pos.payment.PaymentProviderException;

import java.util.Date;
import java.util.Map;

/**
 * 工行收单分期付款提供程序。
 *
 * @author zhangsai 2018-11-27 HIPOSAPP-888
 */
public class IcbcInstallmentProvider extends IcbcPaymentProvider implements IPaymentProvider {

    /**
     * 初始化一个 {@code IcbcInstallmentProvider} 的实例。
     *
     * @param activity Activity 活动
     */
    public IcbcInstallmentProvider(Activity activity) {
        super(activity);
    }


    /**
     * 返回是否支持撤销。
     *
     * @return true 表示支持撤销，false 表示不支持撤销
     */
    @Override
    public boolean supportCancellation() {
        return true;
    }

    /**
     * 消费。
     *
     * @param payRequest 交易金额
     * @param handler    消费结果处理程序
     * @throws PaymentProviderException 如果请求失败，或数据解析错误
     */
    @Override
    public void pay(PayRequest payRequest, PaymentHandler handler) throws PaymentProviderException {
        this.pay(TransListType.INSTALLMENT, payRequest, handler);
    }

    /**
     * 隔日退货。
     *
     * @param payRequest 退款金额
     * @param refNo      参考号
     * @param transDate  交易日期
     * @param params     扩展参数
     * @param handler    隔日退货结果处理程序
     * @throws PaymentProviderException 如果请求失败，或数据解析错误
     */
    @Override
    public void refund(PayRequest payRequest, String refNo, Date transDate, Map<String, String> params,
                       final PaymentHandler handler) throws PaymentProviderException {
        super.refund(TransType.REFUND, payRequest, refNo, transDate, params, handler);
    }
}
