/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.payment.icbc;

/**
 * 工行收单接口返回的交易附加数据。
 *
 * @author zhangsai 2018-11-28 HIPOSAPP-888
 */
public class PurchaseExtraInfo extends ResultBase {

    /**
     * 初始化一个 {@code PurchaseExtraInfo} 的实例。
     */
    PurchaseExtraInfo() {
        super();
    }

    /**
     * 完整的银行卡号。
     * 该数据返回受特别权限控制，如果不具备输出敏感信息签名权限将不会输出该信息
     */
    public String pan() {
        return super.bundle.getString("PAN");
    }

    /**
     * 卡有效期。格式：MMYY。
     * 该数据返回受特别权限控制，如果不具备输出敏感信息签名权限将不会输出该信息。
     */
    public String expDate() {
        return super.bundle.getString("EXP_DATE");
    }

    /**
     * 交易后台返回的部分屏蔽卡号。
     */
    public String shiledPan() {
        return super.bundle.getString("SHILDED_PAN");
    }

    /**
     * 银行卡对应的卡种信息。
     */
    public String cardName() {
        return super.bundle.getString("CARD_NAME");
    }

    /**
     * 银行卡的对应发卡行名称。
     */
    public String cardIssuer() {
        return super.bundle.getString("CARD_ISSUER");
    }

    /**
     * 银行卡的卡组织名称。
     */
    public String cardOrg() {
        return super.bundle.getString("CARD_ORG");
    }
}
