/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.payment.icbc;

/**
 * 工行收单接口返回的交易结果数据。
 *
 * @author zhangsai 2018-11-28 HIPOSAPP-888
 */
public class PurchaseTransResult extends ResultBase {

    /**
     * 初始化一个 {@code PurchaseExtraInfo} 的实例。
     */
    PurchaseTransResult() {
        super();
    }

    /**
     * 交易金额（人民币），单位：分。
     */
    public long amount() {
        return super.bundle.getLong("AMOUNT");
    }

    /**
     * 交易后台返回的检索参考号。
     */
    public String refNo() {
        return super.bundle.getString("REF_NO");
    }

    /**
     * 用户在可选页面上最终选择的付款方式。
     * 输出的是由大写英文组成的交易类型。
     */
    public String payType() {
        return super.bundle.getString("PAY_TYPE");
    }

    /**
     * 交易后台返回二维码订单号（即手机收到支付平台返回的订单号）。
     */
    public String QRCodeOrder() {
        return super.bundle.getString("QRCODE_ORDER");
    }
}
