/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.pos.payment.icbc.bean;

import java.util.ArrayList;

/**
 * 工行交易汇总 银行卡交易item
 * @author lizhixin 20180710 HIPOSAPP-533 工行交易汇总数据解析实体类
 */
public class StOrgItem {

    /**
     * 卡组织简称，详见工行智能pos首单应用文档 7.3  卡组织对照表
     * CUP 为中国银联
     */
    public String org_name;

    /**
     * 该卡组织的汇总金额（人民币），
     * 单位：分。
     * 仅汇总以下未撤销的交易：
     * PURCHASE：银行卡消费
     * INTEGRAL_PURCHASE：积分消费
     * INSTALLMENT：分期付款
     * REFUND：隔日退货
     * INTEGRAL_REFUND：积分退货
     * PREAUTHEND ：预授权确认
     */
    public int org_amt;

    /**
     * 该卡组织的有效交易笔数。
     * 仅汇总以下未撤销的交易：
     * PURCHASE：银行卡消费
     * INTEGRAL_PURCHASE：积分消费
     * INSTALLMENT：分期付款
     * REFUND：隔日退货
     * INTEGRAL_REFUND：积分退货
     * PREAUTHEND ：预授权确认
     */
    public int org_cnt;

    /**
     * 该卡组织下按交易类型单独统计
     */
    public ArrayList<StOrgItemTransItem> trans;

}
