/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.payment.ums;

import android.app.Activity;

import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.PayRequest;
import com.hisense.pos.payment.PaymentHandler;

/**
 * 银联商务收单应用的手机支付提供程序。
 *
 * @author guolina  2020-03-10 HIAPOSCMP-577  邹平圣豪-易收银的微信、支付宝两个支付方式合并为一个
 */
public class UmsMobilePayProvider extends UmsPaymentProvider implements IPaymentProvider {

    /**
     * 初始化一个 {@code UmsMobilePayProvider} 的实例。
     *
     * @param activity Activity 活动
     */
    public UmsMobilePayProvider(Activity activity) {
        super(activity, AppName.POS_MASTER);
    }

    /**
     * 消费。
     *
     * @param payRequest 交易金额
     */
    @Override
    public void pay(PayRequest payRequest, PaymentHandler handler) {
        super.pay(TransId.POS_MASTER, payRequest, TradeType.USE_SCAN);
    }
}
