/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.unionpay.payment.ccb;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;

import com.hisense.pos.payment.PaymentProvider;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

/**
 * 建行直联应用提供程序的基类。
 *
 * @author xieliyan  2019-10-18 HIPOSAPP-1328
 */
abstract class UnionCcbProviderBase extends PaymentProvider {

    static final int TRANS_REQUEST_CODE = 3001; // TODO: 此值为易收银自定义


    /**
     * 初始化一个 {@code CcbProviderBase} 的实例。
     *
     * @param activity Activity 活动
     */
    UnionCcbProviderBase(Activity activity) {
        super(activity);
    }


    /**
     * 返回 Android 请求编码。
     *
     * @return Android 请求编码
     */
    public int requestCode() {
        return TRANS_REQUEST_CODE;
    }


    /**
     * 调用建行收单。
     *
     * @param transId 交易ID
     * @param map     交易数据
     */
    protected void callTrans(String transId, HashMap<String, String> map) {
        ComponentName compName = new ComponentName("com.unionpay.comprehensive.payment",
                "com.unionpay.comprehensive.payment.MainActivity");

        Intent intent = new Intent();
        intent.setComponent(compName);
        intent.putExtra("transName", transId);
        if(map!=null) {
            String amt;
            if (map.containsKey("amt")) {
                amt = map.get("amt");
                intent.putExtra("amount", amt);
            }

            String oldTrace;
            if (map.containsKey("oldTrace")) {
                oldTrace = map.get("oldTrace");
                intent.putExtra("oldTrace", oldTrace);
            }
            String oldReferenceNo;
            if (map.containsKey("oldReferenceNo")) {
                oldReferenceNo = map.get("oldReferenceNo");
                intent.putExtra("oldReferenceNo", oldReferenceNo);
            }
            String oldDate;
            if (map.containsKey("oldDate")) {
                oldDate = map.get("oldDate");
                intent.putExtra("oldDate", oldDate);
            }
            String out_trade_no;
            if (map.containsKey("out_trade_no")) {
                out_trade_no = map.get("out_trade_no");
                intent.putExtra("out_trade_no", out_trade_no);
            }
            String refund_fee;
            if (map.containsKey("refund_fee")) {
                refund_fee = map.get("refund_fee");
                intent.putExtra("refund_fee", refund_fee);
            }
            String mch_id;
            if (map.containsKey("mch_id")) {
                mch_id = map.get("mch_id");
                intent.putExtra("mch_id", mch_id);
            }
        }
        super.activity.startActivityForResult(intent, TRANS_REQUEST_CODE);

    }

    /**
     * 调用建行收单。
     *
     * @param transId 交易ID
     */
    protected void callTrans(String transId) {
        this.callTrans(transId,null);
    }



    /**
     * 返回交易结果
     *
     * @param intent 事件
     * @return map   交易结果
     */
    protected static Map<String, String> filterTransResult(Intent intent) {
        HashMap<String, String> map = new HashMap<>();
        Bundle bundle = intent.getExtras();
        if (bundle != null) {
            if (bundle.containsKey("amount")) {
                map.put("amount", bundle.getString("amount"));
            }
            if (bundle.containsKey("cardNo")) {
                map.put("cardNo", bundle.getString("cardNo"));
            }
            if (bundle.containsKey("mch_id")) {
                map.put("mch_id", bundle.getString("mch_id"));
            }
            if (bundle.containsKey("traceNo")) {
                map.put("traceNo", bundle.getString("traceNo"));
            }
            if (bundle.containsKey("batchNo")) {
                map.put("batchNo", bundle.getString("batchNo"));
            }
            if (bundle.containsKey("merchantId")) {
                map.put("merchantId", bundle.getString("merchantId"));
            }
            if (bundle.containsKey("referenceNo")) {
                map.put("referenceNo", bundle.getString("referenceNo"));
            }

        }
        return map;

    }

}
