/***************************************************************************************************
 * Copyright (c) 2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.pos.unionpay.payment.ccb;

import android.app.Activity;

import com.hisense.pos.payment.IPaymentProvider;
import com.hisense.pos.payment.PayRequest;
import com.hisense.pos.payment.PaymentHandler;

import java.util.Date;
import java.util.Map;

/**
 * 建行直联应用的银行卡支付提供程序。
 *
 * @author xieliyan  2019-10-18 HIPOSAPP-1328
 */
public class UnionCcbUnionPayProvider extends UnionCcbPaymentProvider implements IPaymentProvider {

    /**
     * 初始化一个 {@code UnionCcbUnionPayProvider} 的实例。
     *
     * @param activity Activity 活动
     */
    public UnionCcbUnionPayProvider(Activity activity) {
        super(activity);
    }


    /**
     * 返回是否支持撤销。
     *
     * @return true 表示支持撤销，false 表示不支持撤销
     */
    @Override
    public boolean supportCancellation() {
        return true;
    }

    /**
     * 消费。
     *
     * @param payRequest 交易金额
     */
    @Override
    public void pay(PayRequest payRequest, PaymentHandler handler) {
        this.pay(TransId.CONSUME, payRequest);
    }

    /**
     * 退货。
     *
     * @param payRequest 退款金额
     * @param refNo      参考号
     * @param transDate  交易日期
     * @param params     扩展参数
     */
    @Override
    public void refund(PayRequest payRequest, String refNo, Date transDate, Map<String, String> params, PaymentHandler handler) {
        this.refund(TransId.REFUNDING,payRequest,refNo,transDate,params,handler);
    }

    /**
     * 撤销。
     *
     * @param payRequest 退款金额
     * @param traceNo    原交易凭证号
     * @param params     扩展参数
     */
    @Override
    public void cancel(PayRequest payRequest, String traceNo, Map<String, String> params, PaymentHandler handler) {
        this.cancel(TransId.CANCELLATION,payRequest,traceNo,params,handler);
    }
}
