/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/
package com.hisense.database.sqlite;

import android.database.Cursor;

/**
 * SQLite 查询的回调方法接口。
 *
 * @param <TResult>
 * @author zhangsai 2018-12-22 HIPOSAPP-931
 */
public interface ReadCallback<TResult> {
    /**
     * 读取查询到的第一条数据并转换为 {@code TResult} 指定类型的实例。
     *
     * @param cursor 查询结果的 {@code Cursor} 游标
     * @return {@code TResult} 的实例或 null
     */
    TResult onSuccess(Cursor cursor);
}
