/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.pos.card;

/**
 * 读卡监听程序。
 *
 * @author zhangsai    2018-04-26
 * @author wangyaogang 2019-09-05 HIPOSAPP-1287 调整重新发起监听的间隔
 */
public abstract class CardListener extends Thread {

    private static volatile boolean IS_STOPPING = false;//控制线程是否退出标志

    @Override
    public void run() {
        IS_STOPPING = false;

        while (!IS_STOPPING) {
            onListening();

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

        onStop();
    }

    /**
     * 在一个监听周期后探测并读卡。
     */
    protected abstract void onListening();

    protected void onStop() {

    }

    /**
     * 结束监听。
     */
    public void stopListen() {
        IS_STOPPING = true;
    }
}
