/***************************************************************************************************
 * Copyright (c) 2003-2018 青岛海信智能商用系统股份有限公司 版权所有
 **************************************************************************************************/

package com.hisense.pos.card;

import android.content.Context;


/**
 * 读卡器接口。
 *
 * @author zhangsai 2018-01-18
 */
public interface ICardReader {
    /**
     * 打开并初始化读卡器。
     *
     * @param context Context
     */
    void open(Context context);

    /**
     * 读取卡号。
     *
     * @param password 读卡密码
     * @param callback 读取卡号的回调方法
     */
    void read(String password, CardNoCallback callback);

    /**
     * 开始读卡。
     */
    void start();

    /**
     * 停止读卡。
     */
    void stop();

    /**
     * 关闭读卡器。
     */
    void close();
}
