package com.hisense.pos.payment;

import java.util.Locale;
import java.util.Random;

/**
 * {功能描述}
 *
 * @author wangyaogang 2019-08-19 HIPOSAPP-1225  银联商务增加支付查询
 * @author wangyaogang 2019-09-11 HIPOSAPP-1301 支持中行支付查询.限制uniqueNo长度
 */
public class PayRequest {
    /**
     * 支付金额
     */
    private double amount;

    /**
     * 唯一No,确定一笔交易
     */
    private String uniqueNo;

    public PayRequest(double amount, String uniqueNo) {
        this.amount = amount;
        this.uniqueNo = uniqueNo;
    }

    public double getAmount() {
        return amount;
    }

    public void setAmount(double amount) {
        this.amount = amount;
    }

    public String getUniqueNo() {
        return uniqueNo;
    }

    public void setUniqueNo(String uniqueNo) {
        this.uniqueNo = uniqueNo;
    }

    /**
     * 生成唯一No,用于区分同种支付方式的多次交易
     * (鉴于中行限制长度为20位,若uniqueNo大于20位,进行截取)
     *
     * @param posNo pos号
     * @return 唯一No
     */
    public static String generateUniqueNo(String posNo) {
        String uniqueNo = posNo + System.currentTimeMillis() + String.format(Locale.CHINESE, "%03d", new Random().nextInt(1000));
        if (uniqueNo.length() > 20) {
            uniqueNo = uniqueNo.substring(uniqueNo.length() - 20);
        }
        return uniqueNo;
    }
}
