package com.hisense.pos.scanner;

import android.content.Intent;

/**
 * 扫描器接口。
 *
 * @author zhangsai    2019-01-18 HIPOSAPP-1002
 * @author wangyaogang 2019-12-10 HIAPOSCMP-412 修改默认扫描器请求码,原值与工行冲突
 */
public interface IScanner {

    int SCAN_REQUEST = 1608;

    /**
     * 启动扫描。
     *
     * @param callback 扫描回调方法
     */
    void scan(ScannerCallback callback);

    /**
     * 两步模式下获取扫描结果。
     *
     * @param data 包含扫描结果的数据
     * @return 扫描字符串
     */
    String getScanResult(Intent data);

    /**
     * 关闭扫描。
     */
    void close();
}
