//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package OnePlusOneAndroidSDK.ScalesOS;

import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.content.Context;
import android.util.Log;
import java.io.File;
import java.util.Iterator;
import java.util.List;

public class ScalesSDK {
    private static ScalesSDK instance;
    private static final String TAG = "ScalesSDK";
    private static boolean mNowAutoMode = false;
    private static WeightInfo minfo = null;
    private static ScalesSDK.WeightChangedListener mWeightChangedListener = null;
    private static Context mcontext = null;

    private static void OPO_OnOPOModule(String weight) {
        if (!mNowAutoMode) {
            mNowAutoMode = true;
        }

        minfo.updata(weight);
        if (mWeightChangedListener != null) {
            mWeightChangedListener.onWeightChanged(minfo);
        }

    }

    private ScalesSDK() {
        mNowAutoMode = false;
        minfo = new WeightInfo();
        if (SetModuleCallBack("OnePlusOneAndroidSDK/ScalesOS/ScalesSDK") != 0) {
            Log.d("ScalesSDK", "SetModuleCallBack: OK");
        } else {
            Log.d("ScalesSDK", "SetModuleCallBack: Fail");
        }

    }

    public static boolean isBackground(Context context) {
        ActivityManager activityManager = (ActivityManager)context.getSystemService("activity");
        List<RunningAppProcessInfo> appProcesses = activityManager.getRunningAppProcesses();
        Iterator var3 = appProcesses.iterator();

        RunningAppProcessInfo appProcess;
        do {
            if (!var3.hasNext()) {
                return false;
            }

            appProcess = (RunningAppProcessInfo)var3.next();
        } while(!appProcess.processName.equals(context.getPackageName()));

        if (appProcess.importance != 100) {
            return true;
        } else {
            return false;
        }
    }

    public static synchronized ScalesSDK getInstance(Context context, ScalesSDK.WeightChangedListener paramWeightChangedListener) {
        mcontext = context;
        mWeightChangedListener = paramWeightChangedListener;
        if (instance == null) {
            instance = new ScalesSDK();
            if (context != null) {
                (new Thread() {
                    public void run() {
                        while(true) {
                            try {
                                sleep(1000L);
                                ScalesSDK.ReadThread(!ScalesSDK.isBackground(ScalesSDK.mcontext));
                            } catch (InterruptedException var2) {
                                var2.printStackTrace();
                            }
                        }
                    }
                }).start();
            }
        }

        return instance;
    }

    public boolean Open(File device) {
        if (device.canRead() && device.canWrite()) {
            int mFd = Open(device.getAbsolutePath());
            if (mFd == 0) {
                Log.e("ScalesSDK", "native open returns null");
                return false;
            } else if (!mNowAutoMode) {
                return SetAutoMode() > 0;
            } else {
                return true;
            }
        } else {
            Log.e("ScalesSDK", "OpenFail: device not canRead not canWrite");
            return false;
        }
    }

    public WeightInfo getWeihtInfo() {
        return minfo;
    }

    private static native int SetModuleCallBack(String var0);

    private static native int Open(String var0);

    private static native int SetAutoMode();

    private static native void ReadThread(boolean var0);

    public native int SetFactoryCallBack(String var1);

    public native String OPOModuleSend(int var1, int var2, byte[] var3, int var4);

    public native int DownloadProgramme(String var1, String var2);

    public native int Close();

    public native String GetResult();

    public native String ReadResultCache();

    public native int Zero();

    public native int Tare();

    public native int PreTare(int var1);

    public native int ExitTare();

    static {
        System.loadLibrary("oposcalessdk");
    }

    public interface WeightChangedListener {
        void onWeightChanged(WeightInfo var1);
    }
}
